-- MySQL dump 10.13  Distrib 5.1.66, for unknown-linux-gnu (x86_64)
--
-- Host: localhost    Database: project_j30_publisher_clean
-- ------------------------------------------------------
-- Server version	5.1.66-cll












--
-- Table structure for table `#__assets`
--



CREATE TABLE `#__assets` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `parent_id` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set parent.',
  `lft` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set lft.',
  `rgt` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set rgt.',
  `level` int(10) unsigned NOT NULL COMMENT 'The cached level in the nested tree.',
  `name` varchar(50) NOT NULL COMMENT 'The unique name for the asset.\n',
  `title` varchar(100) NOT NULL COMMENT 'The descriptive title for the asset.',
  `rules` varchar(5120) NOT NULL COMMENT 'JSON encoded access control.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_asset_name` (`name`),
  KEY `idx_lft_rgt` (`lft`,`rgt`),
  KEY `idx_parent_id` (`parent_id`)
) ENGINE=InnoDB AUTO_INCREMENT=65 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__assets`
--


INSERT INTO `#__assets` (`id`, `parent_id`, `lft`, `rgt`, `level`, `name`, `title`, `rules`) VALUES (1,0,1,127,0,'root.1','Root Asset','{\"core.login.site\":{\"6\":1,\"2\":1},\"core.login.admin\":{\"6\":1},\"core.login.offline\":{\"6\":1},\"core.admin\":{\"8\":1},\"core.manage\":{\"7\":1},\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),(2,1,1,2,1,'com_admin','com_admin','{}'),(3,1,3,8,1,'com_banners','com_banners','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(4,1,9,10,1,'com_cache','com_cache','{\"core.admin\":{\"7\":1},\"core.manage\":{\"7\":1}}'),(5,1,11,12,1,'com_checkin','com_checkin','{\"core.admin\":{\"7\":1},\"core.manage\":{\"7\":1}}'),(6,1,13,14,1,'com_config','com_config','{}'),(7,1,15,22,1,'com_contact','com_contact','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),(8,1,23,70,1,'com_content','com_content','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":{\"3\":1},\"core.delete\":[],\"core.edit\":{\"4\":1},\"core.edit.state\":{\"5\":1},\"core.edit.own\":[]}'),(9,1,71,72,1,'com_cpanel','com_cpanel','{}'),(10,1,73,74,1,'com_installer','com_installer','{\"core.admin\":[],\"core.manage\":{\"7\":0},\"core.delete\":{\"7\":0},\"core.edit.state\":{\"7\":0}}'),(11,1,75,76,1,'com_languages','com_languages','{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(12,1,77,78,1,'com_login','com_login','{}'),(13,1,79,80,1,'com_mailto','com_mailto','{}'),(14,1,81,82,1,'com_massmail','com_massmail','{}'),(15,1,83,84,1,'com_media','com_media','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":{\"3\":1},\"core.delete\":{\"5\":1}}'),(16,1,85,86,1,'com_menus','com_menus','{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(17,1,87,88,1,'com_messages','com_messages','{\"core.admin\":{\"7\":1},\"core.manage\":{\"7\":1}}'),(18,1,89,90,1,'com_modules','com_modules','{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(19,1,91,98,1,'com_newsfeeds','com_newsfeeds','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),(20,1,99,100,1,'com_plugins','com_plugins','{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(21,1,101,102,1,'com_redirect','com_redirect','{\"core.admin\":{\"7\":1},\"core.manage\":[]}'),(22,1,103,104,1,'com_search','com_search','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1}}'),(23,1,105,106,1,'com_templates','com_templates','{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(24,1,107,110,1,'com_users','com_users','{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(25,1,111,118,1,'com_weblinks','com_weblinks','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":{\"3\":1},\"core.delete\":[],\"core.edit\":{\"4\":1},\"core.edit.state\":{\"5\":1},\"core.edit.own\":[]}'),(26,1,119,120,1,'com_wrapper','com_wrapper','{}'),(27,8,24,31,2,'com_content.category.2','Uncategorised','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),(28,3,4,5,2,'com_banners.category.3','Uncategorised','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(29,7,16,17,2,'com_contact.category.4','Uncategorised','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),(30,19,92,93,2,'com_newsfeeds.category.5','Uncategorised','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),(31,25,112,113,2,'com_weblinks.category.6','Uncategorised','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),(32,24,108,109,1,'com_users.category.7','Uncategorised','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),(33,1,121,122,1,'com_finder','com_finder','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1}}'),(34,1,123,124,1,'com_joomlaupdate','com_joomlaupdate','{\"core.admin\":[],\"core.manage\":[],\"core.delete\":[],\"core.edit.state\":[]}'),(35,3,6,7,2,'com_banners.category.8','Demo','{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),(36,7,18,19,2,'com_contact.category.9','Sample category I','{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),(37,7,20,21,2,'com_contact.category.10','Sample category II','{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),(38,19,94,95,2,'com_newsfeeds.category.11','GavickPro','{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),(39,19,96,97,2,'com_newsfeeds.category.12','Joomla!','{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),(40,25,114,115,2,'com_weblinks.category.13','Joomla Weblink Category','{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),(41,25,116,117,2,'com_weblinks.category.14','GavickPro','{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),(42,8,32,45,2,'com_content.category.15','Template articles','{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),(43,8,46,47,2,'com_content.category.16','Layouts','{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),(44,8,48,69,2,'com_content.category.17','Snowboard','{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),(45,44,49,52,3,'com_content.category.18','Subcategory I','{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),(46,44,53,54,3,'com_content.category.19','Subcategory II','{\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),(47,27,25,26,3,'com_content.article.1','Archive article I','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),(48,27,27,28,3,'com_content.article.2','Archive article II','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),(49,27,29,30,3,'com_content.article.3','Archive article III','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),(50,42,33,34,3,'com_content.article.4','Typography','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),(51,42,35,36,3,'com_content.article.5','Module positions','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),(52,42,37,38,3,'com_content.article.6','Messages','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),(53,42,39,40,3,'com_content.article.7','Module variations','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),(54,42,41,42,3,'com_content.article.8','Page break example','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),(55,42,43,44,3,'com_content.article.9','Page Break','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),(56,44,55,56,3,'com_content.article.10','Lorem ipsum I','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),(57,44,57,58,3,'com_content.article.11','Lorem ipsum II','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),(58,44,59,60,3,'com_content.article.12','Heading off to higher top','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),(59,44,61,62,3,'com_content.article.13','Snowboard tricks are aerials or maneuvers','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),(60,44,63,64,3,'com_content.article.14','Any snowboard lovers out there?','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),(61,45,50,51,4,'com_content.article.15','Lorem ipsum subcategory','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),(62,44,65,66,3,'com_content.article.16','Get on Frozun Sports Snowboard','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),(63,44,67,68,3,'com_content.article.17','Winter Storm Brutus','{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),(64,1,125,126,1,'com_k2','com_k2','{\"core.admin\":[],\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}');


--
-- Table structure for table `#__associations`
--



CREATE TABLE `#__associations` (
  `id` varchar(50) NOT NULL COMMENT 'A reference to the associated item.',
  `context` varchar(50) NOT NULL COMMENT 'The context of the associated item.',
  `key` char(32) NOT NULL COMMENT 'The key for the association computed from an md5 on associated ids.',
  PRIMARY KEY (`context`,`id`),
  KEY `idx_key` (`key`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__associations`
--




--
-- Table structure for table `#__banner_clients`
--



CREATE TABLE `#__banner_clients` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `contact` varchar(255) NOT NULL DEFAULT '',
  `email` varchar(255) NOT NULL DEFAULT '',
  `extrainfo` text NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `metakey` text NOT NULL,
  `own_prefix` tinyint(4) NOT NULL DEFAULT '0',
  `metakey_prefix` varchar(255) NOT NULL DEFAULT '',
  `purchase_type` tinyint(4) NOT NULL DEFAULT '-1',
  `track_clicks` tinyint(4) NOT NULL DEFAULT '-1',
  `track_impressions` tinyint(4) NOT NULL DEFAULT '-1',
  PRIMARY KEY (`id`),
  KEY `idx_own_prefix` (`own_prefix`),
  KEY `idx_metakey_prefix` (`metakey_prefix`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__banner_clients`
--




--
-- Table structure for table `#__banner_tracks`
--



CREATE TABLE `#__banner_tracks` (
  `track_date` datetime NOT NULL,
  `track_type` int(10) unsigned NOT NULL,
  `banner_id` int(10) unsigned NOT NULL,
  `count` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`track_date`,`track_type`,`banner_id`),
  KEY `idx_track_date` (`track_date`),
  KEY `idx_track_type` (`track_type`),
  KEY `idx_banner_id` (`banner_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__banner_tracks`
--




--
-- Table structure for table `#__banners`
--



CREATE TABLE `#__banners` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `cid` int(11) NOT NULL DEFAULT '0',
  `type` int(11) NOT NULL DEFAULT '0',
  `name` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `imptotal` int(11) NOT NULL DEFAULT '0',
  `impmade` int(11) NOT NULL DEFAULT '0',
  `clicks` int(11) NOT NULL DEFAULT '0',
  `clickurl` varchar(200) NOT NULL DEFAULT '',
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `catid` int(10) unsigned NOT NULL DEFAULT '0',
  `description` text NOT NULL,
  `custombannercode` varchar(2048) NOT NULL,
  `sticky` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `params` text NOT NULL,
  `own_prefix` tinyint(1) NOT NULL DEFAULT '0',
  `metakey_prefix` varchar(255) NOT NULL DEFAULT '',
  `purchase_type` tinyint(4) NOT NULL DEFAULT '-1',
  `track_clicks` tinyint(4) NOT NULL DEFAULT '-1',
  `track_impressions` tinyint(4) NOT NULL DEFAULT '-1',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `reset` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `language` char(7) NOT NULL DEFAULT '',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`),
  KEY `idx_state` (`state`),
  KEY `idx_own_prefix` (`own_prefix`),
  KEY `idx_metakey_prefix` (`metakey_prefix`),
  KEY `idx_banner_catid` (`catid`),
  KEY `idx_language` (`language`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__banners`
--


INSERT INTO `#__banners` (`id`, `cid`, `type`, `name`, `alias`, `imptotal`, `impmade`, `clicks`, `clickurl`, `state`, `catid`, `description`, `custombannercode`, `sticky`, `ordering`, `metakey`, `params`, `own_prefix`, `metakey_prefix`, `purchase_type`, `track_clicks`, `track_impressions`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `reset`, `created`, `language`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `version`) VALUES (1,0,1,'Joomla!','joomla',0,4,0,'',1,3,'','<a href=\"{CLICKURL}\" target=\"_blank\">{NAME}</a>\r\n<br/>\r\nJoomla! The most popular and widely used Open Source CMS Project in the world.',0,1,'','{\"imageurl\":\"\",\"width\":\"\",\"height\":\"\",\"alt\":\"\"}',0,'',-1,0,0,0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','2012-12-03 09:05:18','*',0,'','0000-00-00 00:00:00',0,1),(2,0,1,'JoomlaCode','joomlacode',0,4,0,'',1,3,'','<a href=\"{CLICKURL}\" target=\"_blank\">{NAME}</a>\r\n<br/>\r\nJoomlaCode, development and distribution made easy.',0,2,'','{\"imageurl\":\"\",\"width\":\"\",\"height\":\"\",\"alt\":\"\"}',0,'',-1,0,0,0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','2012-12-03 09:05:49','*',0,'','0000-00-00 00:00:00',0,1),(3,0,1,'GavickPro','gavick',0,4,0,'http://gavick.com',1,3,'','<a href=\"{CLICKURL}\" target=\"_blank\">{NAME}</a>\r\n<br/>\r\nThe best Joomla! Templates.',0,3,'','{\"imageurl\":\"\",\"width\":\"\",\"height\":\"\",\"alt\":\"\"}',0,'',-1,0,0,0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','2012-12-03 09:06:25','*',0,'','0000-00-00 00:00:00',0,1),(4,0,1,'Tools','tools-gavickpro',0,4,0,'http://tools.gavick.com',1,3,'','<a href=\"{CLICKURL}\" target=\"_blank\">{NAME}</a>\r\n<br/>\r\nThe Best Joomla! Extensions',0,4,'','{\"imageurl\":\"\",\"width\":\"\",\"height\":\"\",\"alt\":\"\"}',0,'',-1,0,0,0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','2012-12-03 09:07:03','*',0,'','2012-12-03 09:07:14',944,2);


--
-- Table structure for table `#__categories`
--



CREATE TABLE `#__categories` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `asset_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to the #__assets table.',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0',
  `lft` int(11) NOT NULL DEFAULT '0',
  `rgt` int(11) NOT NULL DEFAULT '0',
  `level` int(10) unsigned NOT NULL DEFAULT '0',
  `path` varchar(255) NOT NULL DEFAULT '',
  `extension` varchar(50) NOT NULL DEFAULT '',
  `title` varchar(255) NOT NULL,
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `note` varchar(255) NOT NULL DEFAULT '',
  `description` mediumtext NOT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  `metadesc` varchar(1024) NOT NULL COMMENT 'The meta description for the page.',
  `metakey` varchar(1024) NOT NULL COMMENT 'The meta keywords for the page.',
  `metadata` varchar(2048) NOT NULL COMMENT 'JSON encoded metadata properties.',
  `created_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `created_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `modified_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL,
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`),
  KEY `cat_idx` (`extension`,`published`,`access`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_path` (`path`),
  KEY `idx_left_right` (`lft`,`rgt`),
  KEY `idx_alias` (`alias`),
  KEY `idx_language` (`language`)
) ENGINE=InnoDB AUTO_INCREMENT=20 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__categories`
--


INSERT INTO `#__categories` (`id`, `asset_id`, `parent_id`, `lft`, `rgt`, `level`, `path`, `extension`, `title`, `alias`, `note`, `description`, `published`, `checked_out`, `checked_out_time`, `access`, `params`, `metadesc`, `metakey`, `metadata`, `created_user_id`, `created_time`, `modified_user_id`, `modified_time`, `hits`, `language`, `version`) VALUES (1,0,0,0,37,0,'','system','ROOT','root','','',1,0,'0000-00-00 00:00:00',1,'{}','','','',42,'2011-01-01 00:00:01',0,'0000-00-00 00:00:00',0,'*',1),(2,27,1,1,2,1,'uncategorised','com_content','Uncategorised','uncategorised','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',42,'2011-01-01 00:00:01',0,'0000-00-00 00:00:00',0,'*',1),(3,28,1,3,4,1,'uncategorised','com_banners','Uncategorised','uncategorised','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\",\"foobar\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',42,'2011-01-01 00:00:01',0,'0000-00-00 00:00:00',0,'*',1),(4,29,1,5,6,1,'uncategorised','com_contact','Uncategorised','uncategorised','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',42,'2011-01-01 00:00:01',0,'0000-00-00 00:00:00',0,'*',1),(5,30,1,7,8,1,'uncategorised','com_newsfeeds','Uncategorised','uncategorised','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',42,'2011-01-01 00:00:01',0,'0000-00-00 00:00:00',0,'*',1),(6,31,1,9,10,1,'uncategorised','com_weblinks','Uncategorised','uncategorised','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',42,'2011-01-01 00:00:01',0,'0000-00-00 00:00:00',0,'*',1),(7,32,1,11,12,1,'uncategorised','com_users','Uncategorised','uncategorised','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',42,'2011-01-01 00:00:01',0,'0000-00-00 00:00:00',0,'*',1),(8,35,1,13,14,1,'demo','com_banners','Demo','demo','','',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',944,'2012-12-03 09:04:27',0,'0000-00-00 00:00:00',0,'*',1),(9,36,1,15,16,1,'sample-category-i','com_contact','Sample category I','sample-category-i','','<p>Category description</p>',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',944,'2012-12-03 09:08:47',0,'0000-00-00 00:00:00',0,'*',1),(10,37,1,17,18,1,'sample-category-ii','com_contact','Sample category II','sample-category-ii','','<p>Sample category description</p>',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',944,'2012-12-03 09:09:13',0,'0000-00-00 00:00:00',0,'*',1),(11,38,1,19,20,1,'gavickpro','com_newsfeeds','GavickPro','gavickpro','','',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',944,'2012-12-03 09:14:27',0,'0000-00-00 00:00:00',0,'*',1),(12,39,1,21,22,1,'joomla','com_newsfeeds','Joomla!','joomla','','',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',944,'2012-12-03 09:14:45',0,'0000-00-00 00:00:00',0,'*',1),(13,40,1,23,24,1,'joomla-weblink-category','com_weblinks','Joomla Weblink Category','joomla-weblink-category','','<p>Simple category with Joomla links!</p>',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',944,'2012-12-03 09:16:23',0,'0000-00-00 00:00:00',0,'*',1),(14,41,1,25,26,1,'gavick','com_weblinks','GavickPro','gavick','','',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',944,'2012-12-03 09:16:37',0,'0000-00-00 00:00:00',0,'*',1),(15,42,1,27,28,1,'template','com_content','Template articles','template','','',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',944,'2012-12-03 09:19:18',0,'0000-00-00 00:00:00',1,'*',1),(16,43,1,29,30,1,'layouts','com_content','Layouts','layouts','','',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',944,'2012-12-03 09:19:48',0,'0000-00-00 00:00:00',0,'*',1),(17,44,1,31,36,1,'snowboard','com_content','Snowboard','snowboard','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut ac augue ac enim interdum interdum ut vitae tellus.</p>',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',944,'2012-12-03 09:20:12',0,'0000-00-00 00:00:00',46,'*',1),(18,45,17,32,33,2,'snowboard/subcategory-1','com_content','Subcategory I','subcategory-1','','',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',944,'2012-12-03 09:20:37',0,'0000-00-00 00:00:00',0,'*',1),(19,46,17,34,35,2,'snowboard/subcategory-2','com_content','Subcategory II','subcategory-2','','',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',944,'2012-12-03 09:20:48',944,'2012-12-03 09:20:59',0,'*',1);


--
-- Table structure for table `#__contact_details`
--



CREATE TABLE `#__contact_details` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `con_position` varchar(255) DEFAULT NULL,
  `address` text,
  `suburb` varchar(100) DEFAULT NULL,
  `state` varchar(100) DEFAULT NULL,
  `country` varchar(100) DEFAULT NULL,
  `postcode` varchar(100) DEFAULT NULL,
  `telephone` varchar(255) DEFAULT NULL,
  `fax` varchar(255) DEFAULT NULL,
  `misc` mediumtext,
  `image` varchar(255) DEFAULT NULL,
  `email_to` varchar(255) DEFAULT NULL,
  `default_con` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  `user_id` int(11) NOT NULL DEFAULT '0',
  `catid` int(11) NOT NULL DEFAULT '0',
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `mobile` varchar(255) NOT NULL DEFAULT '',
  `webpage` varchar(255) NOT NULL DEFAULT '',
  `sortname1` varchar(255) NOT NULL,
  `sortname2` varchar(255) NOT NULL,
  `sortname3` varchar(255) NOT NULL,
  `language` char(7) NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if article is featured.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`published`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__contact_details`
--


INSERT INTO `#__contact_details` (`id`, `name`, `alias`, `con_position`, `address`, `suburb`, `state`, `country`, `postcode`, `telephone`, `fax`, `misc`, `image`, `email_to`, `default_con`, `published`, `checked_out`, `checked_out_time`, `ordering`, `params`, `user_id`, `catid`, `access`, `mobile`, `webpage`, `sortname1`, `sortname2`, `sortname3`, `language`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `metakey`, `metadesc`, `metadata`, `featured`, `xreference`, `publish_up`, `publish_down`, `version`, `hits`) VALUES (1,'Darren Rottman','darren-rottman','','B.S. Sound 25 Cromwell St\r\nGlen Iris\r\nVictoria, 3146. \r\nAustralia','','Australia','','','','','','images/admin_joomla.jpg','test@test.com',0,1,0,'0000-00-00 00:00:00',1,'{\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"presentation_style\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_profile\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linka\":null,\"linkb_name\":\"\",\"linkb\":null,\"linkc_name\":\"\",\"linkc\":null,\"linkd_name\":\"\",\"linkd\":null,\"linke_name\":\"\",\"linke\":\"\",\"contact_layout\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\"}',0,10,1,'','','','','','*','2012-12-03 09:12:00',944,'','0000-00-00 00:00:00',0,'','','{\"robots\":\"\",\"rights\":\"\"}',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00',1,0),(2,'Our address','our-address','','B.S. Sound 25 Cromwell St, Glen Iris\r\n','Victoria','','Australia','00-000,','+49 5241 80-0 00','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nam eget nisl eros. Suspendisse non sem leo. Suspendisse aliquet eros in erat commodo porttitor. Nam et tortor non enim ornare varius sit amet sed turpis.</p>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nam eget nisl eros. Suspendisse non sem leo. Suspendisse aliquet eros in erat commodo porttitor. Nam et tortor non enim ornare varius sit amet sed turpis.</p>','','sample@mail.com',0,1,0,'0000-00-00 00:00:00',2,'{\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"presentation_style\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_profile\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linka\":null,\"linkb_name\":\"\",\"linkb\":null,\"linkc_name\":\"\",\"linkc\":null,\"linkd_name\":\"\",\"linkd\":null,\"linke_name\":\"\",\"linke\":\"\",\"contact_layout\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\"}',0,9,1,'','','','','','*','2012-12-03 09:13:21',944,'','0000-00-00 00:00:00',0,'','','{\"robots\":\"\",\"rights\":\"\"}',1,'','0000-00-00 00:00:00','0000-00-00 00:00:00',1,0);


--
-- Table structure for table `#__content`
--



CREATE TABLE `#__content` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `asset_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to the #__assets table.',
  `title` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `introtext` mediumtext NOT NULL,
  `fulltext` mediumtext NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `catid` int(10) unsigned NOT NULL DEFAULT '0',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `images` text NOT NULL,
  `urls` text NOT NULL,
  `attribs` varchar(5120) NOT NULL,
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `metadata` text NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if article is featured.',
  `language` char(7) NOT NULL COMMENT 'The language code for the article.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`state`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=InnoDB AUTO_INCREMENT=18 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__content`
--


INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `introtext`, `fulltext`, `state`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES (1,47,'Archive article I','archive-article-i','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce ut metus augue, id laoreet dolor. Maecenas volutpat tristique felis, vel placerat sapien congue at. Vivamus vel massa sapien. Sed tempus mattis libero, at consequat neque viverra sed. Sed tortor metus, rhoncus id facilisis at, mattis eget nisi. Curabitur vel tortor felis. Sed mattis diam eu urna fermentum sed porta arcu auctor. Phasellus volutpat, sem feugiat malesuada cursus, magna dui adipiscing lectus, a pharetra leo enim quis lectus. Donec ornare magna a erat euismod egestas. Morbi non arcu sit amet diam dapibus aliquet vel nec massa. Aliquam fermentum sollicitudin lorem, auctor vehicula felis pellentesque a. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed risus magna, mollis sed ultricies ut, pellentesque a metus. Duis eu vestibulum nisl. Mauris blandit elit a turpis pellentesque semper. Integer eget urna erat, et hendrerit magna. In a quam urna, at sollicitudin tellus. <br /><br />Donec ipsum erat, gravida sit amet laoreet et, adipiscing nec nibh. Vivamus ultrices faucibus nulla ut rhoncus. Nunc non posuere sapien. Praesent nec elit vitae sem posuere elementum eget tincidunt lorem. Quisque ornare malesuada dui nec pretium. Ut in mauris sit amet nunc cursus vehicula at id dolor. In enim nisi, venenatis quis lacinia id, congue sed arcu. Morbi nec risus eget augue porttitor pulvinar. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nam quis enim in lacus aliquam tempus eu nec enim. Phasellus adipiscing facilisis est, sit amet volutpat libero vehicula in. Phasellus tincidunt convallis nisl sit amet luctus. Donec leo quam, sollicitudin vel porttitor at, cursus sed tellus. Sed dapibus massa id leo faucibus tempor molestie purus placerat. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Pellentesque tempor fringilla augue sit amet bibendum. Nam vitae hendrerit nulla.</p>','',2,2,'2012-12-03 09:21:53',944,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2012-12-03 09:21:53','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',1,2,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(2,48,'Archive article II','archive-article-ii','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce ut metus augue, id laoreet dolor. Maecenas volutpat tristique felis, vel placerat sapien congue at. Vivamus vel massa sapien. Sed tempus mattis libero, at consequat neque viverra sed. Sed tortor metus, rhoncus id facilisis at, mattis eget nisi. Curabitur vel tortor felis. Sed mattis diam eu urna fermentum sed porta arcu auctor. Phasellus volutpat, sem feugiat malesuada cursus, magna dui adipiscing lectus, a pharetra leo enim quis lectus. Donec ornare magna a erat euismod egestas. Morbi non arcu sit amet diam dapibus aliquet vel nec massa. Aliquam fermentum sollicitudin lorem, auctor vehicula felis pellentesque a. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed risus magna, mollis sed ultricies ut, pellentesque a metus. Duis eu vestibulum nisl. Mauris blandit elit a turpis pellentesque semper. Integer eget urna erat, et hendrerit magna. In a quam urna, at sollicitudin tellus. <br /><br />Donec ipsum erat, gravida sit amet laoreet et, adipiscing nec nibh. Vivamus ultrices faucibus nulla ut rhoncus. Nunc non posuere sapien. Praesent nec elit vitae sem posuere elementum eget tincidunt lorem. Quisque ornare malesuada dui nec pretium. Ut in mauris sit amet nunc cursus vehicula at id dolor. In enim nisi, venenatis quis lacinia id, congue sed arcu. Morbi nec risus eget augue porttitor pulvinar. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nam quis enim in lacus aliquam tempus eu nec enim. Phasellus adipiscing facilisis est, sit amet volutpat libero vehicula in. Phasellus tincidunt convallis nisl sit amet luctus. Donec leo quam, sollicitudin vel porttitor at, cursus sed tellus. Sed dapibus massa id leo faucibus tempor molestie purus placerat. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Pellentesque tempor fringilla augue sit amet bibendum. Nam vitae hendrerit nulla.</p>','',2,2,'2012-12-03 09:22:03',944,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2012-12-03 09:22:03','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',1,1,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(3,49,'Archive article III','archive-article-iii','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce ut metus augue, id laoreet dolor. Maecenas volutpat tristique felis, vel placerat sapien congue at. Vivamus vel massa sapien. Sed tempus mattis libero, at consequat neque viverra sed. Sed tortor metus, rhoncus id facilisis at, mattis eget nisi. Curabitur vel tortor felis. Sed mattis diam eu urna fermentum sed porta arcu auctor. Phasellus volutpat, sem feugiat malesuada cursus, magna dui adipiscing lectus, a pharetra leo enim quis lectus. Donec ornare magna a erat euismod egestas. Morbi non arcu sit amet diam dapibus aliquet vel nec massa. Aliquam fermentum sollicitudin lorem, auctor vehicula felis pellentesque a. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed risus magna, mollis sed ultricies ut, pellentesque a metus. Duis eu vestibulum nisl. Mauris blandit elit a turpis pellentesque semper. Integer eget urna erat, et hendrerit magna. In a quam urna, at sollicitudin tellus. <br /><br />Donec ipsum erat, gravida sit amet laoreet et, adipiscing nec nibh. Vivamus ultrices faucibus nulla ut rhoncus. Nunc non posuere sapien. Praesent nec elit vitae sem posuere elementum eget tincidunt lorem. Quisque ornare malesuada dui nec pretium. Ut in mauris sit amet nunc cursus vehicula at id dolor. In enim nisi, venenatis quis lacinia id, congue sed arcu. Morbi nec risus eget augue porttitor pulvinar. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nam quis enim in lacus aliquam tempus eu nec enim. Phasellus adipiscing facilisis est, sit amet volutpat libero vehicula in. Phasellus tincidunt convallis nisl sit amet luctus. Donec leo quam, sollicitudin vel porttitor at, cursus sed tellus. Sed dapibus massa id leo faucibus tempor molestie purus placerat. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Pellentesque tempor fringilla augue sit amet bibendum. Nam vitae hendrerit nulla.</p>','',2,2,'2012-12-03 09:22:11',944,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2012-12-03 09:22:11','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',1,0,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(4,50,'Typography','typography','<p>It is possible with templates which have a typography page to show you how you can use e.g. headline tags in order to structure your content in a better way. Below, we present rebuilt and refreshed typographical aspects of Gavern Framework. In order to use it, you have to use a plug in which is delivered in a package with a template or use HTML code.</p>\r\n<div id=\"warnings\" class=\"demo-typoDiv typoDesc\">\r\n<h4 class=\"demo-typo\">Warnings</h4>\r\n<p class=\"gkInfo1\">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum venenatis orci non tortor accumsan at accumsan tortor congue.</p>\r\n<p class=\"gkTips1\">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum venenatis orci non tortor accumsan at accumsan tortor congue.</p>\r\n<p class=\"gkWarning1\">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum venenatis orci non tortor accumsan at accumsan tortor congue.</p>\r\n</div>\r\n<div class=\"demo-typoDiv\">\r\n<h4 class=\"demo-typo\">Headings</h4>\r\n<div class=\"demo-typo_padd\">\r\n<h1>This is heading 1</h1>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer semper egestas nunc in volutpat. Fusce adipiscing velit ac eros tempor iaculis. Phasellus venenatis mollis augue, non posuere odio placerat in. Etiam volutpat ultrices lectus. Fusce eu felis erat.</p>\r\n<h2>This is heading 2</h2>\r\n<p>Cras diam justo, sodales quis lobortis sed, lobortis vel mauris. Sed a mollis nunc. Quisque semper condimentum lectus, eget laoreet ipsum auctor et. Quisque sagittis luctus augue, id fringilla enim euismod quis. Nullam blandit, elit at euismod rutrum, tortor nibh posuere mauris, in volutpat diam ante ac dui.</p>\r\n<h3>This is heading 3</h3>\r\n<p>Vivamus rhoncus arcu sit amet est tristique convallis nec vel eros. Vestibulum euismod luctus velit quis porta. Aliquam varius placerat mauris sed vehicula. Integer porta facilisis sapien, in tempus lorem mattis molestie. Suspendisse potenti.</p>\r\n<h4>This is heading 4</h4>\r\n<p>Proin urna erat, egestas vel consectetur at, accumsan at purus. Donec est risus, facilisis dignissim placerat nec, euismod lacinia nisi. Nam ac sem sed quam sollicitudin condimentum et eu neque. Nunc enim urna, ultricies ac mollis pretium, imperdiet hendrerit massa.</p>\r\n</div>\r\n<div class=\"demo-typo_padd\">\r\n<p class=\"gkHeadline\">This is a headline.</p>\r\n<p class=\"gkSubHeadline\">This is a subheadline.</p>\r\n<p>Use <strong>&lt;p class=\"gkHeadling\"&gt;for headline&lt;/p&gt;</strong>.Use <strong>&lt;p class=\"gkSubHeadline\"&gt;for subheadline&lt;/p&gt;</strong>.Proin urna erat, egestas vel consectetur at, accumsan at purus. Donec est risus, facilisis dignissim placerat nec, euismod lacinia nisi. Nam ac sem sed quam sollicitudin condimentum et eu neque.</p>\r\n<p class=\"gkSmallHeadline\">This is a small headline</p>\r\n<p class=\"gkLargeHeadline\">This is a large headline</p>\r\n<p>Use <strong>&lt;p class=\"gkHeadling\"&gt;for headline&lt;/p&gt;</strong>.Use <strong>&lt;p class=\"gkSubHeadline\"&gt;for subheadline&lt;/p&gt;</strong>.Proin urna erat, egestas vel consectetur at, accumsan at purus. Donec est risus, facilisis dignissim placerat nec, euismod lacinia nisi. Nam ac sem sed quam sollicitudin condimentum et eu neque.</p>\r\n</div>\r\n</div>\r\n<div class=\"demo-typoDiv typoDesc\">\r\n<h4 class=\"demo-typo\">Icon set</h4>\r\n<div class=\"demo-typo-col3\">\r\n<div class=\"demo-typo_padd\">\r\n<p class=\"gklink\"><strong>gklink</strong> message <br /> <small>Use &lt;p class=\"gklink\"&gt;Txt...&lt;/p&gt;</small>.</p>\r\n<p class=\"gkinfo\"><strong>gkinfo</strong> message <br /> <small>Use &lt;p class=\"gkinfo\"&gt;Txt...&lt;/p&gt;</small>.</p>\r\n<p class=\"gkpin\"><strong>gkpin</strong> message <br /> <small>Use &lt;p class=\"gkpin\"&gt;Txt...&lt;/p&gt;</small>.</p>\r\n<p class=\"gkfile1\"><strong>file1</strong> message <br /> <small>Use &lt;p class=\"gkfile1\"&gt;Txt...&lt;/p&gt;</small>.</p>\r\n<p class=\"gkfile2\"><strong>kfile2</strong> message <br /> <small>Use &lt;p class=\"gkfile2\"&gt;Txt...&lt;/p&gt;</small>.</p>\r\n<p class=\"gksettings\"><strong>gksettings</strong> message <br /> <small>Use &lt;p class=\"gksettings\"&gt;Txt...&lt;/p&gt;</small>.</p>\r\n</div>\r\n</div>\r\n<div class=\"demo-typo-col3\">\r\n<div class=\"demo-typo_padd\">\r\n<p class=\"gkmic\"><strong>gkmic</strong> message <br /> <small>Use &lt;p class=\"gkmic\"&gt;Txt...&lt;/p&gt;</small>.</p>\r\n<p class=\"gkvideo\"><strong>gkvideo</strong> message <br /> <small>Use &lt;p class=\"gkvideo\"&gt;Txt...&lt;/p&gt;</small>.</p>\r\n<p class=\"gkvoice\"><strong>gkvoice</strong> message <br /> <small>Use &lt;p class=\"gkvoice\"&gt;Txt...&lt;/p&gt;</small>.</p>\r\n<p class=\"gklocked\"><strong>gklocked</strong> message <br /> <small>Use &lt;p class=\"gklocked\"&gt;Txt...&lt;/p&gt;</small>.</p>\r\n<p class=\"gkunlocked\"><strong>gkunlocked</strong> message <br /> <small>Use &lt;p class=\"gkunlocked\"&gt;Txt...&lt;/p&gt;</small>.</p>\r\n<p class=\"gkstats\"><strong>stats</strong> message <br /> <small>Use &lt;p class=\"gkstats\"&gt;Txt...&lt;/p&gt;</small>.</p>\r\n</div>\r\n</div>\r\n<div class=\"demo-typo-col3\">\r\n<div class=\"demo-typo_padd\">\r\n<p class=\"gklocation\"><strong>location</strong> message <br /> <small>Use &lt;p class=\"gklocation\"&gt;Txt...&lt;/p&gt;</small>.</p>\r\n<p class=\"gkmap\"><strong>map</strong> message <br /> <small>Use &lt;p class=\"gkmap\"&gt;Txt...!&lt;/p&gt;</small>.</p>\r\n<p class=\"gktag\"><strong>tag</strong> message <br /> <small>Use &lt;p class=\"gktag\"&gt;Txt...!&lt;/p&gt;</small>.</p>\r\n<p class=\"gkcomment\"><strong>gkcomment</strong> message <br /> <small>Use &lt;p class=\"gkcomment\"&gt;Txt...&lt;/p&gt;</small>.</p>\r\n<p class=\"gkbook\"><strong>book</strong> message <br /> <small>Use &lt;p class=\"gkbook\"&gt;Txt...&lt;/p&gt;</small>.</p>\r\n<p class=\"gkalarm\"><strong>gkalarm</strong> message <br /> <small>Use &lt;p class=\"gkalarm\"&gt;Txt...&lt;/p&gt;</small>.</p>\r\n</div>\r\n</div>\r\n</div>\r\n<h4 class=\"demo-typo\"><a name=\"tooltips\"></a> Tooltips</h4>\r\n<p>Here are some examples of a <a class=\"gkTooltip\" href=\"#\">Classic<span class=\"classicTooltip\">This is just an example of what you can do using a CSS tooltip, feel free to get creative and produce your own!</span></a> , <a class=\"gkTooltip\" href=\"#\">Critical<span class=\"customTooltip criticalTooltip\"><em>Critical</em>This is just an example of what you can do using a CSS tooltip, feel free to get creative and produce your own!</span></a> , <a class=\"gkTooltip\" href=\"#\">Help<span class=\"customTooltip helpTooltip\"><em>Help</em>This is just an example of what you can do using a CSS tooltip, feel free to get creative and produce your own!</span></a> , <a class=\"gkTooltip\" href=\"#\">Information<span class=\"customTooltip infoTooltip\"><em>Information</em>This is just an example of what you can do using a CSS tooltip, feel free to get creative and produce your own!</span></a> and <a class=\"gkTooltip\" href=\"#\">Warning<span class=\"customTooltip warningTooltip\"><em>Warning</em>This is just an example of what you can do using a CSS tooltip, feel free to get creative and produce your own!</span></a> CSS powered tooltip. <br /> This is just an example of what you can do so feel free to get creative and produce your own!</p>\r\n<div class=\"demo-typoDiv typoDesc \">\r\n<h4 class=\"demo-typo\">Highlights</h4>\r\n<div class=\"demo-typo-col2\">\r\n<div class=\"demo-typo_padd\">\r\n<p>This is a <span class=\"gkHighlight1\">highlight phrase</span>. <br /> <small>Use &lt;span class=\"gkHighlight1\"&gt;Your highlight phrase goes here!&lt;/span&gt;</small>.</p>\r\n<p>This is a <span class=\"gkHighlight2\">highlight phrase</span>. <br /> <small>Use &lt;span class=\"gkHighlight2\"&gt;Your highlight phrase goes here!&lt;/span&gt;</small>.</p>\r\n</div>\r\n</div>\r\n<div class=\"demo-typo-col2\">\r\n<div class=\"demo-typo_padd\">\r\n<p>This is a <span class=\"gkHighlight3\">highlight phrase</span>. <br /> <small>Use &lt;span class=\"gkHighlight3\"&gt;Your highlight phrase goes here!&lt;/span&gt;</small>.</p>\r\n<p>This is a <span class=\"gkHighlight4\">highlight phrase</span>.<br /> <small>Use &lt;span class=\"gkHighlight4\"&gt;Your highlight phrase goes here!&lt;/span&gt;</small>.</p>\r\n</div>\r\n</div>\r\n</div>\r\n<div class=\"demo-typoDiv typoDesc\">\r\n<h4 class=\"demo-typo\">Code</h4>\r\n<div class=\"demo-typo-col3\">\r\n<div class=\"demo-typo_padd\">\r\n<pre>#wrapper {<br />  position: relative;<br />  float: left;<br />  display: block;<br />}<br />\r\n</pre>\r\n<p><small>Use &lt;pre&gt; or &lt;div class=\"gkCode1\"&gt;Here goes your code&lt;/div&gt;</small></p>\r\n</div>\r\n</div>\r\n<div class=\"demo-typo-col3\">\r\n<div class=\"demo-typo_padd\">\r\n<div class=\"gkCode2\">#wrapper {<br /> position: relative;<br /> float: left;<br /> display: block;<br /> }</div>\r\n<p><small>Use &lt;div class=\"gkCode2\"&gt;Here goes your code&lt;/div&gt;</small></p>\r\n</div>\r\n</div>\r\n<div class=\"demo-typo-col3\">\r\n<div class=\"demo-typo_padd\">\r\n<div class=\"gkCode3\">\r\n<h4>File</h4>\r\n#wrapper {<br /> position: relative;<br /> float: left;<br /> display: block;<br /> }</div>\r\n<p><small>Use &lt;div class=\"gkCode3\"&gt;&lt;h4&gt;Name of your file&lt;/h4&gt;Here goes your code&lt;/div&gt;</small></p>\r\n</div>\r\n</div>\r\n</div>\r\n<div class=\"demo-typoDiv typoDesc\">\r\n<h4 class=\"demo-typo\">Unordered lists</h4>\r\n<div class=\"demo-typo-col4\">\r\n<div class=\"demo-typo_padd\">\r\n<p><small>&lt;ul class=\"gkBullet1\"&gt;</small></p>\r\n<ul class=\"gkBullet1\">\r\n<li>Lorem ipsum dolor sit amet.</li>\r\n<li>Lorem ipsum dolor sit amet.</li>\r\n<li>Lorem ipsum dolor sit amet.</li>\r\n</ul>\r\n</div>\r\n</div>\r\n<div class=\"demo-typo-col4\">\r\n<div class=\"demo-typo_padd\">\r\n<p><small>&lt;ul class=\"gkBullet2\"&gt;</small></p>\r\n<ul class=\"gkBullet2\">\r\n<li>Lorem ipsum dolor sit amet.</li>\r\n<li>Lorem ipsum dolor sit amet.</li>\r\n<li>Lorem ipsum dolor sit amet.</li>\r\n</ul>\r\n</div>\r\n</div>\r\n<div class=\"demo-typo-col4\">\r\n<div class=\"demo-typo_padd\">\r\n<p><small>&lt;ul class=\"gkBullet3\"&gt;</small></p>\r\n<ul class=\"gkBullet3\">\r\n<li>Lorem ipsum dolor sit amet.</li>\r\n<li>Lorem ipsum dolor sit amet.</li>\r\n<li>Lorem ipsum dolor sit amet.</li>\r\n</ul>\r\n</div>\r\n</div>\r\n<div class=\"demo-typo-col4\">\r\n<div class=\"demo-typo_padd\">\r\n<p><small>&lt;ul class=\"gkBullet4\"&gt;</small></p>\r\n<ul class=\"gkBullet4\">\r\n<li>Lorem ipsum dolor sit amet.</li>\r\n<li>Lorem ipsum dolor sit amet.</li>\r\n<li>Lorem ipsum dolor sit amet.</li>\r\n</ul>\r\n</div>\r\n</div>\r\n</div>\r\n<div class=\"demo-typoDiv typoDesc\">\r\n<div class=\"demo-typo-col4\">\r\n<div class=\"demo-typo_padd\">\r\n<p><small>&lt;ul class=\"gkCircle1\"&gt;</small></p>\r\n<ul class=\"gkCircle1\">\r\n<li>Lorem ipsum dolor sit amet.</li>\r\n<li>Lorem ipsum dolor sit amet.</li>\r\n<li>Lorem ipsum dolor sit amet.</li>\r\n</ul>\r\n</div>\r\n</div>\r\n<div class=\"demo-typo-col4\">\r\n<div class=\"demo-typo_padd\">\r\n<p><small>&lt;ul class=\"gkCircle2\"&gt;</small></p>\r\n<ul class=\"gkCircle2\">\r\n<li>Lorem ipsum dolor sit amet.</li>\r\n<li>Lorem ipsum dolor sit amet.</li>\r\n<li>Lorem ipsum dolor sit amet.</li>\r\n</ul>\r\n</div>\r\n</div>\r\n<div class=\"demo-typo-col4\">\r\n<div class=\"demo-typo_padd\">\r\n<p><small>&lt;ul class=\"gkSquare1\"&gt;</small></p>\r\n<ul class=\"gkSquare1\">\r\n<li>Lorem ipsum dolor sit amet.</li>\r\n<li>Lorem ipsum dolor sit amet.</li>\r\n<li>Lorem ipsum dolor sit amet.</li>\r\n</ul>\r\n</div>\r\n</div>\r\n<div class=\"demo-typo-col4\">\r\n<div class=\"demo-typo_padd\">\r\n<p><small>&lt;ul class=\"gkSquare2\"&gt;</small></p>\r\n<ul class=\"gkSquare2\">\r\n<li>Lorem ipsum dolor sit amet.</li>\r\n<li>Lorem ipsum dolor sit amet.</li>\r\n<li>Lorem ipsum dolor sit amet.</li>\r\n</ul>\r\n</div>\r\n</div>\r\n</div>\r\n<div class=\"demo-typoDiv typoDesc\">\r\n<h4 class=\"demo-typo\">Ordered lists</h4>\r\n<div class=\"demo-typo-col4\">\r\n<div class=\"demo-typo_padd\">\r\n<p><small>&lt;ol class=\"gkRoman\"&gt;</small></p>\r\n<ol class=\"gkRoman\">\r\n<li>Lorem ipsum dolor sit amet.</li>\r\n<li>Lorem ipsum dolor sit amet.</li>\r\n<li>Lorem ipsum dolor sit amet.</li>\r\n<li>Lorem ipsum dolor sit amet.</li>\r\n</ol></div>\r\n</div>\r\n<div class=\"demo-typo-col4\">\r\n<div class=\"demo-typo_padd\">\r\n<p><small>&lt;ol class=\"gkDec\"&gt;</small></p>\r\n<ol class=\"gkDec\">\r\n<li>Lorem ipsum dolor sit amet.</li>\r\n<li>Lorem ipsum dolor sit amet.</li>\r\n<li>Lorem ipsum dolor sit amet.</li>\r\n<li>Lorem ipsum dolor sit amet.</li>\r\n</ol></div>\r\n</div>\r\n<div class=\"demo-typo-col4\">\r\n<div class=\"demo-typo_padd\">\r\n<p><small>&lt;ol class=\"gkAlpha\"&gt;</small></p>\r\n<ol class=\"gkAlpha\">\r\n<li>Lorem ipsum dolor sit amet.</li>\r\n<li>Lorem ipsum dolor sit amet.</li>\r\n<li>Lorem ipsum dolor sit amet.</li>\r\n<li>Lorem ipsum dolor sit amet.</li>\r\n</ol></div>\r\n</div>\r\n<div class=\"demo-typo-col4\">\r\n<div class=\"demo-typo_padd\">\r\n<p><small>&lt;ol class=\"gkDecimalLeadingZero\"&gt;</small></p>\r\n<ol class=\"gkDecimalLeadingZero\">\r\n<li>Lorem ipsum</li>\r\n<li>Lorem ipsum</li>\r\n<li>Lorem ipsum</li>\r\n<li>Lorem ipsum</li>\r\n</ol></div>\r\n</div>\r\n</div>\r\n<div class=\"demo-typoDiv typoDesc\">\r\n<h4 class=\"demo-typo\">numBlocks</h4>\r\n<div class=\"demo-typo-col3\">\r\n<div class=\"demo-typo_padd\">\r\n<p><small>&lt;p class=\"numblocks num-1\"&gt;&lt;span&gt;here goes a number&lt;/span&gt;and here text of element&lt;/p&gt;</small></p>\r\n<p class=\"numblocks num-1\"><span>01</span> Lorem ipsum dolor sit amet, consectetur adipiscing elit.</p>\r\n<p class=\"numblocks num-1\"><span>02</span> Lorem ipsum dolor sit amet, consectetur adipiscing elit.</p>\r\n</div>\r\n</div>\r\n<div class=\"demo-typo-col3\">\r\n<div class=\"demo-typo_padd\">\r\n<p><small>&lt;p class=\"numblocks num-2\"&gt;&lt;span&gt;here goes a number&lt;/span&gt;and here text of element&lt;/p&gt;</small></p>\r\n<p class=\"numblocks num-2\"><span>01</span> Lorem ipsum dolor sit amet, consectetur adipiscing elit.</p>\r\n<p class=\"numblocks num-2\"><span>02</span> Lorem ipsum dolor sit amet, consectetur adipiscing elit.</p>\r\n</div>\r\n</div>\r\n<div class=\"demo-typo-col3\">\r\n<div class=\"demo-typo_padd\">\r\n<p><small>&lt;p class=\"numblocks num-3\"&gt;&lt;span&gt;here goes a number&lt;/span&gt;and here text of element&lt;/p&gt;</small></p>\r\n<p class=\"numblocks num-3\"><span>01</span> Lorem ipsum dolor sit amet, consectetur adipiscing elit.</p>\r\n<p class=\"numblocks num-3\"><span>02</span> Lorem ipsum dolor sit amet, consectetur adipiscing elit.</p>\r\n</div>\r\n</div>\r\n</div>\r\n<div class=\"demo-typoDiv typoDesc\">\r\n<h4 class=\"demo-typo\">Blocks</h4>\r\n<div class=\"demo-typo-col3\">\r\n<div class=\"demo-typo_padd\">\r\n<div class=\"gkblock-1\">Lorem ipsum dolor sit amet, consectetuer adipiscing elit.\r\n<p><small> Use &lt;div class=\"gkblock-1\"&gt;content here... &lt;/div&gt;</small></p>\r\n</div>\r\n<div class=\"gkblock-4\">Lorem ipsum dolor sit amet, consectetuer adipiscing elit.\r\n<p><small> Use &lt;div class=\"gkblock-4\"&gt;content here... &lt;/div&gt;</small></p>\r\n</div>\r\n<div class=\"gkblock-7\">Lorem ipsum dolor sit amet, consectetuer adipiscing elit.\r\n<p><small> Use &lt;div class=\"gkblock-7\"&gt;content here... &lt;/div&gt;</small></p>\r\n</div>\r\n</div>\r\n</div>\r\n<div class=\"demo-typo-col3\">\r\n<div class=\"demo-typo_padd\">\r\n<div class=\"gkblock-2\">Lorem ipsum dolor sit amet, consectetuer adipiscing elit.\r\n<p><small> Use &lt;div class=\"gkblock-2\"&gt;content here... &lt;/div&gt;</small></p>\r\n</div>\r\n<div class=\"gkblock-5\">Lorem ipsum dolor sit amet, consectetuer adipiscing elit.\r\n<p><small> Use &lt;div class=\"gkblock-5\"&gt;content here... &lt;/div&gt;</small></p>\r\n</div>\r\n<div class=\"gkblock-8\">Lorem ipsum dolor sit amet, consectetuer adipiscing elit.\r\n<p><small> Use &lt;div class=\"gkblock-8\"&gt;content here... &lt;/div&gt;</small></p>\r\n</div>\r\n</div>\r\n</div>\r\n<div class=\"demo-typo-col3\">\r\n<div class=\"demo-typo_padd\">\r\n<div class=\"gkblock-3\">Lorem ipsum dolor sit amet, consectetuer adipiscing elit.\r\n<p><small> Use &lt;div class=\"gkblock-3\"&gt;content here... &lt;/div&gt;</small></p>\r\n</div>\r\n<div class=\"gkblock-6\">Lorem ipsum dolor sit amet, consectetuer adipiscing elit.\r\n<p><small> Use &lt;div class=\"gkblock-6\"&gt;content here... &lt;/div&gt;</small></p>\r\n</div>\r\n<div class=\"gkblock-9\">Lorem ipsum dolor sit amet, consectetuer adipiscing elit.\r\n<p><small> Use &lt;div class=\"gkblock-9\"&gt;content here... &lt;/div&gt;</small></p>\r\n</div>\r\n</div>\r\n</div>\r\n</div>\r\n<div class=\"demo-typoDiv demo-typo-col2 typoDesc\">\r\n<div class=\"demo-typo_padd\">\r\n<h4 class=\"demo-typo\">Legends</h4>\r\n<div class=\"gkLegend1\">\r\n<h4>Legend</h4>\r\n<p>Lorem ipsum dolor sit amet, consectetuer adipiscing elit.</p>\r\n<p><small> Use &lt;div class=\"gkLegend1\"&gt; &lt;h4&gt; Title &lt;/h4&gt; &lt;p&gt;and here text.&lt;/p&gt; &lt;/div&gt;</small></p>\r\n</div>\r\n<div class=\"gkLegend2\">\r\n<h4>Legend</h4>\r\n<p>Lorem ipsum dolor sit amet, consectetuer adipiscing elit.</p>\r\n<p><small> Use &lt;div class=\"gkLegend2\"&gt; &lt;h4&gt; Title &lt;/h4&gt; &lt;p&gt;and here text.&lt;/p&gt; &lt;/div&gt;</small></p>\r\n</div>\r\n<div class=\"gkLegend3\">\r\n<h4>Legend</h4>\r\n<p>Lorem ipsum dolor sit amet, consectetuer adipiscing elit.</p>\r\n<p><small> Use &lt;div class=\"gkLegend3\"&gt; &lt;h4&gt; Title &lt;/h4&gt; &lt;p&gt;and here text.&lt;/p&gt; &lt;/div&gt;</small></p>\r\n</div>\r\n<div class=\"gkLegend4\">\r\n<h4>Legend</h4>\r\n<p>Lorem ipsum dolor sit amet, consectetuer adipiscing elit.</p>\r\n<p><small> Use &lt;div class=\"gkLegend4\"&gt; &lt;h4&gt; Title &lt;/h4&gt; &lt;p&gt;and here text.&lt;/p&gt; &lt;/div&gt;</small></p>\r\n</div>\r\n</div>\r\n</div>\r\n<div class=\"demo-typo-col2 typoDesc\">\r\n<div class=\"demo-typo_padd\">\r\n<h4 class=\"demo-typo\">Bubbles</h4>\r\n<div class=\"bubble-1\">Lorem ipsum dolor sit amet, consectetuer adipiscing elit.\r\n<p><small>Use &lt;div class=\"bubble-1\"&gt;content here... &lt;cite&gt;Author name&lt;/cite&gt;&lt;/div&gt;</small></p>\r\n<cite>Robert Gavick</cite></div>\r\n<div class=\"bubble-2\">Lorem ipsum dolor sit amet, consectetuer adipiscing elit.\r\n<p><small>Use &lt;div class=\"bubble-3\"&gt;content here... &lt;cite&gt;Author name&lt;/cite&gt;&lt;/div&gt;</small></p>\r\n<cite>Robert Gavick</cite></div>\r\n<div class=\"bubble-3\">Lorem ipsum dolor sit amet, consectetuer adipiscing elit.\r\n<p><small>Use &lt;div class=\"bubble-5\"&gt;content here... &lt;cite&gt;Author name&lt;/cite&gt;&lt;/div&gt;</small></p>\r\n<cite>Robert Gavick</cite></div>\r\n</div>\r\n</div>\r\n<div class=\"demo-typoDiv typoDesc\">\r\n<h4 class=\"demo-typo\">Abbrs and acronyms</h4>\r\n<p>This is a sample of an abbreviation <abbr title=\"Doctor\">Dr</abbr>. Use <strong>&lt;abbr title=\"Here goes full word or phrase\"&gt;here goes an abbreviation&lt;/abbr&gt;</strong></p>\r\n<p> </p>\r\n<p>This is a sample of an acronym <acronym title=\"North Atlantic Treaty    Organization\">NATO</acronym>. Use <strong>&lt;acronym title=\"Here goes full phrase\"&gt;here goes an acronym&lt;/abbr&gt;</strong></p>\r\n<p> </p>\r\n</div>\r\n<div class=\"demo-typoDiv typoDesc\">\r\n<h4 class=\"demo-typo\">Dropcaps</h4>\r\n<div class=\"demo-typo-col3\">\r\n<div class=\"demo-typo_padd\">\r\n<p><span class=\"gkDropcap1\">T</span>his is a sample text with Dropcap. <br /> Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum condimentum pulvinar justo, sed faucibus ligula...</p>\r\n<p><small>Use &lt;p&gt; &lt;span class=\"gkDropcap1\"&gt;t&lt;/span&gt;his is a sample text with Dropcap. &lt;/p&gt;.</small></p>\r\n</div>\r\n</div>\r\n<div class=\"demo-typo-col3\">\r\n<div class=\"demo-typo_padd\">\r\n<p class=\"gkDropcap2\"><span class=\"gkDropcap2\">T</span>his is a sample text with Dropcap. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum condimentum pulvinar...</p>\r\n<p><small>Use &lt;p class=\"gkDropcap2\"&gt; &lt;span class=\"gkDropcap2\"&gt;t&lt;/span&gt;his is a sample text with Dropcap. &lt;/p&gt;.</small></p>\r\n</div>\r\n</div>\r\n<div class=\"demo-typo-col3\">\r\n<div class=\"demo-typo_padd\">\r\n<p><span class=\"gkDropcap3\">T</span>his is a sample text with Dropcap. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum condimentum pulvinar justo, sed faucibus ligula</p>\r\n<p><small>Use &lt;p&gt; &lt;span class=\"gkDropcap3\"&gt;t&lt;/span&gt;his is a sample text with Dropcap. &lt;/p&gt;.</small></p>\r\n</div>\r\n</div>\r\n</div>\r\n<div class=\"demo-typoDiv typoDesc\">\r\n<h4 class=\"demo-typo\">Blockquotes</h4>\r\n<div class=\"demo-typo-col2\">\r\n<div class=\"demo-typo_padd\">\r\n<blockquote>\r\n<div class=\"gkBlockquote1\">\r\n<div>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam rutrum blandit purus, vitae pharetra odio interdum sit amet.\r\n<p><small>Use &lt; blockquote&gt;&lt;div class=\"gkBlockquote1\"&gt;&lt;div&gt; Your quoted text goes here!&lt; /div&gt;&lt; /div&gt;&lt; /blockquote &gt;</small></p>\r\n</div>\r\n</div>\r\n</blockquote>\r\n</div>\r\n</div>\r\n<div class=\"demo-typo-col2\">\r\n<div class=\"demo-typo_padd\">\r\n<blockquote>\r\n<div class=\"gkBlockquote2\">\r\n<div>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam rutrum blandit purus, vitae pharetra odio interdum sit amet.\r\n<p><small>Use &lt; blockquote&gt;&lt;div class=\"gkBlockquote2\"&gt;&lt;div&gt; Your quoted text goes here!&lt; /div&gt;&lt; /div&gt;&lt; /blockquote &gt;</small></p>\r\n</div>\r\n</div>\r\n</blockquote>\r\n</div>\r\n</div>\r\n<div class=\"demo-typo-col2\">\r\n<div class=\"demo-typo_padd\">\r\n<blockquote>\r\n<div class=\"gkBlockquote3\">\r\n<div>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam rutrum blandit purus, vitae pharetra odio interdum sit amet.\r\n<p><small>Use &lt; blockquote&gt;&lt;div class=\"gkBlockquote3\"&gt;&lt;div&gt; Your quoted text goes here!&lt; /div&gt;&lt; /div&gt;&lt; /blockquote &gt;</small></p>\r\n</div>\r\n</div>\r\n</blockquote>\r\n</div>\r\n</div>\r\n<div class=\"demo-typo-col2\">\r\n<div class=\"demo-typo_padd\">\r\n<blockquote>\r\n<div class=\"gkBlockquote4\">\r\n<div>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam rutrum blandit purus, vitae pharetra odio interdum sit amet.\r\n<p><small>Use &lt; blockquote&gt;&lt;div class=\"gkBlockquote4\"&gt;&lt;div&gt; Your quoted text goes here!&lt; /div&gt;&lt; /div&gt;&lt; /blockquote &gt;</small></p>\r\n</div>\r\n</div>\r\n</blockquote>\r\n</div>\r\n</div>\r\n</div>\r\n<div class=\"demo-typoDiv typoDesc\">\r\n<h4 class=\"demo-typo\">Floated blocks</h4>\r\n<p><small>&lt;p&gt; Here goes main part of the text &lt;span class=\"gkBlockTextLeft\"&gt;Block of text&lt;/span&gt;rest of the text&lt;/p&gt; </small></p>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum condimentum pulvinar justo, sed faucibus ligula feugiat ac. Morbi quis enim nulla, vel congue augue. Duis quis quam sed purus porta eleifend.<span class=\"gkBlockTextLeft\">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum condimentum pulvinar justo, sed faucibus ligula feugiat ac. Morbi quis enim nulla, vel congue augue.</span>Donec eget dignissim augue. Donec ante felis, aliquam ut consequat eget, lobortis dapibus risus. Aliquam laoreet enim et lectus ornare hendrerit. Aliquam rhoncus enim libero. Morbi aliquam, nibh mattis feugiat dapibus, nisi massa adipiscing justo, sit amet condimentum urna ipsum et lacus. Nam fermentum, eros quis ullamcorper convallis, libero mauris lacinia eros, sed tempus leo lorem vitae purus.</p>\r\n<br /> <br />\r\n<p><small>&lt;p&gt; Here goes main part of the text &lt;span class=\"gkBlockTextRight\"&gt;Block of text&lt;/span&gt;rest of the text&lt;/p&gt; </small></p>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum condimentum pulvinar justo, sed faucibus ligula feugiat ac. Morbi quis enim nulla, vel congue augue. Duis quis quam sed purus porta eleifend.<span class=\"gkBlockTextRight\">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum condimentum pulvinar justo, sed faucibus ligula feugiat ac. Morbi quis enim nulla, vel congue augue.</span>Donec eget dignissim augue. Donec ante felis, aliquam ut consequat eget, lobortis dapibus risus. Aliquam laoreet enim et lectus ornare hendrerit. Aliquam rhoncus enim libero. Morbi aliquam, nibh mattis feugiat dapibus, nisi massa adipiscing justo, sit amet condimentum urna ipsum et lacus. Nam fermentum, eros quis ullamcorper convallis, libero mauris lacinia eros, sed tempus leo lorem vitae purus.</p>\r\n<br /> <br />\r\n<p><small>&lt;p&gt; Here goes main part of the text &lt;span class=\"gkBlockTextCenter\"&gt;Block of text&lt;/span&gt;rest of the text&lt;/p&gt; </small></p>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum condimentum pulvinar justo, sed faucibus ligula feugiat ac. Morbi quis enim nulla, vel congue augue. Duis quis quam sed purus porta eleifend.<span class=\"gkBlockTextCenter\">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum condimentum pulvinar justo, sed faucibus ligula feugiat ac. Morbi quis enim nulla, vel congue augue.</span>Donec eget dignissim augue. Donec ante felis, aliquam ut consequat eget, lobortis dapibus risus. Aliquam laoreet enim et lectus ornare hendrerit. Aliquam rhoncus enim libero. Morbi aliquam, nibh mattis feugiat dapibus, nisi massa adipiscing justo, sit amet condimentum urna ipsum et lacus. Nam fermentum, eros quis ullamcorper convallis, libero mauris lacinia eros, sed tempus leo lorem vitae purus. Nunc a malesuada felis. Cras ultrices sapien eu nisi elementum non blandit urna sodales.</p>\r\n</div>\r\n<h3>Special template typography elements</h3>\r\n<h4>Social icons</h4>\r\n<pre>&lt;a class=\"gkFb\" href=\"#\"&gt;Facebook&lt;/a&gt; \r\n&lt;a class=\"gkTwitter\" href=\"#\"&gt;Twitter&lt;/a&gt; \r\n&lt;a class=\"gkGplus\" href=\"#\"&gt;Google+&lt;/a&gt; \r\n&lt;a class=\"gkRSS\" href=\"#\"&gt;RSS&lt;/a&gt;</pre>','',1,15,'2012-12-03 09:23:54',944,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2012-12-03 09:23:54','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"0\",\"show_intro\":\"0\",\"info_block_position\":\"0\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_icons\":\"\",\"show_print_icon\":\"0\",\"show_email_icon\":\"0\",\"show_vote\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',1,5,'','',1,2,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(5,51,'Module positions','module-positions','<p style=\"margin: 0 auto;\"><img src=\"images/demo/module_positions.png\" border=\"0\" alt=\"\" /></p>','',1,15,'2012-12-03 09:24:25',944,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2012-12-03 09:24:25','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',1,4,'','',1,1,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(6,52,'Messages','messages','<p>Joomla! offers three different types of messages. Creatings standard information about Joomla! system is presented depending on a message type as follows:</p>\r\n<p style=\"margin: 43px 0 0;\"> </p>\r\n<dl id=\"system-message\"><dt class=\"error\">Error</dt><dd class=\"message message fade\">\r\n<ul>\r\n<li>This is a sample message</li>\r\n</ul>\r\n</dd></dl><dl id=\"system-message\"><dt class=\"error\">Error</dt><dd class=\"notice message fade\">\r\n<ul>\r\n<li>This is a sample of notice message</li>\r\n</ul>\r\n</dd></dl><dl id=\"system-message\"><dt class=\"error\">Error</dt><dd class=\"error message fade\">\r\n<ul>\r\n<li>This is a sample of error message</li>\r\n</ul>\r\n</dd></dl>','',1,15,'2012-12-03 09:24:57',944,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2012-12-03 09:24:57','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"0\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',1,3,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(7,53,'Module variations','module-variations','<p>On this page you can see basic suffixes used in this template.</p>\r\n<p>The useful feature is built-in in the module titles: if you want to create a second, smaller line in the title please use the \"**\" chars i.e. This is a first line**and it is a second line**.</p>\r\n<p>The <strong>clear</strong> suffix is very useful to create banners or images without additional borders, margins and paddings. The clear suffix is also very useful inside the <strong>mainbody</strong>, <strong>mainbody_top</strong> and <strong>mainbody_bottom</strong> module positions.</p>\r\n<p>Suffixes like <strong>dark</strong>, <strong>transparent</strong> will work only on the sidebar and on the banner module positions.</p>','',1,15,'2012-12-03 09:25:37',944,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2012-12-03 09:25:37','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"0\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',1,2,'','',1,4,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(8,54,'Page break example','page-break-example','<p>Ut dignissim aliquet nibh tristique hendrerit. Donec ullamcorper nulla quis metus vulputate id placerat augue eleifend. Aenean venenatis consectetur orci, sit amet ultricies magna sagittis vel. Nulla non diam nisi, ut ultrices massa. Pellentesque sed nisl metus. Praesent a mi vel ante molestie venenatis.</p>\r\n<p>Donec sed odio dui. Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Donec id elit non mi porta gravida at eget metus. Etiam porta sem malesuada magna mollis euismod. Cras justo odio, dapibus ac facilisis in, egestas eget quam.</p>\r\n<p>Mauris justo metus, ultrices id lobortis et, euismod sit amet metus. Maecenas sed nisl a arcu ultricies consectetur. Integer ut mollis elit. Nulla ultrices scelerisque mauris id commodo. Integer congue lectus et justo pellentesque sed semper lacus facilisis. Nunc tristique placerat odio eget rutrum.</p>\r\n','\r\n<p>Ut viverra erat id augue bibendum rutrum. Nam aliquet feugiat molestie. Maecenas tempus scelerisque tellus eu mattis. Aliquam dignissim aliquam posuere. Sed dignissim, ipsum sed sodales aliquam, erat dolor varius eros, in semper sem metus vel metus. Nullam est mauris, laoreet condimentum hendrerit et, euismod quis dolor. Nunc eleifend lacinia libero eget scelerisque. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae.</p>\r\n<p>Nulla vitae elit libero, a pharetra augue. Donec ullamcorper nulla non metus auctor fringilla. Nulla vitae elit libero, a pharetra augue. Aenean lacinia bibendum nulla sed consectetur. Donec id elit non mi porta gravida at eget metus.</p>\r\n<p>Vivamus eget est urna. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Vivamus mauris justo, fermentum quis mattis vel, auctor vitae metus. Maecenas non dolor ac risus faucibus luctus non id turpis. Morbi ante nibh, suscipit non adipiscing in, ornare in ipsum.</p>\r\n<hr title=\"First Page\" alt=\"first-page\" class=\"system-pagebreak\" />\r\n<p>Nullam ac odio orci, sed pretium velit. Integer sit amet justo faucibus lorem imperdiet sagittis. Proin egestas, risus in faucibus sodales, tortor turpis feugiat risus, varius laoreet dui turpis ac dolor. Nullam suscipit fringilla augue non rhoncus. Nullam ac nibh eu ipsum tristique ullamcorper. Nunc porttitor lorem id orci dapibus lacinia. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas.</p>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed posuere consectetur est at lobortis. Vestibulum id ligula porta felis euismod semper. Donec id elit non mi porta gravida at eget metus. Integer posuere erat a ante venenatis dapibus posuere velit aliquet.</p>\r\n<p>Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Maecenas sed diam eget risus varius blandit sit amet non magna. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus.</p>\r\n<hr title=\"Second Page\" alt=\"second-page\" class=\"system-pagebreak\" />\r\n<p>Donec sed odio dui. Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Donec id elit non mi porta gravida at eget metus. Etiam porta sem malesuada magna mollis euismod. Cras justo odio, dapibus ac facilisis in, egestas eget quam.</p>\r\n<p>Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Maecenas sed diam eget risus varius blandit sit amet non magna. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus.</p>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed posuere consectetur est at lobortis. Vestibulum id ligula porta felis euismod semper. Donec id elit non mi porta gravida at eget metus. Integer posuere erat a ante venenatis dapibus posuere velit aliquet.</p>\r\n<p>Nulla vitae elit libero, a pharetra augue. Donec ullamcorper nulla non metus auctor fringilla. Nulla vitae elit libero, a pharetra augue. Aenean lacinia bibendum nulla sed consectetur. Donec id elit non mi porta gravida at eget metus.</p>\r\n<hr title=\"Third Page\" alt=\"third-page\" class=\"system-pagebreak\" />\r\n<p>Maecenas faucibus mollis interdum. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Donec id elit non mi porta gravida at eget metus. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Praesent commodo cursus magna, vel scelerisque nisl consectetur et.</p>\r\n<p>Fusce id enim id erat sodales auctor. Duis tortor nisl, condimentum vel feugiat vel, venenatis ut dolor. Donec interdum ornare ligula, vitae adipiscing diam imperdiet at. Donec facilisis, nunc sit amet ultricies adipiscing, ligula justo congue lectus, sit amet vehicula enim lorem in neque. In ultrices bibendum justo ac vehicula. Nam tincidunt blandit consequat.</p>\r\n<p>Vestibulum id ligula porta felis euismod semper. Cras justo odio, dapibus ac facilisis in, egestas eget quam. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Donec id elit non mi porta gravida at eget metus.</p>\r\n<hr title=\"Fourth Page\" alt=\"fourth-page\" class=\"system-pagebreak\" />\r\n<p>Nullam quis risus eget urna mollis ornare vel eu leo. Sed posuere consectetur est at lobortis. Aenean lacinia bibendum nulla sed consectetur. Maecenas sed diam eget risus varius blandit sit amet non magna. Etiam porta sem malesuada magna mollis euismod.</p>\r\n<p>Nullam quis risus eget urna mollis ornare vel eu leo. Donec id elit non mi porta gravida at eget metus. Aenean lacinia bibendum nulla sed consectetur.</p>\r\n<p>Vestibulum id ligula porta felis euismod semper. Donec ullamcorper nulla non metus auctor fringilla. Curabitur blandit tempus porttitor. Donec id elit non mi porta gravida at eget metus. Cras justo odio, dapibus ac facilisis in, egestas eget quam.</p>',1,15,'2012-12-03 09:26:07',944,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2012-12-03 09:26:07','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',1,1,'','',1,23,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(9,55,'Page Break','page-break','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Proin posuere nisi quis odio egestas non tempus est sollicitudin. Nulla facilisi. Pellentesque tempus suscipit nulla sed tempor. Phasellus et lorem id libero fermentum molestie sit amet sit amet mi. Quisque ultrices, neque et laoreet dictum, arcu sapien pulvinar odio, in aliquam mi dui eu leo. Nullam posuere, arcu et egestas fermentum, enim purus fermentum diam, quis porta mauris lectus ut odio. In tincidunt dapibus malesuada. Integer a lorem ligula. In tincidunt augue eget velit convallis nec pharetra eros tincidunt. Maecenas et tortor libero, vel malesuada est.</p>\r\n<p>Quisque magna tellus, condimentum a porttitor eu, fermentum nec enim. Aenean et erat nec lectus adipiscing auctor. Sed tellus sapien, condimentum eget tristique ac, faucibus sed nisi. Curabitur pretium porta pulvinar. Integer cursus venenatis dictum. Morbi massa est, ultricies ut ultrices vitae, hendrerit vitae tellus. Duis a nulla quis tellus lacinia tristique.</p>\r\n<hr title=\"Page 1\" alt=\"page1\" class=\"system-pagebreak\" />\r\n<p>Donec libero urna, cursus vitae sollicitudin sit amet, elementum et massa. Donec feugiat, turpis a dictum vulputate, dui diam faucibus nunc, ac sodales augue magna id augue. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Donec sit amet nisi felis. Morbi faucibus nunc id elit aliquam ac condimentum leo laoreet. Sed nec risus sed nulla mattis volutpat in eget diam. In leo nisl, eleifend vel lobortis vel, tincidunt a ligula. Nulla placerat gravida laoreet. In lobortis, ligula in sagittis pellentesque, orci magna venenatis neque, eu sagittis lacus ante et tellus. Morbi vel semper augue. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aliquam erat volutpat.</p>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Proin posuere nisi quis odio egestas non tempus est sollicitudin. Nulla facilisi. Pellentesque tempus suscipit nulla sed tempor. Phasellus et lorem id libero fermentum molestie sit amet sit amet mi. Quisque ultrices, neque et laoreet dictum, arcu sapien pulvinar odio, in aliquam mi dui eu leo. Nullam posuere, arcu et egestas fermentum, enim purus fermentum diam, quis porta mauris lectus ut odio. In tincidunt dapibus malesuada. Integer a lorem ligula. In tincidunt augue eget velit convallis nec pharetra eros tincidunt. Maecenas et tortor libero, vel malesuada est.</p>\r\n<hr title=\"Page 2\" alt=\"page2\" class=\"system-pagebreak\" />\r\n<p>Quisque magna tellus, condimentum a porttitor eu, fermentum nec enim. Aenean et erat nec lectus adipiscing auctor. Sed tellus sapien, condimentum eget tristique ac, faucibus sed nisi. Curabitur pretium porta pulvinar. Integer cursus venenatis dictum. Morbi massa est, ultricies ut ultrices vitae, hendrerit vitae tellus. Duis a nulla quis tellus lacinia tristique.</p>\r\n<p>Donec libero urna, cursus vitae sollicitudin sit amet, elementum et massa. Donec feugiat, turpis a dictum vulputate, dui diam faucibus nunc, ac sodales augue magna id augue. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Donec sit amet nisi felis. Morbi faucibus nunc id elit aliquam ac condimentum leo laoreet. Sed nec risus sed nulla mattis volutpat in eget diam. In leo nisl, eleifend vel lobortis vel, tincidunt a ligula. Nulla placerat gravida laoreet. In lobortis, ligula in sagittis pellentesque, orci magna venenatis neque, eu sagittis lacus ante et tellus. Morbi vel semper augue. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aliquam erat volutpat.</p>','',1,15,'2012-12-03 09:26:37',944,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2012-12-03 09:26:37','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',1,0,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(10,56,'Lorem ipsum I','lorem-ipsum-i','<p>Donec sed odio dui. Etiam porta sem malesuada magna mollis euismod. Sed posuere consectetur est at lobortis. </p>\r\n<p>Curabitur blandit tempus porttitor. Nullam quis risus eget urna mollis ornare vel eu leo. Etiam porta sem malesuada magna mollis euismod. Aenean lacinia bibendum nulla sed consectetur. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. </p>\r\n<p>Vestibulum id ligula porta felis euismod semper. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Nulla vitae elit libero, a pharetra augue. </p>\r\n','\r\n<p>Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Vestibulum id ligula porta felis euismod semper. Cras mattis consectetur purus sit amet fermentum. Vestibulum id ligula porta felis euismod semper. Nullam quis risus eget urna mollis ornare vel eu leo. Lorem ipsum dolor sit amet, consectetur adipiscing elit. </p>\r\n<p>Maecenas faucibus mollis interdum. Etiam porta sem malesuada magna mollis euismod. Aenean lacinia bibendum nulla sed consectetur. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Vestibulum id ligula porta felis euismod semper. </p>\r\n<p>Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Curabitur blandit tempus porttitor. Donec id elit non mi porta gravida at eget metus. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Sed posuere consectetur est at lobortis. Integer posuere erat a ante venenatis dapibus posuere velit aliquet. </p>\r\n<p>Maecenas sed diam eget risus varius blandit sit amet non magna. Cras mattis consectetur purus sit amet fermentum. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Maecenas faucibus mollis interdum. </p>\r\n<p>Maecenas sed diam eget risus varius blandit sit amet non magna. Praesent commodo cursus magna, vel scelerisque nisl consectetur et. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Sed posuere consectetur est at lobortis. Vestibulum id ligula porta felis euismod semper. </p>\r\n<p>Cras justo odio, dapibus ac facilisis in, egestas eget quam. Etiam porta sem malesuada magna mollis euismod. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus.</p>',1,17,'2012-12-03 09:27:57',944,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2012-12-03 09:27:57','0000-00-00 00:00:00','{\"image_intro\":\"images\\/demo\\/blank_medium.png\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/demo\\/blank_big.png\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',1,6,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(11,57,'Lorem ipsum II','lorem-ipsum-ii','<p>Donec sed odio dui. Etiam porta sem malesuada magna mollis euismod. Sed posuere consectetur est at lobortis. </p>\r\n<p>Curabitur blandit tempus porttitor. Nullam quis risus eget urna mollis ornare vel eu leo. Etiam porta sem malesuada magna mollis euismod. Aenean lacinia bibendum nulla sed consectetur. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. </p>\r\n<p>Vestibulum id ligula porta felis euismod semper. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Nulla vitae elit libero, a pharetra augue. </p>\r\n','\r\n<p>Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Vestibulum id ligula porta felis euismod semper. Cras mattis consectetur purus sit amet fermentum. Vestibulum id ligula porta felis euismod semper. Nullam quis risus eget urna mollis ornare vel eu leo. Lorem ipsum dolor sit amet, consectetur adipiscing elit. </p>\r\n<p>Maecenas faucibus mollis interdum. Etiam porta sem malesuada magna mollis euismod. Aenean lacinia bibendum nulla sed consectetur. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Vestibulum id ligula porta felis euismod semper. </p>\r\n<p>Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Curabitur blandit tempus porttitor. Donec id elit non mi porta gravida at eget metus. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Sed posuere consectetur est at lobortis. Integer posuere erat a ante venenatis dapibus posuere velit aliquet. </p>\r\n<p>Maecenas sed diam eget risus varius blandit sit amet non magna. Cras mattis consectetur purus sit amet fermentum. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Maecenas faucibus mollis interdum. </p>\r\n<p>Maecenas sed diam eget risus varius blandit sit amet non magna. Praesent commodo cursus magna, vel scelerisque nisl consectetur et. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Sed posuere consectetur est at lobortis. Vestibulum id ligula porta felis euismod semper. </p>\r\n<p>Cras justo odio, dapibus ac facilisis in, egestas eget quam. Etiam porta sem malesuada magna mollis euismod. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus.</p>',1,17,'2012-12-03 09:29:02',944,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2012-12-03 09:29:02','0000-00-00 00:00:00','{\"image_intro\":\"images\\/demo\\/blank_medium.png\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/demo\\/blank_big.png\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',1,5,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(12,58,'Heading off to higher top','heading-off-to-higher-top','<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi.</p>\r\n','\r\n<p>Curabitur blandit tempus porttitor. Nullam quis risus eget urna mollis ornare vel eu leo. Etiam porta sem malesuada magna mollis euismod. Aenean lacinia bibendum nulla sed consectetur. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. </p>\r\n<p>Vestibulum id ligula porta felis euismod semper. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Nulla vitae elit libero, a pharetra augue.</p>\r\n<p>Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Vestibulum id ligula porta felis euismod semper. Cras mattis consectetur purus sit amet fermentum. Vestibulum id ligula porta felis euismod semper. Nullam quis risus eget urna mollis ornare vel eu leo. Lorem ipsum dolor sit amet, consectetur adipiscing elit. </p>\r\n<p>Maecenas faucibus mollis interdum. Etiam porta sem malesuada magna mollis euismod. Aenean lacinia bibendum nulla sed consectetur. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Vestibulum id ligula porta felis euismod semper. </p>\r\n<p>Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Curabitur blandit tempus porttitor. Donec id elit non mi porta gravida at eget metus. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Sed posuere consectetur est at lobortis. Integer posuere erat a ante venenatis dapibus posuere velit aliquet. </p>\r\n<p>Maecenas sed diam eget risus varius blandit sit amet non magna. Cras mattis consectetur purus sit amet fermentum. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Maecenas faucibus mollis interdum. </p>\r\n<p>Maecenas sed diam eget risus varius blandit sit amet non magna. Praesent commodo cursus magna, vel scelerisque nisl consectetur et. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Sed posuere consectetur est at lobortis. Vestibulum id ligula porta felis euismod semper. </p>\r\n<p>Cras justo odio, dapibus ac facilisis in, egestas eget quam. Etiam porta sem malesuada magna mollis euismod. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus.</p>',1,17,'2012-12-03 09:30:35',944,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2012-12-03 09:30:35','0000-00-00 00:00:00','{\"image_intro\":\"images\\/demo\\/blog_5.jpg\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/demo\\/blog_5.jpg\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',1,4,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',1,'*',''),(13,59,'Snowboard tricks are aerials or maneuvers','snowboard-tricks-are-aerials-or-maneuvers','<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi.</p>\r\n','\r\n<p>Curabitur blandit tempus porttitor. Nullam quis risus eget urna mollis ornare vel eu leo. Etiam porta sem malesuada magna mollis euismod. Aenean lacinia bibendum nulla sed consectetur. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. </p>\r\n<p>Vestibulum id ligula porta felis euismod semper. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Nulla vitae elit libero, a pharetra augue.</p>\r\n<p>Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Vestibulum id ligula porta felis euismod semper. Cras mattis consectetur purus sit amet fermentum. Vestibulum id ligula porta felis euismod semper. Nullam quis risus eget urna mollis ornare vel eu leo. Lorem ipsum dolor sit amet, consectetur adipiscing elit. </p>\r\n<p>Maecenas faucibus mollis interdum. Etiam porta sem malesuada magna mollis euismod. Aenean lacinia bibendum nulla sed consectetur. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Vestibulum id ligula porta felis euismod semper. </p>\r\n<p>Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Curabitur blandit tempus porttitor. Donec id elit non mi porta gravida at eget metus. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Sed posuere consectetur est at lobortis. Integer posuere erat a ante venenatis dapibus posuere velit aliquet. </p>\r\n<p>Maecenas sed diam eget risus varius blandit sit amet non magna. Cras mattis consectetur purus sit amet fermentum. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Maecenas faucibus mollis interdum. </p>\r\n<p>Maecenas sed diam eget risus varius blandit sit amet non magna. Praesent commodo cursus magna, vel scelerisque nisl consectetur et. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Sed posuere consectetur est at lobortis. Vestibulum id ligula porta felis euismod semper. </p>\r\n<p>Cras justo odio, dapibus ac facilisis in, egestas eget quam. Etiam porta sem malesuada magna mollis euismod. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus.</p>',1,17,'2012-12-03 09:31:42',944,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2012-12-03 09:31:42','0000-00-00 00:00:00','{\"image_intro\":\"images\\/demo\\/blog_3.jpg\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/demo\\/blog_3.jpg\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',1,3,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(14,60,'Any snowboard lovers out there?','any-snowboard-lovers-out-there','<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci. Nullam quis risus eget urna mollis ornare vel eu leo. Etiam porta sem malesuada magna mollis euismod. Aenean lacinia bibendum nulla sed consectetur. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. </p>\r\n','\r\n<p>Vestibulum id ligula porta felis euismod semper. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Nulla vitae elit libero, a pharetra augue.</p>\r\n<p>Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Vestibulum id ligula porta felis euismod semper. Cras mattis consectetur purus sit amet fermentum. Vestibulum id ligula porta felis euismod semper. Nullam quis risus eget urna mollis ornare vel eu leo. Lorem ipsum dolor sit amet, consectetur adipiscing elit. </p>\r\n<p>Maecenas faucibus mollis interdum. Etiam porta sem malesuada magna mollis euismod. Aenean lacinia bibendum nulla sed consectetur. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Vestibulum id ligula porta felis euismod semper. </p>\r\n<p>Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Curabitur blandit tempus porttitor. Donec id elit non mi porta gravida at eget metus. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Sed posuere consectetur est at lobortis. Integer posuere erat a ante venenatis dapibus posuere velit aliquet. </p>\r\n<p>Maecenas sed diam eget risus varius blandit sit amet non magna. Cras mattis consectetur purus sit amet fermentum. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Maecenas faucibus mollis interdum. </p>\r\n<p>Maecenas sed diam eget risus varius blandit sit amet non magna. Praesent commodo cursus magna, vel scelerisque nisl consectetur et. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Sed posuere consectetur est at lobortis. Vestibulum id ligula porta felis euismod semper. </p>\r\n<p>Cras justo odio, dapibus ac facilisis in, egestas eget quam. Etiam porta sem malesuada magna mollis euismod. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus.</p>',1,17,'2012-12-03 09:33:18',944,'','2012-12-05 07:51:57',944,0,'0000-00-00 00:00:00','2012-12-03 09:33:18','0000-00-00 00:00:00','{\"image_intro\":\"images\\/demo\\/blog_1.jpg\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"Snowboard lovers\",\"image_fulltext\":\"images\\/demo\\/blog_1.jpg\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"Snowboard lovers\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\",\"og:title\":\"\",\"og:type\":\"article\",\"og:image\":\"\",\"og:site_name\":\"\",\"og:description\":\"\"}',2,2,'','',1,38,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',1,'*',''),(15,61,'Lorem ipsum subcategory','lorem-ipsum-subcategory','<p>Aenean lacinia bibendum nulla sed consectetur. Donec sed odio dui. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Cras justo odio, dapibus ac facilisis in, egestas eget quam. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor.</p>','',1,18,'2012-12-03 09:34:05',944,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2012-12-03 09:34:05','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',1,0,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),(16,62,'Get on Frozun Sports Snowboard','get-on-frozun-sports-snowboard','<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi.</p>\r\n','\r\n<p>Vestibulum id ligula porta felis euismod semper. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Nulla vitae elit libero, a pharetra augue.</p>\r\n<p>Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Vestibulum id ligula porta felis euismod semper. Cras mattis consectetur purus sit amet fermentum. Vestibulum id ligula porta felis euismod semper. Nullam quis risus eget urna mollis ornare vel eu leo. Lorem ipsum dolor sit amet, consectetur adipiscing elit. </p>\r\n<p>Maecenas faucibus mollis interdum. Etiam porta sem malesuada magna mollis euismod. Aenean lacinia bibendum nulla sed consectetur. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Vestibulum id ligula porta felis euismod semper. </p>\r\n<p>Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Curabitur blandit tempus porttitor. Donec id elit non mi porta gravida at eget metus. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Sed posuere consectetur est at lobortis. Integer posuere erat a ante venenatis dapibus posuere velit aliquet. </p>\r\n<p>Maecenas sed diam eget risus varius blandit sit amet non magna. Cras mattis consectetur purus sit amet fermentum. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Maecenas faucibus mollis interdum. </p>\r\n<p>Maecenas sed diam eget risus varius blandit sit amet non magna. Praesent commodo cursus magna, vel scelerisque nisl consectetur et. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Sed posuere consectetur est at lobortis. Vestibulum id ligula porta felis euismod semper. </p>\r\n<p>Cras justo odio, dapibus ac facilisis in, egestas eget quam. Etiam porta sem malesuada magna mollis euismod. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus.</p>',1,17,'2012-12-03 09:35:13',944,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2012-12-03 09:35:13','0000-00-00 00:00:00','{\"image_intro\":\"images\\/demo\\/blog_2.jpg\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/demo\\/blog_2.jpg\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',1,1,'','',1,3,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',1,'*',''),(17,63,'Winter Storm Brutus','winter-storm-brutus','<p>Curabitur blandit tempus porttitor. Nullam quis risus eget urna mollis ornare vel eu leo. Etiam porta sem malesuada magna mollis euismod. Aenean lacinia bibendum nulla sed consectetur. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. </p>\r\n','\r\n<p>Vestibulum id ligula porta felis euismod semper. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Nulla vitae elit libero, a pharetra augue. </p>\r\n<p>Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Vestibulum id ligula porta felis euismod semper. Cras mattis consectetur purus sit amet fermentum. Vestibulum id ligula porta felis euismod semper. Nullam quis risus eget urna mollis ornare vel eu leo. Lorem ipsum dolor sit amet, consectetur adipiscing elit. </p>\r\n<p>Maecenas faucibus mollis interdum. Etiam porta sem malesuada magna mollis euismod. Aenean lacinia bibendum nulla sed consectetur. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Vestibulum id ligula porta felis euismod semper. </p>\r\n<p>Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Curabitur blandit tempus porttitor. Donec id elit non mi porta gravida at eget metus. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Sed posuere consectetur est at lobortis. Integer posuere erat a ante venenatis dapibus posuere velit aliquet. </p>\r\n<p>Maecenas sed diam eget risus varius blandit sit amet non magna. Cras mattis consectetur purus sit amet fermentum. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Maecenas faucibus mollis interdum. </p>\r\n<p>Maecenas sed diam eget risus varius blandit sit amet non magna. Praesent commodo cursus magna, vel scelerisque nisl consectetur et. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Sed posuere consectetur est at lobortis. Vestibulum id ligula porta felis euismod semper. </p>\r\n<p>Cras justo odio, dapibus ac facilisis in, egestas eget quam. Etiam porta sem malesuada magna mollis euismod. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus.</p>',1,17,'2012-12-03 09:36:58',944,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2012-12-03 09:36:58','0000-00-00 00:00:00','{\"image_intro\":\"images\\/demo\\/img1.jpg\",\"float_intro\":\"\",\"image_intro_alt\":\"Winter Storm Brutus\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/demo\\/img1.jpg\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"Winter Storm Brutus\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',1,0,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',1,'*','');


--
-- Table structure for table `#__content_frontpage`
--



CREATE TABLE `#__content_frontpage` (
  `content_id` int(11) NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`content_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__content_frontpage`
--


INSERT INTO `#__content_frontpage` (`content_id`, `ordering`) VALUES (12,4),(14,3),(16,2),(17,1);


--
-- Table structure for table `#__content_rating`
--



CREATE TABLE `#__content_rating` (
  `content_id` int(11) NOT NULL DEFAULT '0',
  `rating_sum` int(10) unsigned NOT NULL DEFAULT '0',
  `rating_count` int(10) unsigned NOT NULL DEFAULT '0',
  `lastip` varchar(50) NOT NULL DEFAULT '',
  PRIMARY KEY (`content_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__content_rating`
--




--
-- Table structure for table `#__core_log_searches`
--



CREATE TABLE `#__core_log_searches` (
  `search_term` varchar(128) NOT NULL DEFAULT '',
  `hits` int(10) unsigned NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__core_log_searches`
--




--
-- Table structure for table `#__extensions`
--



CREATE TABLE `#__extensions` (
  `extension_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  `type` varchar(20) NOT NULL,
  `element` varchar(100) NOT NULL,
  `folder` varchar(100) NOT NULL,
  `client_id` tinyint(3) NOT NULL,
  `enabled` tinyint(3) NOT NULL DEFAULT '1',
  `access` int(10) unsigned NOT NULL DEFAULT '1',
  `protected` tinyint(3) NOT NULL DEFAULT '0',
  `manifest_cache` text NOT NULL,
  `params` text NOT NULL,
  `custom_data` text NOT NULL,
  `system_data` text NOT NULL,
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) DEFAULT '0',
  `state` int(11) DEFAULT '0',
  PRIMARY KEY (`extension_id`),
  KEY `element_clientid` (`element`,`client_id`),
  KEY `element_folder_clientid` (`element`,`folder`,`client_id`),
  KEY `extension` (`type`,`element`,`folder`,`client_id`)
) ENGINE=InnoDB AUTO_INCREMENT=10026 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__extensions`
--


INSERT INTO `#__extensions` (`extension_id`, `name`, `type`, `element`, `folder`, `client_id`, `enabled`, `access`, `protected`, `manifest_cache`, `params`, `custom_data`, `system_data`, `checked_out`, `checked_out_time`, `ordering`, `state`) VALUES (1,'com_mailto','component','com_mailto','',0,1,1,1,'{\"name\":\"com_mailto\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_MAILTO_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(2,'com_wrapper','component','com_wrapper','',0,1,1,1,'{\"name\":\"com_wrapper\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_WRAPPER_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(3,'com_admin','component','com_admin','',1,1,1,1,'{\"name\":\"com_admin\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_ADMIN_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(4,'com_banners','component','com_banners','',1,1,1,0,'{\"name\":\"com_banners\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_BANNERS_XML_DESCRIPTION\",\"group\":\"\"}','{\"purchase_type\":\"3\",\"track_impressions\":\"0\",\"track_clicks\":\"0\",\"metakey_prefix\":\"\"}','','',0,'0000-00-00 00:00:00',0,0),(5,'com_cache','component','com_cache','',1,1,1,1,'{\"name\":\"com_cache\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_CACHE_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(6,'com_categories','component','com_categories','',1,1,1,1,'{\"name\":\"com_categories\",\"type\":\"component\",\"creationDate\":\"December 2007\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_CATEGORIES_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(7,'com_checkin','component','com_checkin','',1,1,1,1,'{\"name\":\"com_checkin\",\"type\":\"component\",\"creationDate\":\"Unknown\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2008 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_CHECKIN_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(8,'com_contact','component','com_contact','',1,1,1,0,'{\"name\":\"com_contact\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_CONTACT_XML_DESCRIPTION\",\"group\":\"\"}','{\"contact_layout\":\"_:default\",\"show_contact_category\":\"hide\",\"show_contact_list\":\"0\",\"presentation_style\":\"plain\",\"show_name\":\"1\",\"show_position\":\"1\",\"show_email\":\"0\",\"show_street_address\":\"1\",\"show_suburb\":\"1\",\"show_state\":\"1\",\"show_postcode\":\"1\",\"show_country\":\"1\",\"show_telephone\":\"1\",\"show_mobile\":\"1\",\"show_fax\":\"1\",\"show_webpage\":\"1\",\"show_misc\":\"1\",\"show_image\":\"1\",\"image\":\"\",\"allow_vcard\":\"0\",\"show_articles\":\"0\",\"show_profile\":\"0\",\"show_links\":\"0\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"contact_icons\":\"0\",\"icon_address\":\"\",\"icon_email\":\"\",\"icon_telephone\":\"\",\"icon_mobile\":\"\",\"icon_fax\":\"\",\"icon_misc\":\"\",\"category_layout\":\"_:default\",\"show_category_title\":\"1\",\"show_description\":\"1\",\"show_description_image\":\"0\",\"maxLevel\":\"-1\",\"show_empty_categories\":\"0\",\"show_subcat_desc\":\"1\",\"show_cat_items\":\"1\",\"show_base_description\":\"1\",\"maxLevelcat\":\"-1\",\"show_empty_categories_cat\":\"0\",\"show_subcat_desc_cat\":\"1\",\"show_cat_items_cat\":\"1\",\"show_pagination_limit\":\"1\",\"show_headings\":\"1\",\"show_position_headings\":\"1\",\"show_email_headings\":\"0\",\"show_telephone_headings\":\"1\",\"show_mobile_headings\":\"0\",\"show_fax_headings\":\"0\",\"show_suburb_headings\":\"1\",\"show_state_headings\":\"1\",\"show_country_headings\":\"1\",\"show_pagination\":\"2\",\"show_pagination_results\":\"1\",\"initial_sort\":\"ordering\",\"captcha\":\"\",\"show_email_form\":\"1\",\"show_email_copy\":\"1\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"1\",\"custom_reply\":\"0\",\"redirect\":\"\",\"show_feed_link\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),(9,'com_cpanel','component','com_cpanel','',1,1,1,1,'{\"name\":\"com_cpanel\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_CPANEL_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(10,'com_installer','component','com_installer','',1,1,1,1,'{\"name\":\"com_installer\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_INSTALLER_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(11,'com_languages','component','com_languages','',1,1,1,1,'{\"name\":\"com_languages\",\"type\":\"component\",\"creationDate\":\"2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_LANGUAGES_XML_DESCRIPTION\",\"group\":\"\"}','{\"administrator\":\"en-GB\",\"site\":\"en-GB\"}','','',0,'0000-00-00 00:00:00',0,0),(12,'com_login','component','com_login','',1,1,1,1,'{\"name\":\"com_login\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_LOGIN_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(13,'com_media','component','com_media','',1,1,0,1,'{\"name\":\"com_media\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_MEDIA_XML_DESCRIPTION\",\"group\":\"\"}','{\"upload_extensions\":\"bmp,csv,doc,gif,ico,jpg,jpeg,odg,odp,ods,odt,pdf,png,ppt,swf,txt,xcf,xls,BMP,CSV,DOC,GIF,ICO,JPG,JPEG,ODG,ODP,ODS,ODT,PDF,PNG,PPT,SWF,TXT,XCF,XLS\",\"upload_maxsize\":\"10\",\"file_path\":\"images\",\"image_path\":\"images\",\"restrict_uploads\":\"1\",\"allowed_media_usergroup\":\"3\",\"check_mime\":\"1\",\"image_extensions\":\"bmp,gif,jpg,png\",\"ignore_extensions\":\"\",\"upload_mime\":\"image\\/jpeg,image\\/gif,image\\/png,image\\/bmp,application\\/x-shockwave-flash,application\\/msword,application\\/excel,application\\/pdf,application\\/powerpoint,text\\/plain,application\\/x-zip\",\"upload_mime_illegal\":\"text\\/html\",\"enable_flash\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),(14,'com_menus','component','com_menus','',1,1,1,1,'{\"name\":\"com_menus\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_MENUS_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(15,'com_messages','component','com_messages','',1,1,1,1,'{\"name\":\"com_messages\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_MESSAGES_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(16,'com_modules','component','com_modules','',1,1,1,1,'{\"name\":\"com_modules\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_MODULES_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(17,'com_newsfeeds','component','com_newsfeeds','',1,1,1,0,'{\"name\":\"com_newsfeeds\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_NEWSFEEDS_XML_DESCRIPTION\",\"group\":\"\"}','{\"show_feed_image\":\"1\",\"show_feed_description\":\"1\",\"show_item_description\":\"1\",\"feed_word_count\":\"0\",\"show_headings\":\"1\",\"show_name\":\"1\",\"show_articles\":\"0\",\"show_link\":\"1\",\"show_description\":\"1\",\"show_description_image\":\"1\",\"display_num\":\"\",\"show_pagination_limit\":\"1\",\"show_pagination\":\"1\",\"show_pagination_results\":\"1\",\"show_cat_items\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),(18,'com_plugins','component','com_plugins','',1,1,1,1,'{\"name\":\"com_plugins\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_PLUGINS_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(19,'com_search','component','com_search','',1,1,1,0,'{\"name\":\"com_search\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_SEARCH_XML_DESCRIPTION\",\"group\":\"\"}','{\"enabled\":\"0\",\"show_date\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),(20,'com_templates','component','com_templates','',1,1,1,1,'{\"name\":\"com_templates\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_TEMPLATES_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(21,'com_weblinks','component','com_weblinks','',1,1,1,0,'{\"name\":\"com_weblinks\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_WEBLINKS_XML_DESCRIPTION\",\"group\":\"\"}','{\"show_comp_description\":\"1\",\"comp_description\":\"\",\"show_link_hits\":\"1\",\"show_link_description\":\"1\",\"show_other_cats\":\"0\",\"show_headings\":\"0\",\"show_numbers\":\"0\",\"show_report\":\"1\",\"count_clicks\":\"1\",\"target\":\"0\",\"link_icons\":\"\"}','','',0,'0000-00-00 00:00:00',0,0),(22,'com_content','component','com_content','',1,1,0,1,'{\"name\":\"com_content\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_CONTENT_XML_DESCRIPTION\",\"group\":\"\"}','{\"article_layout\":\"_:default\",\"show_title\":\"1\",\"link_titles\":\"1\",\"show_intro\":\"1\",\"info_block_position\":\"0\",\"show_category\":\"1\",\"link_category\":\"1\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"1\",\"link_author\":\"0\",\"show_create_date\":\"1\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"1\",\"show_vote\":\"0\",\"show_readmore\":\"1\",\"show_readmore_title\":\"0\",\"readmore_limit\":\"100\",\"show_icons\":\"1\",\"show_print_icon\":\"1\",\"show_email_icon\":\"1\",\"show_hits\":\"1\",\"show_noauth\":\"0\",\"urls_position\":\"0\",\"show_publishing_options\":\"1\",\"show_article_options\":\"1\",\"show_urls_images_frontend\":\"0\",\"show_urls_images_backend\":\"1\",\"targeta\":0,\"targetb\":0,\"targetc\":0,\"float_intro\":\"left\",\"float_fulltext\":\"left\",\"category_layout\":\"_:blog\",\"show_category_title\":\"0\",\"show_description\":\"0\",\"show_description_image\":\"0\",\"maxLevel\":\"1\",\"show_empty_categories\":\"0\",\"show_no_articles\":\"1\",\"show_subcat_desc\":\"1\",\"show_cat_num_articles\":\"0\",\"show_base_description\":\"1\",\"maxLevelcat\":\"-1\",\"show_empty_categories_cat\":\"0\",\"show_subcat_desc_cat\":\"1\",\"show_cat_num_articles_cat\":\"1\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"4\",\"num_columns\":\"2\",\"num_links\":\"4\",\"multi_column_order\":\"0\",\"show_subcategory_content\":\"0\",\"show_pagination_limit\":\"1\",\"filter_field\":\"hide\",\"show_headings\":\"1\",\"list_show_date\":\"0\",\"date_format\":\"\",\"list_show_hits\":\"1\",\"list_show_author\":\"1\",\"orderby_pri\":\"order\",\"orderby_sec\":\"rdate\",\"order_date\":\"published\",\"show_pagination\":\"2\",\"show_pagination_results\":\"1\",\"show_feed_link\":\"1\",\"feed_summary\":\"0\",\"feed_show_readmore\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),(23,'com_config','component','com_config','',1,1,0,1,'{\"name\":\"com_config\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_CONFIG_XML_DESCRIPTION\",\"group\":\"\"}','{\"filters\":{\"1\":{\"filter_type\":\"NH\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"9\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"6\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"7\":{\"filter_type\":\"NONE\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"2\":{\"filter_type\":\"NH\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"3\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"4\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"5\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"8\":{\"filter_type\":\"NONE\",\"filter_tags\":\"\",\"filter_attributes\":\"\"}}}','','',0,'0000-00-00 00:00:00',0,0),(24,'com_redirect','component','com_redirect','',1,1,0,1,'{\"name\":\"com_redirect\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_REDIRECT_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(25,'com_users','component','com_users','',1,1,0,1,'{\"name\":\"com_users\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_USERS_XML_DESCRIPTION\",\"group\":\"\"}','{\"allowUserRegistration\":\"1\",\"new_usertype\":\"2\",\"guest_usergroup\":\"9\",\"sendpassword\":\"1\",\"useractivation\":\"1\",\"mail_to_admin\":\"0\",\"captcha\":\"\",\"frontend_userparams\":\"1\",\"site_language\":\"0\",\"change_login_name\":\"0\",\"reset_count\":\"10\",\"reset_time\":\"1\",\"mailSubjectPrefix\":\"\",\"mailBodySuffix\":\"\"}','','',0,'0000-00-00 00:00:00',0,0),(27,'com_finder','component','com_finder','',1,1,0,0,'{\"name\":\"com_finder\",\"type\":\"component\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_FINDER_XML_DESCRIPTION\",\"group\":\"\"}','{\"show_description\":\"1\",\"description_length\":255,\"allow_empty_query\":\"0\",\"show_url\":\"1\",\"show_advanced\":\"1\",\"expand_advanced\":\"0\",\"show_date_filters\":\"0\",\"highlight_terms\":\"1\",\"opensearch_name\":\"\",\"opensearch_description\":\"\",\"batch_size\":\"50\",\"memory_table_limit\":30000,\"title_multiplier\":\"1.7\",\"text_multiplier\":\"0.7\",\"meta_multiplier\":\"1.2\",\"path_multiplier\":\"2.0\",\"misc_multiplier\":\"0.3\",\"stemmer\":\"snowball\"}','','',0,'0000-00-00 00:00:00',0,0),(28,'com_joomlaupdate','component','com_joomlaupdate','',1,1,0,1,'{\"name\":\"com_joomlaupdate\",\"type\":\"component\",\"creationDate\":\"February 2012\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"COM_JOOMLAUPDATE_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(100,'PHPMailer','library','phpmailer','',0,1,1,1,'{\"name\":\"PHPMailer\",\"type\":\"library\",\"creationDate\":\"2001\",\"author\":\"PHPMailer\",\"copyright\":\"(c) 2001-2003, Brent R. Matzelle, (c) 2004-2009, Andy Prevost. All Rights Reserved., (c) 2010-2012, Jim Jagielski. All Rights Reserved.\",\"authorEmail\":\"jimjag@gmail.com\",\"authorUrl\":\"https:\\/\\/code.google.com\\/a\\/apache-extras.org\\/p\\/phpmailer\\/\",\"version\":\"5.2.1\",\"description\":\"LIB_PHPMAILER_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(101,'SimplePie','library','simplepie','',0,1,1,1,'{\"name\":\"SimplePie\",\"type\":\"library\",\"creationDate\":\"2004\",\"author\":\"SimplePie\",\"copyright\":\"Copyright (c) 2004-2009, Ryan Parman and Geoffrey Sneddon\",\"authorEmail\":\"\",\"authorUrl\":\"http:\\/\\/simplepie.org\\/\",\"version\":\"1.2\",\"description\":\"LIB_SIMPLEPIE_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(102,'phputf8','library','phputf8','',0,1,1,1,'{\"name\":\"phputf8\",\"type\":\"library\",\"creationDate\":\"2006\",\"author\":\"Harry Fuecks\",\"copyright\":\"Copyright various authors\",\"authorEmail\":\"hfuecks@gmail.com\",\"authorUrl\":\"http:\\/\\/sourceforge.net\\/projects\\/phputf8\",\"version\":\"0.5\",\"description\":\"LIB_PHPUTF8_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(103,'Joomla! Platform','library','joomla','',0,1,1,1,'{\"name\":\"Joomla! Platform\",\"type\":\"library\",\"creationDate\":\"2008\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"http:\\/\\/www.joomla.org\",\"version\":\"12.2\",\"description\":\"LIB_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(200,'mod_articles_archive','module','mod_articles_archive','',0,1,1,0,'{\"name\":\"mod_articles_archive\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters.\\n\\t\\tAll rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_ARTICLES_ARCHIVE_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(201,'mod_articles_latest','module','mod_articles_latest','',0,1,1,0,'{\"name\":\"mod_articles_latest\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_LATEST_NEWS_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(202,'mod_articles_popular','module','mod_articles_popular','',0,1,1,0,'{\"name\":\"mod_articles_popular\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_POPULAR_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(203,'mod_banners','module','mod_banners','',0,1,1,0,'{\"name\":\"mod_banners\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_BANNERS_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(204,'mod_breadcrumbs','module','mod_breadcrumbs','',0,1,1,1,'{\"name\":\"mod_breadcrumbs\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_BREADCRUMBS_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(205,'mod_custom','module','mod_custom','',0,1,1,1,'{\"name\":\"mod_custom\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_CUSTOM_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(206,'mod_feed','module','mod_feed','',0,1,1,0,'{\"name\":\"mod_feed\",\"type\":\"module\",\"creationDate\":\"July 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_FEED_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(207,'mod_footer','module','mod_footer','',0,1,1,0,'{\"name\":\"mod_footer\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_FOOTER_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(208,'mod_login','module','mod_login','',0,1,1,1,'{\"name\":\"mod_login\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_LOGIN_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(209,'mod_menu','module','mod_menu','',0,1,1,1,'{\"name\":\"mod_menu\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_MENU_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(210,'mod_articles_news','module','mod_articles_news','',0,1,1,0,'{\"name\":\"mod_articles_news\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_ARTICLES_NEWS_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(211,'mod_random_image','module','mod_random_image','',0,1,1,0,'{\"name\":\"mod_random_image\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_RANDOM_IMAGE_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(212,'mod_related_items','module','mod_related_items','',0,1,1,0,'{\"name\":\"mod_related_items\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_RELATED_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(213,'mod_search','module','mod_search','',0,1,1,0,'{\"name\":\"mod_search\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_SEARCH_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(214,'mod_stats','module','mod_stats','',0,1,1,0,'{\"name\":\"mod_stats\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_STATS_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(215,'mod_syndicate','module','mod_syndicate','',0,1,1,1,'{\"name\":\"mod_syndicate\",\"type\":\"module\",\"creationDate\":\"May 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_SYNDICATE_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(216,'mod_users_latest','module','mod_users_latest','',0,1,1,0,'{\"name\":\"mod_users_latest\",\"type\":\"module\",\"creationDate\":\"December 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_USERS_LATEST_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(217,'mod_weblinks','module','mod_weblinks','',0,1,1,0,'{\"name\":\"mod_weblinks\",\"type\":\"module\",\"creationDate\":\"July 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_WEBLINKS_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(218,'mod_whosonline','module','mod_whosonline','',0,1,1,0,'{\"name\":\"mod_whosonline\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_WHOSONLINE_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(219,'mod_wrapper','module','mod_wrapper','',0,1,1,0,'{\"name\":\"mod_wrapper\",\"type\":\"module\",\"creationDate\":\"October 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_WRAPPER_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(220,'mod_articles_category','module','mod_articles_category','',0,1,1,0,'{\"name\":\"mod_articles_category\",\"type\":\"module\",\"creationDate\":\"February 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_ARTICLES_CATEGORY_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(221,'mod_articles_categories','module','mod_articles_categories','',0,1,1,0,'{\"name\":\"mod_articles_categories\",\"type\":\"module\",\"creationDate\":\"February 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_ARTICLES_CATEGORIES_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(222,'mod_languages','module','mod_languages','',0,1,1,1,'{\"name\":\"mod_languages\",\"type\":\"module\",\"creationDate\":\"February 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_LANGUAGES_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(223,'mod_finder','module','mod_finder','',0,1,0,0,'{\"name\":\"mod_finder\",\"type\":\"module\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_FINDER_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(300,'mod_custom','module','mod_custom','',1,1,1,1,'{\"name\":\"mod_custom\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_CUSTOM_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(301,'mod_feed','module','mod_feed','',1,1,1,0,'{\"name\":\"mod_feed\",\"type\":\"module\",\"creationDate\":\"July 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_FEED_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(302,'mod_latest','module','mod_latest','',1,1,1,0,'{\"name\":\"mod_latest\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_LATEST_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(303,'mod_logged','module','mod_logged','',1,1,1,0,'{\"name\":\"mod_logged\",\"type\":\"module\",\"creationDate\":\"January 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_LOGGED_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(304,'mod_login','module','mod_login','',1,1,1,1,'{\"name\":\"mod_login\",\"type\":\"module\",\"creationDate\":\"March 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_LOGIN_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(305,'mod_menu','module','mod_menu','',1,1,1,0,'{\"name\":\"mod_menu\",\"type\":\"module\",\"creationDate\":\"March 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_MENU_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(307,'mod_popular','module','mod_popular','',1,1,1,0,'{\"name\":\"mod_popular\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_POPULAR_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(308,'mod_quickicon','module','mod_quickicon','',1,1,1,1,'{\"name\":\"mod_quickicon\",\"type\":\"module\",\"creationDate\":\"Nov 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_QUICKICON_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(309,'mod_status','module','mod_status','',1,1,1,0,'{\"name\":\"mod_status\",\"type\":\"module\",\"creationDate\":\"Feb 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_STATUS_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(310,'mod_submenu','module','mod_submenu','',1,1,1,0,'{\"name\":\"mod_submenu\",\"type\":\"module\",\"creationDate\":\"Feb 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_SUBMENU_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(311,'mod_title','module','mod_title','',1,1,1,0,'{\"name\":\"mod_title\",\"type\":\"module\",\"creationDate\":\"Nov 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_TITLE_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(312,'mod_toolbar','module','mod_toolbar','',1,1,1,1,'{\"name\":\"mod_toolbar\",\"type\":\"module\",\"creationDate\":\"Nov 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_TOOLBAR_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(313,'mod_multilangstatus','module','mod_multilangstatus','',1,1,1,0,'{\"name\":\"mod_multilangstatus\",\"type\":\"module\",\"creationDate\":\"September 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_MULTILANGSTATUS_XML_DESCRIPTION\",\"group\":\"\"}','{\"cache\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),(314,'mod_version','module','mod_version','',1,1,1,0,'{\"name\":\"mod_version\",\"type\":\"module\",\"creationDate\":\"January 2012\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_VERSION_XML_DESCRIPTION\",\"group\":\"\"}','{\"format\":\"short\",\"product\":\"1\",\"cache\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),(315,'mod_stats_admin','module','mod_stats_admin','',1,1,1,0,'{\"name\":\"mod_stats_admin\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"MOD_STATS_XML_DESCRIPTION\",\"group\":\"\"}','{\"serverinfo\":\"0\",\"siteinfo\":\"0\",\"counter\":\"0\",\"increase\":\"0\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}','','',0,'0000-00-00 00:00:00',0,0),(400,'plg_authentication_gmail','plugin','gmail','authentication',0,0,1,0,'{\"name\":\"plg_authentication_gmail\",\"type\":\"plugin\",\"creationDate\":\"February 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_GMAIL_XML_DESCRIPTION\",\"group\":\"\"}','{\"applysuffix\":\"0\",\"suffix\":\"\",\"verifypeer\":\"1\",\"user_blacklist\":\"\"}','','',0,'0000-00-00 00:00:00',1,0),(401,'plg_authentication_joomla','plugin','joomla','authentication',0,1,1,1,'{\"name\":\"plg_authentication_joomla\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_AUTH_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(402,'plg_authentication_ldap','plugin','ldap','authentication',0,0,1,0,'{\"name\":\"plg_authentication_ldap\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_LDAP_XML_DESCRIPTION\",\"group\":\"\"}','{\"host\":\"\",\"port\":\"389\",\"use_ldapV3\":\"0\",\"negotiate_tls\":\"0\",\"no_referrals\":\"0\",\"auth_method\":\"bind\",\"base_dn\":\"\",\"search_string\":\"\",\"users_dn\":\"\",\"username\":\"admin\",\"password\":\"bobby7\",\"ldap_fullname\":\"fullName\",\"ldap_email\":\"mail\",\"ldap_uid\":\"uid\"}','','',0,'0000-00-00 00:00:00',3,0),(404,'plg_content_emailcloak','plugin','emailcloak','content',0,1,1,0,'{\"name\":\"plg_content_emailcloak\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_CONTENT_EMAILCLOAK_XML_DESCRIPTION\",\"group\":\"\"}','{\"mode\":\"1\"}','','',0,'0000-00-00 00:00:00',1,0),(405,'plg_content_geshi','plugin','geshi','content',0,0,1,0,'{\"name\":\"plg_content_geshi\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"\",\"authorUrl\":\"qbnz.com\\/highlighter\",\"version\":\"3.0.0\",\"description\":\"PLG_CONTENT_GESHI_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',2,0),(406,'plg_content_loadmodule','plugin','loadmodule','content',0,1,1,0,'{\"name\":\"plg_content_loadmodule\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_LOADMODULE_XML_DESCRIPTION\",\"group\":\"\"}','{\"style\":\"xhtml\"}','','',0,'2011-09-18 15:22:50',0,0),(407,'plg_content_pagebreak','plugin','pagebreak','content',0,1,1,0,'{\"name\":\"plg_content_pagebreak\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_CONTENT_PAGEBREAK_XML_DESCRIPTION\",\"group\":\"\"}','{\"title\":\"1\",\"article_index\":\"1\",\"article_index_text\":\"ARTICLE INDEX\",\"multipage_toc\":\"1\",\"showall\":\"1\",\"style\":\"pages\"}','','',0,'0000-00-00 00:00:00',4,0),(408,'plg_content_pagenavigation','plugin','pagenavigation','content',0,0,1,0,'{\"name\":\"plg_content_pagenavigation\",\"type\":\"plugin\",\"creationDate\":\"January 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_PAGENAVIGATION_XML_DESCRIPTION\",\"group\":\"\"}','{\"position\":\"1\"}','','',0,'0000-00-00 00:00:00',5,0),(409,'plg_content_vote','plugin','vote','content',0,1,1,0,'{\"name\":\"plg_content_vote\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_VOTE_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',6,0),(410,'plg_editors_codemirror','plugin','codemirror','editors',0,1,1,1,'{\"name\":\"plg_editors_codemirror\",\"type\":\"plugin\",\"creationDate\":\"28 March 2011\",\"author\":\"Marijn Haverbeke\",\"copyright\":\"\",\"authorEmail\":\"N\\/A\",\"authorUrl\":\"\",\"version\":\"1.0\",\"description\":\"PLG_CODEMIRROR_XML_DESCRIPTION\",\"group\":\"\"}','{\"linenumbers\":\"0\",\"tabmode\":\"indent\"}','','',0,'0000-00-00 00:00:00',1,0),(411,'plg_editors_none','plugin','none','editors',0,1,1,1,'{\"name\":\"plg_editors_none\",\"type\":\"plugin\",\"creationDate\":\"August 2004\",\"author\":\"Unknown\",\"copyright\":\"\",\"authorEmail\":\"N\\/A\",\"authorUrl\":\"\",\"version\":\"3.0.0\",\"description\":\"PLG_NONE_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',2,0),(412,'plg_editors_tinymce','plugin','tinymce','editors',0,1,1,0,'{\"name\":\"plg_editors_tinymce\",\"type\":\"plugin\",\"creationDate\":\"2005-2012\",\"author\":\"Moxiecode Systems AB\",\"copyright\":\"Moxiecode Systems AB\",\"authorEmail\":\"N\\/A\",\"authorUrl\":\"tinymce.moxiecode.com\\/\",\"version\":\"3.5.6\",\"description\":\"PLG_TINY_XML_DESCRIPTION\",\"group\":\"\"}','{\"mode\":\"1\",\"skin\":\"0\",\"entity_encoding\":\"raw\",\"lang_mode\":\"0\",\"lang_code\":\"en\",\"text_direction\":\"ltr\",\"content_css\":\"1\",\"content_css_custom\":\"\",\"relative_urls\":\"1\",\"newlines\":\"0\",\"invalid_elements\":\"script,applet,iframe\",\"extended_elements\":\"\",\"toolbar\":\"top\",\"toolbar_align\":\"left\",\"html_height\":\"550\",\"html_width\":\"750\",\"resizing\":\"true\",\"resize_horizontal\":\"false\",\"element_path\":\"1\",\"fonts\":\"1\",\"paste\":\"1\",\"searchreplace\":\"1\",\"insertdate\":\"1\",\"format_date\":\"%Y-%m-%d\",\"inserttime\":\"1\",\"format_time\":\"%H:%M:%S\",\"colors\":\"1\",\"table\":\"1\",\"smilies\":\"1\",\"media\":\"1\",\"hr\":\"1\",\"directionality\":\"1\",\"fullscreen\":\"1\",\"style\":\"1\",\"layer\":\"1\",\"xhtmlxtras\":\"1\",\"visualchars\":\"1\",\"nonbreaking\":\"1\",\"template\":\"1\",\"blockquote\":\"1\",\"wordcount\":\"1\",\"advimage\":\"1\",\"advlink\":\"1\",\"advlist\":\"1\",\"autosave\":\"1\",\"contextmenu\":\"1\",\"inlinepopups\":\"1\",\"custom_plugin\":\"\",\"custom_button\":\"\"}','','',0,'0000-00-00 00:00:00',3,0),(413,'plg_editors-xtd_article','plugin','article','editors-xtd',0,1,1,1,'{\"name\":\"plg_editors-xtd_article\",\"type\":\"plugin\",\"creationDate\":\"October 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_ARTICLE_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',1,0),(414,'plg_editors-xtd_image','plugin','image','editors-xtd',0,1,1,0,'{\"name\":\"plg_editors-xtd_image\",\"type\":\"plugin\",\"creationDate\":\"August 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_IMAGE_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',2,0),(415,'plg_editors-xtd_pagebreak','plugin','pagebreak','editors-xtd',0,1,1,0,'{\"name\":\"plg_editors-xtd_pagebreak\",\"type\":\"plugin\",\"creationDate\":\"August 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_EDITORSXTD_PAGEBREAK_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',3,0),(416,'plg_editors-xtd_readmore','plugin','readmore','editors-xtd',0,1,1,0,'{\"name\":\"plg_editors-xtd_readmore\",\"type\":\"plugin\",\"creationDate\":\"March 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_READMORE_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',4,0),(417,'plg_search_categories','plugin','categories','search',0,1,1,0,'{\"name\":\"plg_search_categories\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_SEARCH_CATEGORIES_XML_DESCRIPTION\",\"group\":\"\"}','{\"search_limit\":\"50\",\"search_content\":\"1\",\"search_archived\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),(418,'plg_search_contacts','plugin','contacts','search',0,1,1,0,'{\"name\":\"plg_search_contacts\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_SEARCH_CONTACTS_XML_DESCRIPTION\",\"group\":\"\"}','{\"search_limit\":\"50\",\"search_content\":\"1\",\"search_archived\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),(419,'plg_search_content','plugin','content','search',0,1,1,0,'{\"name\":\"plg_search_content\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_SEARCH_CONTENT_XML_DESCRIPTION\",\"group\":\"\"}','{\"search_limit\":\"50\",\"search_content\":\"1\",\"search_archived\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),(420,'plg_search_newsfeeds','plugin','newsfeeds','search',0,1,1,0,'{\"name\":\"plg_search_newsfeeds\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_SEARCH_NEWSFEEDS_XML_DESCRIPTION\",\"group\":\"\"}','{\"search_limit\":\"50\",\"search_content\":\"1\",\"search_archived\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),(421,'plg_search_weblinks','plugin','weblinks','search',0,1,1,0,'{\"name\":\"plg_search_weblinks\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_SEARCH_WEBLINKS_XML_DESCRIPTION\",\"group\":\"\"}','{\"search_limit\":\"50\",\"search_content\":\"1\",\"search_archived\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),(422,'plg_system_languagefilter','plugin','languagefilter','system',0,0,1,1,'{\"name\":\"plg_system_languagefilter\",\"type\":\"plugin\",\"creationDate\":\"July 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_SYSTEM_LANGUAGEFILTER_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',1,0),(423,'plg_system_p3p','plugin','p3p','system',0,1,1,0,'{\"name\":\"plg_system_p3p\",\"type\":\"plugin\",\"creationDate\":\"September 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_P3P_XML_DESCRIPTION\",\"group\":\"\"}','{\"headers\":\"NOI ADM DEV PSAi COM NAV OUR OTRo STP IND DEM\"}','','',0,'0000-00-00 00:00:00',2,0),(424,'plg_system_cache','plugin','cache','system',0,0,1,1,'{\"name\":\"plg_system_cache\",\"type\":\"plugin\",\"creationDate\":\"February 2007\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_CACHE_XML_DESCRIPTION\",\"group\":\"\"}','{\"browsercache\":\"0\",\"cachetime\":\"15\"}','','',0,'0000-00-00 00:00:00',9,0),(425,'plg_system_debug','plugin','debug','system',0,1,1,0,'{\"name\":\"plg_system_debug\",\"type\":\"plugin\",\"creationDate\":\"December 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_DEBUG_XML_DESCRIPTION\",\"group\":\"\"}','{\"profile\":\"1\",\"queries\":\"1\",\"memory\":\"1\",\"language_files\":\"1\",\"language_strings\":\"1\",\"strip-first\":\"1\",\"strip-prefix\":\"\",\"strip-suffix\":\"\"}','','',0,'0000-00-00 00:00:00',4,0),(426,'plg_system_log','plugin','log','system',0,1,1,1,'{\"name\":\"plg_system_log\",\"type\":\"plugin\",\"creationDate\":\"April 2007\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_LOG_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',5,0),(427,'plg_system_redirect','plugin','redirect','system',0,1,1,1,'{\"name\":\"plg_system_redirect\",\"type\":\"plugin\",\"creationDate\":\"April 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_REDIRECT_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',6,0),(428,'plg_system_remember','plugin','remember','system',0,1,1,1,'{\"name\":\"plg_system_remember\",\"type\":\"plugin\",\"creationDate\":\"April 2007\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_REMEMBER_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',7,0),(429,'plg_system_sef','plugin','sef','system',0,1,1,0,'{\"name\":\"plg_system_sef\",\"type\":\"plugin\",\"creationDate\":\"December 2007\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_SEF_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',8,0),(430,'plg_system_logout','plugin','logout','system',0,1,1,1,'{\"name\":\"plg_system_logout\",\"type\":\"plugin\",\"creationDate\":\"April 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_SYSTEM_LOGOUT_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',3,0),(431,'plg_user_contactcreator','plugin','contactcreator','user',0,0,1,0,'{\"name\":\"plg_user_contactcreator\",\"type\":\"plugin\",\"creationDate\":\"August 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_CONTACTCREATOR_XML_DESCRIPTION\",\"group\":\"\"}','{\"autowebpage\":\"\",\"category\":\"34\",\"autopublish\":\"0\"}','','',0,'0000-00-00 00:00:00',1,0),(432,'plg_user_joomla','plugin','joomla','user',0,1,1,0,'{\"name\":\"plg_user_joomla\",\"type\":\"plugin\",\"creationDate\":\"December 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2009 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_USER_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}','{\"autoregister\":\"1\"}','','',0,'0000-00-00 00:00:00',2,0),(433,'plg_user_profile','plugin','profile','user',0,0,1,0,'{\"name\":\"plg_user_profile\",\"type\":\"plugin\",\"creationDate\":\"January 2008\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_USER_PROFILE_XML_DESCRIPTION\",\"group\":\"\"}','{\"register-require_address1\":\"1\",\"register-require_address2\":\"1\",\"register-require_city\":\"1\",\"register-require_region\":\"1\",\"register-require_country\":\"1\",\"register-require_postal_code\":\"1\",\"register-require_phone\":\"1\",\"register-require_website\":\"1\",\"register-require_favoritebook\":\"1\",\"register-require_aboutme\":\"1\",\"register-require_tos\":\"1\",\"register-require_dob\":\"1\",\"profile-require_address1\":\"1\",\"profile-require_address2\":\"1\",\"profile-require_city\":\"1\",\"profile-require_region\":\"1\",\"profile-require_country\":\"1\",\"profile-require_postal_code\":\"1\",\"profile-require_phone\":\"1\",\"profile-require_website\":\"1\",\"profile-require_favoritebook\":\"1\",\"profile-require_aboutme\":\"1\",\"profile-require_tos\":\"1\",\"profile-require_dob\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),(434,'plg_extension_joomla','plugin','joomla','extension',0,1,1,1,'{\"name\":\"plg_extension_joomla\",\"type\":\"plugin\",\"creationDate\":\"May 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_EXTENSION_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',1,0),(435,'plg_content_joomla','plugin','joomla','content',0,1,1,0,'{\"name\":\"plg_content_joomla\",\"type\":\"plugin\",\"creationDate\":\"November 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_CONTENT_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(436,'plg_system_languagecode','plugin','languagecode','system',0,0,1,0,'{\"name\":\"plg_system_languagecode\",\"type\":\"plugin\",\"creationDate\":\"November 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_SYSTEM_LANGUAGECODE_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',10,0),(437,'plg_quickicon_joomlaupdate','plugin','joomlaupdate','quickicon',0,1,1,1,'{\"name\":\"plg_quickicon_joomlaupdate\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_QUICKICON_JOOMLAUPDATE_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(438,'plg_quickicon_extensionupdate','plugin','extensionupdate','quickicon',0,1,1,1,'{\"name\":\"plg_quickicon_extensionupdate\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_QUICKICON_EXTENSIONUPDATE_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(439,'plg_captcha_recaptcha','plugin','recaptcha','captcha',0,1,1,0,'{\"name\":\"plg_captcha_recaptcha\",\"type\":\"plugin\",\"creationDate\":\"December 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_CAPTCHA_RECAPTCHA_XML_DESCRIPTION\",\"group\":\"\"}','{\"public_key\":\"\",\"private_key\":\"\",\"theme\":\"clean\"}','','',0,'0000-00-00 00:00:00',0,0),(440,'plg_system_highlight','plugin','highlight','system',0,1,1,0,'{\"name\":\"plg_system_highlight\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_SYSTEM_HIGHLIGHT_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',7,0),(441,'plg_content_finder','plugin','finder','content',0,0,1,0,'{\"name\":\"plg_content_finder\",\"type\":\"plugin\",\"creationDate\":\"December 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_CONTENT_FINDER_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(442,'plg_finder_categories','plugin','categories','finder',0,1,1,0,'{\"name\":\"plg_finder_categories\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_FINDER_CATEGORIES_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',1,0),(443,'plg_finder_contacts','plugin','contacts','finder',0,1,1,0,'{\"name\":\"plg_finder_contacts\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_FINDER_CONTACTS_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',2,0),(444,'plg_finder_content','plugin','content','finder',0,1,1,0,'{\"name\":\"plg_finder_content\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_FINDER_CONTENT_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',3,0),(445,'plg_finder_newsfeeds','plugin','newsfeeds','finder',0,1,1,0,'{\"name\":\"plg_finder_newsfeeds\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_FINDER_NEWSFEEDS_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',4,0),(446,'plg_finder_weblinks','plugin','weblinks','finder',0,1,1,0,'{\"name\":\"plg_finder_weblinks\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.0\",\"description\":\"PLG_FINDER_WEBLINKS_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',5,0),(503,'beez3','template','beez3','',0,1,1,0,'{\"name\":\"beez3\",\"type\":\"template\",\"creationDate\":\"25 November 2009\",\"author\":\"Angie Radtke\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters, Inc. All rights reserved.\",\"authorEmail\":\"a.radtke@derauftritt.de\",\"authorUrl\":\"http:\\/\\/www.der-auftritt.de\",\"version\":\"3.0.0\",\"description\":\"TPL_BEEZ3_XML_DESCRIPTION\",\"group\":\"\"}','{\"wrapperSmall\":\"53\",\"wrapperLarge\":\"72\",\"sitetitle\":\"\",\"sitedescription\":\"\",\"navposition\":\"center\",\"templatecolor\":\"nature\"}','','',0,'0000-00-00 00:00:00',0,0),(504,'hathor','template','hathor','',1,1,1,0,'{\"name\":\"hathor\",\"type\":\"template\",\"creationDate\":\"May 2010\",\"author\":\"Andrea Tarr\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters, Inc. All rights reserved.\",\"authorEmail\":\"hathor@tarrconsulting.com\",\"authorUrl\":\"http:\\/\\/www.tarrconsulting.com\",\"version\":\"3.0.0\",\"description\":\"TPL_HATHOR_XML_DESCRIPTION\",\"group\":\"\"}','{\"showSiteName\":\"0\",\"colourChoice\":\"0\",\"boldText\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),(506,'protostar','template','protostar','',0,1,1,0,'{\"name\":\"protostar\",\"type\":\"template\",\"creationDate\":\"4\\/30\\/2012\",\"author\":\"Kyle Ledbetter\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters, Inc. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"\",\"version\":\"1.0\",\"description\":\"TPL_PROTOSTAR_XML_DESCRIPTION\",\"group\":\"\"}','{\"templateColor\":\"\",\"logoFile\":\"\",\"googleFont\":\"1\",\"googleFontName\":\"Open+Sans\",\"fluidContainer\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),(507,'isis','template','isis','',1,1,1,0,'{\"name\":\"isis\",\"type\":\"template\",\"creationDate\":\"3\\/30\\/2012\",\"author\":\"Kyle Ledbetter\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters, Inc. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"\",\"version\":\"1.0\",\"description\":\"TPL_ISIS_XML_DESCRIPTION\",\"group\":\"\"}','{\"templateColor\":\"\",\"logoFile\":\"\"}','','',0,'0000-00-00 00:00:00',0,0),(600,'English (United Kingdom)','language','en-GB','',0,1,1,1,'{\"name\":\"English (United Kingdom)\",\"type\":\"language\",\"creationDate\":\"2008-03-15\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.2\",\"description\":\"en-GB site language\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(601,'English (United Kingdom)','language','en-GB','',1,1,1,1,'{\"name\":\"English (United Kingdom)\",\"type\":\"language\",\"creationDate\":\"2008-03-15\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.2\",\"description\":\"en-GB administrator language\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(700,'files_joomla','file','joomla','',0,1,1,1,'{\"name\":\"files_joomla\",\"type\":\"file\",\"creationDate\":\"November 2012\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"3.0.2\",\"description\":\"FILES_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),(10000,'com_k2','component','com_k2','',1,1,0,0,'{\"name\":\"COM_K2\",\"type\":\"component\",\"creationDate\":\"February 8th, 2013\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2013 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.net\",\"authorUrl\":\"www.joomlaworks.net\",\"version\":\"2.6.5\",\"description\":\"Thank you for installing K2 by JoomlaWorks, the powerful content extension for Joomla!\",\"group\":\"\"}','{\"enable_css\":\"1\",\"jQueryHandling\":\"1.8remote\",\"backendJQueryHandling\":\"remote\",\"userName\":\"1\",\"userImage\":\"1\",\"userDescription\":\"1\",\"userURL\":\"1\",\"userEmail\":\"0\",\"userFeedLink\":\"1\",\"userFeedIcon\":\"1\",\"userItemCount\":\"4\",\"userItemTitle\":\"1\",\"userItemTitleLinked\":\"1\",\"userItemDateCreated\":\"1\",\"userItemImage\":\"1\",\"userItemIntroText\":\"1\",\"userItemCategory\":\"1\",\"userItemTags\":\"1\",\"userItemCommentsAnchor\":\"1\",\"userItemReadMore\":\"1\",\"userItemK2Plugins\":\"1\",\"defaultUsersItemid\":\"\",\"tagItemCount\":\"4\",\"tagItemTitle\":\"1\",\"tagItemTitleLinked\":\"1\",\"tagItemDateCreated\":\"1\",\"tagItemImage\":\"1\",\"tagItemIntroText\":\"1\",\"tagItemCategory\":\"1\",\"tagItemReadMore\":\"1\",\"tagItemExtraFields\":\"0\",\"tagOrdering\":\"\",\"tagFeedLink\":\"1\",\"tagFeedIcon\":\"1\",\"defaultTagsItemid\":\"\",\"genericItemCount\":\"10\",\"genericItemTitle\":\"1\",\"genericItemTitleLinked\":\"1\",\"genericItemDateCreated\":\"1\",\"genericItemImage\":\"1\",\"genericItemIntroText\":\"1\",\"genericItemCategory\":\"1\",\"genericItemReadMore\":\"1\",\"genericItemExtraFields\":\"0\",\"genericFeedLink\":\"1\",\"genericFeedIcon\":\"1\",\"feedLimit\":\"10\",\"feedItemImage\":\"1\",\"feedImgSize\":\"L\",\"feedItemIntroText\":\"1\",\"feedTextWordLimit\":\"\",\"feedItemFullText\":\"1\",\"feedItemTags\":\"0\",\"feedItemVideo\":\"0\",\"feedItemGallery\":\"0\",\"feedItemAttachments\":\"0\",\"feedBogusEmail\":\"\",\"introTextCleanup\":\"0\",\"introTextCleanupExcludeTags\":\"\",\"introTextCleanupTagAttr\":\"\",\"fullTextCleanup\":\"0\",\"fullTextCleanupExcludeTags\":\"\",\"fullTextCleanupTagAttr\":\"\",\"xssFiltering\":\"0\",\"linkPopupWidth\":\"900\",\"linkPopupHeight\":\"600\",\"imagesQuality\":\"95\",\"itemImageXS\":\"100\",\"itemImageS\":\"200\",\"itemImageM\":\"700\",\"itemImageL\":\"700\",\"itemImageXL\":\"918\",\"itemImageGeneric\":\"700\",\"catImageWidth\":\"700\",\"catImageDefault\":\"1\",\"userImageWidth\":\"116\",\"userImageDefault\":\"1\",\"commenterImgWidth\":\"48\",\"onlineImageEditor\":\"splashup\",\"imageTimestamp\":\"0\",\"imageMemoryLimit\":\"\",\"socialButtonCode\":\"\",\"twitterUsername\":\"\",\"facebookImage\":\"Small\",\"comments\":\"1\",\"commentsOrdering\":\"DESC\",\"commentsLimit\":\"10\",\"commentsFormPosition\":\"below\",\"commentsPublishing\":\"1\",\"commentsReporting\":\"2\",\"commentsReportRecipient\":\"\",\"inlineCommentsModeration\":\"0\",\"gravatar\":\"1\",\"recaptcha\":\"0\",\"commentsFormNotes\":\"1\",\"commentsFormNotesText\":\"\",\"frontendEditing\":\"1\",\"showImageTab\":\"1\",\"showImageGalleryTab\":\"1\",\"showVideoTab\":\"1\",\"showExtraFieldsTab\":\"1\",\"showAttachmentsTab\":\"1\",\"showK2Plugins\":\"1\",\"sideBarDisplayFrontend\":\"0\",\"mergeEditors\":\"1\",\"sideBarDisplay\":\"1\",\"attachmentsFolder\":\"\",\"hideImportButton\":\"0\",\"taggingSystem\":\"1\",\"lockTags\":\"0\",\"showTagFilter\":\"0\",\"googleSearch\":\"0\",\"googleSearchContainer\":\"k2Container\",\"K2UserProfile\":\"0\",\"redirect\":\"101\",\"adminSearch\":\"simple\",\"cookieDomain\":\"\",\"recaptcha_public_key\":\"\",\"recaptcha_private_key\":\"\",\"recaptcha_theme\":\"clean\",\"recaptchaOnRegistration\":\"0\",\"stopForumSpam\":\"0\",\"stopForumSpamApiKey\":\"\",\"showItemsCounterAdmin\":\"1\",\"showChildCatItems\":\"1\",\"disableCompactOrdering\":\"0\",\"metaDescLimit\":\"150\",\"SEFReplacements\":\"\\u00c5\\u00a0|S, \\u00c5\\u2019|O, \\u00c5\\u00bd|Z, \\u00c5\\u00a1|s, \\u00c5\\u201c|oe, \\u00c5\\u00be|z, \\u00c5\\u00b8|Y, \\u00c2\\u00a5|Y, \\u00c2\\u00b5|u, \\u00c3\\u20ac|A, \\u00c3\\ufffd|A, \\u00c3\\u201a|A, \\u00c3\\u0192|A, \\u00c3\\u201e|A, \\u00c3\\u2026|A, \\u00c3\\u2020|A, \\u00c3\\u2021|C, \\u00c3\\u02c6|E, \\u00c3\\u2030|E, \\u00c3\\u0160|E, \\u00c3\\u2039|E, \\u00c3\\u0152|I, \\u00c3\\ufffd|I, \\u00c3\\u017d|I, \\u00c3\\ufffd|I, \\u00c3\\ufffd|D, \\u00c3\\u2018|N, \\u00c3\\u2019|O, \\u00c3\\u201c|O, \\u00c3\\u201d|O, \\u00c3\\u2022|O, \\u00c3\\u2013|O, \\u00c3\\u02dc|O, \\u00c3\\u2122|U, \\u00c3\\u0161|U, \\u00c3\\u203a|U, \\u00c3\\u0153|U, \\u00c3\\ufffd|Y, \\u00c3\\u0178|s, \\u00c3\\u00a0|a, \\u00c3\\u00a1|a, \\u00c3\\u00a2|a, \\u00c3\\u00a3|a, \\u00c3\\u00a4|a, \\u00c3\\u00a5|a, \\u00c3\\u00a6|a, \\u00c3\\u00a7|c, \\u00c3\\u00a8|e, \\u00c3\\u00a9|e, \\u00c3\\u00aa|e, \\u00c3\\u00ab|e, \\u00c3\\u00ac|i, \\u00c3\\u00ad|i, \\u00c3\\u00ae|i, \\u00c3\\u00af|i, \\u00c3\\u00b0|o, \\u00c3\\u00b1|n, \\u00c3\\u00b2|o, \\u00c3\\u00b3|o, \\u00c3\\u00b4|o, \\u00c3\\u00b5|o, \\u00c3\\u00b6|o, \\u00c3\\u00b8|o, \\u00c3\\u00b9|u, \\u00c3\\u00ba|u, \\u00c3\\u00bb|u, \\u00c3\\u00bc|u, \\u00c3\\u00bd|y, \\u00c3\\u00bf|y, \\u00c3\\u0178|ss\",\"sh404SefLabelCat\":\"\",\"sh404SefLabelUser\":\"blog\",\"sh404SefLabelItem\":\"2\",\"sh404SefTitleAlias\":\"alias\",\"sh404SefModK2ContentFeedAlias\":\"feed\",\"sh404SefInsertItemId\":\"0\",\"sh404SefInsertUniqueItemId\":\"0\",\"cbIntegration\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),(10001,'plg_finder_k2','plugin','k2','finder',0,1,1,0,'{\"name\":\"plg_finder_k2\",\"type\":\"plugin\",\"creationDate\":\"February 8th, 2013\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2013 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.net\",\"authorUrl\":\"www.joomlaworks.net\",\"version\":\"2.6.5\",\"description\":\"PLG_FINDER_K2_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(10002,'Search - K2','plugin','k2','search',0,1,1,0,'{\"name\":\"Search - K2\",\"type\":\"plugin\",\"creationDate\":\"February 8th, 2013\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2013 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.net\",\"authorUrl\":\"www.joomlaworks.net\",\"version\":\"2.6.5\",\"description\":\"K2_THIS_PLUGIN_EXTENDS_THE_DEFAULT_JOOMLA_SEARCH_FUNCTIONALITY_TO_K2_CONTENT\",\"group\":\"\"}','{\"search_limit\":\"50\",\"search_tags\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),(10003,'System - K2','plugin','k2','system',0,1,1,0,'{\"name\":\"System - K2\",\"type\":\"plugin\",\"creationDate\":\"February 8th, 2013\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2013 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.net\",\"authorUrl\":\"www.joomlaworks.net\",\"version\":\"2.6.5\",\"description\":\"K2_THE_K2_SYSTEM_PLUGIN_IS_USED_TO_ASSIST_THE_PROPER_FUNCTIONALITY_OF_THE_K2_COMPONENT_SITE_WIDE_MAKE_SURE_ITS_ALWAYS_PUBLISHED_WHEN_THE_K2_COMPONENT_IS_INSTALLED\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(10004,'User - K2','plugin','k2','user',0,1,1,0,'{\"name\":\"User - K2\",\"type\":\"plugin\",\"creationDate\":\"February 8th, 2013\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2013 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.net\",\"authorUrl\":\"www.joomlaworks.net\",\"version\":\"2.6.5\",\"description\":\"K2_A_USER_SYNCHRONIZATION_PLUGIN_FOR_K2\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(10005,'Josetta - K2 Categories','plugin','k2category','josetta_ext',0,1,1,0,'{\"name\":\"Josetta - K2 Categories\",\"type\":\"plugin\",\"creationDate\":\"February 8th, 2013\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2013 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.net\",\"authorUrl\":\"www.joomlaworks.net\",\"version\":\"2.6.5\",\"description\":\"\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(10006,'Josetta - K2 Items','plugin','k2item','josetta_ext',0,1,1,0,'{\"name\":\"Josetta - K2 Items\",\"type\":\"plugin\",\"creationDate\":\"June 7th, 2012\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2013 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.net\",\"authorUrl\":\"www.joomlaworks.net\",\"version\":\"2.6.5\",\"description\":\"\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(10007,'K2 Comments','module','mod_k2_comments','',0,1,0,0,'{\"name\":\"K2 Comments\",\"type\":\"module\",\"creationDate\":\"February 8th, 2013\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2013 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.net\",\"authorUrl\":\"www.joomlaworks.net\",\"version\":\"2.6.5\",\"description\":\"MOD_K2_COMMENTS_DESCRIPTION\",\"group\":\"\"}','{\"moduleclass_sfx\":\"\",\"module_usage\":\"\",\"\":\"K2_TOP_COMMENTERS\",\"catfilter\":\"0\",\"category_id\":\"\",\"comments_limit\":\"5\",\"comments_word_limit\":\"10\",\"commenterName\":\"1\",\"commentAvatar\":\"1\",\"commentAvatarWidthSelect\":\"custom\",\"commentAvatarWidth\":\"50\",\"commentDate\":\"1\",\"commentDateFormat\":\"absolute\",\"commentLink\":\"1\",\"itemTitle\":\"1\",\"itemCategory\":\"1\",\"feed\":\"1\",\"commenters_limit\":\"5\",\"commenterNameOrUsername\":\"1\",\"commenterAvatar\":\"1\",\"commenterAvatarWidthSelect\":\"custom\",\"commenterAvatarWidth\":\"50\",\"commenterLink\":\"1\",\"commenterCommentsCounter\":\"1\",\"commenterLatestComment\":\"1\",\"cache\":\"1\",\"cache_time\":\"900\"}','','',0,'0000-00-00 00:00:00',0,0),(10008,'K2 Content','module','mod_k2_content','',0,1,0,0,'{\"name\":\"K2 Content\",\"type\":\"module\",\"creationDate\":\"February 8th, 2013\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2013 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.net\",\"authorUrl\":\"www.joomlaworks.net\",\"version\":\"2.6.5\",\"description\":\"K2_MOD_K2_CONTENT_DESCRIPTION\",\"group\":\"\"}','{\"moduleclass_sfx\":\"\",\"getTemplate\":\"Default\",\"source\":\"filter\",\"\":\"K2_OTHER_OPTIONS\",\"catfilter\":\"0\",\"category_id\":\"\",\"getChildren\":\"0\",\"itemCount\":\"5\",\"itemsOrdering\":\"\",\"FeaturedItems\":\"1\",\"popularityRange\":\"\",\"videosOnly\":\"0\",\"item\":\"\",\"items\":\"\",\"itemTitle\":\"1\",\"itemAuthor\":\"1\",\"itemAuthorAvatar\":\"1\",\"itemAuthorAvatarWidthSelect\":\"custom\",\"itemAuthorAvatarWidth\":\"50\",\"userDescription\":\"1\",\"itemIntroText\":\"1\",\"itemIntroTextWordLimit\":\"\",\"itemImage\":\"1\",\"itemImgSize\":\"Small\",\"itemVideo\":\"1\",\"itemVideoCaption\":\"1\",\"itemVideoCredits\":\"1\",\"itemAttachments\":\"1\",\"itemTags\":\"1\",\"itemCategory\":\"1\",\"itemDateCreated\":\"1\",\"itemHits\":\"1\",\"itemReadMore\":\"1\",\"itemExtraFields\":\"0\",\"itemCommentsCounter\":\"1\",\"feed\":\"1\",\"itemPreText\":\"\",\"itemCustomLink\":\"0\",\"itemCustomLinkTitle\":\"\",\"itemCustomLinkURL\":\"http:\\/\\/\",\"itemCustomLinkMenuItem\":\"\",\"K2Plugins\":\"1\",\"JPlugins\":\"1\",\"cache\":\"1\",\"cache_time\":\"900\"}','','',0,'0000-00-00 00:00:00',0,0),(10009,'K2 Tools','module','mod_k2_tools','',0,1,0,0,'{\"name\":\"K2 Tools\",\"type\":\"module\",\"creationDate\":\"February 8th, 2013\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2013 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.net\",\"authorUrl\":\"www.joomlaworks.net\",\"version\":\"2.6.5\",\"description\":\"K2_TOOLS\",\"group\":\"\"}','{\"moduleclass_sfx\":\"\",\"module_usage\":\"0\",\"\":\"K2_CUSTOM_CODE_SETTINGS\",\"archiveItemsCounter\":\"1\",\"archiveCategory\":\"\",\"authors_module_category\":\"\",\"authorItemsCounter\":\"1\",\"authorAvatar\":\"1\",\"authorAvatarWidthSelect\":\"custom\",\"authorAvatarWidth\":\"50\",\"authorLatestItem\":\"1\",\"calendarCategory\":\"\",\"home\":\"\",\"seperator\":\"\",\"root_id\":\"\",\"end_level\":\"\",\"categoriesListOrdering\":\"\",\"categoriesListItemsCounter\":\"1\",\"root_id2\":\"\",\"catfilter\":\"0\",\"category_id\":\"\",\"getChildren\":\"0\",\"liveSearch\":\"\",\"width\":\"20\",\"text\":\"\",\"button\":\"\",\"imagebutton\":\"\",\"button_text\":\"\",\"min_size\":\"75\",\"max_size\":\"300\",\"cloud_limit\":\"30\",\"cloud_category\":\"0\",\"cloud_category_recursive\":\"0\",\"customCode\":\"\",\"parsePhp\":\"0\",\"K2Plugins\":\"0\",\"JPlugins\":\"0\",\"cache\":\"1\",\"cache_time\":\"900\"}','','',0,'0000-00-00 00:00:00',0,0),(10010,'K2 Users','module','mod_k2_users','',0,1,0,0,'{\"name\":\"K2 Users\",\"type\":\"module\",\"creationDate\":\"February 8th, 2013\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2013 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.net\",\"authorUrl\":\"www.joomlaworks.net\",\"version\":\"2.6.5\",\"description\":\"K2_MOD_K2_USERS_DESCRTIPTION\",\"group\":\"\"}','{\"moduleclass_sfx\":\"\",\"getTemplate\":\"Default\",\"source\":\"0\",\"\":\"K2_DISPLAY_OPTIONS\",\"filter\":\"1\",\"K2UserGroup\":\"\",\"ordering\":\"1\",\"limit\":\"4\",\"userIDs\":\"\",\"userName\":\"1\",\"userAvatar\":\"1\",\"userAvatarWidthSelect\":\"custom\",\"userAvatarWidth\":\"50\",\"userDescription\":\"1\",\"userDescriptionWordLimit\":\"\",\"userURL\":\"1\",\"userEmail\":\"0\",\"userFeed\":\"1\",\"userItemCount\":\"1\",\"cache\":\"1\",\"cache_time\":\"900\"}','','',0,'0000-00-00 00:00:00',0,0),(10011,'K2 User','module','mod_k2_user','',0,1,0,0,'{\"name\":\"K2 User\",\"type\":\"module\",\"creationDate\":\"February 8th, 2013\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2013 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.net\",\"authorUrl\":\"www.joomlaworks.net\",\"version\":\"2.6.5\",\"description\":\"K2_MOD_K2_USER_DESCRIPTION\",\"group\":\"\"}','{\"moduleclass_sfx\":\"\",\"pretext\":\"\",\"\":\"K2_LOGIN_LOGOUT_REDIRECTION\",\"name\":\"1\",\"userAvatar\":\"1\",\"userAvatarWidthSelect\":\"custom\",\"userAvatarWidth\":\"50\",\"menu\":\"\",\"login\":\"\",\"logout\":\"\",\"usesecure\":\"0\",\"cache\":\"0\",\"cache_time\":\"900\"}','','',0,'0000-00-00 00:00:00',0,0),(10012,'K2 Quick Icons (admin)','module','mod_k2_quickicons','',1,1,2,0,'{\"name\":\"K2 Quick Icons (admin)\",\"type\":\"module\",\"creationDate\":\"February 8th, 2013\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2013 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.net\",\"authorUrl\":\"www.joomlaworks.net\",\"version\":\"2.6.5\",\"description\":\"K2_QUICKICONS_FOR_USE_IN_THE_JOOMLA_CONTROL_PANEL_DASHBOARD_PAGE\",\"group\":\"\"}','{\"modCSSStyling\":\"1\",\"modLogo\":\"1\",\"cache\":\"0\",\"cache_time\":\"900\"}','','',0,'0000-00-00 00:00:00',0,0),(10013,'K2 Stats (admin)','module','mod_k2_stats','',1,1,2,0,'{\"name\":\"K2 Stats (admin)\",\"type\":\"module\",\"creationDate\":\"February 8th, 2013\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2013 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.net\",\"authorUrl\":\"www.joomlaworks.net\",\"version\":\"2.6.5\",\"description\":\"K2_STATS_FOR_USE_IN_THE_K2_DASHBOARD_PAGE\",\"group\":\"\"}','{\"latestItems\":\"1\",\"popularItems\":\"1\",\"mostCommentedItems\":\"1\",\"latestComments\":\"1\",\"statistics\":\"1\",\"cache\":\"0\",\"cache_time\":\"900\"}','','',0,'0000-00-00 00:00:00',0,0),(10014,'Authentication - Facebook','plugin','facebook','authentication',0,1,1,0,'{\"name\":\"Authentication - Facebook\",\"type\":\"plugin\",\"creationDate\":\"31 December 2011\",\"author\":\"GavickPro\",\"copyright\":\"Copyright (C) 2010 - 2011 GavickPro. All rights reserved.\",\"authorEmail\":\"support@gavick.com\",\"authorUrl\":\"http:\\/\\/gavick.com\",\"version\":\"GK4 1.2\",\"description\":\"GavickPro Facebook authentication plugin\",\"group\":\"\"}','{\"auto_register\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),(10015,'System - GK Extended Cache','plugin','gavickExtCache','system',0,0,1,0,'{\"name\":\"System - GK Extended Cache\",\"type\":\"plugin\",\"creationDate\":\"25 August 2011\",\"author\":\"www.gavick.com\",\"copyright\":\"All Rights Reserved.\",\"authorEmail\":\"test@gavick.com\",\"authorUrl\":\"http:\\/\\/www.gavick.com\",\"version\":\"1.0\",\"description\":\"Alternative for system cache plugin for GavickPro templates\",\"group\":\"\"}','[]','','',0,'0000-00-00 00:00:00',0,0),(10016,'System - GK Open Graph Article Parameters','plugin','plg_gk_opengraph','system',0,1,1,0,'{\"name\":\"System - GK Open Graph Article Parameters\",\"type\":\"plugin\",\"creationDate\":\"01 May 2010\",\"author\":\"www.gavick.com\",\"copyright\":\"All Rights Reserved.\",\"authorEmail\":\"test@gavick.com\",\"authorUrl\":\"http:\\/\\/www.gavick.com\",\"version\":\"1.0\",\"description\":\"Plugin which adds additional article options for GavickPro templates\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(10017,'Button - GK Typography','plugin','gk_typography','editors-xtd',0,1,1,0,'{\"name\":\"Button - GK Typography\",\"type\":\"plugin\",\"creationDate\":\"08\\/01\\/2011\",\"author\":\"Robert Gavick - GavickPro\",\"copyright\":\"Copyrighted Commercial Software\",\"authorEmail\":\"info@gavick.com\",\"authorUrl\":\"http:\\/\\/www.gavick.com\",\"version\":\"1.0.2\",\"description\":\"Plugin to easier typography using in Joomla WYSIWYG editors.\",\"group\":\"\"}','{\"typo_override\":\"gk_publisher:full.xml\"}','','',0,'0000-00-00 00:00:00',0,0),(10018,'System - GK Cache','plugin','plg_gkcache','system',0,0,1,0,'{\"name\":\"System - GK Cache\",\"type\":\"plugin\",\"creationDate\":\"25 August 2011\",\"author\":\"www.gavick.com\",\"copyright\":\"All Rights Reserved.\",\"authorEmail\":\"test@gavick.com\",\"authorUrl\":\"http:\\/\\/www.gavick.com\",\"version\":\"1.0\",\"description\":\"Plugin necessary if you\'re using Joomla! cache for GavickPro templates\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(10019,'GK Menu Extended Parameters','plugin','gkextmenu','system',0,1,1,0,'{\"name\":\"GK Menu Extended Parameters\",\"type\":\"plugin\",\"creationDate\":\"29 December 2010\",\"author\":\"www.gavick.com\",\"copyright\":\"All Rights Reserved.\",\"authorEmail\":\"support@gavick.com\",\"authorUrl\":\"http:\\/\\/www.gavick.com\",\"version\":\"1.0\",\"description\":\"Plugin which adds additional menu options for GavickPro templates\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(10020,'GK Module Title Links','plugin','plg_gkmodulelinks','system',0,0,1,0,'{\"name\":\"GK Module Title Links\",\"type\":\"plugin\",\"creationDate\":\"29 July 2012\",\"author\":\"www.gavick.com\",\"copyright\":\"All Rights Reserved.\",\"authorEmail\":\"test@gavick.com\",\"authorUrl\":\"http:\\/\\/www.gavick.com\",\"version\":\"1.0\",\"description\":\"Plugin which adds additional module options for module titles in GavickPRO Templates.\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),(10021,'mod_news_pro_gk4','module','mod_news_pro_gk4','',0,1,0,0,'{\"name\":\"mod_news_pro_gk4\",\"type\":\"module\",\"creationDate\":\"18\\/10\\/2012\",\"author\":\"Gavick.com\",\"copyright\":\"(C) 2009-2012 Gavick.com\",\"authorEmail\":\"info@gavick.com\",\"authorUrl\":\"www.gavick.com\",\"version\":\"GK4 3.3.2\",\"description\":\"\\n\\t\\t<style type=\'text\\/css\'>span.readonly { padding: 10px; font-family: Arial; font-size:13px !important; font-weight: normal !important; text-align: justify; color: #4d4d4d; line-height: 24px; } span.readonly h1 { clear:both; font-family: Georgia, sans-serif; font-size:38px; margin:30px 20px 23px; padding:0px 0px 24px 10px; color:#333; border-bottom: 1px solid #eee; font-weight: normal; } span.readonly p { margin: 0 26px 10px } span.readonly p a { color: #ab3f0a } span.readonly p.homepage { margin-top: 30px } span.readonly p.license { border-top: 1px solid #eee; font-size: 11px; margin: 30px 26px 0; padding: 6px 0; }<\\/style><span class=\'readonly\'><h1>News Show Pro GK4 <small>ver. 3.3.2<\\/small><\\/h1><p>GK4 is new generation of our extensions dedicated to Joomla 1.6+.<\\/p><p>Basing on experiences gathered, we created probably the best tool to present articles for Joomla! Huge amount of options and possibilities of formatting causes News Show Pro GK4 is a complex tool in making www pages content attractive. News Show Pro is appropriate while preparing simple structures with an individual article, the same as, complex arrangements including few articles and a list of links.<\\/p> <p class=\'homepage\'><a href=\'http:\\/\\/tools.gavick.com\\/newshowpro.html\' target=\'_blank\'>Learn more at the NSP GK4 project website.<\\/a><\\/p><p class=\'license\'>News Show Pro GK4 is released under the <a target=\\\"_blank\\\" href=\\\"http:\\/\\/www.gnu.org\\/licenses\\/gpl-2.0.html\\\">GNU\\/GPL v2 license.<\\/a><\\/p><\\/span>\\n\\t\",\"group\":\"\"}','{\"moduleclass_sfx\":\"\",\"automatic_module_id\":\"1\",\"module_unique_id\":\"newspro1\",\"module_mode\":\"normal\",\"module_width\":\"100\",\"portal_mode_1_module_height\":\"320\",\"module_font_size\":\"100\",\"data_source\":\"com_categories\",\"com_categories\":\"\",\"com_articles\":\"\",\"k2_categories\":\"\",\"k2_tags\":\"\",\"k2_articles\":\"\",\"news_sort_value\":\"created\",\"news_sort_order\":\"DESC\",\"news_since\":\"\",\"news_frontpage\":\"1\",\"unauthorized\":\"0\",\"only_frontpage\":\"0\",\"startposition\":\"0\",\"time_offset\":\"0\",\"news_portal_mode_1_amount\":\"10\",\"news_portal_mode_2_amount\":\"10\",\"news_portal_mode_3_amount\":\"10\",\"news_portal_mode_4_amount\":\"10\",\"news_portal_mode_5_amount\":\"10\",\"news_full_pages\":\"3\",\"news_column\":\"1\",\"news_rows\":\"1\",\"top_interface_style\":\"arrows_with_pagination\",\"news_content_header_pos\":\"left\",\"news_content_header_float\":\"none\",\"news_header_link\":\"1\",\"use_title_alias\":\"0\",\"title_limit_type\":\"chars\",\"title_limit\":\"40\",\"news_content_image_pos\":\"left\",\"news_content_image_float\":\"left\",\"news_image_link\":\"1\",\"news_content_text_pos\":\"left\",\"news_content_text_float\":\"left\",\"news_text_link\":\"0\",\"news_limit_type\":\"words\",\"news_limit\":\"30\",\"news_content_info_pos\":\"left\",\"news_content_info_float\":\"none\",\"news_content_info2_pos\":\"left\",\"news_content_info2_float\":\"left\",\"info_format\":\"%DATE %HITS %CATEGORY %AUTHOR\",\"info2_format\":\"\",\"category_link\":\"1\",\"date_format\":\"d-m-Y\",\"date_publish\":\"0\",\"username\":\"0\",\"user_avatar\":\"1\",\"avatar_size\":\"16\",\"art_padding\":\"0 20px 20px 0\",\"news_header_order\":\"1\",\"news_header_enabled\":\"1\",\"news_image_order\":\"3\",\"news_image_enabled\":\"1\",\"news_text_order\":\"4\",\"news_text_enabled\":\"1\",\"news_info_order\":\"2\",\"news_info_enabled\":\"1\",\"news_info2_order\":\"5\",\"news_info2_enabled\":\"1\",\"news_content_readmore_pos\":\"right\",\"news_readmore_enabled\":\"1\",\"news_short_pages\":\"3\",\"links_amount\":\"3\",\"links_columns_amount\":\"1\",\"bottom_interface_style\":\"arrows_with_counter\",\"links_margin\":\"0\",\"links_position\":\"bottom\",\"links_width\":\"50\",\"show_list_description\":\"1\",\"list_title_limit_type\":\"words\",\"list_title_limit\":\"20\",\"list_text_limit_type\":\"words\",\"list_text_limit\":\"30\",\"responsive_images\":\"0\",\"wrap_content\":\"0\",\"memory_limit\":\"128M\",\"create_thumbs\":\"0\",\"k2_thumbs\":\"first\",\"thumb_image_type\":\"full\",\"img_auto_scale\":\"1\",\"img_keep_aspect_ratio\":\"0\",\"img_width\":\"160\",\"img_height\":\"120\",\"img_margin\":\"6px 14px 0 0\",\"img_bg\":\"#000\",\"img_stretch\":\"0\",\"img_quality\":\"95\",\"cache_time\":\"30\",\"simple_crop_editor\":\"\",\"simple_crop_top\":\"10\",\"simple_crop_bottom\":\"10\",\"simple_crop_left\":\"10\",\"simple_crop_right\":\"10\",\"crop_rules\":\"\",\"autoanim\":\"0\",\"hover_anim\":\"0\",\"animation_speed\":\"400\",\"animation_interval\":\"5000\",\"news_portal_mode_3_open_first\":\"1\",\"animation_function\":\"Fx.Transitions.Expo.easeIn\",\"clean_xhtml\":\"1\",\"more_text_value\":\"...\",\"parse_plugins\":\"0\",\"clean_plugins\":\"0\",\"useCSS\":\"1\",\"useScript\":\"2\",\"useRTL\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),(10022,'Image Show GK4','module','mod_image_show_gk4','',0,1,0,0,'{\"name\":\"Image Show GK4\",\"type\":\"module\",\"creationDate\":\"08\\/11\\/2012\",\"author\":\"GavickPro\",\"copyright\":\"Copyright (C) 2011-2012 GavickPro. All rights reserved.\",\"authorEmail\":\"info@gavick.com\",\"authorUrl\":\"www.gavickpro.com\",\"version\":\"GK4 1.32\",\"description\":\"\\n\\t\\t<style type=\\\"text\\/css\\\">\\n\\t\\t\\tspan.readonly { padding: 10px; font-family: Arial; font-size:13px !important; font-weight: normal !important; text-align: justify; color: #4d4d4d; line-height: 24px; }\\n\\t\\t\\tspan.readonly h1 { clear:both; font-family: Georgia, sans-serif; font-size:38px; margin:30px 20px 23px; padding:0px 0px 24px 10px; color:#333; border-bottom: 1px solid #eee; font-weight: normal; }\\n\\t\\t\\tspan.readonly p { margin: 0 26px 10px }\\n\\t\\t\\tspan.readonly p a { color: #8e0b8c }\\n\\t\\t\\tspan.readonly p.homepage { margin-top: 30px }\\n\\t\\t\\tspan.readonly p.license { border-top: 1px solid #eee; font-size: 11px; margin: 30px 26px 0; padding: 6px 0; }\\n\\t\\t<\\/style>\\n\\n\\t\\t<span class=\\\"readonly\\\"><h1>Image Show GK4<small>ver. 1.32<\\/small><\\/h1><p>GK4 is new generation of our extensions dedicated to Joomla 1.6+.<\\/p><p>With Image Show GK4 module, you can create slideshow on a site which include various images and article fragments or texts defined by a user. Thanks to slide management system integrated in the module, its support is very easy, intuitive and fast. With the new method of creating module styles you can easily move your slideshow style from one template to other template.<\\/p> <p class=\'homepage\'><a href=\'http:\\/\\/tools.gavick.com\\/image-show.html\' target=\'_blank\'>Learn more at the Image Show GK4 project website.<\\/a><\\/p><p class=\'license\'>Image Show GK4 is released under the <a target=\\\"_blank\\\" href=\\\"http:\\/\\/www.gnu.org\\/licenses\\/gpl-2.0.html\\\">GNU\\/GPL v2 license.<\\/a><\\/p><\\/span>\\n\\t\",\"group\":\"\"}','{\"automatic_module_id\":\"1\",\"module_id\":\"gk-is-1\",\"moduleclass_sfx\":\"\",\"module_style\":\"gk_coffe\",\"use_style_css\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),(10024,'Social GK5','module','mod_social_gk5','',0,1,0,0,'{\"name\":\"Social GK5\",\"type\":\"module\",\"creationDate\":\"19\\/10\\/2012\",\"author\":\"GavickPro\",\"copyright\":\"Copyright (C) 2011-2012 GavickPro. All rights reserved.\",\"authorEmail\":\"info@gavick.com\",\"authorUrl\":\"www.gavickpro.com\",\"version\":\"GK5 1.0\",\"description\":\"\\n\\t\\t<style type=\\\"text\\/css\\\">\\n\\t\\t\\tspan.readonly { padding: 10px; font-family: Arial; font-size:13px !important; font-weight: normal !important; text-align: justify; color: #4d4d4d; line-height: 24px; }\\n\\t\\t\\tspan.readonly h1 { clear:both; font-family: Georgia, sans-serif; font-size:38px; margin:30px 20px 23px; padding:0px 0px 24px 10px; color:#333; border-bottom: 1px solid #eee; font-weight: normal; }\\n\\t\\t\\tspan.readonly p { margin: 0 26px 10px }\\n\\t\\t\\tspan.readonly p a { color: #2F4C6D }\\n\\t\\t\\tspan.readonly p.homepage { margin-top: 30px }\\n\\t\\t\\tspan.readonly p.license { border-top: 1px solid #eee; font-size: 11px; margin: 30px 26px 0; padding: 6px 0; }\\n\\t\\t<\\/style>\\n\\t\\t\\n\\t\\t<span class=\\\"readonly\\\"><h1>Social GK5<small>ver. 1.0<\\/small><\\/h1><p>GK5 is one product of the next generation of GavickPro extensions designed exclusively for Joomla 2.5+.<\\/p><p>Social GK5 combines functionalities from FB GK4, Gplus GK4 and completely new support for data source from a Twitter portal. Social GK5 supports the most popular services like: Facebook, Google+ and Twitter. This module allows visitors to connect directly and to promote your brand on the most popular social portals.<\\/p> <p class=\\\"homepage\\\"><a target=\\\"_blank\\\" href=\\\"https:\\/\\/www.gavick.com\\/social-gk5.html\\\">Learn more at the Social GK5 project website.<\\/a><\\/p><p class=\\\"license\\\">Social GK5 is released under the <a href=\\\"http:\\/\\/www.gnu.org\\/licenses\\/gpl-2.0.html\\\" target=\\\"_blank\\\">GNU\\/GPL v2 license.<\\/a><\\/p><\\/span><\\/span>\\n\\t\",\"group\":\"\"}','{\"automatic_module_id\":\"1\",\"module_id\":\"gk-social-1\",\"moduleclass_sfx\":\"\",\"cookie_conset\":\"0\",\"module_data_source\":\"fb\",\"twitter_widget\":\"search\",\"twitter_username\":\"gavickpro\",\"twitter_search_query\":\"gavickpro\",\"twitter_tweet_amount\":\"10\",\"twitter_title\":\"Search tweets\",\"twitter_desc\":\"by phrase...\",\"twitter_widget_color\":\"#CECCCC\",\"twitter_tweet_color\":\"#FFFFFF\",\"twitter_link_color\":\"#A51212\",\"twitter_widget_text_color\":\"#474747\",\"twitter_tweet_text_color\":\"#444444\",\"twitter_auto_refresh\":\"true\",\"twitter_loop\":\"true\",\"twitter_behaviour\":\"default\",\"twitter_include_scrollbar\":\"false\",\"twitter_interval\":\"30000\",\"twitter_height\":\"250\",\"twitter_tweet_style\":\"search\",\"twitter_rows\":\"5\",\"twitter_columns\":\"1\",\"twitter_use_css\":\"1\",\"twitter_show_uname\":\"1\",\"twitter_show_fname\":\"1\",\"twitter_show_actions\":\"1\",\"twitter_show_avatar\":\"1\",\"twitter_time_mode\":\"cdate\",\"twitter_cache\":\"1\",\"twitter_cache_time\":\"10\",\"gplus_id\":\"110937149959405490547\",\"gplus_badge_style\":\"standard_badge\",\"gplus_lang_code\":\"en\",\"gplus_badge_width\":\"300\",\"gplus_badge_color\":\"light\",\"gplus_async_script\":\"1\",\"gplus_html5_valid\":\"1\",\"gplus_custom_name\":\"\",\"gplus_custom_name_pos\":\"before\",\"fb_auto_url\":\"true\",\"fb_site\":\"www.yourdomain.com\",\"fb_data_source\":\"activity_feed\",\"fb_code_type\":\"iframe\",\"fb_language\":\"en_US\",\"fb_width\":\"300\",\"fb_height\":\"300\",\"fb_header\":\"true\",\"fb_colorscheme\":\"light\",\"fb_font\":\"light\",\"fb_border_color\":\"#CECCCC\",\"fb_recommendations\":\"false\",\"fb_link_target\":\"_blank\",\"fb_number_comments\":\"10\",\"fb_width_comments\":\"500\",\"fb_only_number\":\"false\",\"fb_comments_colorscheme\":\"light\",\"fb_only_number_add\":\"awesome comments\",\"fb_only_number_url\":\"false\",\"fb_facepile_width\":\"200\",\"fb_facepile_num_rows\":\"2\",\"fb_facepile_colorscheme\":\"light\",\"fb_facepile_size\":\"small\",\"fb_likebox_width\":\"300\",\"fb_likebox_height\":\"300\",\"fb_likebox_header\":\"true\",\"fb_likebox_colorscheme\":\"light\",\"fb_likebox_faces\":\"true\",\"fb_likebox_stream\":\"true\",\"fb_livestream_width\":\"300\",\"fb_livestream_height\":\"300\",\"fb_livestream_xid\":\"\",\"fb_livestream_url\":\"\",\"fb_livestream_friends\":\"true\",\"fb_rec_width\":\"300\",\"fb_rec_height\":\"300\",\"fb_rec_header\":\"true\",\"fb_rec_colorscheme\":\"light\",\"fb_rec_font\":\"light\",\"fb_rec_link_target\":\"_blank\",\"fb_rec_border_color\":\"#CECCCC\"}','','',0,'0000-00-00 00:00:00',0,0),(10025,'gk_publisher','template','gk_publisher','',0,1,1,0,'{\"name\":\"gk_publisher\",\"type\":\"template\",\"creationDate\":\"30 November 2012\",\"author\":\"GavickPro\",\"copyright\":\"Copyright (C) 2007 - 2012 GavickPro. All rights reserved.\",\"authorEmail\":\"support@gavick.com\",\"authorUrl\":\"http:\\/\\/gavick.com\",\"version\":\"3.6\",\"description\":\"\\n\\t\\t\\t\\t\\t\\t<link rel=\\\"stylesheet\\\" type=\\\"text\\/css\\\" href=\\\"..\\/templates\\/gk_publisher\\/admin\\/style.css\\\" \\/>\\n\\t\\t\\t\\t\\t\\t\\t\\t\\t<style type=\\\"text\\/css\\\" media=\\\"all\\\">\\n\\t\\t\\t\\t\\t\\t\\t\\t\\t<!--\\n\\t\\t\\t\\t\\t\\t\\t\\t\\t#wrap1 {padding:0px 0px 4px 0px;}\\n\\t\\t\\t\\t\\t\\t\\t\\t\\th1 {clear:both;font-family: Georgia, sans-serif;font-size:38px;margin:30px 20px 12px ;padding:0px 0px 24px 10px;color:#333; border-bottom: 1px solid #ccc; font-weight: normal;}\\n\\t\\t\\t\\t\\t\\t\\t\\t\\th4 { border: none;  margin: 0 0 12px; padding:0; font: italic 20px\\/32px Georgia, sans-serif; color: #333; }\\n\\t\\t\\t\\t\\t\\t\\t\\t\\tsup { font-style: italic; font-size: }\\n\\t\\t\\t\\t\\t\\t\\t\\t\\t.wrap2 {background:#fff;padding: 20px; font-family: Arial; font-size:13px; text-align: justify; color: #4d4d4d; line-height: 24px;}\\n\\t\\t\\t\\t\\t\\t\\t\\t\\t.leftart {margin: 16px 0 0 176px; font-weight:normal!important; }\\n\\t\\t\\t\\t\\t\\t\\t\\t\\t.livedemo { margin-top: 28px; }\\n\\t\\t\\t\\t\\t\\t\\t\\t\\t-->\\n\\t\\t\\t\\t\\t\\t\\t\\t\\t<\\/style>\\t\\n\\t\\t\\t\\t\\t\\t\\t\\t\\t\\n\\t\\t\\t\\t\\t\\t\\t\\t\\t<div id=\\\"wrap1\\\">    \\n\\t\\t\\t\\t\\t\\t\\t\\t\\t<h1><em>Publisher<\\/em><\\/h1>\\n\\t\\t\\t\\t\\t\\t\\t\\t\\t<div class=\\\"wrap2\\\">                    \\n\\t\\t\\t\\t\\t\\t\\t\\t\\t\\n\\t\\t\\t\\t\\t\\t\\t\\t\\t<a title=\\\"Visit the official website!\\\" href=\\\"demo.gavick.com\\/joomla25\\/publisher\\/\\\" target=\\\"_blank\\\"> <img style=\\\"padding-left: 10px;float: left; background-color: #fff;\\\" src=\\\"..\\/templates\\/gk_publisher\\/images\\/template_image.jpg\\\" border=\\\"0\\\" alt=\\\"Logo\\\" \\/><\\/a>       \\n\\t\\t\\t\\t\\t\\t\\t\\t\\t\\n\\t\\t\\t\\t\\t\\t\\t\\t\\t<div class=\\\"leftart\\\">            \\n\\t\\t\\t\\t\\t\\t\\t\\t\\t\\n\\t\\t\\t\\t\\t\\t\\t\\t\\t<h4>Startup - Joomla Business Template <\\/h4>\\n\\t\\t\\t\\t\\t\\t\\t\\t\\t\\n\\t\\t\\t\\t\\t\\t\\t\\t\\t<p>Do you want to express your opinions in public?<\\/p>\\n\\t\\t\\t\\t\\t\\t\\t\\t\\t<p> Share your thoughts and ideas with your users by building your personal website with GavickPro latest Joomla! template.\\n\\t\\t\\t\\t\\t\\t\\t\\t\\tDon\'t you think it\'s high time for you to come out of the shadow and start living your life completely? <br \\/>Publisher will  help you to present all information in a clear manner so as to allow your visitors notice you and your perfectly designed Joomla! website in the crowd.<\\/p>\\n\\t\\t\\t\\t\\t\\t\\t\\t\\t<p> To make your online image more outstanding, we prepared this Joomla! template in four various styles including a Christmas one with which you may feel Christmas atmosphere closer...<\\/p>\\n\\t\\t\\t\\t\\t\\t\\t\\t\\t<p> Our latest template will definitely make your blog or any other personal website more attractive thanks to the following extensions implemented: K2, News Show Pro, Image Show or Social GK5.<\\/p>\\n\\t\\t\\t\\t\\t\\t\\t\\t\\t<p> Don\'t waste your chance, build an effective Joomla! website now!<\\/p>\\n\\t\\t\\t\\t\\t\\t\\t\\t\\t\\n\\t\\t\\t\\t\\t\\t\\t\\t\\t\\n\\t\\t\\t\\t\\t\\t\\t\\t\\t\\n\\t\\t\\t\\t\\t\\t\\t\\t\\t<p class=\\\"livedemo\\\">View Publisher template in action <a href=\\\"demo.gavick.com\\/joomla25\\/publisher\\/\\\" target=\\\"_blank\\\">here<\\/a>...<\\/p><small>Gavern v.3.6<\\/small><\\/div>\\n\\t\\t\\t\\t\\t\\t\\t\\t\\t<\\/div>\\n\\t\\t\\t\\t\\t\\t\\t\\t\\t<\\/div>\\n\\t\\t\\t\",\"group\":\"\"}','{\"template_color\":\"1\",\"default_layout\":\"default\",\"template_width\":\"1020\",\"tablet_width\":\"900\",\"mobile_width\":\"540\",\"sidebar_position\":\"right\",\"sidebar_width\":\"30\",\"login_url\":\"index.php?option=com_users&view=login\",\"register_link\":\"1\",\"register_url\":\"index.php?option=com_users&view=registration\",\"logo_type\":\"image\",\"logo_image\":\"\",\"logo_text\":\"\",\"logo_slogan\":\"\",\"print_logo\":\"\",\"print_behaviour\":\"1\",\"favicon_image\":\"\",\"stylearea\":\"1\",\"framework_logo\":\"1\",\"webmaster_contact_type\":\"1\",\"webmaster_contact\":\"webmaster@gavick.com\",\"typography\":\"0\",\"typo_iconset\":\"0\",\"tools\":\"1\",\"show_menu\":\"1\",\"startlevel\":\"0\",\"endlevel\":\"-1\",\"menu_animation\":\"slide\",\"menu_height\":\"0\",\"menu_width\":\"0\",\"menu_col_width\":\"200\",\"menu_duration\":\"500\",\"fb_api_id\":\"\",\"fb_lang\":\"en_US\",\"fb_login\":\"0\",\"fb_like\":\"0\",\"fb_like_send\":\"0\",\"fb_like_layout\":\"standard\",\"fb_like_show_faces\":\"true\",\"fb_like_width\":\"500\",\"fb_like_action\":\"like\",\"fb_like_font\":\"arial\",\"fb_like_colorscheme\":\"light\",\"google_plus\":\"1\",\"google_plus_count\":\"1\",\"google_plus_size\":\"medium\",\"google_plus_lang\":\"en-GB\",\"google_plus_share\":\"1\",\"google_plus_share_annotation\":\"vertical-bubble\",\"google_plus_share_size\":\"20\",\"tweet_btn\":\"0\",\"tweet_btn_data_count\":\"vertical\",\"tweet_btn_data_via\":\"\",\"tweet_btn_data_lang\":\"en\",\"pinterest_btn\":\"0\",\"pinterest_btn_style\":\"horizontal\",\"excluded_cats\":\"\",\"cookie_consent\":\"0\",\"consenttype\":\"explicit\",\"cookie_latest_version\":\"0\",\"cookie_use_ssl\":\"0\",\"banner_position\":\"bottom\",\"banner_tag_placement\":\"bottom-right\",\"cookie_style\":\"light\",\"refreshOnConsent\":\"0\",\"cookiecss\":\"1\",\"use_gk_cache\":\"0\",\"css_cache\":\"0\",\"css_compression\":\"0\",\"css_override\":\"0\",\"css_prefixer\":\"0\",\"js_compression\":\"0\",\"chrome_frame_support\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0);


--
-- Table structure for table `#__finder_filters`
--



CREATE TABLE `#__finder_filters` (
  `filter_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL,
  `alias` varchar(255) NOT NULL,
  `state` tinyint(1) NOT NULL DEFAULT '1',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL,
  `created_by_alias` varchar(255) NOT NULL,
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `map_count` int(10) unsigned NOT NULL DEFAULT '0',
  `data` text NOT NULL,
  `params` mediumtext,
  PRIMARY KEY (`filter_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_filters`
--




--
-- Table structure for table `#__finder_links`
--



CREATE TABLE `#__finder_links` (
  `link_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `url` varchar(255) NOT NULL,
  `route` varchar(255) NOT NULL,
  `title` varchar(255) DEFAULT NULL,
  `description` varchar(255) DEFAULT NULL,
  `indexdate` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `md5sum` varchar(32) DEFAULT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '1',
  `state` int(5) DEFAULT '1',
  `access` int(5) DEFAULT '0',
  `language` varchar(8) NOT NULL,
  `publish_start_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_end_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `start_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `end_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `list_price` double unsigned NOT NULL DEFAULT '0',
  `sale_price` double unsigned NOT NULL DEFAULT '0',
  `type_id` int(11) NOT NULL,
  `object` mediumblob NOT NULL,
  PRIMARY KEY (`link_id`),
  KEY `idx_type` (`type_id`),
  KEY `idx_title` (`title`),
  KEY `idx_md5` (`md5sum`),
  KEY `idx_url` (`url`(75)),
  KEY `idx_published_list` (`published`,`state`,`access`,`publish_start_date`,`publish_end_date`,`list_price`),
  KEY `idx_published_sale` (`published`,`state`,`access`,`publish_start_date`,`publish_end_date`,`sale_price`)
) ENGINE=InnoDB AUTO_INCREMENT=17 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_links`
--


INSERT INTO `#__finder_links` (`link_id`, `url`, `route`, `title`, `description`, `indexdate`, `md5sum`, `published`, `state`, `access`, `language`, `publish_start_date`, `publish_end_date`, `start_date`, `end_date`, `list_price`, `sale_price`, `type_id`, `object`) VALUES (1,'index.php?option=com_k2&view=item&id=1','index.php?option=com_k2&view=item&id=1:snowbasin-is-now-open&Itemid=166','Snowbasin is now open','Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.','2013-02-08 10:13:30','d465a4ce3ec3b4607a2476b49626e594',1,1,1,'*','2012-12-03 11:26:54','0000-00-00 00:00:00','2012-12-03 11:26:54','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:1:\"1\";s:5:\"alias\";s:21:\"snowbasin-is-now-open\";s:7:\"summary\";s:256:\"<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n\";s:4:\"body\";s:646:\"\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla. Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<ul>\r\n<li>Lorem Ipsum</li>\r\n<li>Lorem Ipsum</li>\r\n<li>Lorem Ipsum</li>\r\n</ul>\r\n<ol>\r\n<li>Lorem Ipsum</li>\r\n<li>Lorem Ipsum</li>\r\n<li>Lorem Ipsum</li>\r\n</ol>\";s:5:\"catid\";s:1:\"3\";s:10:\"created_by\";s:3:\"944\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"2013-02-08 09:13:30\";s:11:\"modified_by\";s:3:\"944\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":136:{s:10:\"enable_css\";s:1:\"1\";s:14:\"jQueryHandling\";s:9:\"1.8remote\";s:21:\"backendJQueryHandling\";s:6:\"remote\";s:8:\"userName\";s:1:\"1\";s:9:\"userImage\";s:1:\"1\";s:15:\"userDescription\";s:1:\"1\";s:7:\"userURL\";s:1:\"1\";s:9:\"userEmail\";s:1:\"0\";s:12:\"userFeedLink\";s:1:\"1\";s:12:\"userFeedIcon\";s:1:\"1\";s:13:\"userItemCount\";s:1:\"4\";s:13:\"userItemTitle\";s:1:\"1\";s:19:\"userItemTitleLinked\";s:1:\"1\";s:19:\"userItemDateCreated\";s:1:\"1\";s:13:\"userItemImage\";s:1:\"1\";s:17:\"userItemIntroText\";s:1:\"1\";s:16:\"userItemCategory\";s:1:\"1\";s:12:\"userItemTags\";s:1:\"1\";s:22:\"userItemCommentsAnchor\";s:1:\"1\";s:16:\"userItemReadMore\";s:1:\"1\";s:17:\"userItemK2Plugins\";s:1:\"1\";s:18:\"defaultUsersItemid\";s:0:\"\";s:12:\"tagItemCount\";s:1:\"4\";s:12:\"tagItemTitle\";s:1:\"1\";s:18:\"tagItemTitleLinked\";s:1:\"1\";s:18:\"tagItemDateCreated\";s:1:\"1\";s:12:\"tagItemImage\";s:1:\"1\";s:16:\"tagItemIntroText\";s:1:\"1\";s:15:\"tagItemCategory\";s:1:\"1\";s:15:\"tagItemReadMore\";s:1:\"1\";s:18:\"tagItemExtraFields\";s:1:\"0\";s:11:\"tagOrdering\";s:0:\"\";s:11:\"tagFeedLink\";s:1:\"1\";s:11:\"tagFeedIcon\";s:1:\"1\";s:17:\"defaultTagsItemid\";s:0:\"\";s:16:\"genericItemCount\";s:2:\"10\";s:16:\"genericItemTitle\";s:1:\"1\";s:22:\"genericItemTitleLinked\";s:1:\"1\";s:22:\"genericItemDateCreated\";s:1:\"1\";s:16:\"genericItemImage\";s:1:\"1\";s:20:\"genericItemIntroText\";s:1:\"1\";s:19:\"genericItemCategory\";s:1:\"1\";s:19:\"genericItemReadMore\";s:1:\"1\";s:22:\"genericItemExtraFields\";s:1:\"0\";s:15:\"genericFeedLink\";s:1:\"1\";s:15:\"genericFeedIcon\";s:1:\"1\";s:9:\"feedLimit\";s:2:\"10\";s:13:\"feedItemImage\";s:1:\"1\";s:11:\"feedImgSize\";s:1:\"L\";s:17:\"feedItemIntroText\";s:1:\"1\";s:17:\"feedTextWordLimit\";s:0:\"\";s:16:\"feedItemFullText\";s:1:\"1\";s:12:\"feedItemTags\";s:1:\"0\";s:13:\"feedItemVideo\";s:1:\"0\";s:15:\"feedItemGallery\";s:1:\"0\";s:19:\"feedItemAttachments\";s:1:\"0\";s:14:\"feedBogusEmail\";s:0:\"\";s:16:\"introTextCleanup\";s:1:\"0\";s:27:\"introTextCleanupExcludeTags\";s:0:\"\";s:23:\"introTextCleanupTagAttr\";s:0:\"\";s:15:\"fullTextCleanup\";s:1:\"0\";s:26:\"fullTextCleanupExcludeTags\";s:0:\"\";s:22:\"fullTextCleanupTagAttr\";s:0:\"\";s:12:\"xssFiltering\";s:1:\"0\";s:14:\"linkPopupWidth\";s:3:\"900\";s:15:\"linkPopupHeight\";s:3:\"600\";s:13:\"imagesQuality\";s:2:\"95\";s:11:\"itemImageXS\";s:3:\"100\";s:10:\"itemImageS\";s:3:\"200\";s:10:\"itemImageM\";s:3:\"700\";s:10:\"itemImageL\";s:3:\"700\";s:11:\"itemImageXL\";s:3:\"918\";s:16:\"itemImageGeneric\";s:3:\"700\";s:13:\"catImageWidth\";s:3:\"700\";s:15:\"catImageDefault\";s:1:\"1\";s:14:\"userImageWidth\";s:3:\"116\";s:16:\"userImageDefault\";s:1:\"1\";s:17:\"commenterImgWidth\";s:2:\"48\";s:17:\"onlineImageEditor\";s:8:\"splashup\";s:14:\"imageTimestamp\";s:1:\"0\";s:16:\"imageMemoryLimit\";s:0:\"\";s:16:\"socialButtonCode\";s:0:\"\";s:15:\"twitterUsername\";s:0:\"\";s:13:\"facebookImage\";s:5:\"Small\";s:8:\"comments\";s:1:\"1\";s:16:\"commentsOrdering\";s:4:\"DESC\";s:13:\"commentsLimit\";s:2:\"10\";s:20:\"commentsFormPosition\";s:5:\"below\";s:18:\"commentsPublishing\";s:1:\"1\";s:17:\"commentsReporting\";s:1:\"2\";s:23:\"commentsReportRecipient\";s:0:\"\";s:24:\"inlineCommentsModeration\";s:1:\"0\";s:8:\"gravatar\";s:1:\"1\";s:9:\"recaptcha\";s:1:\"0\";s:17:\"commentsFormNotes\";s:1:\"1\";s:21:\"commentsFormNotesText\";s:0:\"\";s:15:\"frontendEditing\";s:1:\"1\";s:12:\"showImageTab\";s:1:\"1\";s:19:\"showImageGalleryTab\";s:1:\"1\";s:12:\"showVideoTab\";s:1:\"1\";s:18:\"showExtraFieldsTab\";s:1:\"1\";s:18:\"showAttachmentsTab\";s:1:\"1\";s:13:\"showK2Plugins\";s:1:\"1\";s:22:\"sideBarDisplayFrontend\";s:1:\"0\";s:12:\"mergeEditors\";s:1:\"1\";s:14:\"sideBarDisplay\";s:1:\"1\";s:17:\"attachmentsFolder\";s:0:\"\";s:16:\"hideImportButton\";s:1:\"0\";s:13:\"taggingSystem\";s:1:\"1\";s:8:\"lockTags\";s:1:\"0\";s:13:\"showTagFilter\";s:1:\"0\";s:12:\"googleSearch\";s:1:\"0\";s:21:\"googleSearchContainer\";s:11:\"k2Container\";s:13:\"K2UserProfile\";s:1:\"0\";s:8:\"redirect\";s:3:\"101\";s:11:\"adminSearch\";s:6:\"simple\";s:12:\"cookieDomain\";s:0:\"\";s:20:\"recaptcha_public_key\";s:0:\"\";s:21:\"recaptcha_private_key\";s:0:\"\";s:15:\"recaptcha_theme\";s:5:\"clean\";s:23:\"recaptchaOnRegistration\";s:1:\"0\";s:13:\"stopForumSpam\";s:1:\"0\";s:19:\"stopForumSpamApiKey\";s:0:\"\";s:21:\"showItemsCounterAdmin\";s:1:\"1\";s:17:\"showChildCatItems\";s:1:\"1\";s:22:\"disableCompactOrdering\";s:1:\"0\";s:13:\"metaDescLimit\";s:3:\"150\";s:15:\"SEFReplacements\";s:583:\"Å |S, Å’|O, Å½|Z, Å¡|s, Å“|oe, Å¾|z, Å¸|Y, Â¥|Y, Âµ|u, Ã€|A, Ã�|A, Ã‚|A, Ãƒ|A, Ã„|A, Ã…|A, Ã†|A, Ã‡|C, Ãˆ|E, Ã‰|E, ÃŠ|E, Ã‹|E, ÃŒ|I, Ã�|I, ÃŽ|I, Ã�|I, Ã�|D, Ã‘|N, Ã’|O, Ã“|O, Ã”|O, Ã•|O, Ã–|O, Ã˜|O, Ã™|U, Ãš|U, Ã›|U, Ãœ|U, Ã�|Y, ÃŸ|s, Ã |a, Ã¡|a, Ã¢|a, Ã£|a, Ã¤|a, Ã¥|a, Ã¦|a, Ã§|c, Ã¨|e, Ã©|e, Ãª|e, Ã«|e, Ã¬|i, Ã­|i, Ã®|i, Ã¯|i, Ã°|o, Ã±|n, Ã²|o, Ã³|o, Ã´|o, Ãµ|o, Ã¶|o, Ã¸|o, Ã¹|u, Ãº|u, Ã»|u, Ã¼|u, Ã½|y, Ã¿|y, ÃŸ|ss\";s:16:\"sh404SefLabelCat\";s:0:\"\";s:17:\"sh404SefLabelUser\";s:4:\"blog\";s:17:\"sh404SefLabelItem\";s:1:\"2\";s:18:\"sh404SefTitleAlias\";s:5:\"alias\";s:29:\"sh404SefModK2ContentFeedAlias\";s:4:\"feed\";s:20:\"sh404SefInsertItemId\";s:1:\"0\";s:26:\"sh404SefInsertUniqueItemId\";s:1:\"0\";s:13:\"cbIntegration\";s:1:\"0\";}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";}}s:8:\"ordering\";s:1:\"1\";s:5:\"trash\";s:1:\"0\";s:9:\"cat_trash\";s:1:\"0\";s:8:\"category\";s:16:\"Gear Accessories\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:23:\"1:snowbasin-is-now-open\";s:7:\"catslug\";s:18:\"3:gear-accessories\";s:6:\"author\";s:10:\"Super User\";s:6:\"layout\";s:4:\"item\";s:4:\"path\";s:46:\"index.php/k2/item/item/1-snowbasin-is-now-open\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"K2 Item\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"K2 Item\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:10:\"Super User\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:10:\"Super User\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:11:\"K2 Category\";a:1:{s:16:\"Gear Accessories\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:16:\"Gear Accessories\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:38:\"index.php?option=com_k2&view=item&id=1\";s:5:\"route\";s:71:\"index.php?option=com_k2&view=item&id=1:snowbasin-is-now-open&Itemid=166\";s:5:\"title\";s:21:\"Snowbasin is now open\";s:11:\"description\";s:247:\"Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2012-12-03 11:26:54\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2012-12-03 11:26:54\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;}'),(2,'index.php?option=com_k2&view=item&id=2','index.php?option=com_k2&view=item&id=2:what-makes-a-snowboarding-destination','What Makes A Snowboarding Destination','Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.','2012-12-03 12:32:58','301574457e80c8159d1680e8138980a1',1,1,1,'*','2012-12-03 11:31:02','0000-00-00 00:00:00','2012-12-03 11:31:02','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:1:\"2\";s:5:\"alias\";s:37:\"what-makes-a-snowboarding-destination\";s:7:\"summary\";s:256:\"<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n\";s:4:\"body\";s:488:\"\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla. Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\";s:5:\"catid\";s:1:\"3\";s:10:\"created_by\";s:3:\"944\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"0000-00-00 00:00:00\";s:11:\"modified_by\";s:1:\"0\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":239:{s:10:\"enable_css\";s:1:\"1\";s:14:\"jQueryHandling\";s:9:\"1.8remote\";s:21:\"backendJQueryHandling\";s:6:\"remote\";s:8:\"userName\";s:1:\"1\";s:9:\"userImage\";s:1:\"1\";s:15:\"userDescription\";s:1:\"1\";s:7:\"userURL\";s:1:\"1\";s:9:\"userEmail\";s:1:\"0\";s:12:\"userFeedLink\";s:1:\"1\";s:12:\"userFeedIcon\";s:1:\"1\";s:13:\"userItemCount\";s:1:\"4\";s:13:\"userItemTitle\";s:1:\"1\";s:19:\"userItemTitleLinked\";s:1:\"1\";s:19:\"userItemDateCreated\";s:1:\"1\";s:13:\"userItemImage\";s:1:\"1\";s:17:\"userItemIntroText\";s:1:\"1\";s:16:\"userItemCategory\";s:1:\"1\";s:12:\"userItemTags\";s:1:\"1\";s:22:\"userItemCommentsAnchor\";s:1:\"1\";s:16:\"userItemReadMore\";s:1:\"1\";s:17:\"userItemK2Plugins\";s:1:\"1\";s:18:\"defaultUsersItemid\";s:0:\"\";s:12:\"tagItemCount\";s:1:\"4\";s:12:\"tagItemTitle\";s:1:\"1\";s:18:\"tagItemTitleLinked\";s:1:\"1\";s:18:\"tagItemDateCreated\";s:1:\"1\";s:12:\"tagItemImage\";s:1:\"1\";s:16:\"tagItemIntroText\";s:1:\"1\";s:15:\"tagItemCategory\";s:1:\"1\";s:15:\"tagItemReadMore\";s:1:\"1\";s:18:\"tagItemExtraFields\";s:1:\"0\";s:11:\"tagOrdering\";s:0:\"\";s:11:\"tagFeedLink\";s:1:\"1\";s:11:\"tagFeedIcon\";s:1:\"1\";s:17:\"defaultTagsItemid\";s:0:\"\";s:16:\"genericItemCount\";s:2:\"10\";s:16:\"genericItemTitle\";s:1:\"1\";s:22:\"genericItemTitleLinked\";s:1:\"1\";s:22:\"genericItemDateCreated\";s:1:\"1\";s:16:\"genericItemImage\";s:1:\"1\";s:20:\"genericItemIntroText\";s:1:\"1\";s:19:\"genericItemCategory\";s:1:\"1\";s:19:\"genericItemReadMore\";s:1:\"1\";s:22:\"genericItemExtraFields\";s:1:\"0\";s:15:\"genericFeedLink\";s:1:\"1\";s:15:\"genericFeedIcon\";s:1:\"1\";s:9:\"feedLimit\";s:2:\"10\";s:13:\"feedItemImage\";s:1:\"1\";s:11:\"feedImgSize\";s:1:\"L\";s:17:\"feedItemIntroText\";s:1:\"1\";s:17:\"feedTextWordLimit\";s:0:\"\";s:16:\"feedItemFullText\";s:1:\"1\";s:12:\"feedItemTags\";s:1:\"0\";s:13:\"feedItemVideo\";s:1:\"0\";s:15:\"feedItemGallery\";s:1:\"0\";s:19:\"feedItemAttachments\";s:1:\"0\";s:14:\"feedBogusEmail\";s:0:\"\";s:16:\"introTextCleanup\";s:1:\"0\";s:27:\"introTextCleanupExcludeTags\";s:0:\"\";s:23:\"introTextCleanupTagAttr\";s:0:\"\";s:15:\"fullTextCleanup\";s:1:\"0\";s:26:\"fullTextCleanupExcludeTags\";s:0:\"\";s:22:\"fullTextCleanupTagAttr\";s:0:\"\";s:12:\"xssFiltering\";s:1:\"0\";s:14:\"linkPopupWidth\";s:3:\"900\";s:15:\"linkPopupHeight\";s:3:\"600\";s:13:\"imagesQuality\";s:2:\"95\";s:11:\"itemImageXS\";s:3:\"100\";s:10:\"itemImageS\";s:3:\"200\";s:10:\"itemImageM\";s:3:\"700\";s:10:\"itemImageL\";s:3:\"700\";s:11:\"itemImageXL\";s:3:\"918\";s:16:\"itemImageGeneric\";s:3:\"700\";s:13:\"catImageWidth\";s:3:\"700\";s:15:\"catImageDefault\";s:1:\"1\";s:14:\"userImageWidth\";s:3:\"116\";s:16:\"userImageDefault\";s:1:\"1\";s:17:\"commenterImgWidth\";s:2:\"48\";s:17:\"onlineImageEditor\";s:8:\"splashup\";s:14:\"imageTimestamp\";s:1:\"0\";s:16:\"imageMemoryLimit\";s:0:\"\";s:16:\"socialButtonCode\";s:0:\"\";s:15:\"twitterUsername\";s:0:\"\";s:13:\"facebookImage\";s:5:\"Small\";s:8:\"comments\";s:1:\"1\";s:16:\"commentsOrdering\";s:4:\"DESC\";s:13:\"commentsLimit\";s:2:\"10\";s:20:\"commentsFormPosition\";s:5:\"below\";s:18:\"commentsPublishing\";s:1:\"1\";s:17:\"commentsReporting\";s:1:\"2\";s:23:\"commentsReportRecipient\";s:0:\"\";s:24:\"inlineCommentsModeration\";s:1:\"0\";s:8:\"gravatar\";s:1:\"1\";s:9:\"recaptcha\";s:1:\"0\";s:17:\"commentsFormNotes\";s:1:\"1\";s:21:\"commentsFormNotesText\";s:0:\"\";s:15:\"frontendEditing\";s:1:\"1\";s:12:\"showImageTab\";s:1:\"1\";s:19:\"showImageGalleryTab\";s:1:\"1\";s:12:\"showVideoTab\";s:1:\"1\";s:18:\"showExtraFieldsTab\";s:1:\"1\";s:18:\"showAttachmentsTab\";s:1:\"1\";s:13:\"showK2Plugins\";s:1:\"1\";s:22:\"sideBarDisplayFrontend\";s:1:\"0\";s:12:\"mergeEditors\";s:1:\"1\";s:14:\"sideBarDisplay\";s:1:\"1\";s:17:\"attachmentsFolder\";s:0:\"\";s:16:\"hideImportButton\";s:1:\"0\";s:13:\"taggingSystem\";s:1:\"1\";s:8:\"lockTags\";s:1:\"0\";s:13:\"showTagFilter\";s:1:\"0\";s:12:\"googleSearch\";s:1:\"0\";s:21:\"googleSearchContainer\";s:11:\"k2Container\";s:13:\"K2UserProfile\";s:1:\"0\";s:8:\"redirect\";s:3:\"101\";s:11:\"adminSearch\";s:6:\"simple\";s:12:\"cookieDomain\";s:0:\"\";s:20:\"recaptcha_public_key\";s:0:\"\";s:21:\"recaptcha_private_key\";s:0:\"\";s:15:\"recaptcha_theme\";s:5:\"clean\";s:23:\"recaptchaOnRegistration\";s:1:\"0\";s:13:\"stopForumSpam\";s:1:\"0\";s:19:\"stopForumSpamApiKey\";s:0:\"\";s:21:\"showItemsCounterAdmin\";s:1:\"1\";s:17:\"showChildCatItems\";s:1:\"1\";s:22:\"disableCompactOrdering\";s:1:\"0\";s:13:\"metaDescLimit\";s:3:\"150\";s:15:\"SEFReplacements\";s:583:\"Å |S, Å’|O, Å½|Z, Å¡|s, Å“|oe, Å¾|z, Å¸|Y, Â¥|Y, Âµ|u, Ã€|A, Ã�|A, Ã‚|A, Ãƒ|A, Ã„|A, Ã…|A, Ã†|A, Ã‡|C, Ãˆ|E, Ã‰|E, ÃŠ|E, Ã‹|E, ÃŒ|I, Ã�|I, ÃŽ|I, Ã�|I, Ã�|D, Ã‘|N, Ã’|O, Ã“|O, Ã”|O, Ã•|O, Ã–|O, Ã˜|O, Ã™|U, Ãš|U, Ã›|U, Ãœ|U, Ã�|Y, ÃŸ|s, Ã |a, Ã¡|a, Ã¢|a, Ã£|a, Ã¤|a, Ã¥|a, Ã¦|a, Ã§|c, Ã¨|e, Ã©|e, Ãª|e, Ã«|e, Ã¬|i, Ã­|i, Ã®|i, Ã¯|i, Ã°|o, Ã±|n, Ã²|o, Ã³|o, Ã´|o, Ãµ|o, Ã¶|o, Ã¸|o, Ã¹|u, Ãº|u, Ã»|u, Ã¼|u, Ã½|y, Ã¿|y, ÃŸ|ss\";s:16:\"sh404SefLabelCat\";s:0:\"\";s:17:\"sh404SefLabelUser\";s:4:\"blog\";s:17:\"sh404SefLabelItem\";s:1:\"2\";s:18:\"sh404SefTitleAlias\";s:5:\"alias\";s:29:\"sh404SefModK2ContentFeedAlias\";s:4:\"feed\";s:20:\"sh404SefInsertItemId\";s:1:\"0\";s:26:\"sh404SefInsertUniqueItemId\";s:1:\"0\";s:13:\"cbIntegration\";s:1:\"0\";s:11:\"inheritFrom\";s:1:\"0\";s:17:\"num_leading_items\";s:1:\"4\";s:19:\"num_leading_columns\";s:1:\"1\";s:14:\"leadingImgSize\";s:5:\"Large\";s:17:\"num_primary_items\";s:1:\"4\";s:19:\"num_primary_columns\";s:1:\"1\";s:14:\"primaryImgSize\";s:5:\"Large\";s:19:\"num_secondary_items\";s:1:\"4\";s:21:\"num_secondary_columns\";s:1:\"1\";s:16:\"secondaryImgSize\";s:5:\"Large\";s:9:\"num_links\";s:1:\"2\";s:17:\"num_links_columns\";s:1:\"1\";s:12:\"linksImgSize\";s:5:\"Large\";s:14:\"catCatalogMode\";s:1:\"1\";s:16:\"catFeaturedItems\";s:1:\"1\";s:13:\"catPagination\";s:1:\"2\";s:20:\"catPaginationResults\";s:1:\"1\";s:8:\"catTitle\";s:1:\"0\";s:19:\"catTitleItemCounter\";s:1:\"0\";s:14:\"catDescription\";s:1:\"0\";s:8:\"catImage\";s:1:\"0\";s:11:\"catFeedLink\";s:1:\"1\";s:11:\"catFeedIcon\";s:1:\"1\";s:13:\"subCategories\";s:1:\"0\";s:13:\"subCatColumns\";s:1:\"4\";s:11:\"subCatTitle\";s:1:\"0\";s:22:\"subCatTitleItemCounter\";s:1:\"0\";s:17:\"subCatDescription\";s:1:\"0\";s:11:\"subCatImage\";s:1:\"0\";s:12:\"catItemTitle\";s:1:\"1\";s:18:\"catItemTitleLinked\";s:1:\"1\";s:21:\"catItemFeaturedNotice\";s:1:\"0\";s:13:\"catItemAuthor\";s:1:\"1\";s:18:\"catItemDateCreated\";s:1:\"1\";s:13:\"catItemRating\";s:1:\"0\";s:12:\"catItemImage\";s:1:\"1\";s:16:\"catItemIntroText\";s:1:\"1\";s:18:\"catItemExtraFields\";s:1:\"0\";s:11:\"catItemHits\";s:1:\"0\";s:15:\"catItemCategory\";s:1:\"1\";s:11:\"catItemTags\";s:1:\"0\";s:18:\"catItemAttachments\";s:1:\"0\";s:25:\"catItemAttachmentsCounter\";s:1:\"0\";s:12:\"catItemVideo\";s:1:\"0\";s:20:\"catItemVideoAutoPlay\";s:1:\"0\";s:19:\"catItemImageGallery\";s:1:\"0\";s:19:\"catItemDateModified\";s:1:\"0\";s:15:\"catItemReadMore\";s:1:\"1\";s:21:\"catItemCommentsAnchor\";s:1:\"1\";s:16:\"catItemK2Plugins\";s:1:\"1\";s:15:\"itemDateCreated\";s:1:\"1\";s:9:\"itemTitle\";s:1:\"1\";s:18:\"itemFeaturedNotice\";s:1:\"1\";s:10:\"itemAuthor\";s:1:\"1\";s:15:\"itemFontResizer\";s:1:\"1\";s:15:\"itemPrintButton\";s:1:\"1\";s:15:\"itemEmailButton\";s:1:\"1\";s:16:\"itemSocialButton\";s:1:\"1\";s:15:\"itemVideoAnchor\";s:1:\"1\";s:22:\"itemImageGalleryAnchor\";s:1:\"1\";s:18:\"itemCommentsAnchor\";s:1:\"1\";s:10:\"itemRating\";s:1:\"1\";s:9:\"itemImage\";s:1:\"1\";s:11:\"itemImgSize\";s:5:\"Large\";s:20:\"itemImageMainCaption\";s:1:\"1\";s:20:\"itemImageMainCredits\";s:1:\"1\";s:13:\"itemIntroText\";s:1:\"1\";s:12:\"itemFullText\";s:1:\"1\";s:15:\"itemExtraFields\";s:1:\"1\";s:16:\"itemDateModified\";s:1:\"1\";s:8:\"itemHits\";s:1:\"1\";s:12:\"itemCategory\";s:1:\"1\";s:8:\"itemTags\";s:1:\"1\";s:15:\"itemAttachments\";s:1:\"1\";s:22:\"itemAttachmentsCounter\";s:1:\"1\";s:9:\"itemVideo\";s:1:\"1\";s:17:\"itemVideoAutoPlay\";s:1:\"0\";s:16:\"itemVideoCaption\";s:1:\"1\";s:16:\"itemVideoCredits\";s:1:\"1\";s:16:\"itemImageGallery\";s:1:\"1\";s:14:\"itemNavigation\";s:1:\"1\";s:12:\"itemComments\";s:1:\"1\";s:17:\"itemTwitterButton\";s:1:\"1\";s:18:\"itemFacebookButton\";s:1:\"1\";s:23:\"itemGooglePlusOneButton\";s:1:\"1\";s:15:\"itemAuthorBlock\";s:1:\"1\";s:15:\"itemAuthorImage\";s:1:\"1\";s:21:\"itemAuthorDescription\";s:1:\"1\";s:13:\"itemAuthorURL\";s:1:\"1\";s:15:\"itemAuthorEmail\";s:1:\"0\";s:16:\"itemAuthorLatest\";s:1:\"1\";s:21:\"itemAuthorLatestLimit\";s:1:\"5\";s:11:\"itemRelated\";s:1:\"1\";s:16:\"itemRelatedLimit\";s:1:\"5\";s:16:\"itemRelatedTitle\";s:1:\"1\";s:19:\"itemRelatedCategory\";s:1:\"0\";s:20:\"itemRelatedImageSize\";s:1:\"0\";s:20:\"itemRelatedIntrotext\";s:1:\"0\";s:19:\"itemRelatedFulltext\";s:1:\"0\";s:17:\"itemRelatedAuthor\";s:1:\"0\";s:16:\"itemRelatedMedia\";s:1:\"0\";s:23:\"itemRelatedImageGallery\";s:1:\"0\";s:13:\"itemK2Plugins\";s:1:\"1\";}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";}}s:8:\"ordering\";s:1:\"2\";s:5:\"trash\";s:1:\"0\";s:9:\"cat_trash\";s:1:\"0\";s:8:\"category\";s:16:\"Gear Accessories\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:39:\"2:what-makes-a-snowboarding-destination\";s:7:\"catslug\";s:18:\"3:gear-accessories\";s:6:\"author\";s:10:\"Super User\";s:6:\"layout\";s:4:\"item\";s:4:\"path\";s:67:\"index.php/component/k2/item/2-what-makes-a-snowboarding-destination\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"K2 Item\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"K2 Item\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:10:\"Super User\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:10:\"Super User\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:11:\"K2 Category\";a:1:{s:16:\"Gear Accessories\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:16:\"Gear Accessories\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:38:\"index.php?option=com_k2&view=item&id=2\";s:5:\"route\";s:76:\"index.php?option=com_k2&view=item&id=2:what-makes-a-snowboarding-destination\";s:5:\"title\";s:37:\"What Makes A Snowboarding Destination\";s:11:\"description\";s:247:\"Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2012-12-03 11:31:02\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2012-12-03 11:31:02\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;}'),(3,'index.php?option=com_k2&view=item&id=3','index.php?option=com_k2&view=item&id=3:at-the-end-happy-to-be-alive','At the End - Happy To Be Alive','Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.','2012-12-03 12:37:37','316d68b2ac0fe74620430c9d8fb19c41',1,1,1,'*','2012-12-03 11:32:58','0000-00-00 00:00:00','2012-12-03 11:32:58','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:1:\"3\";s:5:\"alias\";s:28:\"at-the-end-happy-to-be-alive\";s:7:\"summary\";s:256:\"<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n\";s:4:\"body\";s:488:\"\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla. Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\";s:5:\"catid\";s:1:\"4\";s:10:\"created_by\";s:3:\"944\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"0000-00-00 00:00:00\";s:11:\"modified_by\";s:1:\"0\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":239:{s:10:\"enable_css\";s:1:\"1\";s:14:\"jQueryHandling\";s:9:\"1.8remote\";s:21:\"backendJQueryHandling\";s:6:\"remote\";s:8:\"userName\";s:1:\"1\";s:9:\"userImage\";s:1:\"1\";s:15:\"userDescription\";s:1:\"1\";s:7:\"userURL\";s:1:\"1\";s:9:\"userEmail\";s:1:\"0\";s:12:\"userFeedLink\";s:1:\"1\";s:12:\"userFeedIcon\";s:1:\"1\";s:13:\"userItemCount\";s:1:\"4\";s:13:\"userItemTitle\";s:1:\"1\";s:19:\"userItemTitleLinked\";s:1:\"1\";s:19:\"userItemDateCreated\";s:1:\"1\";s:13:\"userItemImage\";s:1:\"1\";s:17:\"userItemIntroText\";s:1:\"1\";s:16:\"userItemCategory\";s:1:\"1\";s:12:\"userItemTags\";s:1:\"1\";s:22:\"userItemCommentsAnchor\";s:1:\"1\";s:16:\"userItemReadMore\";s:1:\"1\";s:17:\"userItemK2Plugins\";s:1:\"1\";s:18:\"defaultUsersItemid\";s:0:\"\";s:12:\"tagItemCount\";s:1:\"4\";s:12:\"tagItemTitle\";s:1:\"1\";s:18:\"tagItemTitleLinked\";s:1:\"1\";s:18:\"tagItemDateCreated\";s:1:\"1\";s:12:\"tagItemImage\";s:1:\"1\";s:16:\"tagItemIntroText\";s:1:\"1\";s:15:\"tagItemCategory\";s:1:\"1\";s:15:\"tagItemReadMore\";s:1:\"1\";s:18:\"tagItemExtraFields\";s:1:\"0\";s:11:\"tagOrdering\";s:0:\"\";s:11:\"tagFeedLink\";s:1:\"1\";s:11:\"tagFeedIcon\";s:1:\"1\";s:17:\"defaultTagsItemid\";s:0:\"\";s:16:\"genericItemCount\";s:2:\"10\";s:16:\"genericItemTitle\";s:1:\"1\";s:22:\"genericItemTitleLinked\";s:1:\"1\";s:22:\"genericItemDateCreated\";s:1:\"1\";s:16:\"genericItemImage\";s:1:\"1\";s:20:\"genericItemIntroText\";s:1:\"1\";s:19:\"genericItemCategory\";s:1:\"1\";s:19:\"genericItemReadMore\";s:1:\"1\";s:22:\"genericItemExtraFields\";s:1:\"0\";s:15:\"genericFeedLink\";s:1:\"1\";s:15:\"genericFeedIcon\";s:1:\"1\";s:9:\"feedLimit\";s:2:\"10\";s:13:\"feedItemImage\";s:1:\"1\";s:11:\"feedImgSize\";s:1:\"L\";s:17:\"feedItemIntroText\";s:1:\"1\";s:17:\"feedTextWordLimit\";s:0:\"\";s:16:\"feedItemFullText\";s:1:\"1\";s:12:\"feedItemTags\";s:1:\"0\";s:13:\"feedItemVideo\";s:1:\"0\";s:15:\"feedItemGallery\";s:1:\"0\";s:19:\"feedItemAttachments\";s:1:\"0\";s:14:\"feedBogusEmail\";s:0:\"\";s:16:\"introTextCleanup\";s:1:\"0\";s:27:\"introTextCleanupExcludeTags\";s:0:\"\";s:23:\"introTextCleanupTagAttr\";s:0:\"\";s:15:\"fullTextCleanup\";s:1:\"0\";s:26:\"fullTextCleanupExcludeTags\";s:0:\"\";s:22:\"fullTextCleanupTagAttr\";s:0:\"\";s:12:\"xssFiltering\";s:1:\"0\";s:14:\"linkPopupWidth\";s:3:\"900\";s:15:\"linkPopupHeight\";s:3:\"600\";s:13:\"imagesQuality\";s:2:\"95\";s:11:\"itemImageXS\";s:3:\"100\";s:10:\"itemImageS\";s:3:\"200\";s:10:\"itemImageM\";s:3:\"700\";s:10:\"itemImageL\";s:3:\"700\";s:11:\"itemImageXL\";s:3:\"918\";s:16:\"itemImageGeneric\";s:3:\"700\";s:13:\"catImageWidth\";s:3:\"700\";s:15:\"catImageDefault\";s:1:\"1\";s:14:\"userImageWidth\";s:3:\"116\";s:16:\"userImageDefault\";s:1:\"1\";s:17:\"commenterImgWidth\";s:2:\"48\";s:17:\"onlineImageEditor\";s:8:\"splashup\";s:14:\"imageTimestamp\";s:1:\"0\";s:16:\"imageMemoryLimit\";s:0:\"\";s:16:\"socialButtonCode\";s:0:\"\";s:15:\"twitterUsername\";s:0:\"\";s:13:\"facebookImage\";s:5:\"Small\";s:8:\"comments\";s:1:\"1\";s:16:\"commentsOrdering\";s:4:\"DESC\";s:13:\"commentsLimit\";s:2:\"10\";s:20:\"commentsFormPosition\";s:5:\"below\";s:18:\"commentsPublishing\";s:1:\"1\";s:17:\"commentsReporting\";s:1:\"2\";s:23:\"commentsReportRecipient\";s:0:\"\";s:24:\"inlineCommentsModeration\";s:1:\"0\";s:8:\"gravatar\";s:1:\"1\";s:9:\"recaptcha\";s:1:\"0\";s:17:\"commentsFormNotes\";s:1:\"1\";s:21:\"commentsFormNotesText\";s:0:\"\";s:15:\"frontendEditing\";s:1:\"1\";s:12:\"showImageTab\";s:1:\"1\";s:19:\"showImageGalleryTab\";s:1:\"1\";s:12:\"showVideoTab\";s:1:\"1\";s:18:\"showExtraFieldsTab\";s:1:\"1\";s:18:\"showAttachmentsTab\";s:1:\"1\";s:13:\"showK2Plugins\";s:1:\"1\";s:22:\"sideBarDisplayFrontend\";s:1:\"0\";s:12:\"mergeEditors\";s:1:\"1\";s:14:\"sideBarDisplay\";s:1:\"1\";s:17:\"attachmentsFolder\";s:0:\"\";s:16:\"hideImportButton\";s:1:\"0\";s:13:\"taggingSystem\";s:1:\"1\";s:8:\"lockTags\";s:1:\"0\";s:13:\"showTagFilter\";s:1:\"0\";s:12:\"googleSearch\";s:1:\"0\";s:21:\"googleSearchContainer\";s:11:\"k2Container\";s:13:\"K2UserProfile\";s:1:\"0\";s:8:\"redirect\";s:3:\"101\";s:11:\"adminSearch\";s:6:\"simple\";s:12:\"cookieDomain\";s:0:\"\";s:20:\"recaptcha_public_key\";s:0:\"\";s:21:\"recaptcha_private_key\";s:0:\"\";s:15:\"recaptcha_theme\";s:5:\"clean\";s:23:\"recaptchaOnRegistration\";s:1:\"0\";s:13:\"stopForumSpam\";s:1:\"0\";s:19:\"stopForumSpamApiKey\";s:0:\"\";s:21:\"showItemsCounterAdmin\";s:1:\"1\";s:17:\"showChildCatItems\";s:1:\"1\";s:22:\"disableCompactOrdering\";s:1:\"0\";s:13:\"metaDescLimit\";s:3:\"150\";s:15:\"SEFReplacements\";s:583:\"Å |S, Å’|O, Å½|Z, Å¡|s, Å“|oe, Å¾|z, Å¸|Y, Â¥|Y, Âµ|u, Ã€|A, Ã�|A, Ã‚|A, Ãƒ|A, Ã„|A, Ã…|A, Ã†|A, Ã‡|C, Ãˆ|E, Ã‰|E, ÃŠ|E, Ã‹|E, ÃŒ|I, Ã�|I, ÃŽ|I, Ã�|I, Ã�|D, Ã‘|N, Ã’|O, Ã“|O, Ã”|O, Ã•|O, Ã–|O, Ã˜|O, Ã™|U, Ãš|U, Ã›|U, Ãœ|U, Ã�|Y, ÃŸ|s, Ã |a, Ã¡|a, Ã¢|a, Ã£|a, Ã¤|a, Ã¥|a, Ã¦|a, Ã§|c, Ã¨|e, Ã©|e, Ãª|e, Ã«|e, Ã¬|i, Ã­|i, Ã®|i, Ã¯|i, Ã°|o, Ã±|n, Ã²|o, Ã³|o, Ã´|o, Ãµ|o, Ã¶|o, Ã¸|o, Ã¹|u, Ãº|u, Ã»|u, Ã¼|u, Ã½|y, Ã¿|y, ÃŸ|ss\";s:16:\"sh404SefLabelCat\";s:0:\"\";s:17:\"sh404SefLabelUser\";s:4:\"blog\";s:17:\"sh404SefLabelItem\";s:1:\"2\";s:18:\"sh404SefTitleAlias\";s:5:\"alias\";s:29:\"sh404SefModK2ContentFeedAlias\";s:4:\"feed\";s:20:\"sh404SefInsertItemId\";s:1:\"0\";s:26:\"sh404SefInsertUniqueItemId\";s:1:\"0\";s:13:\"cbIntegration\";s:1:\"0\";s:11:\"inheritFrom\";s:1:\"0\";s:17:\"num_leading_items\";s:1:\"4\";s:19:\"num_leading_columns\";s:1:\"1\";s:14:\"leadingImgSize\";s:5:\"Large\";s:17:\"num_primary_items\";s:1:\"4\";s:19:\"num_primary_columns\";s:1:\"1\";s:14:\"primaryImgSize\";s:5:\"Large\";s:19:\"num_secondary_items\";s:1:\"4\";s:21:\"num_secondary_columns\";s:1:\"1\";s:16:\"secondaryImgSize\";s:5:\"Large\";s:9:\"num_links\";s:1:\"2\";s:17:\"num_links_columns\";s:1:\"1\";s:12:\"linksImgSize\";s:5:\"Large\";s:14:\"catCatalogMode\";s:1:\"1\";s:16:\"catFeaturedItems\";s:1:\"1\";s:13:\"catPagination\";s:1:\"2\";s:20:\"catPaginationResults\";s:1:\"1\";s:8:\"catTitle\";s:1:\"0\";s:19:\"catTitleItemCounter\";s:1:\"0\";s:14:\"catDescription\";s:1:\"0\";s:8:\"catImage\";s:1:\"0\";s:11:\"catFeedLink\";s:1:\"1\";s:11:\"catFeedIcon\";s:1:\"1\";s:13:\"subCategories\";s:1:\"0\";s:13:\"subCatColumns\";s:1:\"4\";s:11:\"subCatTitle\";s:1:\"0\";s:22:\"subCatTitleItemCounter\";s:1:\"0\";s:17:\"subCatDescription\";s:1:\"0\";s:11:\"subCatImage\";s:1:\"0\";s:12:\"catItemTitle\";s:1:\"1\";s:18:\"catItemTitleLinked\";s:1:\"1\";s:21:\"catItemFeaturedNotice\";s:1:\"0\";s:13:\"catItemAuthor\";s:1:\"1\";s:18:\"catItemDateCreated\";s:1:\"1\";s:13:\"catItemRating\";s:1:\"0\";s:12:\"catItemImage\";s:1:\"1\";s:16:\"catItemIntroText\";s:1:\"1\";s:18:\"catItemExtraFields\";s:1:\"0\";s:11:\"catItemHits\";s:1:\"0\";s:15:\"catItemCategory\";s:1:\"1\";s:11:\"catItemTags\";s:1:\"0\";s:18:\"catItemAttachments\";s:1:\"0\";s:25:\"catItemAttachmentsCounter\";s:1:\"0\";s:12:\"catItemVideo\";s:1:\"0\";s:20:\"catItemVideoAutoPlay\";s:1:\"0\";s:19:\"catItemImageGallery\";s:1:\"0\";s:19:\"catItemDateModified\";s:1:\"0\";s:15:\"catItemReadMore\";s:1:\"1\";s:21:\"catItemCommentsAnchor\";s:1:\"1\";s:16:\"catItemK2Plugins\";s:1:\"1\";s:15:\"itemDateCreated\";s:1:\"1\";s:9:\"itemTitle\";s:1:\"1\";s:18:\"itemFeaturedNotice\";s:1:\"1\";s:10:\"itemAuthor\";s:1:\"1\";s:15:\"itemFontResizer\";s:1:\"1\";s:15:\"itemPrintButton\";s:1:\"1\";s:15:\"itemEmailButton\";s:1:\"1\";s:16:\"itemSocialButton\";s:1:\"1\";s:15:\"itemVideoAnchor\";s:1:\"1\";s:22:\"itemImageGalleryAnchor\";s:1:\"1\";s:18:\"itemCommentsAnchor\";s:1:\"1\";s:10:\"itemRating\";s:1:\"1\";s:9:\"itemImage\";s:1:\"1\";s:11:\"itemImgSize\";s:5:\"Large\";s:20:\"itemImageMainCaption\";s:1:\"1\";s:20:\"itemImageMainCredits\";s:1:\"1\";s:13:\"itemIntroText\";s:1:\"1\";s:12:\"itemFullText\";s:1:\"1\";s:15:\"itemExtraFields\";s:1:\"1\";s:16:\"itemDateModified\";s:1:\"1\";s:8:\"itemHits\";s:1:\"1\";s:12:\"itemCategory\";s:1:\"1\";s:8:\"itemTags\";s:1:\"1\";s:15:\"itemAttachments\";s:1:\"1\";s:22:\"itemAttachmentsCounter\";s:1:\"1\";s:9:\"itemVideo\";s:1:\"1\";s:17:\"itemVideoAutoPlay\";s:1:\"0\";s:16:\"itemVideoCaption\";s:1:\"1\";s:16:\"itemVideoCredits\";s:1:\"1\";s:16:\"itemImageGallery\";s:1:\"1\";s:14:\"itemNavigation\";s:1:\"1\";s:12:\"itemComments\";s:1:\"1\";s:17:\"itemTwitterButton\";s:1:\"1\";s:18:\"itemFacebookButton\";s:1:\"1\";s:23:\"itemGooglePlusOneButton\";s:1:\"1\";s:15:\"itemAuthorBlock\";s:1:\"1\";s:15:\"itemAuthorImage\";s:1:\"1\";s:21:\"itemAuthorDescription\";s:1:\"1\";s:13:\"itemAuthorURL\";s:1:\"1\";s:15:\"itemAuthorEmail\";s:1:\"0\";s:16:\"itemAuthorLatest\";s:1:\"1\";s:21:\"itemAuthorLatestLimit\";s:1:\"5\";s:11:\"itemRelated\";s:1:\"1\";s:16:\"itemRelatedLimit\";s:1:\"5\";s:16:\"itemRelatedTitle\";s:1:\"1\";s:19:\"itemRelatedCategory\";s:1:\"0\";s:20:\"itemRelatedImageSize\";s:1:\"0\";s:20:\"itemRelatedIntrotext\";s:1:\"0\";s:19:\"itemRelatedFulltext\";s:1:\"0\";s:17:\"itemRelatedAuthor\";s:1:\"0\";s:16:\"itemRelatedMedia\";s:1:\"0\";s:23:\"itemRelatedImageGallery\";s:1:\"0\";s:13:\"itemK2Plugins\";s:1:\"1\";}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";}}s:8:\"ordering\";s:1:\"1\";s:5:\"trash\";s:1:\"0\";s:9:\"cat_trash\";s:1:\"0\";s:8:\"category\";s:16:\"Photo Of The Day\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:30:\"3:at-the-end-happy-to-be-alive\";s:7:\"catslug\";s:18:\"4:photo-of-the-day\";s:6:\"author\";s:10:\"Super User\";s:6:\"layout\";s:4:\"item\";s:4:\"path\";s:58:\"index.php/component/k2/item/3-at-the-end-happy-to-be-alive\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"K2 Item\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"K2 Item\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:10:\"Super User\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:10:\"Super User\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:11:\"K2 Category\";a:1:{s:16:\"Photo Of The Day\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:16:\"Photo Of The Day\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:38:\"index.php?option=com_k2&view=item&id=3\";s:5:\"route\";s:67:\"index.php?option=com_k2&view=item&id=3:at-the-end-happy-to-be-alive\";s:5:\"title\";s:30:\"At the End - Happy To Be Alive\";s:11:\"description\";s:247:\"Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2012-12-03 11:32:58\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2012-12-03 11:32:58\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;}'),(4,'index.php?option=com_k2&view=item&id=4','index.php?option=com_k2&view=item&id=4:bear-mountain-sunday-in-the-park','Bear Mountain Sunday In The Park','Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.','2012-12-03 12:39:02','ed43da562a64f1b6c2a713c572b27b28',1,1,1,'*','2012-12-03 11:37:37','0000-00-00 00:00:00','2012-12-03 11:37:37','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:1:\"4\";s:5:\"alias\";s:32:\"bear-mountain-sunday-in-the-park\";s:7:\"summary\";s:256:\"<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n\";s:4:\"body\";s:488:\"\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla. Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\";s:5:\"catid\";s:1:\"1\";s:10:\"created_by\";s:3:\"944\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"0000-00-00 00:00:00\";s:11:\"modified_by\";s:1:\"0\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":239:{s:10:\"enable_css\";s:1:\"1\";s:14:\"jQueryHandling\";s:9:\"1.8remote\";s:21:\"backendJQueryHandling\";s:6:\"remote\";s:8:\"userName\";s:1:\"1\";s:9:\"userImage\";s:1:\"1\";s:15:\"userDescription\";s:1:\"1\";s:7:\"userURL\";s:1:\"1\";s:9:\"userEmail\";s:1:\"0\";s:12:\"userFeedLink\";s:1:\"1\";s:12:\"userFeedIcon\";s:1:\"1\";s:13:\"userItemCount\";s:1:\"4\";s:13:\"userItemTitle\";s:1:\"1\";s:19:\"userItemTitleLinked\";s:1:\"1\";s:19:\"userItemDateCreated\";s:1:\"1\";s:13:\"userItemImage\";s:1:\"1\";s:17:\"userItemIntroText\";s:1:\"1\";s:16:\"userItemCategory\";s:1:\"1\";s:12:\"userItemTags\";s:1:\"1\";s:22:\"userItemCommentsAnchor\";s:1:\"1\";s:16:\"userItemReadMore\";s:1:\"1\";s:17:\"userItemK2Plugins\";s:1:\"1\";s:18:\"defaultUsersItemid\";s:0:\"\";s:12:\"tagItemCount\";s:1:\"4\";s:12:\"tagItemTitle\";s:1:\"1\";s:18:\"tagItemTitleLinked\";s:1:\"1\";s:18:\"tagItemDateCreated\";s:1:\"1\";s:12:\"tagItemImage\";s:1:\"1\";s:16:\"tagItemIntroText\";s:1:\"1\";s:15:\"tagItemCategory\";s:1:\"1\";s:15:\"tagItemReadMore\";s:1:\"1\";s:18:\"tagItemExtraFields\";s:1:\"0\";s:11:\"tagOrdering\";s:0:\"\";s:11:\"tagFeedLink\";s:1:\"1\";s:11:\"tagFeedIcon\";s:1:\"1\";s:17:\"defaultTagsItemid\";s:0:\"\";s:16:\"genericItemCount\";s:2:\"10\";s:16:\"genericItemTitle\";s:1:\"1\";s:22:\"genericItemTitleLinked\";s:1:\"1\";s:22:\"genericItemDateCreated\";s:1:\"1\";s:16:\"genericItemImage\";s:1:\"1\";s:20:\"genericItemIntroText\";s:1:\"1\";s:19:\"genericItemCategory\";s:1:\"1\";s:19:\"genericItemReadMore\";s:1:\"1\";s:22:\"genericItemExtraFields\";s:1:\"0\";s:15:\"genericFeedLink\";s:1:\"1\";s:15:\"genericFeedIcon\";s:1:\"1\";s:9:\"feedLimit\";s:2:\"10\";s:13:\"feedItemImage\";s:1:\"1\";s:11:\"feedImgSize\";s:1:\"L\";s:17:\"feedItemIntroText\";s:1:\"1\";s:17:\"feedTextWordLimit\";s:0:\"\";s:16:\"feedItemFullText\";s:1:\"1\";s:12:\"feedItemTags\";s:1:\"0\";s:13:\"feedItemVideo\";s:1:\"0\";s:15:\"feedItemGallery\";s:1:\"0\";s:19:\"feedItemAttachments\";s:1:\"0\";s:14:\"feedBogusEmail\";s:0:\"\";s:16:\"introTextCleanup\";s:1:\"0\";s:27:\"introTextCleanupExcludeTags\";s:0:\"\";s:23:\"introTextCleanupTagAttr\";s:0:\"\";s:15:\"fullTextCleanup\";s:1:\"0\";s:26:\"fullTextCleanupExcludeTags\";s:0:\"\";s:22:\"fullTextCleanupTagAttr\";s:0:\"\";s:12:\"xssFiltering\";s:1:\"0\";s:14:\"linkPopupWidth\";s:3:\"900\";s:15:\"linkPopupHeight\";s:3:\"600\";s:13:\"imagesQuality\";s:2:\"95\";s:11:\"itemImageXS\";s:3:\"100\";s:10:\"itemImageS\";s:3:\"200\";s:10:\"itemImageM\";s:3:\"700\";s:10:\"itemImageL\";s:3:\"700\";s:11:\"itemImageXL\";s:3:\"918\";s:16:\"itemImageGeneric\";s:3:\"700\";s:13:\"catImageWidth\";s:3:\"700\";s:15:\"catImageDefault\";s:1:\"1\";s:14:\"userImageWidth\";s:3:\"116\";s:16:\"userImageDefault\";s:1:\"1\";s:17:\"commenterImgWidth\";s:2:\"48\";s:17:\"onlineImageEditor\";s:8:\"splashup\";s:14:\"imageTimestamp\";s:1:\"0\";s:16:\"imageMemoryLimit\";s:0:\"\";s:16:\"socialButtonCode\";s:0:\"\";s:15:\"twitterUsername\";s:0:\"\";s:13:\"facebookImage\";s:5:\"Small\";s:8:\"comments\";s:1:\"1\";s:16:\"commentsOrdering\";s:4:\"DESC\";s:13:\"commentsLimit\";s:2:\"10\";s:20:\"commentsFormPosition\";s:5:\"below\";s:18:\"commentsPublishing\";s:1:\"1\";s:17:\"commentsReporting\";s:1:\"2\";s:23:\"commentsReportRecipient\";s:0:\"\";s:24:\"inlineCommentsModeration\";s:1:\"0\";s:8:\"gravatar\";s:1:\"1\";s:9:\"recaptcha\";s:1:\"0\";s:17:\"commentsFormNotes\";s:1:\"1\";s:21:\"commentsFormNotesText\";s:0:\"\";s:15:\"frontendEditing\";s:1:\"1\";s:12:\"showImageTab\";s:1:\"1\";s:19:\"showImageGalleryTab\";s:1:\"1\";s:12:\"showVideoTab\";s:1:\"1\";s:18:\"showExtraFieldsTab\";s:1:\"1\";s:18:\"showAttachmentsTab\";s:1:\"1\";s:13:\"showK2Plugins\";s:1:\"1\";s:22:\"sideBarDisplayFrontend\";s:1:\"0\";s:12:\"mergeEditors\";s:1:\"1\";s:14:\"sideBarDisplay\";s:1:\"1\";s:17:\"attachmentsFolder\";s:0:\"\";s:16:\"hideImportButton\";s:1:\"0\";s:13:\"taggingSystem\";s:1:\"1\";s:8:\"lockTags\";s:1:\"0\";s:13:\"showTagFilter\";s:1:\"0\";s:12:\"googleSearch\";s:1:\"0\";s:21:\"googleSearchContainer\";s:11:\"k2Container\";s:13:\"K2UserProfile\";s:1:\"0\";s:8:\"redirect\";s:3:\"101\";s:11:\"adminSearch\";s:6:\"simple\";s:12:\"cookieDomain\";s:0:\"\";s:20:\"recaptcha_public_key\";s:0:\"\";s:21:\"recaptcha_private_key\";s:0:\"\";s:15:\"recaptcha_theme\";s:5:\"clean\";s:23:\"recaptchaOnRegistration\";s:1:\"0\";s:13:\"stopForumSpam\";s:1:\"0\";s:19:\"stopForumSpamApiKey\";s:0:\"\";s:21:\"showItemsCounterAdmin\";s:1:\"1\";s:17:\"showChildCatItems\";s:1:\"1\";s:22:\"disableCompactOrdering\";s:1:\"0\";s:13:\"metaDescLimit\";s:3:\"150\";s:15:\"SEFReplacements\";s:583:\"Å |S, Å’|O, Å½|Z, Å¡|s, Å“|oe, Å¾|z, Å¸|Y, Â¥|Y, Âµ|u, Ã€|A, Ã�|A, Ã‚|A, Ãƒ|A, Ã„|A, Ã…|A, Ã†|A, Ã‡|C, Ãˆ|E, Ã‰|E, ÃŠ|E, Ã‹|E, ÃŒ|I, Ã�|I, ÃŽ|I, Ã�|I, Ã�|D, Ã‘|N, Ã’|O, Ã“|O, Ã”|O, Ã•|O, Ã–|O, Ã˜|O, Ã™|U, Ãš|U, Ã›|U, Ãœ|U, Ã�|Y, ÃŸ|s, Ã |a, Ã¡|a, Ã¢|a, Ã£|a, Ã¤|a, Ã¥|a, Ã¦|a, Ã§|c, Ã¨|e, Ã©|e, Ãª|e, Ã«|e, Ã¬|i, Ã­|i, Ã®|i, Ã¯|i, Ã°|o, Ã±|n, Ã²|o, Ã³|o, Ã´|o, Ãµ|o, Ã¶|o, Ã¸|o, Ã¹|u, Ãº|u, Ã»|u, Ã¼|u, Ã½|y, Ã¿|y, ÃŸ|ss\";s:16:\"sh404SefLabelCat\";s:0:\"\";s:17:\"sh404SefLabelUser\";s:4:\"blog\";s:17:\"sh404SefLabelItem\";s:1:\"2\";s:18:\"sh404SefTitleAlias\";s:5:\"alias\";s:29:\"sh404SefModK2ContentFeedAlias\";s:4:\"feed\";s:20:\"sh404SefInsertItemId\";s:1:\"0\";s:26:\"sh404SefInsertUniqueItemId\";s:1:\"0\";s:13:\"cbIntegration\";s:1:\"0\";s:11:\"inheritFrom\";s:1:\"0\";s:17:\"num_leading_items\";s:1:\"4\";s:19:\"num_leading_columns\";s:1:\"1\";s:14:\"leadingImgSize\";s:5:\"Large\";s:17:\"num_primary_items\";s:1:\"4\";s:19:\"num_primary_columns\";s:1:\"1\";s:14:\"primaryImgSize\";s:5:\"Large\";s:19:\"num_secondary_items\";s:1:\"4\";s:21:\"num_secondary_columns\";s:1:\"1\";s:16:\"secondaryImgSize\";s:5:\"Large\";s:9:\"num_links\";s:1:\"2\";s:17:\"num_links_columns\";s:1:\"1\";s:12:\"linksImgSize\";s:5:\"Large\";s:14:\"catCatalogMode\";s:1:\"1\";s:16:\"catFeaturedItems\";s:1:\"1\";s:13:\"catPagination\";s:1:\"2\";s:20:\"catPaginationResults\";s:1:\"1\";s:8:\"catTitle\";s:1:\"0\";s:19:\"catTitleItemCounter\";s:1:\"0\";s:14:\"catDescription\";s:1:\"0\";s:8:\"catImage\";s:1:\"0\";s:11:\"catFeedLink\";s:1:\"1\";s:11:\"catFeedIcon\";s:1:\"1\";s:13:\"subCategories\";s:1:\"0\";s:13:\"subCatColumns\";s:1:\"4\";s:11:\"subCatTitle\";s:1:\"0\";s:22:\"subCatTitleItemCounter\";s:1:\"0\";s:17:\"subCatDescription\";s:1:\"0\";s:11:\"subCatImage\";s:1:\"0\";s:12:\"catItemTitle\";s:1:\"1\";s:18:\"catItemTitleLinked\";s:1:\"1\";s:21:\"catItemFeaturedNotice\";s:1:\"0\";s:13:\"catItemAuthor\";s:1:\"1\";s:18:\"catItemDateCreated\";s:1:\"1\";s:13:\"catItemRating\";s:1:\"0\";s:12:\"catItemImage\";s:1:\"1\";s:16:\"catItemIntroText\";s:1:\"1\";s:18:\"catItemExtraFields\";s:1:\"0\";s:11:\"catItemHits\";s:1:\"0\";s:15:\"catItemCategory\";s:1:\"1\";s:11:\"catItemTags\";s:1:\"0\";s:18:\"catItemAttachments\";s:1:\"0\";s:25:\"catItemAttachmentsCounter\";s:1:\"0\";s:12:\"catItemVideo\";s:1:\"0\";s:20:\"catItemVideoAutoPlay\";s:1:\"0\";s:19:\"catItemImageGallery\";s:1:\"0\";s:19:\"catItemDateModified\";s:1:\"0\";s:15:\"catItemReadMore\";s:1:\"1\";s:21:\"catItemCommentsAnchor\";s:1:\"1\";s:16:\"catItemK2Plugins\";s:1:\"1\";s:15:\"itemDateCreated\";s:1:\"1\";s:9:\"itemTitle\";s:1:\"1\";s:18:\"itemFeaturedNotice\";s:1:\"1\";s:10:\"itemAuthor\";s:1:\"1\";s:15:\"itemFontResizer\";s:1:\"1\";s:15:\"itemPrintButton\";s:1:\"1\";s:15:\"itemEmailButton\";s:1:\"1\";s:16:\"itemSocialButton\";s:1:\"1\";s:15:\"itemVideoAnchor\";s:1:\"1\";s:22:\"itemImageGalleryAnchor\";s:1:\"1\";s:18:\"itemCommentsAnchor\";s:1:\"1\";s:10:\"itemRating\";s:1:\"1\";s:9:\"itemImage\";s:1:\"1\";s:11:\"itemImgSize\";s:5:\"Large\";s:20:\"itemImageMainCaption\";s:1:\"1\";s:20:\"itemImageMainCredits\";s:1:\"1\";s:13:\"itemIntroText\";s:1:\"1\";s:12:\"itemFullText\";s:1:\"1\";s:15:\"itemExtraFields\";s:1:\"1\";s:16:\"itemDateModified\";s:1:\"1\";s:8:\"itemHits\";s:1:\"1\";s:12:\"itemCategory\";s:1:\"1\";s:8:\"itemTags\";s:1:\"1\";s:15:\"itemAttachments\";s:1:\"1\";s:22:\"itemAttachmentsCounter\";s:1:\"1\";s:9:\"itemVideo\";s:1:\"1\";s:17:\"itemVideoAutoPlay\";s:1:\"0\";s:16:\"itemVideoCaption\";s:1:\"1\";s:16:\"itemVideoCredits\";s:1:\"1\";s:16:\"itemImageGallery\";s:1:\"1\";s:14:\"itemNavigation\";s:1:\"1\";s:12:\"itemComments\";s:1:\"1\";s:17:\"itemTwitterButton\";s:1:\"1\";s:18:\"itemFacebookButton\";s:1:\"1\";s:23:\"itemGooglePlusOneButton\";s:1:\"1\";s:15:\"itemAuthorBlock\";s:1:\"1\";s:15:\"itemAuthorImage\";s:1:\"1\";s:21:\"itemAuthorDescription\";s:1:\"1\";s:13:\"itemAuthorURL\";s:1:\"1\";s:15:\"itemAuthorEmail\";s:1:\"0\";s:16:\"itemAuthorLatest\";s:1:\"1\";s:21:\"itemAuthorLatestLimit\";s:1:\"5\";s:11:\"itemRelated\";s:1:\"1\";s:16:\"itemRelatedLimit\";s:1:\"5\";s:16:\"itemRelatedTitle\";s:1:\"1\";s:19:\"itemRelatedCategory\";s:1:\"0\";s:20:\"itemRelatedImageSize\";s:1:\"0\";s:20:\"itemRelatedIntrotext\";s:1:\"0\";s:19:\"itemRelatedFulltext\";s:1:\"0\";s:17:\"itemRelatedAuthor\";s:1:\"0\";s:16:\"itemRelatedMedia\";s:1:\"0\";s:23:\"itemRelatedImageGallery\";s:1:\"0\";s:13:\"itemK2Plugins\";s:1:\"1\";}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";}}s:8:\"ordering\";s:1:\"1\";s:5:\"trash\";s:1:\"0\";s:9:\"cat_trash\";s:1:\"0\";s:8:\"category\";s:20:\"Snowboarding Resorts\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:34:\"4:bear-mountain-sunday-in-the-park\";s:7:\"catslug\";s:22:\"1:snowboarding-resorts\";s:6:\"author\";s:10:\"Super User\";s:6:\"layout\";s:4:\"item\";s:4:\"path\";s:62:\"index.php/component/k2/item/4-bear-mountain-sunday-in-the-park\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"K2 Item\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"K2 Item\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:10:\"Super User\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:10:\"Super User\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:11:\"K2 Category\";a:1:{s:20:\"Snowboarding Resorts\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:20:\"Snowboarding Resorts\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:38:\"index.php?option=com_k2&view=item&id=4\";s:5:\"route\";s:71:\"index.php?option=com_k2&view=item&id=4:bear-mountain-sunday-in-the-park\";s:5:\"title\";s:32:\"Bear Mountain Sunday In The Park\";s:11:\"description\";s:247:\"Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2012-12-03 11:37:37\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2012-12-03 11:37:37\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;}'),(5,'index.php?option=com_k2&view=item&id=5','index.php?option=com_k2&view=item&id=5:sooner-or-later-you-reach-higher','Sooner or later you reach higher','Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.','2012-12-03 12:40:56','042758ae27159cb37e1f9b4f7df4d18d',1,1,1,'*','2012-12-03 11:39:02','0000-00-00 00:00:00','2012-12-03 11:39:02','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:1:\"5\";s:5:\"alias\";s:32:\"sooner-or-later-you-reach-higher\";s:7:\"summary\";s:256:\"<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n\";s:4:\"body\";s:488:\"\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla. Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\";s:5:\"catid\";s:1:\"1\";s:10:\"created_by\";s:3:\"944\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"0000-00-00 00:00:00\";s:11:\"modified_by\";s:1:\"0\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":239:{s:10:\"enable_css\";s:1:\"1\";s:14:\"jQueryHandling\";s:9:\"1.8remote\";s:21:\"backendJQueryHandling\";s:6:\"remote\";s:8:\"userName\";s:1:\"1\";s:9:\"userImage\";s:1:\"1\";s:15:\"userDescription\";s:1:\"1\";s:7:\"userURL\";s:1:\"1\";s:9:\"userEmail\";s:1:\"0\";s:12:\"userFeedLink\";s:1:\"1\";s:12:\"userFeedIcon\";s:1:\"1\";s:13:\"userItemCount\";s:1:\"4\";s:13:\"userItemTitle\";s:1:\"1\";s:19:\"userItemTitleLinked\";s:1:\"1\";s:19:\"userItemDateCreated\";s:1:\"1\";s:13:\"userItemImage\";s:1:\"1\";s:17:\"userItemIntroText\";s:1:\"1\";s:16:\"userItemCategory\";s:1:\"1\";s:12:\"userItemTags\";s:1:\"1\";s:22:\"userItemCommentsAnchor\";s:1:\"1\";s:16:\"userItemReadMore\";s:1:\"1\";s:17:\"userItemK2Plugins\";s:1:\"1\";s:18:\"defaultUsersItemid\";s:0:\"\";s:12:\"tagItemCount\";s:1:\"4\";s:12:\"tagItemTitle\";s:1:\"1\";s:18:\"tagItemTitleLinked\";s:1:\"1\";s:18:\"tagItemDateCreated\";s:1:\"1\";s:12:\"tagItemImage\";s:1:\"1\";s:16:\"tagItemIntroText\";s:1:\"1\";s:15:\"tagItemCategory\";s:1:\"1\";s:15:\"tagItemReadMore\";s:1:\"1\";s:18:\"tagItemExtraFields\";s:1:\"0\";s:11:\"tagOrdering\";s:0:\"\";s:11:\"tagFeedLink\";s:1:\"1\";s:11:\"tagFeedIcon\";s:1:\"1\";s:17:\"defaultTagsItemid\";s:0:\"\";s:16:\"genericItemCount\";s:2:\"10\";s:16:\"genericItemTitle\";s:1:\"1\";s:22:\"genericItemTitleLinked\";s:1:\"1\";s:22:\"genericItemDateCreated\";s:1:\"1\";s:16:\"genericItemImage\";s:1:\"1\";s:20:\"genericItemIntroText\";s:1:\"1\";s:19:\"genericItemCategory\";s:1:\"1\";s:19:\"genericItemReadMore\";s:1:\"1\";s:22:\"genericItemExtraFields\";s:1:\"0\";s:15:\"genericFeedLink\";s:1:\"1\";s:15:\"genericFeedIcon\";s:1:\"1\";s:9:\"feedLimit\";s:2:\"10\";s:13:\"feedItemImage\";s:1:\"1\";s:11:\"feedImgSize\";s:1:\"L\";s:17:\"feedItemIntroText\";s:1:\"1\";s:17:\"feedTextWordLimit\";s:0:\"\";s:16:\"feedItemFullText\";s:1:\"1\";s:12:\"feedItemTags\";s:1:\"0\";s:13:\"feedItemVideo\";s:1:\"0\";s:15:\"feedItemGallery\";s:1:\"0\";s:19:\"feedItemAttachments\";s:1:\"0\";s:14:\"feedBogusEmail\";s:0:\"\";s:16:\"introTextCleanup\";s:1:\"0\";s:27:\"introTextCleanupExcludeTags\";s:0:\"\";s:23:\"introTextCleanupTagAttr\";s:0:\"\";s:15:\"fullTextCleanup\";s:1:\"0\";s:26:\"fullTextCleanupExcludeTags\";s:0:\"\";s:22:\"fullTextCleanupTagAttr\";s:0:\"\";s:12:\"xssFiltering\";s:1:\"0\";s:14:\"linkPopupWidth\";s:3:\"900\";s:15:\"linkPopupHeight\";s:3:\"600\";s:13:\"imagesQuality\";s:2:\"95\";s:11:\"itemImageXS\";s:3:\"100\";s:10:\"itemImageS\";s:3:\"200\";s:10:\"itemImageM\";s:3:\"700\";s:10:\"itemImageL\";s:3:\"700\";s:11:\"itemImageXL\";s:3:\"918\";s:16:\"itemImageGeneric\";s:3:\"700\";s:13:\"catImageWidth\";s:3:\"700\";s:15:\"catImageDefault\";s:1:\"1\";s:14:\"userImageWidth\";s:3:\"116\";s:16:\"userImageDefault\";s:1:\"1\";s:17:\"commenterImgWidth\";s:2:\"48\";s:17:\"onlineImageEditor\";s:8:\"splashup\";s:14:\"imageTimestamp\";s:1:\"0\";s:16:\"imageMemoryLimit\";s:0:\"\";s:16:\"socialButtonCode\";s:0:\"\";s:15:\"twitterUsername\";s:0:\"\";s:13:\"facebookImage\";s:5:\"Small\";s:8:\"comments\";s:1:\"1\";s:16:\"commentsOrdering\";s:4:\"DESC\";s:13:\"commentsLimit\";s:2:\"10\";s:20:\"commentsFormPosition\";s:5:\"below\";s:18:\"commentsPublishing\";s:1:\"1\";s:17:\"commentsReporting\";s:1:\"2\";s:23:\"commentsReportRecipient\";s:0:\"\";s:24:\"inlineCommentsModeration\";s:1:\"0\";s:8:\"gravatar\";s:1:\"1\";s:9:\"recaptcha\";s:1:\"0\";s:17:\"commentsFormNotes\";s:1:\"1\";s:21:\"commentsFormNotesText\";s:0:\"\";s:15:\"frontendEditing\";s:1:\"1\";s:12:\"showImageTab\";s:1:\"1\";s:19:\"showImageGalleryTab\";s:1:\"1\";s:12:\"showVideoTab\";s:1:\"1\";s:18:\"showExtraFieldsTab\";s:1:\"1\";s:18:\"showAttachmentsTab\";s:1:\"1\";s:13:\"showK2Plugins\";s:1:\"1\";s:22:\"sideBarDisplayFrontend\";s:1:\"0\";s:12:\"mergeEditors\";s:1:\"1\";s:14:\"sideBarDisplay\";s:1:\"1\";s:17:\"attachmentsFolder\";s:0:\"\";s:16:\"hideImportButton\";s:1:\"0\";s:13:\"taggingSystem\";s:1:\"1\";s:8:\"lockTags\";s:1:\"0\";s:13:\"showTagFilter\";s:1:\"0\";s:12:\"googleSearch\";s:1:\"0\";s:21:\"googleSearchContainer\";s:11:\"k2Container\";s:13:\"K2UserProfile\";s:1:\"0\";s:8:\"redirect\";s:3:\"101\";s:11:\"adminSearch\";s:6:\"simple\";s:12:\"cookieDomain\";s:0:\"\";s:20:\"recaptcha_public_key\";s:0:\"\";s:21:\"recaptcha_private_key\";s:0:\"\";s:15:\"recaptcha_theme\";s:5:\"clean\";s:23:\"recaptchaOnRegistration\";s:1:\"0\";s:13:\"stopForumSpam\";s:1:\"0\";s:19:\"stopForumSpamApiKey\";s:0:\"\";s:21:\"showItemsCounterAdmin\";s:1:\"1\";s:17:\"showChildCatItems\";s:1:\"1\";s:22:\"disableCompactOrdering\";s:1:\"0\";s:13:\"metaDescLimit\";s:3:\"150\";s:15:\"SEFReplacements\";s:583:\"Å |S, Å’|O, Å½|Z, Å¡|s, Å“|oe, Å¾|z, Å¸|Y, Â¥|Y, Âµ|u, Ã€|A, Ã�|A, Ã‚|A, Ãƒ|A, Ã„|A, Ã…|A, Ã†|A, Ã‡|C, Ãˆ|E, Ã‰|E, ÃŠ|E, Ã‹|E, ÃŒ|I, Ã�|I, ÃŽ|I, Ã�|I, Ã�|D, Ã‘|N, Ã’|O, Ã“|O, Ã”|O, Ã•|O, Ã–|O, Ã˜|O, Ã™|U, Ãš|U, Ã›|U, Ãœ|U, Ã�|Y, ÃŸ|s, Ã |a, Ã¡|a, Ã¢|a, Ã£|a, Ã¤|a, Ã¥|a, Ã¦|a, Ã§|c, Ã¨|e, Ã©|e, Ãª|e, Ã«|e, Ã¬|i, Ã­|i, Ã®|i, Ã¯|i, Ã°|o, Ã±|n, Ã²|o, Ã³|o, Ã´|o, Ãµ|o, Ã¶|o, Ã¸|o, Ã¹|u, Ãº|u, Ã»|u, Ã¼|u, Ã½|y, Ã¿|y, ÃŸ|ss\";s:16:\"sh404SefLabelCat\";s:0:\"\";s:17:\"sh404SefLabelUser\";s:4:\"blog\";s:17:\"sh404SefLabelItem\";s:1:\"2\";s:18:\"sh404SefTitleAlias\";s:5:\"alias\";s:29:\"sh404SefModK2ContentFeedAlias\";s:4:\"feed\";s:20:\"sh404SefInsertItemId\";s:1:\"0\";s:26:\"sh404SefInsertUniqueItemId\";s:1:\"0\";s:13:\"cbIntegration\";s:1:\"0\";s:11:\"inheritFrom\";s:1:\"0\";s:17:\"num_leading_items\";s:1:\"4\";s:19:\"num_leading_columns\";s:1:\"1\";s:14:\"leadingImgSize\";s:5:\"Large\";s:17:\"num_primary_items\";s:1:\"4\";s:19:\"num_primary_columns\";s:1:\"1\";s:14:\"primaryImgSize\";s:5:\"Large\";s:19:\"num_secondary_items\";s:1:\"4\";s:21:\"num_secondary_columns\";s:1:\"1\";s:16:\"secondaryImgSize\";s:5:\"Large\";s:9:\"num_links\";s:1:\"2\";s:17:\"num_links_columns\";s:1:\"1\";s:12:\"linksImgSize\";s:5:\"Large\";s:14:\"catCatalogMode\";s:1:\"1\";s:16:\"catFeaturedItems\";s:1:\"1\";s:13:\"catPagination\";s:1:\"2\";s:20:\"catPaginationResults\";s:1:\"1\";s:8:\"catTitle\";s:1:\"0\";s:19:\"catTitleItemCounter\";s:1:\"0\";s:14:\"catDescription\";s:1:\"0\";s:8:\"catImage\";s:1:\"0\";s:11:\"catFeedLink\";s:1:\"1\";s:11:\"catFeedIcon\";s:1:\"1\";s:13:\"subCategories\";s:1:\"0\";s:13:\"subCatColumns\";s:1:\"4\";s:11:\"subCatTitle\";s:1:\"0\";s:22:\"subCatTitleItemCounter\";s:1:\"0\";s:17:\"subCatDescription\";s:1:\"0\";s:11:\"subCatImage\";s:1:\"0\";s:12:\"catItemTitle\";s:1:\"1\";s:18:\"catItemTitleLinked\";s:1:\"1\";s:21:\"catItemFeaturedNotice\";s:1:\"0\";s:13:\"catItemAuthor\";s:1:\"1\";s:18:\"catItemDateCreated\";s:1:\"1\";s:13:\"catItemRating\";s:1:\"0\";s:12:\"catItemImage\";s:1:\"1\";s:16:\"catItemIntroText\";s:1:\"1\";s:18:\"catItemExtraFields\";s:1:\"0\";s:11:\"catItemHits\";s:1:\"0\";s:15:\"catItemCategory\";s:1:\"1\";s:11:\"catItemTags\";s:1:\"0\";s:18:\"catItemAttachments\";s:1:\"0\";s:25:\"catItemAttachmentsCounter\";s:1:\"0\";s:12:\"catItemVideo\";s:1:\"0\";s:20:\"catItemVideoAutoPlay\";s:1:\"0\";s:19:\"catItemImageGallery\";s:1:\"0\";s:19:\"catItemDateModified\";s:1:\"0\";s:15:\"catItemReadMore\";s:1:\"1\";s:21:\"catItemCommentsAnchor\";s:1:\"1\";s:16:\"catItemK2Plugins\";s:1:\"1\";s:15:\"itemDateCreated\";s:1:\"1\";s:9:\"itemTitle\";s:1:\"1\";s:18:\"itemFeaturedNotice\";s:1:\"1\";s:10:\"itemAuthor\";s:1:\"1\";s:15:\"itemFontResizer\";s:1:\"1\";s:15:\"itemPrintButton\";s:1:\"1\";s:15:\"itemEmailButton\";s:1:\"1\";s:16:\"itemSocialButton\";s:1:\"1\";s:15:\"itemVideoAnchor\";s:1:\"1\";s:22:\"itemImageGalleryAnchor\";s:1:\"1\";s:18:\"itemCommentsAnchor\";s:1:\"1\";s:10:\"itemRating\";s:1:\"1\";s:9:\"itemImage\";s:1:\"1\";s:11:\"itemImgSize\";s:5:\"Large\";s:20:\"itemImageMainCaption\";s:1:\"1\";s:20:\"itemImageMainCredits\";s:1:\"1\";s:13:\"itemIntroText\";s:1:\"1\";s:12:\"itemFullText\";s:1:\"1\";s:15:\"itemExtraFields\";s:1:\"1\";s:16:\"itemDateModified\";s:1:\"1\";s:8:\"itemHits\";s:1:\"1\";s:12:\"itemCategory\";s:1:\"1\";s:8:\"itemTags\";s:1:\"1\";s:15:\"itemAttachments\";s:1:\"1\";s:22:\"itemAttachmentsCounter\";s:1:\"1\";s:9:\"itemVideo\";s:1:\"1\";s:17:\"itemVideoAutoPlay\";s:1:\"0\";s:16:\"itemVideoCaption\";s:1:\"1\";s:16:\"itemVideoCredits\";s:1:\"1\";s:16:\"itemImageGallery\";s:1:\"1\";s:14:\"itemNavigation\";s:1:\"1\";s:12:\"itemComments\";s:1:\"1\";s:17:\"itemTwitterButton\";s:1:\"1\";s:18:\"itemFacebookButton\";s:1:\"1\";s:23:\"itemGooglePlusOneButton\";s:1:\"1\";s:15:\"itemAuthorBlock\";s:1:\"1\";s:15:\"itemAuthorImage\";s:1:\"1\";s:21:\"itemAuthorDescription\";s:1:\"1\";s:13:\"itemAuthorURL\";s:1:\"1\";s:15:\"itemAuthorEmail\";s:1:\"0\";s:16:\"itemAuthorLatest\";s:1:\"1\";s:21:\"itemAuthorLatestLimit\";s:1:\"5\";s:11:\"itemRelated\";s:1:\"1\";s:16:\"itemRelatedLimit\";s:1:\"5\";s:16:\"itemRelatedTitle\";s:1:\"1\";s:19:\"itemRelatedCategory\";s:1:\"0\";s:20:\"itemRelatedImageSize\";s:1:\"0\";s:20:\"itemRelatedIntrotext\";s:1:\"0\";s:19:\"itemRelatedFulltext\";s:1:\"0\";s:17:\"itemRelatedAuthor\";s:1:\"0\";s:16:\"itemRelatedMedia\";s:1:\"0\";s:23:\"itemRelatedImageGallery\";s:1:\"0\";s:13:\"itemK2Plugins\";s:1:\"1\";}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";}}s:8:\"ordering\";s:1:\"2\";s:5:\"trash\";s:1:\"0\";s:9:\"cat_trash\";s:1:\"0\";s:8:\"category\";s:20:\"Snowboarding Resorts\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:34:\"5:sooner-or-later-you-reach-higher\";s:7:\"catslug\";s:22:\"1:snowboarding-resorts\";s:6:\"author\";s:10:\"Super User\";s:6:\"layout\";s:4:\"item\";s:4:\"path\";s:62:\"index.php/component/k2/item/5-sooner-or-later-you-reach-higher\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"K2 Item\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"K2 Item\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:10:\"Super User\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:10:\"Super User\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:11:\"K2 Category\";a:1:{s:20:\"Snowboarding Resorts\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:20:\"Snowboarding Resorts\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:38:\"index.php?option=com_k2&view=item&id=5\";s:5:\"route\";s:71:\"index.php?option=com_k2&view=item&id=5:sooner-or-later-you-reach-higher\";s:5:\"title\";s:32:\"Sooner or later you reach higher\";s:11:\"description\";s:247:\"Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2012-12-03 11:39:02\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2012-12-03 11:39:02\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;}'),(6,'index.php?option=com_k2&view=item&id=6','index.php?option=com_k2&view=item&id=6:happy-to-be-alive','Happy To Be Alive','Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.','2012-12-03 12:42:46','fd7672cb41d9dec87857f538bdbc277d',1,1,1,'*','2012-12-03 11:40:57','0000-00-00 00:00:00','2012-12-03 11:40:57','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:1:\"6\";s:5:\"alias\";s:17:\"happy-to-be-alive\";s:7:\"summary\";s:256:\"<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n\";s:4:\"body\";s:488:\"\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla. Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\";s:5:\"catid\";s:1:\"1\";s:10:\"created_by\";s:3:\"944\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"0000-00-00 00:00:00\";s:11:\"modified_by\";s:1:\"0\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":239:{s:10:\"enable_css\";s:1:\"1\";s:14:\"jQueryHandling\";s:9:\"1.8remote\";s:21:\"backendJQueryHandling\";s:6:\"remote\";s:8:\"userName\";s:1:\"1\";s:9:\"userImage\";s:1:\"1\";s:15:\"userDescription\";s:1:\"1\";s:7:\"userURL\";s:1:\"1\";s:9:\"userEmail\";s:1:\"0\";s:12:\"userFeedLink\";s:1:\"1\";s:12:\"userFeedIcon\";s:1:\"1\";s:13:\"userItemCount\";s:1:\"4\";s:13:\"userItemTitle\";s:1:\"1\";s:19:\"userItemTitleLinked\";s:1:\"1\";s:19:\"userItemDateCreated\";s:1:\"1\";s:13:\"userItemImage\";s:1:\"1\";s:17:\"userItemIntroText\";s:1:\"1\";s:16:\"userItemCategory\";s:1:\"1\";s:12:\"userItemTags\";s:1:\"1\";s:22:\"userItemCommentsAnchor\";s:1:\"1\";s:16:\"userItemReadMore\";s:1:\"1\";s:17:\"userItemK2Plugins\";s:1:\"1\";s:18:\"defaultUsersItemid\";s:0:\"\";s:12:\"tagItemCount\";s:1:\"4\";s:12:\"tagItemTitle\";s:1:\"1\";s:18:\"tagItemTitleLinked\";s:1:\"1\";s:18:\"tagItemDateCreated\";s:1:\"1\";s:12:\"tagItemImage\";s:1:\"1\";s:16:\"tagItemIntroText\";s:1:\"1\";s:15:\"tagItemCategory\";s:1:\"1\";s:15:\"tagItemReadMore\";s:1:\"1\";s:18:\"tagItemExtraFields\";s:1:\"0\";s:11:\"tagOrdering\";s:0:\"\";s:11:\"tagFeedLink\";s:1:\"1\";s:11:\"tagFeedIcon\";s:1:\"1\";s:17:\"defaultTagsItemid\";s:0:\"\";s:16:\"genericItemCount\";s:2:\"10\";s:16:\"genericItemTitle\";s:1:\"1\";s:22:\"genericItemTitleLinked\";s:1:\"1\";s:22:\"genericItemDateCreated\";s:1:\"1\";s:16:\"genericItemImage\";s:1:\"1\";s:20:\"genericItemIntroText\";s:1:\"1\";s:19:\"genericItemCategory\";s:1:\"1\";s:19:\"genericItemReadMore\";s:1:\"1\";s:22:\"genericItemExtraFields\";s:1:\"0\";s:15:\"genericFeedLink\";s:1:\"1\";s:15:\"genericFeedIcon\";s:1:\"1\";s:9:\"feedLimit\";s:2:\"10\";s:13:\"feedItemImage\";s:1:\"1\";s:11:\"feedImgSize\";s:1:\"L\";s:17:\"feedItemIntroText\";s:1:\"1\";s:17:\"feedTextWordLimit\";s:0:\"\";s:16:\"feedItemFullText\";s:1:\"1\";s:12:\"feedItemTags\";s:1:\"0\";s:13:\"feedItemVideo\";s:1:\"0\";s:15:\"feedItemGallery\";s:1:\"0\";s:19:\"feedItemAttachments\";s:1:\"0\";s:14:\"feedBogusEmail\";s:0:\"\";s:16:\"introTextCleanup\";s:1:\"0\";s:27:\"introTextCleanupExcludeTags\";s:0:\"\";s:23:\"introTextCleanupTagAttr\";s:0:\"\";s:15:\"fullTextCleanup\";s:1:\"0\";s:26:\"fullTextCleanupExcludeTags\";s:0:\"\";s:22:\"fullTextCleanupTagAttr\";s:0:\"\";s:12:\"xssFiltering\";s:1:\"0\";s:14:\"linkPopupWidth\";s:3:\"900\";s:15:\"linkPopupHeight\";s:3:\"600\";s:13:\"imagesQuality\";s:2:\"95\";s:11:\"itemImageXS\";s:3:\"100\";s:10:\"itemImageS\";s:3:\"200\";s:10:\"itemImageM\";s:3:\"700\";s:10:\"itemImageL\";s:3:\"700\";s:11:\"itemImageXL\";s:3:\"918\";s:16:\"itemImageGeneric\";s:3:\"700\";s:13:\"catImageWidth\";s:3:\"700\";s:15:\"catImageDefault\";s:1:\"1\";s:14:\"userImageWidth\";s:3:\"116\";s:16:\"userImageDefault\";s:1:\"1\";s:17:\"commenterImgWidth\";s:2:\"48\";s:17:\"onlineImageEditor\";s:8:\"splashup\";s:14:\"imageTimestamp\";s:1:\"0\";s:16:\"imageMemoryLimit\";s:0:\"\";s:16:\"socialButtonCode\";s:0:\"\";s:15:\"twitterUsername\";s:0:\"\";s:13:\"facebookImage\";s:5:\"Small\";s:8:\"comments\";s:1:\"1\";s:16:\"commentsOrdering\";s:4:\"DESC\";s:13:\"commentsLimit\";s:2:\"10\";s:20:\"commentsFormPosition\";s:5:\"below\";s:18:\"commentsPublishing\";s:1:\"1\";s:17:\"commentsReporting\";s:1:\"2\";s:23:\"commentsReportRecipient\";s:0:\"\";s:24:\"inlineCommentsModeration\";s:1:\"0\";s:8:\"gravatar\";s:1:\"1\";s:9:\"recaptcha\";s:1:\"0\";s:17:\"commentsFormNotes\";s:1:\"1\";s:21:\"commentsFormNotesText\";s:0:\"\";s:15:\"frontendEditing\";s:1:\"1\";s:12:\"showImageTab\";s:1:\"1\";s:19:\"showImageGalleryTab\";s:1:\"1\";s:12:\"showVideoTab\";s:1:\"1\";s:18:\"showExtraFieldsTab\";s:1:\"1\";s:18:\"showAttachmentsTab\";s:1:\"1\";s:13:\"showK2Plugins\";s:1:\"1\";s:22:\"sideBarDisplayFrontend\";s:1:\"0\";s:12:\"mergeEditors\";s:1:\"1\";s:14:\"sideBarDisplay\";s:1:\"1\";s:17:\"attachmentsFolder\";s:0:\"\";s:16:\"hideImportButton\";s:1:\"0\";s:13:\"taggingSystem\";s:1:\"1\";s:8:\"lockTags\";s:1:\"0\";s:13:\"showTagFilter\";s:1:\"0\";s:12:\"googleSearch\";s:1:\"0\";s:21:\"googleSearchContainer\";s:11:\"k2Container\";s:13:\"K2UserProfile\";s:1:\"0\";s:8:\"redirect\";s:3:\"101\";s:11:\"adminSearch\";s:6:\"simple\";s:12:\"cookieDomain\";s:0:\"\";s:20:\"recaptcha_public_key\";s:0:\"\";s:21:\"recaptcha_private_key\";s:0:\"\";s:15:\"recaptcha_theme\";s:5:\"clean\";s:23:\"recaptchaOnRegistration\";s:1:\"0\";s:13:\"stopForumSpam\";s:1:\"0\";s:19:\"stopForumSpamApiKey\";s:0:\"\";s:21:\"showItemsCounterAdmin\";s:1:\"1\";s:17:\"showChildCatItems\";s:1:\"1\";s:22:\"disableCompactOrdering\";s:1:\"0\";s:13:\"metaDescLimit\";s:3:\"150\";s:15:\"SEFReplacements\";s:583:\"Å |S, Å’|O, Å½|Z, Å¡|s, Å“|oe, Å¾|z, Å¸|Y, Â¥|Y, Âµ|u, Ã€|A, Ã�|A, Ã‚|A, Ãƒ|A, Ã„|A, Ã…|A, Ã†|A, Ã‡|C, Ãˆ|E, Ã‰|E, ÃŠ|E, Ã‹|E, ÃŒ|I, Ã�|I, ÃŽ|I, Ã�|I, Ã�|D, Ã‘|N, Ã’|O, Ã“|O, Ã”|O, Ã•|O, Ã–|O, Ã˜|O, Ã™|U, Ãš|U, Ã›|U, Ãœ|U, Ã�|Y, ÃŸ|s, Ã |a, Ã¡|a, Ã¢|a, Ã£|a, Ã¤|a, Ã¥|a, Ã¦|a, Ã§|c, Ã¨|e, Ã©|e, Ãª|e, Ã«|e, Ã¬|i, Ã­|i, Ã®|i, Ã¯|i, Ã°|o, Ã±|n, Ã²|o, Ã³|o, Ã´|o, Ãµ|o, Ã¶|o, Ã¸|o, Ã¹|u, Ãº|u, Ã»|u, Ã¼|u, Ã½|y, Ã¿|y, ÃŸ|ss\";s:16:\"sh404SefLabelCat\";s:0:\"\";s:17:\"sh404SefLabelUser\";s:4:\"blog\";s:17:\"sh404SefLabelItem\";s:1:\"2\";s:18:\"sh404SefTitleAlias\";s:5:\"alias\";s:29:\"sh404SefModK2ContentFeedAlias\";s:4:\"feed\";s:20:\"sh404SefInsertItemId\";s:1:\"0\";s:26:\"sh404SefInsertUniqueItemId\";s:1:\"0\";s:13:\"cbIntegration\";s:1:\"0\";s:11:\"inheritFrom\";s:1:\"0\";s:17:\"num_leading_items\";s:1:\"4\";s:19:\"num_leading_columns\";s:1:\"1\";s:14:\"leadingImgSize\";s:5:\"Large\";s:17:\"num_primary_items\";s:1:\"4\";s:19:\"num_primary_columns\";s:1:\"1\";s:14:\"primaryImgSize\";s:5:\"Large\";s:19:\"num_secondary_items\";s:1:\"4\";s:21:\"num_secondary_columns\";s:1:\"1\";s:16:\"secondaryImgSize\";s:5:\"Large\";s:9:\"num_links\";s:1:\"2\";s:17:\"num_links_columns\";s:1:\"1\";s:12:\"linksImgSize\";s:5:\"Large\";s:14:\"catCatalogMode\";s:1:\"1\";s:16:\"catFeaturedItems\";s:1:\"1\";s:13:\"catPagination\";s:1:\"2\";s:20:\"catPaginationResults\";s:1:\"1\";s:8:\"catTitle\";s:1:\"0\";s:19:\"catTitleItemCounter\";s:1:\"0\";s:14:\"catDescription\";s:1:\"0\";s:8:\"catImage\";s:1:\"0\";s:11:\"catFeedLink\";s:1:\"1\";s:11:\"catFeedIcon\";s:1:\"1\";s:13:\"subCategories\";s:1:\"0\";s:13:\"subCatColumns\";s:1:\"4\";s:11:\"subCatTitle\";s:1:\"0\";s:22:\"subCatTitleItemCounter\";s:1:\"0\";s:17:\"subCatDescription\";s:1:\"0\";s:11:\"subCatImage\";s:1:\"0\";s:12:\"catItemTitle\";s:1:\"1\";s:18:\"catItemTitleLinked\";s:1:\"1\";s:21:\"catItemFeaturedNotice\";s:1:\"0\";s:13:\"catItemAuthor\";s:1:\"1\";s:18:\"catItemDateCreated\";s:1:\"1\";s:13:\"catItemRating\";s:1:\"0\";s:12:\"catItemImage\";s:1:\"1\";s:16:\"catItemIntroText\";s:1:\"1\";s:18:\"catItemExtraFields\";s:1:\"0\";s:11:\"catItemHits\";s:1:\"0\";s:15:\"catItemCategory\";s:1:\"1\";s:11:\"catItemTags\";s:1:\"0\";s:18:\"catItemAttachments\";s:1:\"0\";s:25:\"catItemAttachmentsCounter\";s:1:\"0\";s:12:\"catItemVideo\";s:1:\"0\";s:20:\"catItemVideoAutoPlay\";s:1:\"0\";s:19:\"catItemImageGallery\";s:1:\"0\";s:19:\"catItemDateModified\";s:1:\"0\";s:15:\"catItemReadMore\";s:1:\"1\";s:21:\"catItemCommentsAnchor\";s:1:\"1\";s:16:\"catItemK2Plugins\";s:1:\"1\";s:15:\"itemDateCreated\";s:1:\"1\";s:9:\"itemTitle\";s:1:\"1\";s:18:\"itemFeaturedNotice\";s:1:\"1\";s:10:\"itemAuthor\";s:1:\"1\";s:15:\"itemFontResizer\";s:1:\"1\";s:15:\"itemPrintButton\";s:1:\"1\";s:15:\"itemEmailButton\";s:1:\"1\";s:16:\"itemSocialButton\";s:1:\"1\";s:15:\"itemVideoAnchor\";s:1:\"1\";s:22:\"itemImageGalleryAnchor\";s:1:\"1\";s:18:\"itemCommentsAnchor\";s:1:\"1\";s:10:\"itemRating\";s:1:\"1\";s:9:\"itemImage\";s:1:\"1\";s:11:\"itemImgSize\";s:5:\"Large\";s:20:\"itemImageMainCaption\";s:1:\"1\";s:20:\"itemImageMainCredits\";s:1:\"1\";s:13:\"itemIntroText\";s:1:\"1\";s:12:\"itemFullText\";s:1:\"1\";s:15:\"itemExtraFields\";s:1:\"1\";s:16:\"itemDateModified\";s:1:\"1\";s:8:\"itemHits\";s:1:\"1\";s:12:\"itemCategory\";s:1:\"1\";s:8:\"itemTags\";s:1:\"1\";s:15:\"itemAttachments\";s:1:\"1\";s:22:\"itemAttachmentsCounter\";s:1:\"1\";s:9:\"itemVideo\";s:1:\"1\";s:17:\"itemVideoAutoPlay\";s:1:\"0\";s:16:\"itemVideoCaption\";s:1:\"1\";s:16:\"itemVideoCredits\";s:1:\"1\";s:16:\"itemImageGallery\";s:1:\"1\";s:14:\"itemNavigation\";s:1:\"1\";s:12:\"itemComments\";s:1:\"1\";s:17:\"itemTwitterButton\";s:1:\"1\";s:18:\"itemFacebookButton\";s:1:\"1\";s:23:\"itemGooglePlusOneButton\";s:1:\"1\";s:15:\"itemAuthorBlock\";s:1:\"1\";s:15:\"itemAuthorImage\";s:1:\"1\";s:21:\"itemAuthorDescription\";s:1:\"1\";s:13:\"itemAuthorURL\";s:1:\"1\";s:15:\"itemAuthorEmail\";s:1:\"0\";s:16:\"itemAuthorLatest\";s:1:\"1\";s:21:\"itemAuthorLatestLimit\";s:1:\"5\";s:11:\"itemRelated\";s:1:\"1\";s:16:\"itemRelatedLimit\";s:1:\"5\";s:16:\"itemRelatedTitle\";s:1:\"1\";s:19:\"itemRelatedCategory\";s:1:\"0\";s:20:\"itemRelatedImageSize\";s:1:\"0\";s:20:\"itemRelatedIntrotext\";s:1:\"0\";s:19:\"itemRelatedFulltext\";s:1:\"0\";s:17:\"itemRelatedAuthor\";s:1:\"0\";s:16:\"itemRelatedMedia\";s:1:\"0\";s:23:\"itemRelatedImageGallery\";s:1:\"0\";s:13:\"itemK2Plugins\";s:1:\"1\";}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";}}s:8:\"ordering\";s:1:\"3\";s:5:\"trash\";s:1:\"0\";s:9:\"cat_trash\";s:1:\"0\";s:8:\"category\";s:20:\"Snowboarding Resorts\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:19:\"6:happy-to-be-alive\";s:7:\"catslug\";s:22:\"1:snowboarding-resorts\";s:6:\"author\";s:10:\"Super User\";s:6:\"layout\";s:4:\"item\";s:4:\"path\";s:47:\"index.php/component/k2/item/6-happy-to-be-alive\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"K2 Item\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"K2 Item\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:10:\"Super User\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:10:\"Super User\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:11:\"K2 Category\";a:1:{s:20:\"Snowboarding Resorts\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:20:\"Snowboarding Resorts\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:38:\"index.php?option=com_k2&view=item&id=6\";s:5:\"route\";s:56:\"index.php?option=com_k2&view=item&id=6:happy-to-be-alive\";s:5:\"title\";s:17:\"Happy To Be Alive\";s:11:\"description\";s:247:\"Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2012-12-03 11:40:57\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2012-12-03 11:40:57\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;}'),(7,'index.php?option=com_k2&view=item&id=7','index.php?option=com_k2&view=item&id=7:perfect-weather-a-great-slopestyle','Perfect weather, a great slopestyle','Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.','2012-12-03 12:44:16','da3eb2dd7c862c4c066e65970cd4a7fc',1,1,1,'*','2012-12-03 11:42:47','0000-00-00 00:00:00','2012-12-03 11:42:47','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:1:\"7\";s:5:\"alias\";s:34:\"perfect-weather-a-great-slopestyle\";s:7:\"summary\";s:256:\"<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n\";s:4:\"body\";s:488:\"\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla. Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\";s:5:\"catid\";s:1:\"2\";s:10:\"created_by\";s:3:\"944\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"0000-00-00 00:00:00\";s:11:\"modified_by\";s:1:\"0\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":239:{s:10:\"enable_css\";s:1:\"1\";s:14:\"jQueryHandling\";s:9:\"1.8remote\";s:21:\"backendJQueryHandling\";s:6:\"remote\";s:8:\"userName\";s:1:\"1\";s:9:\"userImage\";s:1:\"1\";s:15:\"userDescription\";s:1:\"1\";s:7:\"userURL\";s:1:\"1\";s:9:\"userEmail\";s:1:\"0\";s:12:\"userFeedLink\";s:1:\"1\";s:12:\"userFeedIcon\";s:1:\"1\";s:13:\"userItemCount\";s:1:\"4\";s:13:\"userItemTitle\";s:1:\"1\";s:19:\"userItemTitleLinked\";s:1:\"1\";s:19:\"userItemDateCreated\";s:1:\"1\";s:13:\"userItemImage\";s:1:\"1\";s:17:\"userItemIntroText\";s:1:\"1\";s:16:\"userItemCategory\";s:1:\"1\";s:12:\"userItemTags\";s:1:\"1\";s:22:\"userItemCommentsAnchor\";s:1:\"1\";s:16:\"userItemReadMore\";s:1:\"1\";s:17:\"userItemK2Plugins\";s:1:\"1\";s:18:\"defaultUsersItemid\";s:0:\"\";s:12:\"tagItemCount\";s:1:\"4\";s:12:\"tagItemTitle\";s:1:\"1\";s:18:\"tagItemTitleLinked\";s:1:\"1\";s:18:\"tagItemDateCreated\";s:1:\"1\";s:12:\"tagItemImage\";s:1:\"1\";s:16:\"tagItemIntroText\";s:1:\"1\";s:15:\"tagItemCategory\";s:1:\"1\";s:15:\"tagItemReadMore\";s:1:\"1\";s:18:\"tagItemExtraFields\";s:1:\"0\";s:11:\"tagOrdering\";s:0:\"\";s:11:\"tagFeedLink\";s:1:\"1\";s:11:\"tagFeedIcon\";s:1:\"1\";s:17:\"defaultTagsItemid\";s:0:\"\";s:16:\"genericItemCount\";s:2:\"10\";s:16:\"genericItemTitle\";s:1:\"1\";s:22:\"genericItemTitleLinked\";s:1:\"1\";s:22:\"genericItemDateCreated\";s:1:\"1\";s:16:\"genericItemImage\";s:1:\"1\";s:20:\"genericItemIntroText\";s:1:\"1\";s:19:\"genericItemCategory\";s:1:\"1\";s:19:\"genericItemReadMore\";s:1:\"1\";s:22:\"genericItemExtraFields\";s:1:\"0\";s:15:\"genericFeedLink\";s:1:\"1\";s:15:\"genericFeedIcon\";s:1:\"1\";s:9:\"feedLimit\";s:2:\"10\";s:13:\"feedItemImage\";s:1:\"1\";s:11:\"feedImgSize\";s:1:\"L\";s:17:\"feedItemIntroText\";s:1:\"1\";s:17:\"feedTextWordLimit\";s:0:\"\";s:16:\"feedItemFullText\";s:1:\"1\";s:12:\"feedItemTags\";s:1:\"0\";s:13:\"feedItemVideo\";s:1:\"0\";s:15:\"feedItemGallery\";s:1:\"0\";s:19:\"feedItemAttachments\";s:1:\"0\";s:14:\"feedBogusEmail\";s:0:\"\";s:16:\"introTextCleanup\";s:1:\"0\";s:27:\"introTextCleanupExcludeTags\";s:0:\"\";s:23:\"introTextCleanupTagAttr\";s:0:\"\";s:15:\"fullTextCleanup\";s:1:\"0\";s:26:\"fullTextCleanupExcludeTags\";s:0:\"\";s:22:\"fullTextCleanupTagAttr\";s:0:\"\";s:12:\"xssFiltering\";s:1:\"0\";s:14:\"linkPopupWidth\";s:3:\"900\";s:15:\"linkPopupHeight\";s:3:\"600\";s:13:\"imagesQuality\";s:2:\"95\";s:11:\"itemImageXS\";s:3:\"100\";s:10:\"itemImageS\";s:3:\"200\";s:10:\"itemImageM\";s:3:\"700\";s:10:\"itemImageL\";s:3:\"700\";s:11:\"itemImageXL\";s:3:\"918\";s:16:\"itemImageGeneric\";s:3:\"700\";s:13:\"catImageWidth\";s:3:\"700\";s:15:\"catImageDefault\";s:1:\"1\";s:14:\"userImageWidth\";s:3:\"116\";s:16:\"userImageDefault\";s:1:\"1\";s:17:\"commenterImgWidth\";s:2:\"48\";s:17:\"onlineImageEditor\";s:8:\"splashup\";s:14:\"imageTimestamp\";s:1:\"0\";s:16:\"imageMemoryLimit\";s:0:\"\";s:16:\"socialButtonCode\";s:0:\"\";s:15:\"twitterUsername\";s:0:\"\";s:13:\"facebookImage\";s:5:\"Small\";s:8:\"comments\";s:1:\"1\";s:16:\"commentsOrdering\";s:4:\"DESC\";s:13:\"commentsLimit\";s:2:\"10\";s:20:\"commentsFormPosition\";s:5:\"below\";s:18:\"commentsPublishing\";s:1:\"1\";s:17:\"commentsReporting\";s:1:\"2\";s:23:\"commentsReportRecipient\";s:0:\"\";s:24:\"inlineCommentsModeration\";s:1:\"0\";s:8:\"gravatar\";s:1:\"1\";s:9:\"recaptcha\";s:1:\"0\";s:17:\"commentsFormNotes\";s:1:\"1\";s:21:\"commentsFormNotesText\";s:0:\"\";s:15:\"frontendEditing\";s:1:\"1\";s:12:\"showImageTab\";s:1:\"1\";s:19:\"showImageGalleryTab\";s:1:\"1\";s:12:\"showVideoTab\";s:1:\"1\";s:18:\"showExtraFieldsTab\";s:1:\"1\";s:18:\"showAttachmentsTab\";s:1:\"1\";s:13:\"showK2Plugins\";s:1:\"1\";s:22:\"sideBarDisplayFrontend\";s:1:\"0\";s:12:\"mergeEditors\";s:1:\"1\";s:14:\"sideBarDisplay\";s:1:\"1\";s:17:\"attachmentsFolder\";s:0:\"\";s:16:\"hideImportButton\";s:1:\"0\";s:13:\"taggingSystem\";s:1:\"1\";s:8:\"lockTags\";s:1:\"0\";s:13:\"showTagFilter\";s:1:\"0\";s:12:\"googleSearch\";s:1:\"0\";s:21:\"googleSearchContainer\";s:11:\"k2Container\";s:13:\"K2UserProfile\";s:1:\"0\";s:8:\"redirect\";s:3:\"101\";s:11:\"adminSearch\";s:6:\"simple\";s:12:\"cookieDomain\";s:0:\"\";s:20:\"recaptcha_public_key\";s:0:\"\";s:21:\"recaptcha_private_key\";s:0:\"\";s:15:\"recaptcha_theme\";s:5:\"clean\";s:23:\"recaptchaOnRegistration\";s:1:\"0\";s:13:\"stopForumSpam\";s:1:\"0\";s:19:\"stopForumSpamApiKey\";s:0:\"\";s:21:\"showItemsCounterAdmin\";s:1:\"1\";s:17:\"showChildCatItems\";s:1:\"1\";s:22:\"disableCompactOrdering\";s:1:\"0\";s:13:\"metaDescLimit\";s:3:\"150\";s:15:\"SEFReplacements\";s:583:\"Å |S, Å’|O, Å½|Z, Å¡|s, Å“|oe, Å¾|z, Å¸|Y, Â¥|Y, Âµ|u, Ã€|A, Ã�|A, Ã‚|A, Ãƒ|A, Ã„|A, Ã…|A, Ã†|A, Ã‡|C, Ãˆ|E, Ã‰|E, ÃŠ|E, Ã‹|E, ÃŒ|I, Ã�|I, ÃŽ|I, Ã�|I, Ã�|D, Ã‘|N, Ã’|O, Ã“|O, Ã”|O, Ã•|O, Ã–|O, Ã˜|O, Ã™|U, Ãš|U, Ã›|U, Ãœ|U, Ã�|Y, ÃŸ|s, Ã |a, Ã¡|a, Ã¢|a, Ã£|a, Ã¤|a, Ã¥|a, Ã¦|a, Ã§|c, Ã¨|e, Ã©|e, Ãª|e, Ã«|e, Ã¬|i, Ã­|i, Ã®|i, Ã¯|i, Ã°|o, Ã±|n, Ã²|o, Ã³|o, Ã´|o, Ãµ|o, Ã¶|o, Ã¸|o, Ã¹|u, Ãº|u, Ã»|u, Ã¼|u, Ã½|y, Ã¿|y, ÃŸ|ss\";s:16:\"sh404SefLabelCat\";s:0:\"\";s:17:\"sh404SefLabelUser\";s:4:\"blog\";s:17:\"sh404SefLabelItem\";s:1:\"2\";s:18:\"sh404SefTitleAlias\";s:5:\"alias\";s:29:\"sh404SefModK2ContentFeedAlias\";s:4:\"feed\";s:20:\"sh404SefInsertItemId\";s:1:\"0\";s:26:\"sh404SefInsertUniqueItemId\";s:1:\"0\";s:13:\"cbIntegration\";s:1:\"0\";s:11:\"inheritFrom\";s:1:\"0\";s:17:\"num_leading_items\";s:1:\"4\";s:19:\"num_leading_columns\";s:1:\"1\";s:14:\"leadingImgSize\";s:5:\"Large\";s:17:\"num_primary_items\";s:1:\"4\";s:19:\"num_primary_columns\";s:1:\"1\";s:14:\"primaryImgSize\";s:5:\"Large\";s:19:\"num_secondary_items\";s:1:\"4\";s:21:\"num_secondary_columns\";s:1:\"1\";s:16:\"secondaryImgSize\";s:5:\"Large\";s:9:\"num_links\";s:1:\"2\";s:17:\"num_links_columns\";s:1:\"1\";s:12:\"linksImgSize\";s:5:\"Large\";s:14:\"catCatalogMode\";s:1:\"1\";s:16:\"catFeaturedItems\";s:1:\"1\";s:13:\"catPagination\";s:1:\"2\";s:20:\"catPaginationResults\";s:1:\"1\";s:8:\"catTitle\";s:1:\"0\";s:19:\"catTitleItemCounter\";s:1:\"0\";s:14:\"catDescription\";s:1:\"0\";s:8:\"catImage\";s:1:\"0\";s:11:\"catFeedLink\";s:1:\"1\";s:11:\"catFeedIcon\";s:1:\"1\";s:13:\"subCategories\";s:1:\"0\";s:13:\"subCatColumns\";s:1:\"4\";s:11:\"subCatTitle\";s:1:\"0\";s:22:\"subCatTitleItemCounter\";s:1:\"0\";s:17:\"subCatDescription\";s:1:\"0\";s:11:\"subCatImage\";s:1:\"0\";s:12:\"catItemTitle\";s:1:\"1\";s:18:\"catItemTitleLinked\";s:1:\"1\";s:21:\"catItemFeaturedNotice\";s:1:\"0\";s:13:\"catItemAuthor\";s:1:\"1\";s:18:\"catItemDateCreated\";s:1:\"1\";s:13:\"catItemRating\";s:1:\"0\";s:12:\"catItemImage\";s:1:\"1\";s:16:\"catItemIntroText\";s:1:\"1\";s:18:\"catItemExtraFields\";s:1:\"0\";s:11:\"catItemHits\";s:1:\"0\";s:15:\"catItemCategory\";s:1:\"1\";s:11:\"catItemTags\";s:1:\"0\";s:18:\"catItemAttachments\";s:1:\"0\";s:25:\"catItemAttachmentsCounter\";s:1:\"0\";s:12:\"catItemVideo\";s:1:\"0\";s:20:\"catItemVideoAutoPlay\";s:1:\"0\";s:19:\"catItemImageGallery\";s:1:\"0\";s:19:\"catItemDateModified\";s:1:\"0\";s:15:\"catItemReadMore\";s:1:\"1\";s:21:\"catItemCommentsAnchor\";s:1:\"1\";s:16:\"catItemK2Plugins\";s:1:\"1\";s:15:\"itemDateCreated\";s:1:\"1\";s:9:\"itemTitle\";s:1:\"1\";s:18:\"itemFeaturedNotice\";s:1:\"1\";s:10:\"itemAuthor\";s:1:\"1\";s:15:\"itemFontResizer\";s:1:\"1\";s:15:\"itemPrintButton\";s:1:\"1\";s:15:\"itemEmailButton\";s:1:\"1\";s:16:\"itemSocialButton\";s:1:\"1\";s:15:\"itemVideoAnchor\";s:1:\"1\";s:22:\"itemImageGalleryAnchor\";s:1:\"1\";s:18:\"itemCommentsAnchor\";s:1:\"1\";s:10:\"itemRating\";s:1:\"1\";s:9:\"itemImage\";s:1:\"1\";s:11:\"itemImgSize\";s:5:\"Large\";s:20:\"itemImageMainCaption\";s:1:\"1\";s:20:\"itemImageMainCredits\";s:1:\"1\";s:13:\"itemIntroText\";s:1:\"1\";s:12:\"itemFullText\";s:1:\"1\";s:15:\"itemExtraFields\";s:1:\"1\";s:16:\"itemDateModified\";s:1:\"1\";s:8:\"itemHits\";s:1:\"1\";s:12:\"itemCategory\";s:1:\"1\";s:8:\"itemTags\";s:1:\"1\";s:15:\"itemAttachments\";s:1:\"1\";s:22:\"itemAttachmentsCounter\";s:1:\"1\";s:9:\"itemVideo\";s:1:\"1\";s:17:\"itemVideoAutoPlay\";s:1:\"0\";s:16:\"itemVideoCaption\";s:1:\"1\";s:16:\"itemVideoCredits\";s:1:\"1\";s:16:\"itemImageGallery\";s:1:\"1\";s:14:\"itemNavigation\";s:1:\"1\";s:12:\"itemComments\";s:1:\"1\";s:17:\"itemTwitterButton\";s:1:\"1\";s:18:\"itemFacebookButton\";s:1:\"1\";s:23:\"itemGooglePlusOneButton\";s:1:\"1\";s:15:\"itemAuthorBlock\";s:1:\"1\";s:15:\"itemAuthorImage\";s:1:\"1\";s:21:\"itemAuthorDescription\";s:1:\"1\";s:13:\"itemAuthorURL\";s:1:\"1\";s:15:\"itemAuthorEmail\";s:1:\"0\";s:16:\"itemAuthorLatest\";s:1:\"1\";s:21:\"itemAuthorLatestLimit\";s:1:\"5\";s:11:\"itemRelated\";s:1:\"1\";s:16:\"itemRelatedLimit\";s:1:\"5\";s:16:\"itemRelatedTitle\";s:1:\"1\";s:19:\"itemRelatedCategory\";s:1:\"0\";s:20:\"itemRelatedImageSize\";s:1:\"0\";s:20:\"itemRelatedIntrotext\";s:1:\"0\";s:19:\"itemRelatedFulltext\";s:1:\"0\";s:17:\"itemRelatedAuthor\";s:1:\"0\";s:16:\"itemRelatedMedia\";s:1:\"0\";s:23:\"itemRelatedImageGallery\";s:1:\"0\";s:13:\"itemK2Plugins\";s:1:\"1\";}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";}}s:8:\"ordering\";s:1:\"1\";s:5:\"trash\";s:1:\"0\";s:9:\"cat_trash\";s:1:\"0\";s:8:\"category\";s:14:\"Event Coverage\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:36:\"7:perfect-weather-a-great-slopestyle\";s:7:\"catslug\";s:16:\"2:event-coverage\";s:6:\"author\";s:10:\"Super User\";s:6:\"layout\";s:4:\"item\";s:4:\"path\";s:64:\"index.php/component/k2/item/7-perfect-weather-a-great-slopestyle\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"K2 Item\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"K2 Item\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:10:\"Super User\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:10:\"Super User\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:11:\"K2 Category\";a:1:{s:14:\"Event Coverage\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:14:\"Event Coverage\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:38:\"index.php?option=com_k2&view=item&id=7\";s:5:\"route\";s:73:\"index.php?option=com_k2&view=item&id=7:perfect-weather-a-great-slopestyle\";s:5:\"title\";s:35:\"Perfect weather, a great slopestyle\";s:11:\"description\";s:247:\"Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2012-12-03 11:42:47\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2012-12-03 11:42:47\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;}'),(8,'index.php?option=com_k2&view=item&id=8','index.php?option=com_k2&view=item&id=8:just-jared-premium-partner','Just Jared premium partner','Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.','2012-12-03 12:45:49','f3e4776296d139aa0b379ae0f7665b86',1,1,1,'*','2012-12-03 11:44:17','0000-00-00 00:00:00','2012-12-03 11:44:17','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:1:\"8\";s:5:\"alias\";s:26:\"just-jared-premium-partner\";s:7:\"summary\";s:256:\"<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n\";s:4:\"body\";s:488:\"\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla. Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\";s:5:\"catid\";s:1:\"2\";s:10:\"created_by\";s:3:\"944\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"0000-00-00 00:00:00\";s:11:\"modified_by\";s:1:\"0\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":239:{s:10:\"enable_css\";s:1:\"1\";s:14:\"jQueryHandling\";s:9:\"1.8remote\";s:21:\"backendJQueryHandling\";s:6:\"remote\";s:8:\"userName\";s:1:\"1\";s:9:\"userImage\";s:1:\"1\";s:15:\"userDescription\";s:1:\"1\";s:7:\"userURL\";s:1:\"1\";s:9:\"userEmail\";s:1:\"0\";s:12:\"userFeedLink\";s:1:\"1\";s:12:\"userFeedIcon\";s:1:\"1\";s:13:\"userItemCount\";s:1:\"4\";s:13:\"userItemTitle\";s:1:\"1\";s:19:\"userItemTitleLinked\";s:1:\"1\";s:19:\"userItemDateCreated\";s:1:\"1\";s:13:\"userItemImage\";s:1:\"1\";s:17:\"userItemIntroText\";s:1:\"1\";s:16:\"userItemCategory\";s:1:\"1\";s:12:\"userItemTags\";s:1:\"1\";s:22:\"userItemCommentsAnchor\";s:1:\"1\";s:16:\"userItemReadMore\";s:1:\"1\";s:17:\"userItemK2Plugins\";s:1:\"1\";s:18:\"defaultUsersItemid\";s:0:\"\";s:12:\"tagItemCount\";s:1:\"4\";s:12:\"tagItemTitle\";s:1:\"1\";s:18:\"tagItemTitleLinked\";s:1:\"1\";s:18:\"tagItemDateCreated\";s:1:\"1\";s:12:\"tagItemImage\";s:1:\"1\";s:16:\"tagItemIntroText\";s:1:\"1\";s:15:\"tagItemCategory\";s:1:\"1\";s:15:\"tagItemReadMore\";s:1:\"1\";s:18:\"tagItemExtraFields\";s:1:\"0\";s:11:\"tagOrdering\";s:0:\"\";s:11:\"tagFeedLink\";s:1:\"1\";s:11:\"tagFeedIcon\";s:1:\"1\";s:17:\"defaultTagsItemid\";s:0:\"\";s:16:\"genericItemCount\";s:2:\"10\";s:16:\"genericItemTitle\";s:1:\"1\";s:22:\"genericItemTitleLinked\";s:1:\"1\";s:22:\"genericItemDateCreated\";s:1:\"1\";s:16:\"genericItemImage\";s:1:\"1\";s:20:\"genericItemIntroText\";s:1:\"1\";s:19:\"genericItemCategory\";s:1:\"1\";s:19:\"genericItemReadMore\";s:1:\"1\";s:22:\"genericItemExtraFields\";s:1:\"0\";s:15:\"genericFeedLink\";s:1:\"1\";s:15:\"genericFeedIcon\";s:1:\"1\";s:9:\"feedLimit\";s:2:\"10\";s:13:\"feedItemImage\";s:1:\"1\";s:11:\"feedImgSize\";s:1:\"L\";s:17:\"feedItemIntroText\";s:1:\"1\";s:17:\"feedTextWordLimit\";s:0:\"\";s:16:\"feedItemFullText\";s:1:\"1\";s:12:\"feedItemTags\";s:1:\"0\";s:13:\"feedItemVideo\";s:1:\"0\";s:15:\"feedItemGallery\";s:1:\"0\";s:19:\"feedItemAttachments\";s:1:\"0\";s:14:\"feedBogusEmail\";s:0:\"\";s:16:\"introTextCleanup\";s:1:\"0\";s:27:\"introTextCleanupExcludeTags\";s:0:\"\";s:23:\"introTextCleanupTagAttr\";s:0:\"\";s:15:\"fullTextCleanup\";s:1:\"0\";s:26:\"fullTextCleanupExcludeTags\";s:0:\"\";s:22:\"fullTextCleanupTagAttr\";s:0:\"\";s:12:\"xssFiltering\";s:1:\"0\";s:14:\"linkPopupWidth\";s:3:\"900\";s:15:\"linkPopupHeight\";s:3:\"600\";s:13:\"imagesQuality\";s:2:\"95\";s:11:\"itemImageXS\";s:3:\"100\";s:10:\"itemImageS\";s:3:\"200\";s:10:\"itemImageM\";s:3:\"700\";s:10:\"itemImageL\";s:3:\"700\";s:11:\"itemImageXL\";s:3:\"918\";s:16:\"itemImageGeneric\";s:3:\"700\";s:13:\"catImageWidth\";s:3:\"700\";s:15:\"catImageDefault\";s:1:\"1\";s:14:\"userImageWidth\";s:3:\"116\";s:16:\"userImageDefault\";s:1:\"1\";s:17:\"commenterImgWidth\";s:2:\"48\";s:17:\"onlineImageEditor\";s:8:\"splashup\";s:14:\"imageTimestamp\";s:1:\"0\";s:16:\"imageMemoryLimit\";s:0:\"\";s:16:\"socialButtonCode\";s:0:\"\";s:15:\"twitterUsername\";s:0:\"\";s:13:\"facebookImage\";s:5:\"Small\";s:8:\"comments\";s:1:\"1\";s:16:\"commentsOrdering\";s:4:\"DESC\";s:13:\"commentsLimit\";s:2:\"10\";s:20:\"commentsFormPosition\";s:5:\"below\";s:18:\"commentsPublishing\";s:1:\"1\";s:17:\"commentsReporting\";s:1:\"2\";s:23:\"commentsReportRecipient\";s:0:\"\";s:24:\"inlineCommentsModeration\";s:1:\"0\";s:8:\"gravatar\";s:1:\"1\";s:9:\"recaptcha\";s:1:\"0\";s:17:\"commentsFormNotes\";s:1:\"1\";s:21:\"commentsFormNotesText\";s:0:\"\";s:15:\"frontendEditing\";s:1:\"1\";s:12:\"showImageTab\";s:1:\"1\";s:19:\"showImageGalleryTab\";s:1:\"1\";s:12:\"showVideoTab\";s:1:\"1\";s:18:\"showExtraFieldsTab\";s:1:\"1\";s:18:\"showAttachmentsTab\";s:1:\"1\";s:13:\"showK2Plugins\";s:1:\"1\";s:22:\"sideBarDisplayFrontend\";s:1:\"0\";s:12:\"mergeEditors\";s:1:\"1\";s:14:\"sideBarDisplay\";s:1:\"1\";s:17:\"attachmentsFolder\";s:0:\"\";s:16:\"hideImportButton\";s:1:\"0\";s:13:\"taggingSystem\";s:1:\"1\";s:8:\"lockTags\";s:1:\"0\";s:13:\"showTagFilter\";s:1:\"0\";s:12:\"googleSearch\";s:1:\"0\";s:21:\"googleSearchContainer\";s:11:\"k2Container\";s:13:\"K2UserProfile\";s:1:\"0\";s:8:\"redirect\";s:3:\"101\";s:11:\"adminSearch\";s:6:\"simple\";s:12:\"cookieDomain\";s:0:\"\";s:20:\"recaptcha_public_key\";s:0:\"\";s:21:\"recaptcha_private_key\";s:0:\"\";s:15:\"recaptcha_theme\";s:5:\"clean\";s:23:\"recaptchaOnRegistration\";s:1:\"0\";s:13:\"stopForumSpam\";s:1:\"0\";s:19:\"stopForumSpamApiKey\";s:0:\"\";s:21:\"showItemsCounterAdmin\";s:1:\"1\";s:17:\"showChildCatItems\";s:1:\"1\";s:22:\"disableCompactOrdering\";s:1:\"0\";s:13:\"metaDescLimit\";s:3:\"150\";s:15:\"SEFReplacements\";s:583:\"Å |S, Å’|O, Å½|Z, Å¡|s, Å“|oe, Å¾|z, Å¸|Y, Â¥|Y, Âµ|u, Ã€|A, Ã�|A, Ã‚|A, Ãƒ|A, Ã„|A, Ã…|A, Ã†|A, Ã‡|C, Ãˆ|E, Ã‰|E, ÃŠ|E, Ã‹|E, ÃŒ|I, Ã�|I, ÃŽ|I, Ã�|I, Ã�|D, Ã‘|N, Ã’|O, Ã“|O, Ã”|O, Ã•|O, Ã–|O, Ã˜|O, Ã™|U, Ãš|U, Ã›|U, Ãœ|U, Ã�|Y, ÃŸ|s, Ã |a, Ã¡|a, Ã¢|a, Ã£|a, Ã¤|a, Ã¥|a, Ã¦|a, Ã§|c, Ã¨|e, Ã©|e, Ãª|e, Ã«|e, Ã¬|i, Ã­|i, Ã®|i, Ã¯|i, Ã°|o, Ã±|n, Ã²|o, Ã³|o, Ã´|o, Ãµ|o, Ã¶|o, Ã¸|o, Ã¹|u, Ãº|u, Ã»|u, Ã¼|u, Ã½|y, Ã¿|y, ÃŸ|ss\";s:16:\"sh404SefLabelCat\";s:0:\"\";s:17:\"sh404SefLabelUser\";s:4:\"blog\";s:17:\"sh404SefLabelItem\";s:1:\"2\";s:18:\"sh404SefTitleAlias\";s:5:\"alias\";s:29:\"sh404SefModK2ContentFeedAlias\";s:4:\"feed\";s:20:\"sh404SefInsertItemId\";s:1:\"0\";s:26:\"sh404SefInsertUniqueItemId\";s:1:\"0\";s:13:\"cbIntegration\";s:1:\"0\";s:11:\"inheritFrom\";s:1:\"0\";s:17:\"num_leading_items\";s:1:\"4\";s:19:\"num_leading_columns\";s:1:\"1\";s:14:\"leadingImgSize\";s:5:\"Large\";s:17:\"num_primary_items\";s:1:\"4\";s:19:\"num_primary_columns\";s:1:\"1\";s:14:\"primaryImgSize\";s:5:\"Large\";s:19:\"num_secondary_items\";s:1:\"4\";s:21:\"num_secondary_columns\";s:1:\"1\";s:16:\"secondaryImgSize\";s:5:\"Large\";s:9:\"num_links\";s:1:\"2\";s:17:\"num_links_columns\";s:1:\"1\";s:12:\"linksImgSize\";s:5:\"Large\";s:14:\"catCatalogMode\";s:1:\"1\";s:16:\"catFeaturedItems\";s:1:\"1\";s:13:\"catPagination\";s:1:\"2\";s:20:\"catPaginationResults\";s:1:\"1\";s:8:\"catTitle\";s:1:\"0\";s:19:\"catTitleItemCounter\";s:1:\"0\";s:14:\"catDescription\";s:1:\"0\";s:8:\"catImage\";s:1:\"0\";s:11:\"catFeedLink\";s:1:\"1\";s:11:\"catFeedIcon\";s:1:\"1\";s:13:\"subCategories\";s:1:\"0\";s:13:\"subCatColumns\";s:1:\"4\";s:11:\"subCatTitle\";s:1:\"0\";s:22:\"subCatTitleItemCounter\";s:1:\"0\";s:17:\"subCatDescription\";s:1:\"0\";s:11:\"subCatImage\";s:1:\"0\";s:12:\"catItemTitle\";s:1:\"1\";s:18:\"catItemTitleLinked\";s:1:\"1\";s:21:\"catItemFeaturedNotice\";s:1:\"0\";s:13:\"catItemAuthor\";s:1:\"1\";s:18:\"catItemDateCreated\";s:1:\"1\";s:13:\"catItemRating\";s:1:\"0\";s:12:\"catItemImage\";s:1:\"1\";s:16:\"catItemIntroText\";s:1:\"1\";s:18:\"catItemExtraFields\";s:1:\"0\";s:11:\"catItemHits\";s:1:\"0\";s:15:\"catItemCategory\";s:1:\"1\";s:11:\"catItemTags\";s:1:\"0\";s:18:\"catItemAttachments\";s:1:\"0\";s:25:\"catItemAttachmentsCounter\";s:1:\"0\";s:12:\"catItemVideo\";s:1:\"0\";s:20:\"catItemVideoAutoPlay\";s:1:\"0\";s:19:\"catItemImageGallery\";s:1:\"0\";s:19:\"catItemDateModified\";s:1:\"0\";s:15:\"catItemReadMore\";s:1:\"1\";s:21:\"catItemCommentsAnchor\";s:1:\"1\";s:16:\"catItemK2Plugins\";s:1:\"1\";s:15:\"itemDateCreated\";s:1:\"1\";s:9:\"itemTitle\";s:1:\"1\";s:18:\"itemFeaturedNotice\";s:1:\"1\";s:10:\"itemAuthor\";s:1:\"1\";s:15:\"itemFontResizer\";s:1:\"1\";s:15:\"itemPrintButton\";s:1:\"1\";s:15:\"itemEmailButton\";s:1:\"1\";s:16:\"itemSocialButton\";s:1:\"1\";s:15:\"itemVideoAnchor\";s:1:\"1\";s:22:\"itemImageGalleryAnchor\";s:1:\"1\";s:18:\"itemCommentsAnchor\";s:1:\"1\";s:10:\"itemRating\";s:1:\"1\";s:9:\"itemImage\";s:1:\"1\";s:11:\"itemImgSize\";s:5:\"Large\";s:20:\"itemImageMainCaption\";s:1:\"1\";s:20:\"itemImageMainCredits\";s:1:\"1\";s:13:\"itemIntroText\";s:1:\"1\";s:12:\"itemFullText\";s:1:\"1\";s:15:\"itemExtraFields\";s:1:\"1\";s:16:\"itemDateModified\";s:1:\"1\";s:8:\"itemHits\";s:1:\"1\";s:12:\"itemCategory\";s:1:\"1\";s:8:\"itemTags\";s:1:\"1\";s:15:\"itemAttachments\";s:1:\"1\";s:22:\"itemAttachmentsCounter\";s:1:\"1\";s:9:\"itemVideo\";s:1:\"1\";s:17:\"itemVideoAutoPlay\";s:1:\"0\";s:16:\"itemVideoCaption\";s:1:\"1\";s:16:\"itemVideoCredits\";s:1:\"1\";s:16:\"itemImageGallery\";s:1:\"1\";s:14:\"itemNavigation\";s:1:\"1\";s:12:\"itemComments\";s:1:\"1\";s:17:\"itemTwitterButton\";s:1:\"1\";s:18:\"itemFacebookButton\";s:1:\"1\";s:23:\"itemGooglePlusOneButton\";s:1:\"1\";s:15:\"itemAuthorBlock\";s:1:\"1\";s:15:\"itemAuthorImage\";s:1:\"1\";s:21:\"itemAuthorDescription\";s:1:\"1\";s:13:\"itemAuthorURL\";s:1:\"1\";s:15:\"itemAuthorEmail\";s:1:\"0\";s:16:\"itemAuthorLatest\";s:1:\"1\";s:21:\"itemAuthorLatestLimit\";s:1:\"5\";s:11:\"itemRelated\";s:1:\"1\";s:16:\"itemRelatedLimit\";s:1:\"5\";s:16:\"itemRelatedTitle\";s:1:\"1\";s:19:\"itemRelatedCategory\";s:1:\"0\";s:20:\"itemRelatedImageSize\";s:1:\"0\";s:20:\"itemRelatedIntrotext\";s:1:\"0\";s:19:\"itemRelatedFulltext\";s:1:\"0\";s:17:\"itemRelatedAuthor\";s:1:\"0\";s:16:\"itemRelatedMedia\";s:1:\"0\";s:23:\"itemRelatedImageGallery\";s:1:\"0\";s:13:\"itemK2Plugins\";s:1:\"1\";}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";}}s:8:\"ordering\";s:1:\"2\";s:5:\"trash\";s:1:\"0\";s:9:\"cat_trash\";s:1:\"0\";s:8:\"category\";s:14:\"Event Coverage\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:28:\"8:just-jared-premium-partner\";s:7:\"catslug\";s:16:\"2:event-coverage\";s:6:\"author\";s:10:\"Super User\";s:6:\"layout\";s:4:\"item\";s:4:\"path\";s:56:\"index.php/component/k2/item/8-just-jared-premium-partner\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"K2 Item\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"K2 Item\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:10:\"Super User\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:10:\"Super User\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:11:\"K2 Category\";a:1:{s:14:\"Event Coverage\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:14:\"Event Coverage\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:38:\"index.php?option=com_k2&view=item&id=8\";s:5:\"route\";s:65:\"index.php?option=com_k2&view=item&id=8:just-jared-premium-partner\";s:5:\"title\";s:26:\"Just Jared premium partner\";s:11:\"description\";s:247:\"Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2012-12-03 11:44:17\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2012-12-03 11:44:17\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;}'),(9,'index.php?option=com_k2&view=item&id=9','index.php?option=com_k2&view=item&id=9:snowboarding-on-sunny-day','Snowboarding on sunny day','Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.','2012-12-03 12:47:17','640c7616ee4a6d68404e5377c46af62c',1,1,1,'*','2012-12-03 11:45:50','0000-00-00 00:00:00','2012-12-03 11:45:50','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:1:\"9\";s:5:\"alias\";s:25:\"snowboarding-on-sunny-day\";s:7:\"summary\";s:256:\"<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n\";s:4:\"body\";s:488:\"\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla. Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\";s:5:\"catid\";s:1:\"2\";s:10:\"created_by\";s:3:\"944\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"0000-00-00 00:00:00\";s:11:\"modified_by\";s:1:\"0\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":239:{s:10:\"enable_css\";s:1:\"1\";s:14:\"jQueryHandling\";s:9:\"1.8remote\";s:21:\"backendJQueryHandling\";s:6:\"remote\";s:8:\"userName\";s:1:\"1\";s:9:\"userImage\";s:1:\"1\";s:15:\"userDescription\";s:1:\"1\";s:7:\"userURL\";s:1:\"1\";s:9:\"userEmail\";s:1:\"0\";s:12:\"userFeedLink\";s:1:\"1\";s:12:\"userFeedIcon\";s:1:\"1\";s:13:\"userItemCount\";s:1:\"4\";s:13:\"userItemTitle\";s:1:\"1\";s:19:\"userItemTitleLinked\";s:1:\"1\";s:19:\"userItemDateCreated\";s:1:\"1\";s:13:\"userItemImage\";s:1:\"1\";s:17:\"userItemIntroText\";s:1:\"1\";s:16:\"userItemCategory\";s:1:\"1\";s:12:\"userItemTags\";s:1:\"1\";s:22:\"userItemCommentsAnchor\";s:1:\"1\";s:16:\"userItemReadMore\";s:1:\"1\";s:17:\"userItemK2Plugins\";s:1:\"1\";s:18:\"defaultUsersItemid\";s:0:\"\";s:12:\"tagItemCount\";s:1:\"4\";s:12:\"tagItemTitle\";s:1:\"1\";s:18:\"tagItemTitleLinked\";s:1:\"1\";s:18:\"tagItemDateCreated\";s:1:\"1\";s:12:\"tagItemImage\";s:1:\"1\";s:16:\"tagItemIntroText\";s:1:\"1\";s:15:\"tagItemCategory\";s:1:\"1\";s:15:\"tagItemReadMore\";s:1:\"1\";s:18:\"tagItemExtraFields\";s:1:\"0\";s:11:\"tagOrdering\";s:0:\"\";s:11:\"tagFeedLink\";s:1:\"1\";s:11:\"tagFeedIcon\";s:1:\"1\";s:17:\"defaultTagsItemid\";s:0:\"\";s:16:\"genericItemCount\";s:2:\"10\";s:16:\"genericItemTitle\";s:1:\"1\";s:22:\"genericItemTitleLinked\";s:1:\"1\";s:22:\"genericItemDateCreated\";s:1:\"1\";s:16:\"genericItemImage\";s:1:\"1\";s:20:\"genericItemIntroText\";s:1:\"1\";s:19:\"genericItemCategory\";s:1:\"1\";s:19:\"genericItemReadMore\";s:1:\"1\";s:22:\"genericItemExtraFields\";s:1:\"0\";s:15:\"genericFeedLink\";s:1:\"1\";s:15:\"genericFeedIcon\";s:1:\"1\";s:9:\"feedLimit\";s:2:\"10\";s:13:\"feedItemImage\";s:1:\"1\";s:11:\"feedImgSize\";s:1:\"L\";s:17:\"feedItemIntroText\";s:1:\"1\";s:17:\"feedTextWordLimit\";s:0:\"\";s:16:\"feedItemFullText\";s:1:\"1\";s:12:\"feedItemTags\";s:1:\"0\";s:13:\"feedItemVideo\";s:1:\"0\";s:15:\"feedItemGallery\";s:1:\"0\";s:19:\"feedItemAttachments\";s:1:\"0\";s:14:\"feedBogusEmail\";s:0:\"\";s:16:\"introTextCleanup\";s:1:\"0\";s:27:\"introTextCleanupExcludeTags\";s:0:\"\";s:23:\"introTextCleanupTagAttr\";s:0:\"\";s:15:\"fullTextCleanup\";s:1:\"0\";s:26:\"fullTextCleanupExcludeTags\";s:0:\"\";s:22:\"fullTextCleanupTagAttr\";s:0:\"\";s:12:\"xssFiltering\";s:1:\"0\";s:14:\"linkPopupWidth\";s:3:\"900\";s:15:\"linkPopupHeight\";s:3:\"600\";s:13:\"imagesQuality\";s:2:\"95\";s:11:\"itemImageXS\";s:3:\"100\";s:10:\"itemImageS\";s:3:\"200\";s:10:\"itemImageM\";s:3:\"700\";s:10:\"itemImageL\";s:3:\"700\";s:11:\"itemImageXL\";s:3:\"918\";s:16:\"itemImageGeneric\";s:3:\"700\";s:13:\"catImageWidth\";s:3:\"700\";s:15:\"catImageDefault\";s:1:\"1\";s:14:\"userImageWidth\";s:3:\"116\";s:16:\"userImageDefault\";s:1:\"1\";s:17:\"commenterImgWidth\";s:2:\"48\";s:17:\"onlineImageEditor\";s:8:\"splashup\";s:14:\"imageTimestamp\";s:1:\"0\";s:16:\"imageMemoryLimit\";s:0:\"\";s:16:\"socialButtonCode\";s:0:\"\";s:15:\"twitterUsername\";s:0:\"\";s:13:\"facebookImage\";s:5:\"Small\";s:8:\"comments\";s:1:\"1\";s:16:\"commentsOrdering\";s:4:\"DESC\";s:13:\"commentsLimit\";s:2:\"10\";s:20:\"commentsFormPosition\";s:5:\"below\";s:18:\"commentsPublishing\";s:1:\"1\";s:17:\"commentsReporting\";s:1:\"2\";s:23:\"commentsReportRecipient\";s:0:\"\";s:24:\"inlineCommentsModeration\";s:1:\"0\";s:8:\"gravatar\";s:1:\"1\";s:9:\"recaptcha\";s:1:\"0\";s:17:\"commentsFormNotes\";s:1:\"1\";s:21:\"commentsFormNotesText\";s:0:\"\";s:15:\"frontendEditing\";s:1:\"1\";s:12:\"showImageTab\";s:1:\"1\";s:19:\"showImageGalleryTab\";s:1:\"1\";s:12:\"showVideoTab\";s:1:\"1\";s:18:\"showExtraFieldsTab\";s:1:\"1\";s:18:\"showAttachmentsTab\";s:1:\"1\";s:13:\"showK2Plugins\";s:1:\"1\";s:22:\"sideBarDisplayFrontend\";s:1:\"0\";s:12:\"mergeEditors\";s:1:\"1\";s:14:\"sideBarDisplay\";s:1:\"1\";s:17:\"attachmentsFolder\";s:0:\"\";s:16:\"hideImportButton\";s:1:\"0\";s:13:\"taggingSystem\";s:1:\"1\";s:8:\"lockTags\";s:1:\"0\";s:13:\"showTagFilter\";s:1:\"0\";s:12:\"googleSearch\";s:1:\"0\";s:21:\"googleSearchContainer\";s:11:\"k2Container\";s:13:\"K2UserProfile\";s:1:\"0\";s:8:\"redirect\";s:3:\"101\";s:11:\"adminSearch\";s:6:\"simple\";s:12:\"cookieDomain\";s:0:\"\";s:20:\"recaptcha_public_key\";s:0:\"\";s:21:\"recaptcha_private_key\";s:0:\"\";s:15:\"recaptcha_theme\";s:5:\"clean\";s:23:\"recaptchaOnRegistration\";s:1:\"0\";s:13:\"stopForumSpam\";s:1:\"0\";s:19:\"stopForumSpamApiKey\";s:0:\"\";s:21:\"showItemsCounterAdmin\";s:1:\"1\";s:17:\"showChildCatItems\";s:1:\"1\";s:22:\"disableCompactOrdering\";s:1:\"0\";s:13:\"metaDescLimit\";s:3:\"150\";s:15:\"SEFReplacements\";s:583:\"Å |S, Å’|O, Å½|Z, Å¡|s, Å“|oe, Å¾|z, Å¸|Y, Â¥|Y, Âµ|u, Ã€|A, Ã�|A, Ã‚|A, Ãƒ|A, Ã„|A, Ã…|A, Ã†|A, Ã‡|C, Ãˆ|E, Ã‰|E, ÃŠ|E, Ã‹|E, ÃŒ|I, Ã�|I, ÃŽ|I, Ã�|I, Ã�|D, Ã‘|N, Ã’|O, Ã“|O, Ã”|O, Ã•|O, Ã–|O, Ã˜|O, Ã™|U, Ãš|U, Ã›|U, Ãœ|U, Ã�|Y, ÃŸ|s, Ã |a, Ã¡|a, Ã¢|a, Ã£|a, Ã¤|a, Ã¥|a, Ã¦|a, Ã§|c, Ã¨|e, Ã©|e, Ãª|e, Ã«|e, Ã¬|i, Ã­|i, Ã®|i, Ã¯|i, Ã°|o, Ã±|n, Ã²|o, Ã³|o, Ã´|o, Ãµ|o, Ã¶|o, Ã¸|o, Ã¹|u, Ãº|u, Ã»|u, Ã¼|u, Ã½|y, Ã¿|y, ÃŸ|ss\";s:16:\"sh404SefLabelCat\";s:0:\"\";s:17:\"sh404SefLabelUser\";s:4:\"blog\";s:17:\"sh404SefLabelItem\";s:1:\"2\";s:18:\"sh404SefTitleAlias\";s:5:\"alias\";s:29:\"sh404SefModK2ContentFeedAlias\";s:4:\"feed\";s:20:\"sh404SefInsertItemId\";s:1:\"0\";s:26:\"sh404SefInsertUniqueItemId\";s:1:\"0\";s:13:\"cbIntegration\";s:1:\"0\";s:11:\"inheritFrom\";s:1:\"0\";s:17:\"num_leading_items\";s:1:\"4\";s:19:\"num_leading_columns\";s:1:\"1\";s:14:\"leadingImgSize\";s:5:\"Large\";s:17:\"num_primary_items\";s:1:\"4\";s:19:\"num_primary_columns\";s:1:\"1\";s:14:\"primaryImgSize\";s:5:\"Large\";s:19:\"num_secondary_items\";s:1:\"4\";s:21:\"num_secondary_columns\";s:1:\"1\";s:16:\"secondaryImgSize\";s:5:\"Large\";s:9:\"num_links\";s:1:\"2\";s:17:\"num_links_columns\";s:1:\"1\";s:12:\"linksImgSize\";s:5:\"Large\";s:14:\"catCatalogMode\";s:1:\"1\";s:16:\"catFeaturedItems\";s:1:\"1\";s:13:\"catPagination\";s:1:\"2\";s:20:\"catPaginationResults\";s:1:\"1\";s:8:\"catTitle\";s:1:\"0\";s:19:\"catTitleItemCounter\";s:1:\"0\";s:14:\"catDescription\";s:1:\"0\";s:8:\"catImage\";s:1:\"0\";s:11:\"catFeedLink\";s:1:\"1\";s:11:\"catFeedIcon\";s:1:\"1\";s:13:\"subCategories\";s:1:\"0\";s:13:\"subCatColumns\";s:1:\"4\";s:11:\"subCatTitle\";s:1:\"0\";s:22:\"subCatTitleItemCounter\";s:1:\"0\";s:17:\"subCatDescription\";s:1:\"0\";s:11:\"subCatImage\";s:1:\"0\";s:12:\"catItemTitle\";s:1:\"1\";s:18:\"catItemTitleLinked\";s:1:\"1\";s:21:\"catItemFeaturedNotice\";s:1:\"0\";s:13:\"catItemAuthor\";s:1:\"1\";s:18:\"catItemDateCreated\";s:1:\"1\";s:13:\"catItemRating\";s:1:\"0\";s:12:\"catItemImage\";s:1:\"1\";s:16:\"catItemIntroText\";s:1:\"1\";s:18:\"catItemExtraFields\";s:1:\"0\";s:11:\"catItemHits\";s:1:\"0\";s:15:\"catItemCategory\";s:1:\"1\";s:11:\"catItemTags\";s:1:\"0\";s:18:\"catItemAttachments\";s:1:\"0\";s:25:\"catItemAttachmentsCounter\";s:1:\"0\";s:12:\"catItemVideo\";s:1:\"0\";s:20:\"catItemVideoAutoPlay\";s:1:\"0\";s:19:\"catItemImageGallery\";s:1:\"0\";s:19:\"catItemDateModified\";s:1:\"0\";s:15:\"catItemReadMore\";s:1:\"1\";s:21:\"catItemCommentsAnchor\";s:1:\"1\";s:16:\"catItemK2Plugins\";s:1:\"1\";s:15:\"itemDateCreated\";s:1:\"1\";s:9:\"itemTitle\";s:1:\"1\";s:18:\"itemFeaturedNotice\";s:1:\"1\";s:10:\"itemAuthor\";s:1:\"1\";s:15:\"itemFontResizer\";s:1:\"1\";s:15:\"itemPrintButton\";s:1:\"1\";s:15:\"itemEmailButton\";s:1:\"1\";s:16:\"itemSocialButton\";s:1:\"1\";s:15:\"itemVideoAnchor\";s:1:\"1\";s:22:\"itemImageGalleryAnchor\";s:1:\"1\";s:18:\"itemCommentsAnchor\";s:1:\"1\";s:10:\"itemRating\";s:1:\"1\";s:9:\"itemImage\";s:1:\"1\";s:11:\"itemImgSize\";s:5:\"Large\";s:20:\"itemImageMainCaption\";s:1:\"1\";s:20:\"itemImageMainCredits\";s:1:\"1\";s:13:\"itemIntroText\";s:1:\"1\";s:12:\"itemFullText\";s:1:\"1\";s:15:\"itemExtraFields\";s:1:\"1\";s:16:\"itemDateModified\";s:1:\"1\";s:8:\"itemHits\";s:1:\"1\";s:12:\"itemCategory\";s:1:\"1\";s:8:\"itemTags\";s:1:\"1\";s:15:\"itemAttachments\";s:1:\"1\";s:22:\"itemAttachmentsCounter\";s:1:\"1\";s:9:\"itemVideo\";s:1:\"1\";s:17:\"itemVideoAutoPlay\";s:1:\"0\";s:16:\"itemVideoCaption\";s:1:\"1\";s:16:\"itemVideoCredits\";s:1:\"1\";s:16:\"itemImageGallery\";s:1:\"1\";s:14:\"itemNavigation\";s:1:\"1\";s:12:\"itemComments\";s:1:\"1\";s:17:\"itemTwitterButton\";s:1:\"1\";s:18:\"itemFacebookButton\";s:1:\"1\";s:23:\"itemGooglePlusOneButton\";s:1:\"1\";s:15:\"itemAuthorBlock\";s:1:\"1\";s:15:\"itemAuthorImage\";s:1:\"1\";s:21:\"itemAuthorDescription\";s:1:\"1\";s:13:\"itemAuthorURL\";s:1:\"1\";s:15:\"itemAuthorEmail\";s:1:\"0\";s:16:\"itemAuthorLatest\";s:1:\"1\";s:21:\"itemAuthorLatestLimit\";s:1:\"5\";s:11:\"itemRelated\";s:1:\"1\";s:16:\"itemRelatedLimit\";s:1:\"5\";s:16:\"itemRelatedTitle\";s:1:\"1\";s:19:\"itemRelatedCategory\";s:1:\"0\";s:20:\"itemRelatedImageSize\";s:1:\"0\";s:20:\"itemRelatedIntrotext\";s:1:\"0\";s:19:\"itemRelatedFulltext\";s:1:\"0\";s:17:\"itemRelatedAuthor\";s:1:\"0\";s:16:\"itemRelatedMedia\";s:1:\"0\";s:23:\"itemRelatedImageGallery\";s:1:\"0\";s:13:\"itemK2Plugins\";s:1:\"1\";}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";}}s:8:\"ordering\";s:1:\"3\";s:5:\"trash\";s:1:\"0\";s:9:\"cat_trash\";s:1:\"0\";s:8:\"category\";s:14:\"Event Coverage\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:27:\"9:snowboarding-on-sunny-day\";s:7:\"catslug\";s:16:\"2:event-coverage\";s:6:\"author\";s:10:\"Super User\";s:6:\"layout\";s:4:\"item\";s:4:\"path\";s:55:\"index.php/component/k2/item/9-snowboarding-on-sunny-day\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"K2 Item\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"K2 Item\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:10:\"Super User\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:10:\"Super User\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:11:\"K2 Category\";a:1:{s:14:\"Event Coverage\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:14:\"Event Coverage\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:38:\"index.php?option=com_k2&view=item&id=9\";s:5:\"route\";s:64:\"index.php?option=com_k2&view=item&id=9:snowboarding-on-sunny-day\";s:5:\"title\";s:25:\"Snowboarding on sunny day\";s:11:\"description\";s:247:\"Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2012-12-03 11:45:50\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2012-12-03 11:45:50\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;}'),(10,'index.php?option=com_k2&view=item&id=10','index.php?option=com_k2&view=item&id=10:billy-morgan-is-going-big-at-the-moment','Billy Morgan is going big at the moment','Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.','2012-12-03 12:51:29','c263c68cb22d40925f822fc060c64b8d',1,1,1,'*','2012-12-03 11:47:17','0000-00-00 00:00:00','2012-12-03 11:47:17','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:2:\"10\";s:5:\"alias\";s:39:\"billy-morgan-is-going-big-at-the-moment\";s:7:\"summary\";s:256:\"<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n\";s:4:\"body\";s:488:\"\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla. Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\";s:5:\"catid\";s:1:\"2\";s:10:\"created_by\";s:3:\"944\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"0000-00-00 00:00:00\";s:11:\"modified_by\";s:1:\"0\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":239:{s:10:\"enable_css\";s:1:\"1\";s:14:\"jQueryHandling\";s:9:\"1.8remote\";s:21:\"backendJQueryHandling\";s:6:\"remote\";s:8:\"userName\";s:1:\"1\";s:9:\"userImage\";s:1:\"1\";s:15:\"userDescription\";s:1:\"1\";s:7:\"userURL\";s:1:\"1\";s:9:\"userEmail\";s:1:\"0\";s:12:\"userFeedLink\";s:1:\"1\";s:12:\"userFeedIcon\";s:1:\"1\";s:13:\"userItemCount\";s:1:\"4\";s:13:\"userItemTitle\";s:1:\"1\";s:19:\"userItemTitleLinked\";s:1:\"1\";s:19:\"userItemDateCreated\";s:1:\"1\";s:13:\"userItemImage\";s:1:\"1\";s:17:\"userItemIntroText\";s:1:\"1\";s:16:\"userItemCategory\";s:1:\"1\";s:12:\"userItemTags\";s:1:\"1\";s:22:\"userItemCommentsAnchor\";s:1:\"1\";s:16:\"userItemReadMore\";s:1:\"1\";s:17:\"userItemK2Plugins\";s:1:\"1\";s:18:\"defaultUsersItemid\";s:0:\"\";s:12:\"tagItemCount\";s:1:\"4\";s:12:\"tagItemTitle\";s:1:\"1\";s:18:\"tagItemTitleLinked\";s:1:\"1\";s:18:\"tagItemDateCreated\";s:1:\"1\";s:12:\"tagItemImage\";s:1:\"1\";s:16:\"tagItemIntroText\";s:1:\"1\";s:15:\"tagItemCategory\";s:1:\"1\";s:15:\"tagItemReadMore\";s:1:\"1\";s:18:\"tagItemExtraFields\";s:1:\"0\";s:11:\"tagOrdering\";s:0:\"\";s:11:\"tagFeedLink\";s:1:\"1\";s:11:\"tagFeedIcon\";s:1:\"1\";s:17:\"defaultTagsItemid\";s:0:\"\";s:16:\"genericItemCount\";s:2:\"10\";s:16:\"genericItemTitle\";s:1:\"1\";s:22:\"genericItemTitleLinked\";s:1:\"1\";s:22:\"genericItemDateCreated\";s:1:\"1\";s:16:\"genericItemImage\";s:1:\"1\";s:20:\"genericItemIntroText\";s:1:\"1\";s:19:\"genericItemCategory\";s:1:\"1\";s:19:\"genericItemReadMore\";s:1:\"1\";s:22:\"genericItemExtraFields\";s:1:\"0\";s:15:\"genericFeedLink\";s:1:\"1\";s:15:\"genericFeedIcon\";s:1:\"1\";s:9:\"feedLimit\";s:2:\"10\";s:13:\"feedItemImage\";s:1:\"1\";s:11:\"feedImgSize\";s:1:\"L\";s:17:\"feedItemIntroText\";s:1:\"1\";s:17:\"feedTextWordLimit\";s:0:\"\";s:16:\"feedItemFullText\";s:1:\"1\";s:12:\"feedItemTags\";s:1:\"0\";s:13:\"feedItemVideo\";s:1:\"0\";s:15:\"feedItemGallery\";s:1:\"0\";s:19:\"feedItemAttachments\";s:1:\"0\";s:14:\"feedBogusEmail\";s:0:\"\";s:16:\"introTextCleanup\";s:1:\"0\";s:27:\"introTextCleanupExcludeTags\";s:0:\"\";s:23:\"introTextCleanupTagAttr\";s:0:\"\";s:15:\"fullTextCleanup\";s:1:\"0\";s:26:\"fullTextCleanupExcludeTags\";s:0:\"\";s:22:\"fullTextCleanupTagAttr\";s:0:\"\";s:12:\"xssFiltering\";s:1:\"0\";s:14:\"linkPopupWidth\";s:3:\"900\";s:15:\"linkPopupHeight\";s:3:\"600\";s:13:\"imagesQuality\";s:2:\"95\";s:11:\"itemImageXS\";s:3:\"100\";s:10:\"itemImageS\";s:3:\"200\";s:10:\"itemImageM\";s:3:\"700\";s:10:\"itemImageL\";s:3:\"700\";s:11:\"itemImageXL\";s:3:\"918\";s:16:\"itemImageGeneric\";s:3:\"700\";s:13:\"catImageWidth\";s:3:\"700\";s:15:\"catImageDefault\";s:1:\"1\";s:14:\"userImageWidth\";s:3:\"116\";s:16:\"userImageDefault\";s:1:\"1\";s:17:\"commenterImgWidth\";s:2:\"48\";s:17:\"onlineImageEditor\";s:8:\"splashup\";s:14:\"imageTimestamp\";s:1:\"0\";s:16:\"imageMemoryLimit\";s:0:\"\";s:16:\"socialButtonCode\";s:0:\"\";s:15:\"twitterUsername\";s:0:\"\";s:13:\"facebookImage\";s:5:\"Small\";s:8:\"comments\";s:1:\"1\";s:16:\"commentsOrdering\";s:4:\"DESC\";s:13:\"commentsLimit\";s:2:\"10\";s:20:\"commentsFormPosition\";s:5:\"below\";s:18:\"commentsPublishing\";s:1:\"1\";s:17:\"commentsReporting\";s:1:\"2\";s:23:\"commentsReportRecipient\";s:0:\"\";s:24:\"inlineCommentsModeration\";s:1:\"0\";s:8:\"gravatar\";s:1:\"1\";s:9:\"recaptcha\";s:1:\"0\";s:17:\"commentsFormNotes\";s:1:\"1\";s:21:\"commentsFormNotesText\";s:0:\"\";s:15:\"frontendEditing\";s:1:\"1\";s:12:\"showImageTab\";s:1:\"1\";s:19:\"showImageGalleryTab\";s:1:\"1\";s:12:\"showVideoTab\";s:1:\"1\";s:18:\"showExtraFieldsTab\";s:1:\"1\";s:18:\"showAttachmentsTab\";s:1:\"1\";s:13:\"showK2Plugins\";s:1:\"1\";s:22:\"sideBarDisplayFrontend\";s:1:\"0\";s:12:\"mergeEditors\";s:1:\"1\";s:14:\"sideBarDisplay\";s:1:\"1\";s:17:\"attachmentsFolder\";s:0:\"\";s:16:\"hideImportButton\";s:1:\"0\";s:13:\"taggingSystem\";s:1:\"1\";s:8:\"lockTags\";s:1:\"0\";s:13:\"showTagFilter\";s:1:\"0\";s:12:\"googleSearch\";s:1:\"0\";s:21:\"googleSearchContainer\";s:11:\"k2Container\";s:13:\"K2UserProfile\";s:1:\"0\";s:8:\"redirect\";s:3:\"101\";s:11:\"adminSearch\";s:6:\"simple\";s:12:\"cookieDomain\";s:0:\"\";s:20:\"recaptcha_public_key\";s:0:\"\";s:21:\"recaptcha_private_key\";s:0:\"\";s:15:\"recaptcha_theme\";s:5:\"clean\";s:23:\"recaptchaOnRegistration\";s:1:\"0\";s:13:\"stopForumSpam\";s:1:\"0\";s:19:\"stopForumSpamApiKey\";s:0:\"\";s:21:\"showItemsCounterAdmin\";s:1:\"1\";s:17:\"showChildCatItems\";s:1:\"1\";s:22:\"disableCompactOrdering\";s:1:\"0\";s:13:\"metaDescLimit\";s:3:\"150\";s:15:\"SEFReplacements\";s:583:\"Å |S, Å’|O, Å½|Z, Å¡|s, Å“|oe, Å¾|z, Å¸|Y, Â¥|Y, Âµ|u, Ã€|A, Ã�|A, Ã‚|A, Ãƒ|A, Ã„|A, Ã…|A, Ã†|A, Ã‡|C, Ãˆ|E, Ã‰|E, ÃŠ|E, Ã‹|E, ÃŒ|I, Ã�|I, ÃŽ|I, Ã�|I, Ã�|D, Ã‘|N, Ã’|O, Ã“|O, Ã”|O, Ã•|O, Ã–|O, Ã˜|O, Ã™|U, Ãš|U, Ã›|U, Ãœ|U, Ã�|Y, ÃŸ|s, Ã |a, Ã¡|a, Ã¢|a, Ã£|a, Ã¤|a, Ã¥|a, Ã¦|a, Ã§|c, Ã¨|e, Ã©|e, Ãª|e, Ã«|e, Ã¬|i, Ã­|i, Ã®|i, Ã¯|i, Ã°|o, Ã±|n, Ã²|o, Ã³|o, Ã´|o, Ãµ|o, Ã¶|o, Ã¸|o, Ã¹|u, Ãº|u, Ã»|u, Ã¼|u, Ã½|y, Ã¿|y, ÃŸ|ss\";s:16:\"sh404SefLabelCat\";s:0:\"\";s:17:\"sh404SefLabelUser\";s:4:\"blog\";s:17:\"sh404SefLabelItem\";s:1:\"2\";s:18:\"sh404SefTitleAlias\";s:5:\"alias\";s:29:\"sh404SefModK2ContentFeedAlias\";s:4:\"feed\";s:20:\"sh404SefInsertItemId\";s:1:\"0\";s:26:\"sh404SefInsertUniqueItemId\";s:1:\"0\";s:13:\"cbIntegration\";s:1:\"0\";s:11:\"inheritFrom\";s:1:\"0\";s:17:\"num_leading_items\";s:1:\"4\";s:19:\"num_leading_columns\";s:1:\"1\";s:14:\"leadingImgSize\";s:5:\"Large\";s:17:\"num_primary_items\";s:1:\"4\";s:19:\"num_primary_columns\";s:1:\"1\";s:14:\"primaryImgSize\";s:5:\"Large\";s:19:\"num_secondary_items\";s:1:\"4\";s:21:\"num_secondary_columns\";s:1:\"1\";s:16:\"secondaryImgSize\";s:5:\"Large\";s:9:\"num_links\";s:1:\"2\";s:17:\"num_links_columns\";s:1:\"1\";s:12:\"linksImgSize\";s:5:\"Large\";s:14:\"catCatalogMode\";s:1:\"1\";s:16:\"catFeaturedItems\";s:1:\"1\";s:13:\"catPagination\";s:1:\"2\";s:20:\"catPaginationResults\";s:1:\"1\";s:8:\"catTitle\";s:1:\"0\";s:19:\"catTitleItemCounter\";s:1:\"0\";s:14:\"catDescription\";s:1:\"0\";s:8:\"catImage\";s:1:\"0\";s:11:\"catFeedLink\";s:1:\"1\";s:11:\"catFeedIcon\";s:1:\"1\";s:13:\"subCategories\";s:1:\"0\";s:13:\"subCatColumns\";s:1:\"4\";s:11:\"subCatTitle\";s:1:\"0\";s:22:\"subCatTitleItemCounter\";s:1:\"0\";s:17:\"subCatDescription\";s:1:\"0\";s:11:\"subCatImage\";s:1:\"0\";s:12:\"catItemTitle\";s:1:\"1\";s:18:\"catItemTitleLinked\";s:1:\"1\";s:21:\"catItemFeaturedNotice\";s:1:\"0\";s:13:\"catItemAuthor\";s:1:\"1\";s:18:\"catItemDateCreated\";s:1:\"1\";s:13:\"catItemRating\";s:1:\"0\";s:12:\"catItemImage\";s:1:\"1\";s:16:\"catItemIntroText\";s:1:\"1\";s:18:\"catItemExtraFields\";s:1:\"0\";s:11:\"catItemHits\";s:1:\"0\";s:15:\"catItemCategory\";s:1:\"1\";s:11:\"catItemTags\";s:1:\"0\";s:18:\"catItemAttachments\";s:1:\"0\";s:25:\"catItemAttachmentsCounter\";s:1:\"0\";s:12:\"catItemVideo\";s:1:\"0\";s:20:\"catItemVideoAutoPlay\";s:1:\"0\";s:19:\"catItemImageGallery\";s:1:\"0\";s:19:\"catItemDateModified\";s:1:\"0\";s:15:\"catItemReadMore\";s:1:\"1\";s:21:\"catItemCommentsAnchor\";s:1:\"1\";s:16:\"catItemK2Plugins\";s:1:\"1\";s:15:\"itemDateCreated\";s:1:\"1\";s:9:\"itemTitle\";s:1:\"1\";s:18:\"itemFeaturedNotice\";s:1:\"1\";s:10:\"itemAuthor\";s:1:\"1\";s:15:\"itemFontResizer\";s:1:\"1\";s:15:\"itemPrintButton\";s:1:\"1\";s:15:\"itemEmailButton\";s:1:\"1\";s:16:\"itemSocialButton\";s:1:\"1\";s:15:\"itemVideoAnchor\";s:1:\"1\";s:22:\"itemImageGalleryAnchor\";s:1:\"1\";s:18:\"itemCommentsAnchor\";s:1:\"1\";s:10:\"itemRating\";s:1:\"1\";s:9:\"itemImage\";s:1:\"1\";s:11:\"itemImgSize\";s:5:\"Large\";s:20:\"itemImageMainCaption\";s:1:\"1\";s:20:\"itemImageMainCredits\";s:1:\"1\";s:13:\"itemIntroText\";s:1:\"1\";s:12:\"itemFullText\";s:1:\"1\";s:15:\"itemExtraFields\";s:1:\"1\";s:16:\"itemDateModified\";s:1:\"1\";s:8:\"itemHits\";s:1:\"1\";s:12:\"itemCategory\";s:1:\"1\";s:8:\"itemTags\";s:1:\"1\";s:15:\"itemAttachments\";s:1:\"1\";s:22:\"itemAttachmentsCounter\";s:1:\"1\";s:9:\"itemVideo\";s:1:\"1\";s:17:\"itemVideoAutoPlay\";s:1:\"0\";s:16:\"itemVideoCaption\";s:1:\"1\";s:16:\"itemVideoCredits\";s:1:\"1\";s:16:\"itemImageGallery\";s:1:\"1\";s:14:\"itemNavigation\";s:1:\"1\";s:12:\"itemComments\";s:1:\"1\";s:17:\"itemTwitterButton\";s:1:\"1\";s:18:\"itemFacebookButton\";s:1:\"1\";s:23:\"itemGooglePlusOneButton\";s:1:\"1\";s:15:\"itemAuthorBlock\";s:1:\"1\";s:15:\"itemAuthorImage\";s:1:\"1\";s:21:\"itemAuthorDescription\";s:1:\"1\";s:13:\"itemAuthorURL\";s:1:\"1\";s:15:\"itemAuthorEmail\";s:1:\"0\";s:16:\"itemAuthorLatest\";s:1:\"1\";s:21:\"itemAuthorLatestLimit\";s:1:\"5\";s:11:\"itemRelated\";s:1:\"1\";s:16:\"itemRelatedLimit\";s:1:\"5\";s:16:\"itemRelatedTitle\";s:1:\"1\";s:19:\"itemRelatedCategory\";s:1:\"0\";s:20:\"itemRelatedImageSize\";s:1:\"0\";s:20:\"itemRelatedIntrotext\";s:1:\"0\";s:19:\"itemRelatedFulltext\";s:1:\"0\";s:17:\"itemRelatedAuthor\";s:1:\"0\";s:16:\"itemRelatedMedia\";s:1:\"0\";s:23:\"itemRelatedImageGallery\";s:1:\"0\";s:13:\"itemK2Plugins\";s:1:\"1\";}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";}}s:8:\"ordering\";s:1:\"4\";s:5:\"trash\";s:1:\"0\";s:9:\"cat_trash\";s:1:\"0\";s:8:\"category\";s:14:\"Event Coverage\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:42:\"10:billy-morgan-is-going-big-at-the-moment\";s:7:\"catslug\";s:16:\"2:event-coverage\";s:6:\"author\";s:10:\"Super User\";s:6:\"layout\";s:4:\"item\";s:4:\"path\";s:70:\"index.php/component/k2/item/10-billy-morgan-is-going-big-at-the-moment\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"K2 Item\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"K2 Item\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:10:\"Super User\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:10:\"Super User\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:11:\"K2 Category\";a:1:{s:14:\"Event Coverage\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:14:\"Event Coverage\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:39:\"index.php?option=com_k2&view=item&id=10\";s:5:\"route\";s:79:\"index.php?option=com_k2&view=item&id=10:billy-morgan-is-going-big-at-the-moment\";s:5:\"title\";s:39:\"Billy Morgan is going big at the moment\";s:11:\"description\";s:247:\"Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2012-12-03 11:47:17\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2012-12-03 11:47:17\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;}'),(11,'index.php?option=com_k2&view=item&id=11','index.php?option=com_k2&view=item&id=11:missing-winter?-craving-some-pow?','Missing Winter? Craving Some Pow?','Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.','2012-12-03 12:53:13','5141b19fe304946220024b635986b086',1,1,1,'*','2012-12-03 11:51:30','0000-00-00 00:00:00','2012-12-03 11:51:30','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:2:\"11\";s:5:\"alias\";s:33:\"missing-winter?-craving-some-pow?\";s:7:\"summary\";s:256:\"<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n\";s:4:\"body\";s:488:\"\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla. Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\";s:5:\"catid\";s:1:\"4\";s:10:\"created_by\";s:3:\"944\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"0000-00-00 00:00:00\";s:11:\"modified_by\";s:1:\"0\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":239:{s:10:\"enable_css\";s:1:\"1\";s:14:\"jQueryHandling\";s:9:\"1.8remote\";s:21:\"backendJQueryHandling\";s:6:\"remote\";s:8:\"userName\";s:1:\"1\";s:9:\"userImage\";s:1:\"1\";s:15:\"userDescription\";s:1:\"1\";s:7:\"userURL\";s:1:\"1\";s:9:\"userEmail\";s:1:\"0\";s:12:\"userFeedLink\";s:1:\"1\";s:12:\"userFeedIcon\";s:1:\"1\";s:13:\"userItemCount\";s:1:\"4\";s:13:\"userItemTitle\";s:1:\"1\";s:19:\"userItemTitleLinked\";s:1:\"1\";s:19:\"userItemDateCreated\";s:1:\"1\";s:13:\"userItemImage\";s:1:\"1\";s:17:\"userItemIntroText\";s:1:\"1\";s:16:\"userItemCategory\";s:1:\"1\";s:12:\"userItemTags\";s:1:\"1\";s:22:\"userItemCommentsAnchor\";s:1:\"1\";s:16:\"userItemReadMore\";s:1:\"1\";s:17:\"userItemK2Plugins\";s:1:\"1\";s:18:\"defaultUsersItemid\";s:0:\"\";s:12:\"tagItemCount\";s:1:\"4\";s:12:\"tagItemTitle\";s:1:\"1\";s:18:\"tagItemTitleLinked\";s:1:\"1\";s:18:\"tagItemDateCreated\";s:1:\"1\";s:12:\"tagItemImage\";s:1:\"1\";s:16:\"tagItemIntroText\";s:1:\"1\";s:15:\"tagItemCategory\";s:1:\"1\";s:15:\"tagItemReadMore\";s:1:\"1\";s:18:\"tagItemExtraFields\";s:1:\"0\";s:11:\"tagOrdering\";s:0:\"\";s:11:\"tagFeedLink\";s:1:\"1\";s:11:\"tagFeedIcon\";s:1:\"1\";s:17:\"defaultTagsItemid\";s:0:\"\";s:16:\"genericItemCount\";s:2:\"10\";s:16:\"genericItemTitle\";s:1:\"1\";s:22:\"genericItemTitleLinked\";s:1:\"1\";s:22:\"genericItemDateCreated\";s:1:\"1\";s:16:\"genericItemImage\";s:1:\"1\";s:20:\"genericItemIntroText\";s:1:\"1\";s:19:\"genericItemCategory\";s:1:\"1\";s:19:\"genericItemReadMore\";s:1:\"1\";s:22:\"genericItemExtraFields\";s:1:\"0\";s:15:\"genericFeedLink\";s:1:\"1\";s:15:\"genericFeedIcon\";s:1:\"1\";s:9:\"feedLimit\";s:2:\"10\";s:13:\"feedItemImage\";s:1:\"1\";s:11:\"feedImgSize\";s:1:\"L\";s:17:\"feedItemIntroText\";s:1:\"1\";s:17:\"feedTextWordLimit\";s:0:\"\";s:16:\"feedItemFullText\";s:1:\"1\";s:12:\"feedItemTags\";s:1:\"0\";s:13:\"feedItemVideo\";s:1:\"0\";s:15:\"feedItemGallery\";s:1:\"0\";s:19:\"feedItemAttachments\";s:1:\"0\";s:14:\"feedBogusEmail\";s:0:\"\";s:16:\"introTextCleanup\";s:1:\"0\";s:27:\"introTextCleanupExcludeTags\";s:0:\"\";s:23:\"introTextCleanupTagAttr\";s:0:\"\";s:15:\"fullTextCleanup\";s:1:\"0\";s:26:\"fullTextCleanupExcludeTags\";s:0:\"\";s:22:\"fullTextCleanupTagAttr\";s:0:\"\";s:12:\"xssFiltering\";s:1:\"0\";s:14:\"linkPopupWidth\";s:3:\"900\";s:15:\"linkPopupHeight\";s:3:\"600\";s:13:\"imagesQuality\";s:2:\"95\";s:11:\"itemImageXS\";s:3:\"100\";s:10:\"itemImageS\";s:3:\"200\";s:10:\"itemImageM\";s:3:\"700\";s:10:\"itemImageL\";s:3:\"700\";s:11:\"itemImageXL\";s:3:\"918\";s:16:\"itemImageGeneric\";s:3:\"700\";s:13:\"catImageWidth\";s:3:\"700\";s:15:\"catImageDefault\";s:1:\"1\";s:14:\"userImageWidth\";s:3:\"116\";s:16:\"userImageDefault\";s:1:\"1\";s:17:\"commenterImgWidth\";s:2:\"48\";s:17:\"onlineImageEditor\";s:8:\"splashup\";s:14:\"imageTimestamp\";s:1:\"0\";s:16:\"imageMemoryLimit\";s:0:\"\";s:16:\"socialButtonCode\";s:0:\"\";s:15:\"twitterUsername\";s:0:\"\";s:13:\"facebookImage\";s:5:\"Small\";s:8:\"comments\";s:1:\"1\";s:16:\"commentsOrdering\";s:4:\"DESC\";s:13:\"commentsLimit\";s:2:\"10\";s:20:\"commentsFormPosition\";s:5:\"below\";s:18:\"commentsPublishing\";s:1:\"1\";s:17:\"commentsReporting\";s:1:\"2\";s:23:\"commentsReportRecipient\";s:0:\"\";s:24:\"inlineCommentsModeration\";s:1:\"0\";s:8:\"gravatar\";s:1:\"1\";s:9:\"recaptcha\";s:1:\"0\";s:17:\"commentsFormNotes\";s:1:\"1\";s:21:\"commentsFormNotesText\";s:0:\"\";s:15:\"frontendEditing\";s:1:\"1\";s:12:\"showImageTab\";s:1:\"1\";s:19:\"showImageGalleryTab\";s:1:\"1\";s:12:\"showVideoTab\";s:1:\"1\";s:18:\"showExtraFieldsTab\";s:1:\"1\";s:18:\"showAttachmentsTab\";s:1:\"1\";s:13:\"showK2Plugins\";s:1:\"1\";s:22:\"sideBarDisplayFrontend\";s:1:\"0\";s:12:\"mergeEditors\";s:1:\"1\";s:14:\"sideBarDisplay\";s:1:\"1\";s:17:\"attachmentsFolder\";s:0:\"\";s:16:\"hideImportButton\";s:1:\"0\";s:13:\"taggingSystem\";s:1:\"1\";s:8:\"lockTags\";s:1:\"0\";s:13:\"showTagFilter\";s:1:\"0\";s:12:\"googleSearch\";s:1:\"0\";s:21:\"googleSearchContainer\";s:11:\"k2Container\";s:13:\"K2UserProfile\";s:1:\"0\";s:8:\"redirect\";s:3:\"101\";s:11:\"adminSearch\";s:6:\"simple\";s:12:\"cookieDomain\";s:0:\"\";s:20:\"recaptcha_public_key\";s:0:\"\";s:21:\"recaptcha_private_key\";s:0:\"\";s:15:\"recaptcha_theme\";s:5:\"clean\";s:23:\"recaptchaOnRegistration\";s:1:\"0\";s:13:\"stopForumSpam\";s:1:\"0\";s:19:\"stopForumSpamApiKey\";s:0:\"\";s:21:\"showItemsCounterAdmin\";s:1:\"1\";s:17:\"showChildCatItems\";s:1:\"1\";s:22:\"disableCompactOrdering\";s:1:\"0\";s:13:\"metaDescLimit\";s:3:\"150\";s:15:\"SEFReplacements\";s:583:\"Å |S, Å’|O, Å½|Z, Å¡|s, Å“|oe, Å¾|z, Å¸|Y, Â¥|Y, Âµ|u, Ã€|A, Ã�|A, Ã‚|A, Ãƒ|A, Ã„|A, Ã…|A, Ã†|A, Ã‡|C, Ãˆ|E, Ã‰|E, ÃŠ|E, Ã‹|E, ÃŒ|I, Ã�|I, ÃŽ|I, Ã�|I, Ã�|D, Ã‘|N, Ã’|O, Ã“|O, Ã”|O, Ã•|O, Ã–|O, Ã˜|O, Ã™|U, Ãš|U, Ã›|U, Ãœ|U, Ã�|Y, ÃŸ|s, Ã |a, Ã¡|a, Ã¢|a, Ã£|a, Ã¤|a, Ã¥|a, Ã¦|a, Ã§|c, Ã¨|e, Ã©|e, Ãª|e, Ã«|e, Ã¬|i, Ã­|i, Ã®|i, Ã¯|i, Ã°|o, Ã±|n, Ã²|o, Ã³|o, Ã´|o, Ãµ|o, Ã¶|o, Ã¸|o, Ã¹|u, Ãº|u, Ã»|u, Ã¼|u, Ã½|y, Ã¿|y, ÃŸ|ss\";s:16:\"sh404SefLabelCat\";s:0:\"\";s:17:\"sh404SefLabelUser\";s:4:\"blog\";s:17:\"sh404SefLabelItem\";s:1:\"2\";s:18:\"sh404SefTitleAlias\";s:5:\"alias\";s:29:\"sh404SefModK2ContentFeedAlias\";s:4:\"feed\";s:20:\"sh404SefInsertItemId\";s:1:\"0\";s:26:\"sh404SefInsertUniqueItemId\";s:1:\"0\";s:13:\"cbIntegration\";s:1:\"0\";s:11:\"inheritFrom\";s:1:\"0\";s:17:\"num_leading_items\";s:1:\"4\";s:19:\"num_leading_columns\";s:1:\"1\";s:14:\"leadingImgSize\";s:5:\"Large\";s:17:\"num_primary_items\";s:1:\"4\";s:19:\"num_primary_columns\";s:1:\"1\";s:14:\"primaryImgSize\";s:5:\"Large\";s:19:\"num_secondary_items\";s:1:\"4\";s:21:\"num_secondary_columns\";s:1:\"1\";s:16:\"secondaryImgSize\";s:5:\"Large\";s:9:\"num_links\";s:1:\"2\";s:17:\"num_links_columns\";s:1:\"1\";s:12:\"linksImgSize\";s:5:\"Large\";s:14:\"catCatalogMode\";s:1:\"1\";s:16:\"catFeaturedItems\";s:1:\"1\";s:13:\"catPagination\";s:1:\"2\";s:20:\"catPaginationResults\";s:1:\"1\";s:8:\"catTitle\";s:1:\"0\";s:19:\"catTitleItemCounter\";s:1:\"0\";s:14:\"catDescription\";s:1:\"0\";s:8:\"catImage\";s:1:\"0\";s:11:\"catFeedLink\";s:1:\"1\";s:11:\"catFeedIcon\";s:1:\"1\";s:13:\"subCategories\";s:1:\"0\";s:13:\"subCatColumns\";s:1:\"4\";s:11:\"subCatTitle\";s:1:\"0\";s:22:\"subCatTitleItemCounter\";s:1:\"0\";s:17:\"subCatDescription\";s:1:\"0\";s:11:\"subCatImage\";s:1:\"0\";s:12:\"catItemTitle\";s:1:\"1\";s:18:\"catItemTitleLinked\";s:1:\"1\";s:21:\"catItemFeaturedNotice\";s:1:\"0\";s:13:\"catItemAuthor\";s:1:\"1\";s:18:\"catItemDateCreated\";s:1:\"1\";s:13:\"catItemRating\";s:1:\"0\";s:12:\"catItemImage\";s:1:\"1\";s:16:\"catItemIntroText\";s:1:\"1\";s:18:\"catItemExtraFields\";s:1:\"0\";s:11:\"catItemHits\";s:1:\"0\";s:15:\"catItemCategory\";s:1:\"1\";s:11:\"catItemTags\";s:1:\"0\";s:18:\"catItemAttachments\";s:1:\"0\";s:25:\"catItemAttachmentsCounter\";s:1:\"0\";s:12:\"catItemVideo\";s:1:\"0\";s:20:\"catItemVideoAutoPlay\";s:1:\"0\";s:19:\"catItemImageGallery\";s:1:\"0\";s:19:\"catItemDateModified\";s:1:\"0\";s:15:\"catItemReadMore\";s:1:\"1\";s:21:\"catItemCommentsAnchor\";s:1:\"1\";s:16:\"catItemK2Plugins\";s:1:\"1\";s:15:\"itemDateCreated\";s:1:\"1\";s:9:\"itemTitle\";s:1:\"1\";s:18:\"itemFeaturedNotice\";s:1:\"1\";s:10:\"itemAuthor\";s:1:\"1\";s:15:\"itemFontResizer\";s:1:\"1\";s:15:\"itemPrintButton\";s:1:\"1\";s:15:\"itemEmailButton\";s:1:\"1\";s:16:\"itemSocialButton\";s:1:\"1\";s:15:\"itemVideoAnchor\";s:1:\"1\";s:22:\"itemImageGalleryAnchor\";s:1:\"1\";s:18:\"itemCommentsAnchor\";s:1:\"1\";s:10:\"itemRating\";s:1:\"1\";s:9:\"itemImage\";s:1:\"1\";s:11:\"itemImgSize\";s:5:\"Large\";s:20:\"itemImageMainCaption\";s:1:\"1\";s:20:\"itemImageMainCredits\";s:1:\"1\";s:13:\"itemIntroText\";s:1:\"1\";s:12:\"itemFullText\";s:1:\"1\";s:15:\"itemExtraFields\";s:1:\"1\";s:16:\"itemDateModified\";s:1:\"1\";s:8:\"itemHits\";s:1:\"1\";s:12:\"itemCategory\";s:1:\"1\";s:8:\"itemTags\";s:1:\"1\";s:15:\"itemAttachments\";s:1:\"1\";s:22:\"itemAttachmentsCounter\";s:1:\"1\";s:9:\"itemVideo\";s:1:\"1\";s:17:\"itemVideoAutoPlay\";s:1:\"0\";s:16:\"itemVideoCaption\";s:1:\"1\";s:16:\"itemVideoCredits\";s:1:\"1\";s:16:\"itemImageGallery\";s:1:\"1\";s:14:\"itemNavigation\";s:1:\"1\";s:12:\"itemComments\";s:1:\"1\";s:17:\"itemTwitterButton\";s:1:\"1\";s:18:\"itemFacebookButton\";s:1:\"1\";s:23:\"itemGooglePlusOneButton\";s:1:\"1\";s:15:\"itemAuthorBlock\";s:1:\"1\";s:15:\"itemAuthorImage\";s:1:\"1\";s:21:\"itemAuthorDescription\";s:1:\"1\";s:13:\"itemAuthorURL\";s:1:\"1\";s:15:\"itemAuthorEmail\";s:1:\"0\";s:16:\"itemAuthorLatest\";s:1:\"1\";s:21:\"itemAuthorLatestLimit\";s:1:\"5\";s:11:\"itemRelated\";s:1:\"1\";s:16:\"itemRelatedLimit\";s:1:\"5\";s:16:\"itemRelatedTitle\";s:1:\"1\";s:19:\"itemRelatedCategory\";s:1:\"0\";s:20:\"itemRelatedImageSize\";s:1:\"0\";s:20:\"itemRelatedIntrotext\";s:1:\"0\";s:19:\"itemRelatedFulltext\";s:1:\"0\";s:17:\"itemRelatedAuthor\";s:1:\"0\";s:16:\"itemRelatedMedia\";s:1:\"0\";s:23:\"itemRelatedImageGallery\";s:1:\"0\";s:13:\"itemK2Plugins\";s:1:\"1\";}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";}}s:8:\"ordering\";s:1:\"2\";s:5:\"trash\";s:1:\"0\";s:9:\"cat_trash\";s:1:\"0\";s:8:\"category\";s:16:\"Photo Of The Day\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:36:\"11:missing-winter?-craving-some-pow?\";s:7:\"catslug\";s:18:\"4:photo-of-the-day\";s:6:\"author\";s:10:\"Super User\";s:6:\"layout\";s:4:\"item\";s:4:\"path\";s:64:\"index.php/component/k2/item/11-missing-winter?-craving-some-pow?\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"K2 Item\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"K2 Item\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:10:\"Super User\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:10:\"Super User\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:11:\"K2 Category\";a:1:{s:16:\"Photo Of The Day\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:16:\"Photo Of The Day\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:39:\"index.php?option=com_k2&view=item&id=11\";s:5:\"route\";s:73:\"index.php?option=com_k2&view=item&id=11:missing-winter?-craving-some-pow?\";s:5:\"title\";s:33:\"Missing Winter? Craving Some Pow?\";s:11:\"description\";s:247:\"Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2012-12-03 11:51:30\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2012-12-03 11:51:30\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;}'),(12,'index.php?option=com_k2&view=item&id=12','index.php?option=com_k2&view=item&id=12:torstein-–-in-your-face','Torstein – In Your Face','Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.','2012-12-03 12:54:36','d265c7f25b22957a4a6af4c7bdb79442',1,1,1,'*','2012-12-03 11:53:14','0000-00-00 00:00:00','2012-12-03 11:53:14','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:2:\"12\";s:5:\"alias\";s:25:\"torstein-–-in-your-face\";s:7:\"summary\";s:256:\"<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n\";s:4:\"body\";s:488:\"\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla. Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\";s:5:\"catid\";s:1:\"4\";s:10:\"created_by\";s:3:\"944\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"0000-00-00 00:00:00\";s:11:\"modified_by\";s:1:\"0\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":239:{s:10:\"enable_css\";s:1:\"1\";s:14:\"jQueryHandling\";s:9:\"1.8remote\";s:21:\"backendJQueryHandling\";s:6:\"remote\";s:8:\"userName\";s:1:\"1\";s:9:\"userImage\";s:1:\"1\";s:15:\"userDescription\";s:1:\"1\";s:7:\"userURL\";s:1:\"1\";s:9:\"userEmail\";s:1:\"0\";s:12:\"userFeedLink\";s:1:\"1\";s:12:\"userFeedIcon\";s:1:\"1\";s:13:\"userItemCount\";s:1:\"4\";s:13:\"userItemTitle\";s:1:\"1\";s:19:\"userItemTitleLinked\";s:1:\"1\";s:19:\"userItemDateCreated\";s:1:\"1\";s:13:\"userItemImage\";s:1:\"1\";s:17:\"userItemIntroText\";s:1:\"1\";s:16:\"userItemCategory\";s:1:\"1\";s:12:\"userItemTags\";s:1:\"1\";s:22:\"userItemCommentsAnchor\";s:1:\"1\";s:16:\"userItemReadMore\";s:1:\"1\";s:17:\"userItemK2Plugins\";s:1:\"1\";s:18:\"defaultUsersItemid\";s:0:\"\";s:12:\"tagItemCount\";s:1:\"4\";s:12:\"tagItemTitle\";s:1:\"1\";s:18:\"tagItemTitleLinked\";s:1:\"1\";s:18:\"tagItemDateCreated\";s:1:\"1\";s:12:\"tagItemImage\";s:1:\"1\";s:16:\"tagItemIntroText\";s:1:\"1\";s:15:\"tagItemCategory\";s:1:\"1\";s:15:\"tagItemReadMore\";s:1:\"1\";s:18:\"tagItemExtraFields\";s:1:\"0\";s:11:\"tagOrdering\";s:0:\"\";s:11:\"tagFeedLink\";s:1:\"1\";s:11:\"tagFeedIcon\";s:1:\"1\";s:17:\"defaultTagsItemid\";s:0:\"\";s:16:\"genericItemCount\";s:2:\"10\";s:16:\"genericItemTitle\";s:1:\"1\";s:22:\"genericItemTitleLinked\";s:1:\"1\";s:22:\"genericItemDateCreated\";s:1:\"1\";s:16:\"genericItemImage\";s:1:\"1\";s:20:\"genericItemIntroText\";s:1:\"1\";s:19:\"genericItemCategory\";s:1:\"1\";s:19:\"genericItemReadMore\";s:1:\"1\";s:22:\"genericItemExtraFields\";s:1:\"0\";s:15:\"genericFeedLink\";s:1:\"1\";s:15:\"genericFeedIcon\";s:1:\"1\";s:9:\"feedLimit\";s:2:\"10\";s:13:\"feedItemImage\";s:1:\"1\";s:11:\"feedImgSize\";s:1:\"L\";s:17:\"feedItemIntroText\";s:1:\"1\";s:17:\"feedTextWordLimit\";s:0:\"\";s:16:\"feedItemFullText\";s:1:\"1\";s:12:\"feedItemTags\";s:1:\"0\";s:13:\"feedItemVideo\";s:1:\"0\";s:15:\"feedItemGallery\";s:1:\"0\";s:19:\"feedItemAttachments\";s:1:\"0\";s:14:\"feedBogusEmail\";s:0:\"\";s:16:\"introTextCleanup\";s:1:\"0\";s:27:\"introTextCleanupExcludeTags\";s:0:\"\";s:23:\"introTextCleanupTagAttr\";s:0:\"\";s:15:\"fullTextCleanup\";s:1:\"0\";s:26:\"fullTextCleanupExcludeTags\";s:0:\"\";s:22:\"fullTextCleanupTagAttr\";s:0:\"\";s:12:\"xssFiltering\";s:1:\"0\";s:14:\"linkPopupWidth\";s:3:\"900\";s:15:\"linkPopupHeight\";s:3:\"600\";s:13:\"imagesQuality\";s:2:\"95\";s:11:\"itemImageXS\";s:3:\"100\";s:10:\"itemImageS\";s:3:\"200\";s:10:\"itemImageM\";s:3:\"700\";s:10:\"itemImageL\";s:3:\"700\";s:11:\"itemImageXL\";s:3:\"918\";s:16:\"itemImageGeneric\";s:3:\"700\";s:13:\"catImageWidth\";s:3:\"700\";s:15:\"catImageDefault\";s:1:\"1\";s:14:\"userImageWidth\";s:3:\"116\";s:16:\"userImageDefault\";s:1:\"1\";s:17:\"commenterImgWidth\";s:2:\"48\";s:17:\"onlineImageEditor\";s:8:\"splashup\";s:14:\"imageTimestamp\";s:1:\"0\";s:16:\"imageMemoryLimit\";s:0:\"\";s:16:\"socialButtonCode\";s:0:\"\";s:15:\"twitterUsername\";s:0:\"\";s:13:\"facebookImage\";s:5:\"Small\";s:8:\"comments\";s:1:\"1\";s:16:\"commentsOrdering\";s:4:\"DESC\";s:13:\"commentsLimit\";s:2:\"10\";s:20:\"commentsFormPosition\";s:5:\"below\";s:18:\"commentsPublishing\";s:1:\"1\";s:17:\"commentsReporting\";s:1:\"2\";s:23:\"commentsReportRecipient\";s:0:\"\";s:24:\"inlineCommentsModeration\";s:1:\"0\";s:8:\"gravatar\";s:1:\"1\";s:9:\"recaptcha\";s:1:\"0\";s:17:\"commentsFormNotes\";s:1:\"1\";s:21:\"commentsFormNotesText\";s:0:\"\";s:15:\"frontendEditing\";s:1:\"1\";s:12:\"showImageTab\";s:1:\"1\";s:19:\"showImageGalleryTab\";s:1:\"1\";s:12:\"showVideoTab\";s:1:\"1\";s:18:\"showExtraFieldsTab\";s:1:\"1\";s:18:\"showAttachmentsTab\";s:1:\"1\";s:13:\"showK2Plugins\";s:1:\"1\";s:22:\"sideBarDisplayFrontend\";s:1:\"0\";s:12:\"mergeEditors\";s:1:\"1\";s:14:\"sideBarDisplay\";s:1:\"1\";s:17:\"attachmentsFolder\";s:0:\"\";s:16:\"hideImportButton\";s:1:\"0\";s:13:\"taggingSystem\";s:1:\"1\";s:8:\"lockTags\";s:1:\"0\";s:13:\"showTagFilter\";s:1:\"0\";s:12:\"googleSearch\";s:1:\"0\";s:21:\"googleSearchContainer\";s:11:\"k2Container\";s:13:\"K2UserProfile\";s:1:\"0\";s:8:\"redirect\";s:3:\"101\";s:11:\"adminSearch\";s:6:\"simple\";s:12:\"cookieDomain\";s:0:\"\";s:20:\"recaptcha_public_key\";s:0:\"\";s:21:\"recaptcha_private_key\";s:0:\"\";s:15:\"recaptcha_theme\";s:5:\"clean\";s:23:\"recaptchaOnRegistration\";s:1:\"0\";s:13:\"stopForumSpam\";s:1:\"0\";s:19:\"stopForumSpamApiKey\";s:0:\"\";s:21:\"showItemsCounterAdmin\";s:1:\"1\";s:17:\"showChildCatItems\";s:1:\"1\";s:22:\"disableCompactOrdering\";s:1:\"0\";s:13:\"metaDescLimit\";s:3:\"150\";s:15:\"SEFReplacements\";s:583:\"Å |S, Å’|O, Å½|Z, Å¡|s, Å“|oe, Å¾|z, Å¸|Y, Â¥|Y, Âµ|u, Ã€|A, Ã�|A, Ã‚|A, Ãƒ|A, Ã„|A, Ã…|A, Ã†|A, Ã‡|C, Ãˆ|E, Ã‰|E, ÃŠ|E, Ã‹|E, ÃŒ|I, Ã�|I, ÃŽ|I, Ã�|I, Ã�|D, Ã‘|N, Ã’|O, Ã“|O, Ã”|O, Ã•|O, Ã–|O, Ã˜|O, Ã™|U, Ãš|U, Ã›|U, Ãœ|U, Ã�|Y, ÃŸ|s, Ã |a, Ã¡|a, Ã¢|a, Ã£|a, Ã¤|a, Ã¥|a, Ã¦|a, Ã§|c, Ã¨|e, Ã©|e, Ãª|e, Ã«|e, Ã¬|i, Ã­|i, Ã®|i, Ã¯|i, Ã°|o, Ã±|n, Ã²|o, Ã³|o, Ã´|o, Ãµ|o, Ã¶|o, Ã¸|o, Ã¹|u, Ãº|u, Ã»|u, Ã¼|u, Ã½|y, Ã¿|y, ÃŸ|ss\";s:16:\"sh404SefLabelCat\";s:0:\"\";s:17:\"sh404SefLabelUser\";s:4:\"blog\";s:17:\"sh404SefLabelItem\";s:1:\"2\";s:18:\"sh404SefTitleAlias\";s:5:\"alias\";s:29:\"sh404SefModK2ContentFeedAlias\";s:4:\"feed\";s:20:\"sh404SefInsertItemId\";s:1:\"0\";s:26:\"sh404SefInsertUniqueItemId\";s:1:\"0\";s:13:\"cbIntegration\";s:1:\"0\";s:11:\"inheritFrom\";s:1:\"0\";s:17:\"num_leading_items\";s:1:\"4\";s:19:\"num_leading_columns\";s:1:\"1\";s:14:\"leadingImgSize\";s:5:\"Large\";s:17:\"num_primary_items\";s:1:\"4\";s:19:\"num_primary_columns\";s:1:\"1\";s:14:\"primaryImgSize\";s:5:\"Large\";s:19:\"num_secondary_items\";s:1:\"4\";s:21:\"num_secondary_columns\";s:1:\"1\";s:16:\"secondaryImgSize\";s:5:\"Large\";s:9:\"num_links\";s:1:\"2\";s:17:\"num_links_columns\";s:1:\"1\";s:12:\"linksImgSize\";s:5:\"Large\";s:14:\"catCatalogMode\";s:1:\"1\";s:16:\"catFeaturedItems\";s:1:\"1\";s:13:\"catPagination\";s:1:\"2\";s:20:\"catPaginationResults\";s:1:\"1\";s:8:\"catTitle\";s:1:\"0\";s:19:\"catTitleItemCounter\";s:1:\"0\";s:14:\"catDescription\";s:1:\"0\";s:8:\"catImage\";s:1:\"0\";s:11:\"catFeedLink\";s:1:\"1\";s:11:\"catFeedIcon\";s:1:\"1\";s:13:\"subCategories\";s:1:\"0\";s:13:\"subCatColumns\";s:1:\"4\";s:11:\"subCatTitle\";s:1:\"0\";s:22:\"subCatTitleItemCounter\";s:1:\"0\";s:17:\"subCatDescription\";s:1:\"0\";s:11:\"subCatImage\";s:1:\"0\";s:12:\"catItemTitle\";s:1:\"1\";s:18:\"catItemTitleLinked\";s:1:\"1\";s:21:\"catItemFeaturedNotice\";s:1:\"0\";s:13:\"catItemAuthor\";s:1:\"1\";s:18:\"catItemDateCreated\";s:1:\"1\";s:13:\"catItemRating\";s:1:\"0\";s:12:\"catItemImage\";s:1:\"1\";s:16:\"catItemIntroText\";s:1:\"1\";s:18:\"catItemExtraFields\";s:1:\"0\";s:11:\"catItemHits\";s:1:\"0\";s:15:\"catItemCategory\";s:1:\"1\";s:11:\"catItemTags\";s:1:\"0\";s:18:\"catItemAttachments\";s:1:\"0\";s:25:\"catItemAttachmentsCounter\";s:1:\"0\";s:12:\"catItemVideo\";s:1:\"0\";s:20:\"catItemVideoAutoPlay\";s:1:\"0\";s:19:\"catItemImageGallery\";s:1:\"0\";s:19:\"catItemDateModified\";s:1:\"0\";s:15:\"catItemReadMore\";s:1:\"1\";s:21:\"catItemCommentsAnchor\";s:1:\"1\";s:16:\"catItemK2Plugins\";s:1:\"1\";s:15:\"itemDateCreated\";s:1:\"1\";s:9:\"itemTitle\";s:1:\"1\";s:18:\"itemFeaturedNotice\";s:1:\"1\";s:10:\"itemAuthor\";s:1:\"1\";s:15:\"itemFontResizer\";s:1:\"1\";s:15:\"itemPrintButton\";s:1:\"1\";s:15:\"itemEmailButton\";s:1:\"1\";s:16:\"itemSocialButton\";s:1:\"1\";s:15:\"itemVideoAnchor\";s:1:\"1\";s:22:\"itemImageGalleryAnchor\";s:1:\"1\";s:18:\"itemCommentsAnchor\";s:1:\"1\";s:10:\"itemRating\";s:1:\"1\";s:9:\"itemImage\";s:1:\"1\";s:11:\"itemImgSize\";s:5:\"Large\";s:20:\"itemImageMainCaption\";s:1:\"1\";s:20:\"itemImageMainCredits\";s:1:\"1\";s:13:\"itemIntroText\";s:1:\"1\";s:12:\"itemFullText\";s:1:\"1\";s:15:\"itemExtraFields\";s:1:\"1\";s:16:\"itemDateModified\";s:1:\"1\";s:8:\"itemHits\";s:1:\"1\";s:12:\"itemCategory\";s:1:\"1\";s:8:\"itemTags\";s:1:\"1\";s:15:\"itemAttachments\";s:1:\"1\";s:22:\"itemAttachmentsCounter\";s:1:\"1\";s:9:\"itemVideo\";s:1:\"1\";s:17:\"itemVideoAutoPlay\";s:1:\"0\";s:16:\"itemVideoCaption\";s:1:\"1\";s:16:\"itemVideoCredits\";s:1:\"1\";s:16:\"itemImageGallery\";s:1:\"1\";s:14:\"itemNavigation\";s:1:\"1\";s:12:\"itemComments\";s:1:\"1\";s:17:\"itemTwitterButton\";s:1:\"1\";s:18:\"itemFacebookButton\";s:1:\"1\";s:23:\"itemGooglePlusOneButton\";s:1:\"1\";s:15:\"itemAuthorBlock\";s:1:\"1\";s:15:\"itemAuthorImage\";s:1:\"1\";s:21:\"itemAuthorDescription\";s:1:\"1\";s:13:\"itemAuthorURL\";s:1:\"1\";s:15:\"itemAuthorEmail\";s:1:\"0\";s:16:\"itemAuthorLatest\";s:1:\"1\";s:21:\"itemAuthorLatestLimit\";s:1:\"5\";s:11:\"itemRelated\";s:1:\"1\";s:16:\"itemRelatedLimit\";s:1:\"5\";s:16:\"itemRelatedTitle\";s:1:\"1\";s:19:\"itemRelatedCategory\";s:1:\"0\";s:20:\"itemRelatedImageSize\";s:1:\"0\";s:20:\"itemRelatedIntrotext\";s:1:\"0\";s:19:\"itemRelatedFulltext\";s:1:\"0\";s:17:\"itemRelatedAuthor\";s:1:\"0\";s:16:\"itemRelatedMedia\";s:1:\"0\";s:23:\"itemRelatedImageGallery\";s:1:\"0\";s:13:\"itemK2Plugins\";s:1:\"1\";}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";}}s:8:\"ordering\";s:1:\"3\";s:5:\"trash\";s:1:\"0\";s:9:\"cat_trash\";s:1:\"0\";s:8:\"category\";s:16:\"Photo Of The Day\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:28:\"12:torstein-–-in-your-face\";s:7:\"catslug\";s:18:\"4:photo-of-the-day\";s:6:\"author\";s:10:\"Super User\";s:6:\"layout\";s:4:\"item\";s:4:\"path\";s:56:\"index.php/component/k2/item/12-torstein-–-in-your-face\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"K2 Item\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"K2 Item\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:10:\"Super User\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:10:\"Super User\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:11:\"K2 Category\";a:1:{s:16:\"Photo Of The Day\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:16:\"Photo Of The Day\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:39:\"index.php?option=com_k2&view=item&id=12\";s:5:\"route\";s:65:\"index.php?option=com_k2&view=item&id=12:torstein-–-in-your-face\";s:5:\"title\";s:25:\"Torstein – In Your Face\";s:11:\"description\";s:247:\"Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2012-12-03 11:53:14\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2012-12-03 11:53:14\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;}'),(13,'index.php?option=com_k2&view=item&id=13','index.php?option=com_k2&view=item&id=13:why-do-you-snowboard?','Why Do You Snowboard?','Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.','2012-12-03 12:56:01','88a272a09410fe22be37d06853ca77b0',1,1,1,'*','2012-12-03 11:54:37','0000-00-00 00:00:00','2012-12-03 11:54:37','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:2:\"13\";s:5:\"alias\";s:21:\"why-do-you-snowboard?\";s:7:\"summary\";s:256:\"<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n\";s:4:\"body\";s:488:\"\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla. Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\";s:5:\"catid\";s:1:\"4\";s:10:\"created_by\";s:3:\"944\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"0000-00-00 00:00:00\";s:11:\"modified_by\";s:1:\"0\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":239:{s:10:\"enable_css\";s:1:\"1\";s:14:\"jQueryHandling\";s:9:\"1.8remote\";s:21:\"backendJQueryHandling\";s:6:\"remote\";s:8:\"userName\";s:1:\"1\";s:9:\"userImage\";s:1:\"1\";s:15:\"userDescription\";s:1:\"1\";s:7:\"userURL\";s:1:\"1\";s:9:\"userEmail\";s:1:\"0\";s:12:\"userFeedLink\";s:1:\"1\";s:12:\"userFeedIcon\";s:1:\"1\";s:13:\"userItemCount\";s:1:\"4\";s:13:\"userItemTitle\";s:1:\"1\";s:19:\"userItemTitleLinked\";s:1:\"1\";s:19:\"userItemDateCreated\";s:1:\"1\";s:13:\"userItemImage\";s:1:\"1\";s:17:\"userItemIntroText\";s:1:\"1\";s:16:\"userItemCategory\";s:1:\"1\";s:12:\"userItemTags\";s:1:\"1\";s:22:\"userItemCommentsAnchor\";s:1:\"1\";s:16:\"userItemReadMore\";s:1:\"1\";s:17:\"userItemK2Plugins\";s:1:\"1\";s:18:\"defaultUsersItemid\";s:0:\"\";s:12:\"tagItemCount\";s:1:\"4\";s:12:\"tagItemTitle\";s:1:\"1\";s:18:\"tagItemTitleLinked\";s:1:\"1\";s:18:\"tagItemDateCreated\";s:1:\"1\";s:12:\"tagItemImage\";s:1:\"1\";s:16:\"tagItemIntroText\";s:1:\"1\";s:15:\"tagItemCategory\";s:1:\"1\";s:15:\"tagItemReadMore\";s:1:\"1\";s:18:\"tagItemExtraFields\";s:1:\"0\";s:11:\"tagOrdering\";s:0:\"\";s:11:\"tagFeedLink\";s:1:\"1\";s:11:\"tagFeedIcon\";s:1:\"1\";s:17:\"defaultTagsItemid\";s:0:\"\";s:16:\"genericItemCount\";s:2:\"10\";s:16:\"genericItemTitle\";s:1:\"1\";s:22:\"genericItemTitleLinked\";s:1:\"1\";s:22:\"genericItemDateCreated\";s:1:\"1\";s:16:\"genericItemImage\";s:1:\"1\";s:20:\"genericItemIntroText\";s:1:\"1\";s:19:\"genericItemCategory\";s:1:\"1\";s:19:\"genericItemReadMore\";s:1:\"1\";s:22:\"genericItemExtraFields\";s:1:\"0\";s:15:\"genericFeedLink\";s:1:\"1\";s:15:\"genericFeedIcon\";s:1:\"1\";s:9:\"feedLimit\";s:2:\"10\";s:13:\"feedItemImage\";s:1:\"1\";s:11:\"feedImgSize\";s:1:\"L\";s:17:\"feedItemIntroText\";s:1:\"1\";s:17:\"feedTextWordLimit\";s:0:\"\";s:16:\"feedItemFullText\";s:1:\"1\";s:12:\"feedItemTags\";s:1:\"0\";s:13:\"feedItemVideo\";s:1:\"0\";s:15:\"feedItemGallery\";s:1:\"0\";s:19:\"feedItemAttachments\";s:1:\"0\";s:14:\"feedBogusEmail\";s:0:\"\";s:16:\"introTextCleanup\";s:1:\"0\";s:27:\"introTextCleanupExcludeTags\";s:0:\"\";s:23:\"introTextCleanupTagAttr\";s:0:\"\";s:15:\"fullTextCleanup\";s:1:\"0\";s:26:\"fullTextCleanupExcludeTags\";s:0:\"\";s:22:\"fullTextCleanupTagAttr\";s:0:\"\";s:12:\"xssFiltering\";s:1:\"0\";s:14:\"linkPopupWidth\";s:3:\"900\";s:15:\"linkPopupHeight\";s:3:\"600\";s:13:\"imagesQuality\";s:2:\"95\";s:11:\"itemImageXS\";s:3:\"100\";s:10:\"itemImageS\";s:3:\"200\";s:10:\"itemImageM\";s:3:\"700\";s:10:\"itemImageL\";s:3:\"700\";s:11:\"itemImageXL\";s:3:\"918\";s:16:\"itemImageGeneric\";s:3:\"700\";s:13:\"catImageWidth\";s:3:\"700\";s:15:\"catImageDefault\";s:1:\"1\";s:14:\"userImageWidth\";s:3:\"116\";s:16:\"userImageDefault\";s:1:\"1\";s:17:\"commenterImgWidth\";s:2:\"48\";s:17:\"onlineImageEditor\";s:8:\"splashup\";s:14:\"imageTimestamp\";s:1:\"0\";s:16:\"imageMemoryLimit\";s:0:\"\";s:16:\"socialButtonCode\";s:0:\"\";s:15:\"twitterUsername\";s:0:\"\";s:13:\"facebookImage\";s:5:\"Small\";s:8:\"comments\";s:1:\"1\";s:16:\"commentsOrdering\";s:4:\"DESC\";s:13:\"commentsLimit\";s:2:\"10\";s:20:\"commentsFormPosition\";s:5:\"below\";s:18:\"commentsPublishing\";s:1:\"1\";s:17:\"commentsReporting\";s:1:\"2\";s:23:\"commentsReportRecipient\";s:0:\"\";s:24:\"inlineCommentsModeration\";s:1:\"0\";s:8:\"gravatar\";s:1:\"1\";s:9:\"recaptcha\";s:1:\"0\";s:17:\"commentsFormNotes\";s:1:\"1\";s:21:\"commentsFormNotesText\";s:0:\"\";s:15:\"frontendEditing\";s:1:\"1\";s:12:\"showImageTab\";s:1:\"1\";s:19:\"showImageGalleryTab\";s:1:\"1\";s:12:\"showVideoTab\";s:1:\"1\";s:18:\"showExtraFieldsTab\";s:1:\"1\";s:18:\"showAttachmentsTab\";s:1:\"1\";s:13:\"showK2Plugins\";s:1:\"1\";s:22:\"sideBarDisplayFrontend\";s:1:\"0\";s:12:\"mergeEditors\";s:1:\"1\";s:14:\"sideBarDisplay\";s:1:\"1\";s:17:\"attachmentsFolder\";s:0:\"\";s:16:\"hideImportButton\";s:1:\"0\";s:13:\"taggingSystem\";s:1:\"1\";s:8:\"lockTags\";s:1:\"0\";s:13:\"showTagFilter\";s:1:\"0\";s:12:\"googleSearch\";s:1:\"0\";s:21:\"googleSearchContainer\";s:11:\"k2Container\";s:13:\"K2UserProfile\";s:1:\"0\";s:8:\"redirect\";s:3:\"101\";s:11:\"adminSearch\";s:6:\"simple\";s:12:\"cookieDomain\";s:0:\"\";s:20:\"recaptcha_public_key\";s:0:\"\";s:21:\"recaptcha_private_key\";s:0:\"\";s:15:\"recaptcha_theme\";s:5:\"clean\";s:23:\"recaptchaOnRegistration\";s:1:\"0\";s:13:\"stopForumSpam\";s:1:\"0\";s:19:\"stopForumSpamApiKey\";s:0:\"\";s:21:\"showItemsCounterAdmin\";s:1:\"1\";s:17:\"showChildCatItems\";s:1:\"1\";s:22:\"disableCompactOrdering\";s:1:\"0\";s:13:\"metaDescLimit\";s:3:\"150\";s:15:\"SEFReplacements\";s:583:\"Å |S, Å’|O, Å½|Z, Å¡|s, Å“|oe, Å¾|z, Å¸|Y, Â¥|Y, Âµ|u, Ã€|A, Ã�|A, Ã‚|A, Ãƒ|A, Ã„|A, Ã…|A, Ã†|A, Ã‡|C, Ãˆ|E, Ã‰|E, ÃŠ|E, Ã‹|E, ÃŒ|I, Ã�|I, ÃŽ|I, Ã�|I, Ã�|D, Ã‘|N, Ã’|O, Ã“|O, Ã”|O, Ã•|O, Ã–|O, Ã˜|O, Ã™|U, Ãš|U, Ã›|U, Ãœ|U, Ã�|Y, ÃŸ|s, Ã |a, Ã¡|a, Ã¢|a, Ã£|a, Ã¤|a, Ã¥|a, Ã¦|a, Ã§|c, Ã¨|e, Ã©|e, Ãª|e, Ã«|e, Ã¬|i, Ã­|i, Ã®|i, Ã¯|i, Ã°|o, Ã±|n, Ã²|o, Ã³|o, Ã´|o, Ãµ|o, Ã¶|o, Ã¸|o, Ã¹|u, Ãº|u, Ã»|u, Ã¼|u, Ã½|y, Ã¿|y, ÃŸ|ss\";s:16:\"sh404SefLabelCat\";s:0:\"\";s:17:\"sh404SefLabelUser\";s:4:\"blog\";s:17:\"sh404SefLabelItem\";s:1:\"2\";s:18:\"sh404SefTitleAlias\";s:5:\"alias\";s:29:\"sh404SefModK2ContentFeedAlias\";s:4:\"feed\";s:20:\"sh404SefInsertItemId\";s:1:\"0\";s:26:\"sh404SefInsertUniqueItemId\";s:1:\"0\";s:13:\"cbIntegration\";s:1:\"0\";s:11:\"inheritFrom\";s:1:\"0\";s:17:\"num_leading_items\";s:1:\"4\";s:19:\"num_leading_columns\";s:1:\"1\";s:14:\"leadingImgSize\";s:5:\"Large\";s:17:\"num_primary_items\";s:1:\"4\";s:19:\"num_primary_columns\";s:1:\"1\";s:14:\"primaryImgSize\";s:5:\"Large\";s:19:\"num_secondary_items\";s:1:\"4\";s:21:\"num_secondary_columns\";s:1:\"1\";s:16:\"secondaryImgSize\";s:5:\"Large\";s:9:\"num_links\";s:1:\"2\";s:17:\"num_links_columns\";s:1:\"1\";s:12:\"linksImgSize\";s:5:\"Large\";s:14:\"catCatalogMode\";s:1:\"1\";s:16:\"catFeaturedItems\";s:1:\"1\";s:13:\"catPagination\";s:1:\"2\";s:20:\"catPaginationResults\";s:1:\"1\";s:8:\"catTitle\";s:1:\"0\";s:19:\"catTitleItemCounter\";s:1:\"0\";s:14:\"catDescription\";s:1:\"0\";s:8:\"catImage\";s:1:\"0\";s:11:\"catFeedLink\";s:1:\"1\";s:11:\"catFeedIcon\";s:1:\"1\";s:13:\"subCategories\";s:1:\"0\";s:13:\"subCatColumns\";s:1:\"4\";s:11:\"subCatTitle\";s:1:\"0\";s:22:\"subCatTitleItemCounter\";s:1:\"0\";s:17:\"subCatDescription\";s:1:\"0\";s:11:\"subCatImage\";s:1:\"0\";s:12:\"catItemTitle\";s:1:\"1\";s:18:\"catItemTitleLinked\";s:1:\"1\";s:21:\"catItemFeaturedNotice\";s:1:\"0\";s:13:\"catItemAuthor\";s:1:\"1\";s:18:\"catItemDateCreated\";s:1:\"1\";s:13:\"catItemRating\";s:1:\"0\";s:12:\"catItemImage\";s:1:\"1\";s:16:\"catItemIntroText\";s:1:\"1\";s:18:\"catItemExtraFields\";s:1:\"0\";s:11:\"catItemHits\";s:1:\"0\";s:15:\"catItemCategory\";s:1:\"1\";s:11:\"catItemTags\";s:1:\"0\";s:18:\"catItemAttachments\";s:1:\"0\";s:25:\"catItemAttachmentsCounter\";s:1:\"0\";s:12:\"catItemVideo\";s:1:\"0\";s:20:\"catItemVideoAutoPlay\";s:1:\"0\";s:19:\"catItemImageGallery\";s:1:\"0\";s:19:\"catItemDateModified\";s:1:\"0\";s:15:\"catItemReadMore\";s:1:\"1\";s:21:\"catItemCommentsAnchor\";s:1:\"1\";s:16:\"catItemK2Plugins\";s:1:\"1\";s:15:\"itemDateCreated\";s:1:\"1\";s:9:\"itemTitle\";s:1:\"1\";s:18:\"itemFeaturedNotice\";s:1:\"1\";s:10:\"itemAuthor\";s:1:\"1\";s:15:\"itemFontResizer\";s:1:\"1\";s:15:\"itemPrintButton\";s:1:\"1\";s:15:\"itemEmailButton\";s:1:\"1\";s:16:\"itemSocialButton\";s:1:\"1\";s:15:\"itemVideoAnchor\";s:1:\"1\";s:22:\"itemImageGalleryAnchor\";s:1:\"1\";s:18:\"itemCommentsAnchor\";s:1:\"1\";s:10:\"itemRating\";s:1:\"1\";s:9:\"itemImage\";s:1:\"1\";s:11:\"itemImgSize\";s:5:\"Large\";s:20:\"itemImageMainCaption\";s:1:\"1\";s:20:\"itemImageMainCredits\";s:1:\"1\";s:13:\"itemIntroText\";s:1:\"1\";s:12:\"itemFullText\";s:1:\"1\";s:15:\"itemExtraFields\";s:1:\"1\";s:16:\"itemDateModified\";s:1:\"1\";s:8:\"itemHits\";s:1:\"1\";s:12:\"itemCategory\";s:1:\"1\";s:8:\"itemTags\";s:1:\"1\";s:15:\"itemAttachments\";s:1:\"1\";s:22:\"itemAttachmentsCounter\";s:1:\"1\";s:9:\"itemVideo\";s:1:\"1\";s:17:\"itemVideoAutoPlay\";s:1:\"0\";s:16:\"itemVideoCaption\";s:1:\"1\";s:16:\"itemVideoCredits\";s:1:\"1\";s:16:\"itemImageGallery\";s:1:\"1\";s:14:\"itemNavigation\";s:1:\"1\";s:12:\"itemComments\";s:1:\"1\";s:17:\"itemTwitterButton\";s:1:\"1\";s:18:\"itemFacebookButton\";s:1:\"1\";s:23:\"itemGooglePlusOneButton\";s:1:\"1\";s:15:\"itemAuthorBlock\";s:1:\"1\";s:15:\"itemAuthorImage\";s:1:\"1\";s:21:\"itemAuthorDescription\";s:1:\"1\";s:13:\"itemAuthorURL\";s:1:\"1\";s:15:\"itemAuthorEmail\";s:1:\"0\";s:16:\"itemAuthorLatest\";s:1:\"1\";s:21:\"itemAuthorLatestLimit\";s:1:\"5\";s:11:\"itemRelated\";s:1:\"1\";s:16:\"itemRelatedLimit\";s:1:\"5\";s:16:\"itemRelatedTitle\";s:1:\"1\";s:19:\"itemRelatedCategory\";s:1:\"0\";s:20:\"itemRelatedImageSize\";s:1:\"0\";s:20:\"itemRelatedIntrotext\";s:1:\"0\";s:19:\"itemRelatedFulltext\";s:1:\"0\";s:17:\"itemRelatedAuthor\";s:1:\"0\";s:16:\"itemRelatedMedia\";s:1:\"0\";s:23:\"itemRelatedImageGallery\";s:1:\"0\";s:13:\"itemK2Plugins\";s:1:\"1\";}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";}}s:8:\"ordering\";s:1:\"4\";s:5:\"trash\";s:1:\"0\";s:9:\"cat_trash\";s:1:\"0\";s:8:\"category\";s:16:\"Photo Of The Day\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:24:\"13:why-do-you-snowboard?\";s:7:\"catslug\";s:18:\"4:photo-of-the-day\";s:6:\"author\";s:10:\"Super User\";s:6:\"layout\";s:4:\"item\";s:4:\"path\";s:52:\"index.php/component/k2/item/13-why-do-you-snowboard?\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"K2 Item\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"K2 Item\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:10:\"Super User\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:10:\"Super User\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:11:\"K2 Category\";a:1:{s:16:\"Photo Of The Day\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:16:\"Photo Of The Day\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:39:\"index.php?option=com_k2&view=item&id=13\";s:5:\"route\";s:61:\"index.php?option=com_k2&view=item&id=13:why-do-you-snowboard?\";s:5:\"title\";s:21:\"Why Do You Snowboard?\";s:11:\"description\";s:247:\"Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2012-12-03 11:54:37\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2012-12-03 11:54:37\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;}'),(14,'index.php?option=com_k2&view=item&id=14','index.php?option=com_k2&view=item&id=14:early-season-park-action-at-bear-mountain','Early Season Park Action at Bear Mountain','Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.','2012-12-03 12:57:25','3ca5096161486afbed939802840e8957',1,1,1,'*','2012-12-03 11:56:02','0000-00-00 00:00:00','2012-12-03 11:56:02','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:2:\"14\";s:5:\"alias\";s:41:\"early-season-park-action-at-bear-mountain\";s:7:\"summary\";s:256:\"<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n\";s:4:\"body\";s:488:\"\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla. Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\";s:5:\"catid\";s:1:\"3\";s:10:\"created_by\";s:3:\"944\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"0000-00-00 00:00:00\";s:11:\"modified_by\";s:1:\"0\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":239:{s:10:\"enable_css\";s:1:\"1\";s:14:\"jQueryHandling\";s:9:\"1.8remote\";s:21:\"backendJQueryHandling\";s:6:\"remote\";s:8:\"userName\";s:1:\"1\";s:9:\"userImage\";s:1:\"1\";s:15:\"userDescription\";s:1:\"1\";s:7:\"userURL\";s:1:\"1\";s:9:\"userEmail\";s:1:\"0\";s:12:\"userFeedLink\";s:1:\"1\";s:12:\"userFeedIcon\";s:1:\"1\";s:13:\"userItemCount\";s:1:\"4\";s:13:\"userItemTitle\";s:1:\"1\";s:19:\"userItemTitleLinked\";s:1:\"1\";s:19:\"userItemDateCreated\";s:1:\"1\";s:13:\"userItemImage\";s:1:\"1\";s:17:\"userItemIntroText\";s:1:\"1\";s:16:\"userItemCategory\";s:1:\"1\";s:12:\"userItemTags\";s:1:\"1\";s:22:\"userItemCommentsAnchor\";s:1:\"1\";s:16:\"userItemReadMore\";s:1:\"1\";s:17:\"userItemK2Plugins\";s:1:\"1\";s:18:\"defaultUsersItemid\";s:0:\"\";s:12:\"tagItemCount\";s:1:\"4\";s:12:\"tagItemTitle\";s:1:\"1\";s:18:\"tagItemTitleLinked\";s:1:\"1\";s:18:\"tagItemDateCreated\";s:1:\"1\";s:12:\"tagItemImage\";s:1:\"1\";s:16:\"tagItemIntroText\";s:1:\"1\";s:15:\"tagItemCategory\";s:1:\"1\";s:15:\"tagItemReadMore\";s:1:\"1\";s:18:\"tagItemExtraFields\";s:1:\"0\";s:11:\"tagOrdering\";s:0:\"\";s:11:\"tagFeedLink\";s:1:\"1\";s:11:\"tagFeedIcon\";s:1:\"1\";s:17:\"defaultTagsItemid\";s:0:\"\";s:16:\"genericItemCount\";s:2:\"10\";s:16:\"genericItemTitle\";s:1:\"1\";s:22:\"genericItemTitleLinked\";s:1:\"1\";s:22:\"genericItemDateCreated\";s:1:\"1\";s:16:\"genericItemImage\";s:1:\"1\";s:20:\"genericItemIntroText\";s:1:\"1\";s:19:\"genericItemCategory\";s:1:\"1\";s:19:\"genericItemReadMore\";s:1:\"1\";s:22:\"genericItemExtraFields\";s:1:\"0\";s:15:\"genericFeedLink\";s:1:\"1\";s:15:\"genericFeedIcon\";s:1:\"1\";s:9:\"feedLimit\";s:2:\"10\";s:13:\"feedItemImage\";s:1:\"1\";s:11:\"feedImgSize\";s:1:\"L\";s:17:\"feedItemIntroText\";s:1:\"1\";s:17:\"feedTextWordLimit\";s:0:\"\";s:16:\"feedItemFullText\";s:1:\"1\";s:12:\"feedItemTags\";s:1:\"0\";s:13:\"feedItemVideo\";s:1:\"0\";s:15:\"feedItemGallery\";s:1:\"0\";s:19:\"feedItemAttachments\";s:1:\"0\";s:14:\"feedBogusEmail\";s:0:\"\";s:16:\"introTextCleanup\";s:1:\"0\";s:27:\"introTextCleanupExcludeTags\";s:0:\"\";s:23:\"introTextCleanupTagAttr\";s:0:\"\";s:15:\"fullTextCleanup\";s:1:\"0\";s:26:\"fullTextCleanupExcludeTags\";s:0:\"\";s:22:\"fullTextCleanupTagAttr\";s:0:\"\";s:12:\"xssFiltering\";s:1:\"0\";s:14:\"linkPopupWidth\";s:3:\"900\";s:15:\"linkPopupHeight\";s:3:\"600\";s:13:\"imagesQuality\";s:2:\"95\";s:11:\"itemImageXS\";s:3:\"100\";s:10:\"itemImageS\";s:3:\"200\";s:10:\"itemImageM\";s:3:\"700\";s:10:\"itemImageL\";s:3:\"700\";s:11:\"itemImageXL\";s:3:\"918\";s:16:\"itemImageGeneric\";s:3:\"700\";s:13:\"catImageWidth\";s:3:\"700\";s:15:\"catImageDefault\";s:1:\"1\";s:14:\"userImageWidth\";s:3:\"116\";s:16:\"userImageDefault\";s:1:\"1\";s:17:\"commenterImgWidth\";s:2:\"48\";s:17:\"onlineImageEditor\";s:8:\"splashup\";s:14:\"imageTimestamp\";s:1:\"0\";s:16:\"imageMemoryLimit\";s:0:\"\";s:16:\"socialButtonCode\";s:0:\"\";s:15:\"twitterUsername\";s:0:\"\";s:13:\"facebookImage\";s:5:\"Small\";s:8:\"comments\";s:1:\"1\";s:16:\"commentsOrdering\";s:4:\"DESC\";s:13:\"commentsLimit\";s:2:\"10\";s:20:\"commentsFormPosition\";s:5:\"below\";s:18:\"commentsPublishing\";s:1:\"1\";s:17:\"commentsReporting\";s:1:\"2\";s:23:\"commentsReportRecipient\";s:0:\"\";s:24:\"inlineCommentsModeration\";s:1:\"0\";s:8:\"gravatar\";s:1:\"1\";s:9:\"recaptcha\";s:1:\"0\";s:17:\"commentsFormNotes\";s:1:\"1\";s:21:\"commentsFormNotesText\";s:0:\"\";s:15:\"frontendEditing\";s:1:\"1\";s:12:\"showImageTab\";s:1:\"1\";s:19:\"showImageGalleryTab\";s:1:\"1\";s:12:\"showVideoTab\";s:1:\"1\";s:18:\"showExtraFieldsTab\";s:1:\"1\";s:18:\"showAttachmentsTab\";s:1:\"1\";s:13:\"showK2Plugins\";s:1:\"1\";s:22:\"sideBarDisplayFrontend\";s:1:\"0\";s:12:\"mergeEditors\";s:1:\"1\";s:14:\"sideBarDisplay\";s:1:\"1\";s:17:\"attachmentsFolder\";s:0:\"\";s:16:\"hideImportButton\";s:1:\"0\";s:13:\"taggingSystem\";s:1:\"1\";s:8:\"lockTags\";s:1:\"0\";s:13:\"showTagFilter\";s:1:\"0\";s:12:\"googleSearch\";s:1:\"0\";s:21:\"googleSearchContainer\";s:11:\"k2Container\";s:13:\"K2UserProfile\";s:1:\"0\";s:8:\"redirect\";s:3:\"101\";s:11:\"adminSearch\";s:6:\"simple\";s:12:\"cookieDomain\";s:0:\"\";s:20:\"recaptcha_public_key\";s:0:\"\";s:21:\"recaptcha_private_key\";s:0:\"\";s:15:\"recaptcha_theme\";s:5:\"clean\";s:23:\"recaptchaOnRegistration\";s:1:\"0\";s:13:\"stopForumSpam\";s:1:\"0\";s:19:\"stopForumSpamApiKey\";s:0:\"\";s:21:\"showItemsCounterAdmin\";s:1:\"1\";s:17:\"showChildCatItems\";s:1:\"1\";s:22:\"disableCompactOrdering\";s:1:\"0\";s:13:\"metaDescLimit\";s:3:\"150\";s:15:\"SEFReplacements\";s:583:\"Å |S, Å’|O, Å½|Z, Å¡|s, Å“|oe, Å¾|z, Å¸|Y, Â¥|Y, Âµ|u, Ã€|A, Ã�|A, Ã‚|A, Ãƒ|A, Ã„|A, Ã…|A, Ã†|A, Ã‡|C, Ãˆ|E, Ã‰|E, ÃŠ|E, Ã‹|E, ÃŒ|I, Ã�|I, ÃŽ|I, Ã�|I, Ã�|D, Ã‘|N, Ã’|O, Ã“|O, Ã”|O, Ã•|O, Ã–|O, Ã˜|O, Ã™|U, Ãš|U, Ã›|U, Ãœ|U, Ã�|Y, ÃŸ|s, Ã |a, Ã¡|a, Ã¢|a, Ã£|a, Ã¤|a, Ã¥|a, Ã¦|a, Ã§|c, Ã¨|e, Ã©|e, Ãª|e, Ã«|e, Ã¬|i, Ã­|i, Ã®|i, Ã¯|i, Ã°|o, Ã±|n, Ã²|o, Ã³|o, Ã´|o, Ãµ|o, Ã¶|o, Ã¸|o, Ã¹|u, Ãº|u, Ã»|u, Ã¼|u, Ã½|y, Ã¿|y, ÃŸ|ss\";s:16:\"sh404SefLabelCat\";s:0:\"\";s:17:\"sh404SefLabelUser\";s:4:\"blog\";s:17:\"sh404SefLabelItem\";s:1:\"2\";s:18:\"sh404SefTitleAlias\";s:5:\"alias\";s:29:\"sh404SefModK2ContentFeedAlias\";s:4:\"feed\";s:20:\"sh404SefInsertItemId\";s:1:\"0\";s:26:\"sh404SefInsertUniqueItemId\";s:1:\"0\";s:13:\"cbIntegration\";s:1:\"0\";s:11:\"inheritFrom\";s:1:\"0\";s:17:\"num_leading_items\";s:1:\"4\";s:19:\"num_leading_columns\";s:1:\"1\";s:14:\"leadingImgSize\";s:5:\"Large\";s:17:\"num_primary_items\";s:1:\"4\";s:19:\"num_primary_columns\";s:1:\"1\";s:14:\"primaryImgSize\";s:5:\"Large\";s:19:\"num_secondary_items\";s:1:\"4\";s:21:\"num_secondary_columns\";s:1:\"1\";s:16:\"secondaryImgSize\";s:5:\"Large\";s:9:\"num_links\";s:1:\"2\";s:17:\"num_links_columns\";s:1:\"1\";s:12:\"linksImgSize\";s:5:\"Large\";s:14:\"catCatalogMode\";s:1:\"1\";s:16:\"catFeaturedItems\";s:1:\"1\";s:13:\"catPagination\";s:1:\"2\";s:20:\"catPaginationResults\";s:1:\"1\";s:8:\"catTitle\";s:1:\"0\";s:19:\"catTitleItemCounter\";s:1:\"0\";s:14:\"catDescription\";s:1:\"0\";s:8:\"catImage\";s:1:\"0\";s:11:\"catFeedLink\";s:1:\"1\";s:11:\"catFeedIcon\";s:1:\"1\";s:13:\"subCategories\";s:1:\"0\";s:13:\"subCatColumns\";s:1:\"4\";s:11:\"subCatTitle\";s:1:\"0\";s:22:\"subCatTitleItemCounter\";s:1:\"0\";s:17:\"subCatDescription\";s:1:\"0\";s:11:\"subCatImage\";s:1:\"0\";s:12:\"catItemTitle\";s:1:\"1\";s:18:\"catItemTitleLinked\";s:1:\"1\";s:21:\"catItemFeaturedNotice\";s:1:\"0\";s:13:\"catItemAuthor\";s:1:\"1\";s:18:\"catItemDateCreated\";s:1:\"1\";s:13:\"catItemRating\";s:1:\"0\";s:12:\"catItemImage\";s:1:\"1\";s:16:\"catItemIntroText\";s:1:\"1\";s:18:\"catItemExtraFields\";s:1:\"0\";s:11:\"catItemHits\";s:1:\"0\";s:15:\"catItemCategory\";s:1:\"1\";s:11:\"catItemTags\";s:1:\"0\";s:18:\"catItemAttachments\";s:1:\"0\";s:25:\"catItemAttachmentsCounter\";s:1:\"0\";s:12:\"catItemVideo\";s:1:\"0\";s:20:\"catItemVideoAutoPlay\";s:1:\"0\";s:19:\"catItemImageGallery\";s:1:\"0\";s:19:\"catItemDateModified\";s:1:\"0\";s:15:\"catItemReadMore\";s:1:\"1\";s:21:\"catItemCommentsAnchor\";s:1:\"1\";s:16:\"catItemK2Plugins\";s:1:\"1\";s:15:\"itemDateCreated\";s:1:\"1\";s:9:\"itemTitle\";s:1:\"1\";s:18:\"itemFeaturedNotice\";s:1:\"1\";s:10:\"itemAuthor\";s:1:\"1\";s:15:\"itemFontResizer\";s:1:\"1\";s:15:\"itemPrintButton\";s:1:\"1\";s:15:\"itemEmailButton\";s:1:\"1\";s:16:\"itemSocialButton\";s:1:\"1\";s:15:\"itemVideoAnchor\";s:1:\"1\";s:22:\"itemImageGalleryAnchor\";s:1:\"1\";s:18:\"itemCommentsAnchor\";s:1:\"1\";s:10:\"itemRating\";s:1:\"1\";s:9:\"itemImage\";s:1:\"1\";s:11:\"itemImgSize\";s:5:\"Large\";s:20:\"itemImageMainCaption\";s:1:\"1\";s:20:\"itemImageMainCredits\";s:1:\"1\";s:13:\"itemIntroText\";s:1:\"1\";s:12:\"itemFullText\";s:1:\"1\";s:15:\"itemExtraFields\";s:1:\"1\";s:16:\"itemDateModified\";s:1:\"1\";s:8:\"itemHits\";s:1:\"1\";s:12:\"itemCategory\";s:1:\"1\";s:8:\"itemTags\";s:1:\"1\";s:15:\"itemAttachments\";s:1:\"1\";s:22:\"itemAttachmentsCounter\";s:1:\"1\";s:9:\"itemVideo\";s:1:\"1\";s:17:\"itemVideoAutoPlay\";s:1:\"0\";s:16:\"itemVideoCaption\";s:1:\"1\";s:16:\"itemVideoCredits\";s:1:\"1\";s:16:\"itemImageGallery\";s:1:\"1\";s:14:\"itemNavigation\";s:1:\"1\";s:12:\"itemComments\";s:1:\"1\";s:17:\"itemTwitterButton\";s:1:\"1\";s:18:\"itemFacebookButton\";s:1:\"1\";s:23:\"itemGooglePlusOneButton\";s:1:\"1\";s:15:\"itemAuthorBlock\";s:1:\"1\";s:15:\"itemAuthorImage\";s:1:\"1\";s:21:\"itemAuthorDescription\";s:1:\"1\";s:13:\"itemAuthorURL\";s:1:\"1\";s:15:\"itemAuthorEmail\";s:1:\"0\";s:16:\"itemAuthorLatest\";s:1:\"1\";s:21:\"itemAuthorLatestLimit\";s:1:\"5\";s:11:\"itemRelated\";s:1:\"1\";s:16:\"itemRelatedLimit\";s:1:\"5\";s:16:\"itemRelatedTitle\";s:1:\"1\";s:19:\"itemRelatedCategory\";s:1:\"0\";s:20:\"itemRelatedImageSize\";s:1:\"0\";s:20:\"itemRelatedIntrotext\";s:1:\"0\";s:19:\"itemRelatedFulltext\";s:1:\"0\";s:17:\"itemRelatedAuthor\";s:1:\"0\";s:16:\"itemRelatedMedia\";s:1:\"0\";s:23:\"itemRelatedImageGallery\";s:1:\"0\";s:13:\"itemK2Plugins\";s:1:\"1\";}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";}}s:8:\"ordering\";s:1:\"3\";s:5:\"trash\";s:1:\"0\";s:9:\"cat_trash\";s:1:\"0\";s:8:\"category\";s:16:\"Gear Accessories\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:44:\"14:early-season-park-action-at-bear-mountain\";s:7:\"catslug\";s:18:\"3:gear-accessories\";s:6:\"author\";s:10:\"Super User\";s:6:\"layout\";s:4:\"item\";s:4:\"path\";s:72:\"index.php/component/k2/item/14-early-season-park-action-at-bear-mountain\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"K2 Item\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"K2 Item\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:10:\"Super User\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:10:\"Super User\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:11:\"K2 Category\";a:1:{s:16:\"Gear Accessories\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:16:\"Gear Accessories\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:39:\"index.php?option=com_k2&view=item&id=14\";s:5:\"route\";s:81:\"index.php?option=com_k2&view=item&id=14:early-season-park-action-at-bear-mountain\";s:5:\"title\";s:41:\"Early Season Park Action at Bear Mountain\";s:11:\"description\";s:247:\"Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2012-12-03 11:56:02\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2012-12-03 11:56:02\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;}'),(15,'index.php?option=com_k2&view=item&id=15','index.php?option=com_k2&view=item&id=15:insane-opening-day-at-mt-baker','Insane Opening Day at Mt Baker','Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.','2012-12-03 12:59:10','2854678d18f5267621bc6aaaf6c481be',1,1,1,'*','2012-12-03 11:57:26','0000-00-00 00:00:00','2012-12-03 11:57:26','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:2:\"15\";s:5:\"alias\";s:30:\"insane-opening-day-at-mt-baker\";s:7:\"summary\";s:256:\"<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n\";s:4:\"body\";s:488:\"\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla. Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\";s:5:\"catid\";s:1:\"3\";s:10:\"created_by\";s:3:\"944\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"0000-00-00 00:00:00\";s:11:\"modified_by\";s:1:\"0\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":239:{s:10:\"enable_css\";s:1:\"1\";s:14:\"jQueryHandling\";s:9:\"1.8remote\";s:21:\"backendJQueryHandling\";s:6:\"remote\";s:8:\"userName\";s:1:\"1\";s:9:\"userImage\";s:1:\"1\";s:15:\"userDescription\";s:1:\"1\";s:7:\"userURL\";s:1:\"1\";s:9:\"userEmail\";s:1:\"0\";s:12:\"userFeedLink\";s:1:\"1\";s:12:\"userFeedIcon\";s:1:\"1\";s:13:\"userItemCount\";s:1:\"4\";s:13:\"userItemTitle\";s:1:\"1\";s:19:\"userItemTitleLinked\";s:1:\"1\";s:19:\"userItemDateCreated\";s:1:\"1\";s:13:\"userItemImage\";s:1:\"1\";s:17:\"userItemIntroText\";s:1:\"1\";s:16:\"userItemCategory\";s:1:\"1\";s:12:\"userItemTags\";s:1:\"1\";s:22:\"userItemCommentsAnchor\";s:1:\"1\";s:16:\"userItemReadMore\";s:1:\"1\";s:17:\"userItemK2Plugins\";s:1:\"1\";s:18:\"defaultUsersItemid\";s:0:\"\";s:12:\"tagItemCount\";s:1:\"4\";s:12:\"tagItemTitle\";s:1:\"1\";s:18:\"tagItemTitleLinked\";s:1:\"1\";s:18:\"tagItemDateCreated\";s:1:\"1\";s:12:\"tagItemImage\";s:1:\"1\";s:16:\"tagItemIntroText\";s:1:\"1\";s:15:\"tagItemCategory\";s:1:\"1\";s:15:\"tagItemReadMore\";s:1:\"1\";s:18:\"tagItemExtraFields\";s:1:\"0\";s:11:\"tagOrdering\";s:0:\"\";s:11:\"tagFeedLink\";s:1:\"1\";s:11:\"tagFeedIcon\";s:1:\"1\";s:17:\"defaultTagsItemid\";s:0:\"\";s:16:\"genericItemCount\";s:2:\"10\";s:16:\"genericItemTitle\";s:1:\"1\";s:22:\"genericItemTitleLinked\";s:1:\"1\";s:22:\"genericItemDateCreated\";s:1:\"1\";s:16:\"genericItemImage\";s:1:\"1\";s:20:\"genericItemIntroText\";s:1:\"1\";s:19:\"genericItemCategory\";s:1:\"1\";s:19:\"genericItemReadMore\";s:1:\"1\";s:22:\"genericItemExtraFields\";s:1:\"0\";s:15:\"genericFeedLink\";s:1:\"1\";s:15:\"genericFeedIcon\";s:1:\"1\";s:9:\"feedLimit\";s:2:\"10\";s:13:\"feedItemImage\";s:1:\"1\";s:11:\"feedImgSize\";s:1:\"L\";s:17:\"feedItemIntroText\";s:1:\"1\";s:17:\"feedTextWordLimit\";s:0:\"\";s:16:\"feedItemFullText\";s:1:\"1\";s:12:\"feedItemTags\";s:1:\"0\";s:13:\"feedItemVideo\";s:1:\"0\";s:15:\"feedItemGallery\";s:1:\"0\";s:19:\"feedItemAttachments\";s:1:\"0\";s:14:\"feedBogusEmail\";s:0:\"\";s:16:\"introTextCleanup\";s:1:\"0\";s:27:\"introTextCleanupExcludeTags\";s:0:\"\";s:23:\"introTextCleanupTagAttr\";s:0:\"\";s:15:\"fullTextCleanup\";s:1:\"0\";s:26:\"fullTextCleanupExcludeTags\";s:0:\"\";s:22:\"fullTextCleanupTagAttr\";s:0:\"\";s:12:\"xssFiltering\";s:1:\"0\";s:14:\"linkPopupWidth\";s:3:\"900\";s:15:\"linkPopupHeight\";s:3:\"600\";s:13:\"imagesQuality\";s:2:\"95\";s:11:\"itemImageXS\";s:3:\"100\";s:10:\"itemImageS\";s:3:\"200\";s:10:\"itemImageM\";s:3:\"700\";s:10:\"itemImageL\";s:3:\"700\";s:11:\"itemImageXL\";s:3:\"918\";s:16:\"itemImageGeneric\";s:3:\"700\";s:13:\"catImageWidth\";s:3:\"700\";s:15:\"catImageDefault\";s:1:\"1\";s:14:\"userImageWidth\";s:3:\"116\";s:16:\"userImageDefault\";s:1:\"1\";s:17:\"commenterImgWidth\";s:2:\"48\";s:17:\"onlineImageEditor\";s:8:\"splashup\";s:14:\"imageTimestamp\";s:1:\"0\";s:16:\"imageMemoryLimit\";s:0:\"\";s:16:\"socialButtonCode\";s:0:\"\";s:15:\"twitterUsername\";s:0:\"\";s:13:\"facebookImage\";s:5:\"Small\";s:8:\"comments\";s:1:\"1\";s:16:\"commentsOrdering\";s:4:\"DESC\";s:13:\"commentsLimit\";s:2:\"10\";s:20:\"commentsFormPosition\";s:5:\"below\";s:18:\"commentsPublishing\";s:1:\"1\";s:17:\"commentsReporting\";s:1:\"2\";s:23:\"commentsReportRecipient\";s:0:\"\";s:24:\"inlineCommentsModeration\";s:1:\"0\";s:8:\"gravatar\";s:1:\"1\";s:9:\"recaptcha\";s:1:\"0\";s:17:\"commentsFormNotes\";s:1:\"1\";s:21:\"commentsFormNotesText\";s:0:\"\";s:15:\"frontendEditing\";s:1:\"1\";s:12:\"showImageTab\";s:1:\"1\";s:19:\"showImageGalleryTab\";s:1:\"1\";s:12:\"showVideoTab\";s:1:\"1\";s:18:\"showExtraFieldsTab\";s:1:\"1\";s:18:\"showAttachmentsTab\";s:1:\"1\";s:13:\"showK2Plugins\";s:1:\"1\";s:22:\"sideBarDisplayFrontend\";s:1:\"0\";s:12:\"mergeEditors\";s:1:\"1\";s:14:\"sideBarDisplay\";s:1:\"1\";s:17:\"attachmentsFolder\";s:0:\"\";s:16:\"hideImportButton\";s:1:\"0\";s:13:\"taggingSystem\";s:1:\"1\";s:8:\"lockTags\";s:1:\"0\";s:13:\"showTagFilter\";s:1:\"0\";s:12:\"googleSearch\";s:1:\"0\";s:21:\"googleSearchContainer\";s:11:\"k2Container\";s:13:\"K2UserProfile\";s:1:\"0\";s:8:\"redirect\";s:3:\"101\";s:11:\"adminSearch\";s:6:\"simple\";s:12:\"cookieDomain\";s:0:\"\";s:20:\"recaptcha_public_key\";s:0:\"\";s:21:\"recaptcha_private_key\";s:0:\"\";s:15:\"recaptcha_theme\";s:5:\"clean\";s:23:\"recaptchaOnRegistration\";s:1:\"0\";s:13:\"stopForumSpam\";s:1:\"0\";s:19:\"stopForumSpamApiKey\";s:0:\"\";s:21:\"showItemsCounterAdmin\";s:1:\"1\";s:17:\"showChildCatItems\";s:1:\"1\";s:22:\"disableCompactOrdering\";s:1:\"0\";s:13:\"metaDescLimit\";s:3:\"150\";s:15:\"SEFReplacements\";s:583:\"Å |S, Å’|O, Å½|Z, Å¡|s, Å“|oe, Å¾|z, Å¸|Y, Â¥|Y, Âµ|u, Ã€|A, Ã�|A, Ã‚|A, Ãƒ|A, Ã„|A, Ã…|A, Ã†|A, Ã‡|C, Ãˆ|E, Ã‰|E, ÃŠ|E, Ã‹|E, ÃŒ|I, Ã�|I, ÃŽ|I, Ã�|I, Ã�|D, Ã‘|N, Ã’|O, Ã“|O, Ã”|O, Ã•|O, Ã–|O, Ã˜|O, Ã™|U, Ãš|U, Ã›|U, Ãœ|U, Ã�|Y, ÃŸ|s, Ã |a, Ã¡|a, Ã¢|a, Ã£|a, Ã¤|a, Ã¥|a, Ã¦|a, Ã§|c, Ã¨|e, Ã©|e, Ãª|e, Ã«|e, Ã¬|i, Ã­|i, Ã®|i, Ã¯|i, Ã°|o, Ã±|n, Ã²|o, Ã³|o, Ã´|o, Ãµ|o, Ã¶|o, Ã¸|o, Ã¹|u, Ãº|u, Ã»|u, Ã¼|u, Ã½|y, Ã¿|y, ÃŸ|ss\";s:16:\"sh404SefLabelCat\";s:0:\"\";s:17:\"sh404SefLabelUser\";s:4:\"blog\";s:17:\"sh404SefLabelItem\";s:1:\"2\";s:18:\"sh404SefTitleAlias\";s:5:\"alias\";s:29:\"sh404SefModK2ContentFeedAlias\";s:4:\"feed\";s:20:\"sh404SefInsertItemId\";s:1:\"0\";s:26:\"sh404SefInsertUniqueItemId\";s:1:\"0\";s:13:\"cbIntegration\";s:1:\"0\";s:11:\"inheritFrom\";s:1:\"0\";s:17:\"num_leading_items\";s:1:\"4\";s:19:\"num_leading_columns\";s:1:\"1\";s:14:\"leadingImgSize\";s:5:\"Large\";s:17:\"num_primary_items\";s:1:\"4\";s:19:\"num_primary_columns\";s:1:\"1\";s:14:\"primaryImgSize\";s:5:\"Large\";s:19:\"num_secondary_items\";s:1:\"4\";s:21:\"num_secondary_columns\";s:1:\"1\";s:16:\"secondaryImgSize\";s:5:\"Large\";s:9:\"num_links\";s:1:\"2\";s:17:\"num_links_columns\";s:1:\"1\";s:12:\"linksImgSize\";s:5:\"Large\";s:14:\"catCatalogMode\";s:1:\"1\";s:16:\"catFeaturedItems\";s:1:\"1\";s:13:\"catPagination\";s:1:\"2\";s:20:\"catPaginationResults\";s:1:\"1\";s:8:\"catTitle\";s:1:\"0\";s:19:\"catTitleItemCounter\";s:1:\"0\";s:14:\"catDescription\";s:1:\"0\";s:8:\"catImage\";s:1:\"0\";s:11:\"catFeedLink\";s:1:\"1\";s:11:\"catFeedIcon\";s:1:\"1\";s:13:\"subCategories\";s:1:\"0\";s:13:\"subCatColumns\";s:1:\"4\";s:11:\"subCatTitle\";s:1:\"0\";s:22:\"subCatTitleItemCounter\";s:1:\"0\";s:17:\"subCatDescription\";s:1:\"0\";s:11:\"subCatImage\";s:1:\"0\";s:12:\"catItemTitle\";s:1:\"1\";s:18:\"catItemTitleLinked\";s:1:\"1\";s:21:\"catItemFeaturedNotice\";s:1:\"0\";s:13:\"catItemAuthor\";s:1:\"1\";s:18:\"catItemDateCreated\";s:1:\"1\";s:13:\"catItemRating\";s:1:\"0\";s:12:\"catItemImage\";s:1:\"1\";s:16:\"catItemIntroText\";s:1:\"1\";s:18:\"catItemExtraFields\";s:1:\"0\";s:11:\"catItemHits\";s:1:\"0\";s:15:\"catItemCategory\";s:1:\"1\";s:11:\"catItemTags\";s:1:\"0\";s:18:\"catItemAttachments\";s:1:\"0\";s:25:\"catItemAttachmentsCounter\";s:1:\"0\";s:12:\"catItemVideo\";s:1:\"0\";s:20:\"catItemVideoAutoPlay\";s:1:\"0\";s:19:\"catItemImageGallery\";s:1:\"0\";s:19:\"catItemDateModified\";s:1:\"0\";s:15:\"catItemReadMore\";s:1:\"1\";s:21:\"catItemCommentsAnchor\";s:1:\"1\";s:16:\"catItemK2Plugins\";s:1:\"1\";s:15:\"itemDateCreated\";s:1:\"1\";s:9:\"itemTitle\";s:1:\"1\";s:18:\"itemFeaturedNotice\";s:1:\"1\";s:10:\"itemAuthor\";s:1:\"1\";s:15:\"itemFontResizer\";s:1:\"1\";s:15:\"itemPrintButton\";s:1:\"1\";s:15:\"itemEmailButton\";s:1:\"1\";s:16:\"itemSocialButton\";s:1:\"1\";s:15:\"itemVideoAnchor\";s:1:\"1\";s:22:\"itemImageGalleryAnchor\";s:1:\"1\";s:18:\"itemCommentsAnchor\";s:1:\"1\";s:10:\"itemRating\";s:1:\"1\";s:9:\"itemImage\";s:1:\"1\";s:11:\"itemImgSize\";s:5:\"Large\";s:20:\"itemImageMainCaption\";s:1:\"1\";s:20:\"itemImageMainCredits\";s:1:\"1\";s:13:\"itemIntroText\";s:1:\"1\";s:12:\"itemFullText\";s:1:\"1\";s:15:\"itemExtraFields\";s:1:\"1\";s:16:\"itemDateModified\";s:1:\"1\";s:8:\"itemHits\";s:1:\"1\";s:12:\"itemCategory\";s:1:\"1\";s:8:\"itemTags\";s:1:\"1\";s:15:\"itemAttachments\";s:1:\"1\";s:22:\"itemAttachmentsCounter\";s:1:\"1\";s:9:\"itemVideo\";s:1:\"1\";s:17:\"itemVideoAutoPlay\";s:1:\"0\";s:16:\"itemVideoCaption\";s:1:\"1\";s:16:\"itemVideoCredits\";s:1:\"1\";s:16:\"itemImageGallery\";s:1:\"1\";s:14:\"itemNavigation\";s:1:\"1\";s:12:\"itemComments\";s:1:\"1\";s:17:\"itemTwitterButton\";s:1:\"1\";s:18:\"itemFacebookButton\";s:1:\"1\";s:23:\"itemGooglePlusOneButton\";s:1:\"1\";s:15:\"itemAuthorBlock\";s:1:\"1\";s:15:\"itemAuthorImage\";s:1:\"1\";s:21:\"itemAuthorDescription\";s:1:\"1\";s:13:\"itemAuthorURL\";s:1:\"1\";s:15:\"itemAuthorEmail\";s:1:\"0\";s:16:\"itemAuthorLatest\";s:1:\"1\";s:21:\"itemAuthorLatestLimit\";s:1:\"5\";s:11:\"itemRelated\";s:1:\"1\";s:16:\"itemRelatedLimit\";s:1:\"5\";s:16:\"itemRelatedTitle\";s:1:\"1\";s:19:\"itemRelatedCategory\";s:1:\"0\";s:20:\"itemRelatedImageSize\";s:1:\"0\";s:20:\"itemRelatedIntrotext\";s:1:\"0\";s:19:\"itemRelatedFulltext\";s:1:\"0\";s:17:\"itemRelatedAuthor\";s:1:\"0\";s:16:\"itemRelatedMedia\";s:1:\"0\";s:23:\"itemRelatedImageGallery\";s:1:\"0\";s:13:\"itemK2Plugins\";s:1:\"1\";}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";}}s:8:\"ordering\";s:1:\"4\";s:5:\"trash\";s:1:\"0\";s:9:\"cat_trash\";s:1:\"0\";s:8:\"category\";s:16:\"Gear Accessories\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:33:\"15:insane-opening-day-at-mt-baker\";s:7:\"catslug\";s:18:\"3:gear-accessories\";s:6:\"author\";s:10:\"Super User\";s:6:\"layout\";s:4:\"item\";s:4:\"path\";s:61:\"index.php/component/k2/item/15-insane-opening-day-at-mt-baker\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"K2 Item\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"K2 Item\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:10:\"Super User\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:10:\"Super User\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:11:\"K2 Category\";a:1:{s:16:\"Gear Accessories\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:16:\"Gear Accessories\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:39:\"index.php?option=com_k2&view=item&id=15\";s:5:\"route\";s:70:\"index.php?option=com_k2&view=item&id=15:insane-opening-day-at-mt-baker\";s:5:\"title\";s:30:\"Insane Opening Day at Mt Baker\";s:11:\"description\";s:247:\"Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2012-12-03 11:57:26\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2012-12-03 11:57:26\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;}'),(16,'index.php?option=com_k2&view=item&id=16','index.php?option=com_k2&view=item&id=16:go-bigger-in-the-uk?','Go Bigger In The UK?','Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.','2012-12-03 13:00:35','c23de3ea25652f639193069bdf5f8b26',1,1,1,'*','2012-12-03 11:59:11','0000-00-00 00:00:00','2012-12-03 11:59:11','0000-00-00 00:00:00',0,0,1,'O:19:\"FinderIndexerResult\":18:{s:11:\"\0*\0elements\";a:25:{s:2:\"id\";s:2:\"16\";s:5:\"alias\";s:20:\"go-bigger-in-the-uk?\";s:7:\"summary\";s:256:\"<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n\";s:4:\"body\";s:488:\"\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla. Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\";s:5:\"catid\";s:1:\"1\";s:10:\"created_by\";s:3:\"944\";s:16:\"created_by_alias\";s:0:\"\";s:8:\"modified\";s:19:\"0000-00-00 00:00:00\";s:11:\"modified_by\";s:1:\"0\";s:6:\"params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":239:{s:10:\"enable_css\";s:1:\"1\";s:14:\"jQueryHandling\";s:9:\"1.8remote\";s:21:\"backendJQueryHandling\";s:6:\"remote\";s:8:\"userName\";s:1:\"1\";s:9:\"userImage\";s:1:\"1\";s:15:\"userDescription\";s:1:\"1\";s:7:\"userURL\";s:1:\"1\";s:9:\"userEmail\";s:1:\"0\";s:12:\"userFeedLink\";s:1:\"1\";s:12:\"userFeedIcon\";s:1:\"1\";s:13:\"userItemCount\";s:1:\"4\";s:13:\"userItemTitle\";s:1:\"1\";s:19:\"userItemTitleLinked\";s:1:\"1\";s:19:\"userItemDateCreated\";s:1:\"1\";s:13:\"userItemImage\";s:1:\"1\";s:17:\"userItemIntroText\";s:1:\"1\";s:16:\"userItemCategory\";s:1:\"1\";s:12:\"userItemTags\";s:1:\"1\";s:22:\"userItemCommentsAnchor\";s:1:\"1\";s:16:\"userItemReadMore\";s:1:\"1\";s:17:\"userItemK2Plugins\";s:1:\"1\";s:18:\"defaultUsersItemid\";s:0:\"\";s:12:\"tagItemCount\";s:1:\"4\";s:12:\"tagItemTitle\";s:1:\"1\";s:18:\"tagItemTitleLinked\";s:1:\"1\";s:18:\"tagItemDateCreated\";s:1:\"1\";s:12:\"tagItemImage\";s:1:\"1\";s:16:\"tagItemIntroText\";s:1:\"1\";s:15:\"tagItemCategory\";s:1:\"1\";s:15:\"tagItemReadMore\";s:1:\"1\";s:18:\"tagItemExtraFields\";s:1:\"0\";s:11:\"tagOrdering\";s:0:\"\";s:11:\"tagFeedLink\";s:1:\"1\";s:11:\"tagFeedIcon\";s:1:\"1\";s:17:\"defaultTagsItemid\";s:0:\"\";s:16:\"genericItemCount\";s:2:\"10\";s:16:\"genericItemTitle\";s:1:\"1\";s:22:\"genericItemTitleLinked\";s:1:\"1\";s:22:\"genericItemDateCreated\";s:1:\"1\";s:16:\"genericItemImage\";s:1:\"1\";s:20:\"genericItemIntroText\";s:1:\"1\";s:19:\"genericItemCategory\";s:1:\"1\";s:19:\"genericItemReadMore\";s:1:\"1\";s:22:\"genericItemExtraFields\";s:1:\"0\";s:15:\"genericFeedLink\";s:1:\"1\";s:15:\"genericFeedIcon\";s:1:\"1\";s:9:\"feedLimit\";s:2:\"10\";s:13:\"feedItemImage\";s:1:\"1\";s:11:\"feedImgSize\";s:1:\"L\";s:17:\"feedItemIntroText\";s:1:\"1\";s:17:\"feedTextWordLimit\";s:0:\"\";s:16:\"feedItemFullText\";s:1:\"1\";s:12:\"feedItemTags\";s:1:\"0\";s:13:\"feedItemVideo\";s:1:\"0\";s:15:\"feedItemGallery\";s:1:\"0\";s:19:\"feedItemAttachments\";s:1:\"0\";s:14:\"feedBogusEmail\";s:0:\"\";s:16:\"introTextCleanup\";s:1:\"0\";s:27:\"introTextCleanupExcludeTags\";s:0:\"\";s:23:\"introTextCleanupTagAttr\";s:0:\"\";s:15:\"fullTextCleanup\";s:1:\"0\";s:26:\"fullTextCleanupExcludeTags\";s:0:\"\";s:22:\"fullTextCleanupTagAttr\";s:0:\"\";s:12:\"xssFiltering\";s:1:\"0\";s:14:\"linkPopupWidth\";s:3:\"900\";s:15:\"linkPopupHeight\";s:3:\"600\";s:13:\"imagesQuality\";s:2:\"95\";s:11:\"itemImageXS\";s:3:\"100\";s:10:\"itemImageS\";s:3:\"200\";s:10:\"itemImageM\";s:3:\"700\";s:10:\"itemImageL\";s:3:\"700\";s:11:\"itemImageXL\";s:3:\"918\";s:16:\"itemImageGeneric\";s:3:\"700\";s:13:\"catImageWidth\";s:3:\"700\";s:15:\"catImageDefault\";s:1:\"1\";s:14:\"userImageWidth\";s:3:\"116\";s:16:\"userImageDefault\";s:1:\"1\";s:17:\"commenterImgWidth\";s:2:\"48\";s:17:\"onlineImageEditor\";s:8:\"splashup\";s:14:\"imageTimestamp\";s:1:\"0\";s:16:\"imageMemoryLimit\";s:0:\"\";s:16:\"socialButtonCode\";s:0:\"\";s:15:\"twitterUsername\";s:0:\"\";s:13:\"facebookImage\";s:5:\"Small\";s:8:\"comments\";s:1:\"1\";s:16:\"commentsOrdering\";s:4:\"DESC\";s:13:\"commentsLimit\";s:2:\"10\";s:20:\"commentsFormPosition\";s:5:\"below\";s:18:\"commentsPublishing\";s:1:\"1\";s:17:\"commentsReporting\";s:1:\"2\";s:23:\"commentsReportRecipient\";s:0:\"\";s:24:\"inlineCommentsModeration\";s:1:\"0\";s:8:\"gravatar\";s:1:\"1\";s:9:\"recaptcha\";s:1:\"0\";s:17:\"commentsFormNotes\";s:1:\"1\";s:21:\"commentsFormNotesText\";s:0:\"\";s:15:\"frontendEditing\";s:1:\"1\";s:12:\"showImageTab\";s:1:\"1\";s:19:\"showImageGalleryTab\";s:1:\"1\";s:12:\"showVideoTab\";s:1:\"1\";s:18:\"showExtraFieldsTab\";s:1:\"1\";s:18:\"showAttachmentsTab\";s:1:\"1\";s:13:\"showK2Plugins\";s:1:\"1\";s:22:\"sideBarDisplayFrontend\";s:1:\"0\";s:12:\"mergeEditors\";s:1:\"1\";s:14:\"sideBarDisplay\";s:1:\"1\";s:17:\"attachmentsFolder\";s:0:\"\";s:16:\"hideImportButton\";s:1:\"0\";s:13:\"taggingSystem\";s:1:\"1\";s:8:\"lockTags\";s:1:\"0\";s:13:\"showTagFilter\";s:1:\"0\";s:12:\"googleSearch\";s:1:\"0\";s:21:\"googleSearchContainer\";s:11:\"k2Container\";s:13:\"K2UserProfile\";s:1:\"0\";s:8:\"redirect\";s:3:\"101\";s:11:\"adminSearch\";s:6:\"simple\";s:12:\"cookieDomain\";s:0:\"\";s:20:\"recaptcha_public_key\";s:0:\"\";s:21:\"recaptcha_private_key\";s:0:\"\";s:15:\"recaptcha_theme\";s:5:\"clean\";s:23:\"recaptchaOnRegistration\";s:1:\"0\";s:13:\"stopForumSpam\";s:1:\"0\";s:19:\"stopForumSpamApiKey\";s:0:\"\";s:21:\"showItemsCounterAdmin\";s:1:\"1\";s:17:\"showChildCatItems\";s:1:\"1\";s:22:\"disableCompactOrdering\";s:1:\"0\";s:13:\"metaDescLimit\";s:3:\"150\";s:15:\"SEFReplacements\";s:583:\"Å |S, Å’|O, Å½|Z, Å¡|s, Å“|oe, Å¾|z, Å¸|Y, Â¥|Y, Âµ|u, Ã€|A, Ã�|A, Ã‚|A, Ãƒ|A, Ã„|A, Ã…|A, Ã†|A, Ã‡|C, Ãˆ|E, Ã‰|E, ÃŠ|E, Ã‹|E, ÃŒ|I, Ã�|I, ÃŽ|I, Ã�|I, Ã�|D, Ã‘|N, Ã’|O, Ã“|O, Ã”|O, Ã•|O, Ã–|O, Ã˜|O, Ã™|U, Ãš|U, Ã›|U, Ãœ|U, Ã�|Y, ÃŸ|s, Ã |a, Ã¡|a, Ã¢|a, Ã£|a, Ã¤|a, Ã¥|a, Ã¦|a, Ã§|c, Ã¨|e, Ã©|e, Ãª|e, Ã«|e, Ã¬|i, Ã­|i, Ã®|i, Ã¯|i, Ã°|o, Ã±|n, Ã²|o, Ã³|o, Ã´|o, Ãµ|o, Ã¶|o, Ã¸|o, Ã¹|u, Ãº|u, Ã»|u, Ã¼|u, Ã½|y, Ã¿|y, ÃŸ|ss\";s:16:\"sh404SefLabelCat\";s:0:\"\";s:17:\"sh404SefLabelUser\";s:4:\"blog\";s:17:\"sh404SefLabelItem\";s:1:\"2\";s:18:\"sh404SefTitleAlias\";s:5:\"alias\";s:29:\"sh404SefModK2ContentFeedAlias\";s:4:\"feed\";s:20:\"sh404SefInsertItemId\";s:1:\"0\";s:26:\"sh404SefInsertUniqueItemId\";s:1:\"0\";s:13:\"cbIntegration\";s:1:\"0\";s:11:\"inheritFrom\";s:1:\"0\";s:17:\"num_leading_items\";s:1:\"4\";s:19:\"num_leading_columns\";s:1:\"1\";s:14:\"leadingImgSize\";s:5:\"Large\";s:17:\"num_primary_items\";s:1:\"4\";s:19:\"num_primary_columns\";s:1:\"1\";s:14:\"primaryImgSize\";s:5:\"Large\";s:19:\"num_secondary_items\";s:1:\"4\";s:21:\"num_secondary_columns\";s:1:\"1\";s:16:\"secondaryImgSize\";s:5:\"Large\";s:9:\"num_links\";s:1:\"2\";s:17:\"num_links_columns\";s:1:\"1\";s:12:\"linksImgSize\";s:5:\"Large\";s:14:\"catCatalogMode\";s:1:\"1\";s:16:\"catFeaturedItems\";s:1:\"1\";s:13:\"catPagination\";s:1:\"2\";s:20:\"catPaginationResults\";s:1:\"1\";s:8:\"catTitle\";s:1:\"0\";s:19:\"catTitleItemCounter\";s:1:\"0\";s:14:\"catDescription\";s:1:\"0\";s:8:\"catImage\";s:1:\"0\";s:11:\"catFeedLink\";s:1:\"1\";s:11:\"catFeedIcon\";s:1:\"1\";s:13:\"subCategories\";s:1:\"0\";s:13:\"subCatColumns\";s:1:\"4\";s:11:\"subCatTitle\";s:1:\"0\";s:22:\"subCatTitleItemCounter\";s:1:\"0\";s:17:\"subCatDescription\";s:1:\"0\";s:11:\"subCatImage\";s:1:\"0\";s:12:\"catItemTitle\";s:1:\"1\";s:18:\"catItemTitleLinked\";s:1:\"1\";s:21:\"catItemFeaturedNotice\";s:1:\"0\";s:13:\"catItemAuthor\";s:1:\"1\";s:18:\"catItemDateCreated\";s:1:\"1\";s:13:\"catItemRating\";s:1:\"0\";s:12:\"catItemImage\";s:1:\"1\";s:16:\"catItemIntroText\";s:1:\"1\";s:18:\"catItemExtraFields\";s:1:\"0\";s:11:\"catItemHits\";s:1:\"0\";s:15:\"catItemCategory\";s:1:\"1\";s:11:\"catItemTags\";s:1:\"0\";s:18:\"catItemAttachments\";s:1:\"0\";s:25:\"catItemAttachmentsCounter\";s:1:\"0\";s:12:\"catItemVideo\";s:1:\"0\";s:20:\"catItemVideoAutoPlay\";s:1:\"0\";s:19:\"catItemImageGallery\";s:1:\"0\";s:19:\"catItemDateModified\";s:1:\"0\";s:15:\"catItemReadMore\";s:1:\"1\";s:21:\"catItemCommentsAnchor\";s:1:\"1\";s:16:\"catItemK2Plugins\";s:1:\"1\";s:15:\"itemDateCreated\";s:1:\"1\";s:9:\"itemTitle\";s:1:\"1\";s:18:\"itemFeaturedNotice\";s:1:\"1\";s:10:\"itemAuthor\";s:1:\"1\";s:15:\"itemFontResizer\";s:1:\"1\";s:15:\"itemPrintButton\";s:1:\"1\";s:15:\"itemEmailButton\";s:1:\"1\";s:16:\"itemSocialButton\";s:1:\"1\";s:15:\"itemVideoAnchor\";s:1:\"1\";s:22:\"itemImageGalleryAnchor\";s:1:\"1\";s:18:\"itemCommentsAnchor\";s:1:\"1\";s:10:\"itemRating\";s:1:\"1\";s:9:\"itemImage\";s:1:\"1\";s:11:\"itemImgSize\";s:5:\"Large\";s:20:\"itemImageMainCaption\";s:1:\"1\";s:20:\"itemImageMainCredits\";s:1:\"1\";s:13:\"itemIntroText\";s:1:\"1\";s:12:\"itemFullText\";s:1:\"1\";s:15:\"itemExtraFields\";s:1:\"1\";s:16:\"itemDateModified\";s:1:\"1\";s:8:\"itemHits\";s:1:\"1\";s:12:\"itemCategory\";s:1:\"1\";s:8:\"itemTags\";s:1:\"1\";s:15:\"itemAttachments\";s:1:\"1\";s:22:\"itemAttachmentsCounter\";s:1:\"1\";s:9:\"itemVideo\";s:1:\"1\";s:17:\"itemVideoAutoPlay\";s:1:\"0\";s:16:\"itemVideoCaption\";s:1:\"1\";s:16:\"itemVideoCredits\";s:1:\"1\";s:16:\"itemImageGallery\";s:1:\"1\";s:14:\"itemNavigation\";s:1:\"1\";s:12:\"itemComments\";s:1:\"1\";s:17:\"itemTwitterButton\";s:1:\"1\";s:18:\"itemFacebookButton\";s:1:\"1\";s:23:\"itemGooglePlusOneButton\";s:1:\"1\";s:15:\"itemAuthorBlock\";s:1:\"1\";s:15:\"itemAuthorImage\";s:1:\"1\";s:21:\"itemAuthorDescription\";s:1:\"1\";s:13:\"itemAuthorURL\";s:1:\"1\";s:15:\"itemAuthorEmail\";s:1:\"0\";s:16:\"itemAuthorLatest\";s:1:\"1\";s:21:\"itemAuthorLatestLimit\";s:1:\"5\";s:11:\"itemRelated\";s:1:\"1\";s:16:\"itemRelatedLimit\";s:1:\"5\";s:16:\"itemRelatedTitle\";s:1:\"1\";s:19:\"itemRelatedCategory\";s:1:\"0\";s:20:\"itemRelatedImageSize\";s:1:\"0\";s:20:\"itemRelatedIntrotext\";s:1:\"0\";s:19:\"itemRelatedFulltext\";s:1:\"0\";s:17:\"itemRelatedAuthor\";s:1:\"0\";s:16:\"itemRelatedMedia\";s:1:\"0\";s:23:\"itemRelatedImageGallery\";s:1:\"0\";s:13:\"itemK2Plugins\";s:1:\"1\";}}s:7:\"metakey\";s:0:\"\";s:8:\"metadesc\";s:0:\"\";s:8:\"metadata\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":2:{s:6:\"robots\";s:0:\"\";s:6:\"author\";s:0:\"\";}}s:8:\"ordering\";s:1:\"4\";s:5:\"trash\";s:1:\"0\";s:9:\"cat_trash\";s:1:\"0\";s:8:\"category\";s:20:\"Snowboarding Resorts\";s:9:\"cat_state\";s:1:\"1\";s:10:\"cat_access\";s:1:\"1\";s:4:\"slug\";s:23:\"16:go-bigger-in-the-uk?\";s:7:\"catslug\";s:22:\"1:snowboarding-resorts\";s:6:\"author\";s:10:\"Super User\";s:6:\"layout\";s:4:\"item\";s:4:\"path\";s:51:\"index.php/component/k2/item/16-go-bigger-in-the-uk?\";s:10:\"metaauthor\";N;}s:15:\"\0*\0instructions\";a:5:{i:1;a:3:{i:0;s:5:\"title\";i:1;s:8:\"subtitle\";i:2;s:2:\"id\";}i:2;a:2:{i:0;s:7:\"summary\";i:1;s:4:\"body\";}i:3;a:8:{i:0;s:4:\"meta\";i:1;s:10:\"list_price\";i:2;s:10:\"sale_price\";i:3;s:7:\"metakey\";i:4;s:8:\"metadesc\";i:5;s:10:\"metaauthor\";i:6;s:6:\"author\";i:7;s:16:\"created_by_alias\";}i:4;a:2:{i:0;s:4:\"path\";i:1;s:5:\"alias\";}i:5;a:1:{i:0;s:8:\"comments\";}}s:11:\"\0*\0taxonomy\";a:4:{s:4:\"Type\";a:1:{s:7:\"K2 Item\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:7:\"K2 Item\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:6:\"Author\";a:1:{s:10:\"Super User\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:10:\"Super User\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:11:\"K2 Category\";a:1:{s:20:\"Snowboarding Resorts\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:20:\"Snowboarding Resorts\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}s:8:\"Language\";a:1:{s:1:\"*\";O:7:\"JObject\":4:{s:10:\"\0*\0_errors\";a:0:{}s:5:\"title\";s:1:\"*\";s:5:\"state\";i:1;s:6:\"access\";i:1;}}}s:3:\"url\";s:39:\"index.php?option=com_k2&view=item&id=16\";s:5:\"route\";s:60:\"index.php?option=com_k2&view=item&id=16:go-bigger-in-the-uk?\";s:5:\"title\";s:20:\"Go Bigger In The UK?\";s:11:\"description\";s:247:\"Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.\";s:9:\"published\";N;s:5:\"state\";i:1;s:6:\"access\";s:1:\"1\";s:8:\"language\";s:1:\"*\";s:18:\"publish_start_date\";s:19:\"2012-12-03 11:59:11\";s:16:\"publish_end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"start_date\";s:19:\"2012-12-03 11:59:11\";s:8:\"end_date\";s:19:\"0000-00-00 00:00:00\";s:10:\"list_price\";N;s:10:\"sale_price\";N;s:7:\"type_id\";i:1;}');


--
-- Table structure for table `#__finder_links_terms0`
--



CREATE TABLE `#__finder_links_terms0` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_links_terms0`
--


INSERT INTO `#__finder_links_terms0` (`link_id`, `term_id`, `weight`) VALUES (1,3,0.09338),(3,3,0.09338),(4,3,0.09338),(5,3,0.09338),(6,3,0.09338),(8,3,0.09338),(9,3,0.09338),(10,3,0.09338),(11,3,0.09338),(12,3,0.09338),(13,3,0.09338),(14,3,0.09338),(15,3,0.09338),(16,3,0.09338),(2,3,0.34017),(7,3,0.34017),(1,4,0.86331),(2,4,0.86331),(3,4,0.86331),(4,4,0.86331),(5,4,0.86331),(6,4,0.86331),(7,4,0.86331),(8,4,0.86331),(9,4,0.86331),(10,4,0.86331),(11,4,0.86331),(12,4,0.86331),(13,4,0.86331),(14,4,0.86331),(15,4,0.86331),(16,4,0.86331),(1,5,0.95669),(2,5,0.95669),(3,5,0.95669),(4,5,0.95669),(5,5,0.95669),(6,5,0.95669),(7,5,0.95669),(8,5,0.95669),(9,5,0.95669),(10,5,0.95669),(11,5,0.95669),(12,5,0.95669),(13,5,0.95669),(14,5,0.95669),(15,5,0.95669),(16,5,0.95669),(1,6,0.86331),(2,6,0.86331),(3,6,0.86331),(4,6,0.86331),(5,6,0.86331),(6,6,0.86331),(7,6,0.86331),(8,6,0.86331),(9,6,0.86331),(10,6,0.86331),(11,6,0.86331),(12,6,0.86331),(13,6,0.86331),(14,6,0.86331),(15,6,0.86331),(16,6,0.86331),(1,7,1.00331),(2,7,1.00331),(3,7,1.00331),(4,7,1.00331),(5,7,1.00331),(6,7,1.00331),(7,7,1.00331),(8,7,1.00331),(9,7,1.00331),(10,7,1.00331),(11,7,1.00331),(12,7,1.00331),(13,7,1.00331),(14,7,1.00331),(15,7,1.00331),(16,7,1.00331),(1,8,0.87996),(2,8,0.87996),(14,8,0.87996),(15,8,0.87996),(1,9,0.28),(2,9,0.28),(3,9,0.28),(4,9,0.28),(5,9,0.28),(6,9,0.28),(7,9,0.28),(8,9,0.28),(9,9,0.28),(10,9,0.28),(11,9,0.28),(12,9,0.28),(13,9,0.28),(14,9,0.28),(15,9,0.28),(16,9,0.28),(1,10,0.91),(2,10,0.91),(3,10,0.91),(4,10,0.91),(5,10,0.91),(6,10,0.91),(7,10,0.91),(8,10,0.91),(9,10,0.91),(10,10,0.91),(11,10,0.91),(12,10,0.91),(13,10,0.91),(14,10,0.91),(15,10,0.91),(16,10,0.91),(1,11,1.00331),(2,11,1.00331),(3,11,1.00331),(4,11,1.00331),(5,11,1.00331),(6,11,1.00331),(7,11,1.00331),(8,11,1.00331),(9,11,1.00331),(10,11,1.00331),(11,11,1.00331),(12,11,1.00331),(13,11,1.00331),(14,11,1.00331),(15,11,1.00331),(16,11,1.00331),(1,12,0.32669),(2,12,0.32669),(3,12,0.32669),(4,12,0.32669),(5,12,0.32669),(6,12,0.32669),(7,12,0.32669),(8,12,0.32669),(9,12,0.32669),(10,12,0.32669),(11,12,0.32669),(12,12,0.32669),(13,12,0.32669),(14,12,0.32669),(15,12,0.32669),(16,12,0.32669),(1,13,1.02669),(2,13,1.02669),(3,13,1.02669),(4,13,1.02669),(5,13,1.02669),(6,13,1.02669),(7,13,1.02669),(8,13,1.02669),(9,13,1.02669),(10,13,1.02669),(11,13,1.02669),(12,13,1.02669),(13,13,1.02669),(14,13,1.02669),(15,13,1.02669),(16,13,1.02669),(1,14,1.19),(2,14,1.19),(3,14,1.19),(4,14,1.19),(5,14,1.19),(6,14,1.19),(7,14,1.19),(8,14,1.19),(9,14,1.19),(10,14,1.19),(11,14,1.19),(12,14,1.19),(13,14,1.19),(14,14,1.19),(15,14,1.19),(16,14,1.19),(1,15,0.37338),(2,15,0.37338),(3,15,0.37338),(4,15,0.37338),(5,15,0.37338),(6,15,0.37338),(7,15,0.37338),(8,15,0.37338),(9,15,0.37338),(10,15,0.37338),(11,15,0.37338),(12,15,0.37338),(13,15,0.37338),(14,15,0.37338),(15,15,0.37338),(16,15,0.37338),(1,16,2.05338),(2,16,2.05338),(3,16,2.05338),(4,16,2.05338),(5,16,2.05338),(6,16,2.05338),(7,16,2.05338),(8,16,2.05338),(9,16,2.05338),(10,16,2.05338),(11,16,2.05338),(12,16,2.05338),(13,16,2.05338),(14,16,2.05338),(15,16,2.05338),(16,16,2.05338),(1,17,1.16669),(2,17,1.16669),(3,17,1.16669),(4,17,1.16669),(5,17,1.16669),(6,17,1.16669),(7,17,1.16669),(8,17,1.16669),(9,17,1.16669),(10,17,1.16669),(11,17,1.16669),(12,17,1.16669),(13,17,1.16669),(14,17,1.16669),(15,17,1.16669),(16,17,1.16669),(1,18,1.19),(2,18,1.19),(3,18,1.19),(4,18,1.19),(5,18,1.19),(6,18,1.19),(7,18,1.19),(8,18,1.19),(9,18,1.19),(10,18,1.19),(11,18,1.19),(12,18,1.19),(13,18,1.19),(14,18,1.19),(15,18,1.19),(16,18,1.19),(1,19,0.09331),(2,19,0.09331),(4,19,0.09331),(5,19,0.09331),(6,19,0.09331),(7,19,0.09331),(8,19,0.09331),(9,19,0.09331),(11,19,0.09331),(12,19,0.09331),(13,19,0.09331),(16,19,0.09331),(3,19,0.58652),(10,19,0.58652),(14,19,0.58652),(15,19,0.58652),(1,20,0.95669),(2,20,0.95669),(3,20,0.95669),(4,20,0.95669),(5,20,0.95669),(6,20,0.95669),(7,20,0.95669),(8,20,0.95669),(9,20,0.95669),(10,20,0.95669),(11,20,0.95669),(12,20,0.95669),(13,20,0.95669),(14,20,0.95669),(15,20,0.95669),(16,20,0.95669),(1,21,1.09669),(2,21,1.09669),(3,21,1.09669),(4,21,1.09669),(5,21,1.09669),(6,21,1.09669),(7,21,1.09669),(8,21,1.09669),(9,21,1.09669),(10,21,1.09669),(11,21,1.09669),(12,21,1.09669),(13,21,1.09669),(14,21,1.09669),(15,21,1.09669),(16,21,1.09669),(1,22,0.56),(2,22,0.56),(3,22,0.56),(4,22,0.56),(5,22,0.56),(6,22,0.56),(7,22,0.56),(8,22,0.56),(9,22,0.56),(10,22,0.56),(11,22,0.56),(12,22,0.56),(13,22,0.56),(14,22,0.56),(15,22,0.56),(16,22,0.56),(1,23,2.14662),(2,23,2.14662),(3,23,2.14662),(4,23,2.14662),(5,23,2.14662),(6,23,2.14662),(7,23,2.14662),(8,23,2.14662),(9,23,2.14662),(10,23,2.14662),(11,23,2.14662),(12,23,2.14662),(13,23,2.14662),(14,23,2.14662),(15,23,2.14662),(16,23,2.14662),(1,24,1.19),(2,24,1.19),(3,24,1.19),(4,24,1.19),(5,24,1.19),(6,24,1.19),(7,24,1.19),(8,24,1.19),(9,24,1.19),(10,24,1.19),(11,24,1.19),(12,24,1.19),(13,24,1.19),(14,24,1.19),(15,24,1.19),(16,24,1.19),(2,197,0.42),(3,197,0.42),(4,197,0.42),(5,197,0.42),(6,197,0.42),(7,197,0.42),(8,197,0.42),(9,197,0.42),(10,197,0.42),(11,197,0.42),(12,197,0.42),(13,197,0.42),(14,197,0.42),(15,197,0.42),(16,197,0.42),(1,197,0.42),(1,198,0.81669),(2,198,0.81669),(3,198,0.81669),(4,198,0.81669),(5,198,0.81669),(6,198,0.81669),(7,198,0.81669),(8,198,0.81669),(9,198,0.81669),(10,198,0.81669),(11,198,0.81669),(12,198,0.81669),(13,198,0.81669),(14,198,0.81669),(15,198,0.81669),(16,198,0.81669),(1,199,0.95669),(2,199,0.95669),(3,199,0.95669),(4,199,0.95669),(5,199,0.95669),(6,199,0.95669),(7,199,0.95669),(8,199,0.95669),(9,199,0.95669),(10,199,0.95669),(11,199,0.95669),(12,199,0.95669),(13,199,0.95669),(14,199,0.95669),(15,199,0.95669),(16,199,0.95669),(1,200,0.95669),(2,200,0.95669),(3,200,0.95669),(4,200,0.95669),(5,200,0.95669),(6,200,0.95669),(7,200,0.95669),(8,200,0.95669),(9,200,0.95669),(10,200,0.95669),(11,200,0.95669),(12,200,0.95669),(13,200,0.95669),(14,200,0.95669),(15,200,0.95669),(16,200,0.95669),(1,201,1.05),(2,201,1.05),(3,201,1.05),(4,201,1.05),(5,201,1.05),(6,201,1.05),(7,201,1.05),(8,201,1.05),(9,201,1.05),(10,201,1.05),(11,201,1.05),(12,201,1.05),(13,201,1.05),(14,201,1.05),(15,201,1.05),(16,201,1.05),(1,202,0.95669),(2,202,0.95669),(3,202,0.95669),(4,202,0.95669),(5,202,0.95669),(6,202,0.95669),(7,202,0.95669),(8,202,0.95669),(9,202,0.95669),(10,202,0.95669),(11,202,0.95669),(12,202,0.95669),(13,202,0.95669),(14,202,0.95669),(15,202,0.95669),(16,202,0.95669),(1,203,1.23669),(2,203,1.23669),(3,203,1.23669),(4,203,1.23669),(5,203,1.23669),(6,203,1.23669),(7,203,1.23669),(8,203,1.23669),(9,203,1.23669),(10,203,1.23669),(11,203,1.23669),(12,203,1.23669),(13,203,1.23669),(14,203,1.23669),(15,203,1.23669),(16,203,1.23669),(1,204,0.28),(2,204,0.28),(3,204,0.28),(4,204,0.28),(5,204,0.28),(6,204,0.28),(7,204,0.28),(8,204,0.28),(9,204,0.28),(10,204,0.28),(11,204,0.28),(12,204,0.28),(13,204,0.28),(14,204,0.28),(15,204,0.28),(16,204,0.28),(1,205,0.95669),(2,205,0.95669),(3,205,0.95669),(4,205,0.95669),(5,205,0.95669),(6,205,0.95669),(7,205,0.95669),(8,205,0.95669),(9,205,0.95669),(10,205,0.95669),(11,205,0.95669),(12,205,0.95669),(13,205,0.95669),(14,205,0.95669),(15,205,0.95669),(16,205,0.95669),(1,206,1.07331),(2,206,1.07331),(3,206,1.07331),(4,206,1.07331),(5,206,1.07331),(6,206,1.07331),(7,206,1.07331),(8,206,1.07331),(9,206,1.07331),(10,206,1.07331),(11,206,1.07331),(12,206,1.07331),(13,206,1.07331),(14,206,1.07331),(15,206,1.07331),(16,206,1.07331),(1,207,1.00331),(2,207,1.00331),(3,207,1.00331),(4,207,1.00331),(5,207,1.00331),(6,207,1.00331),(7,207,1.00331),(8,207,1.00331),(9,207,1.00331),(10,207,1.00331),(11,207,1.00331),(12,207,1.00331),(13,207,1.00331),(14,207,1.00331),(15,207,1.00331),(16,207,1.00331),(1,208,1.14331),(2,208,1.14331),(3,208,1.14331),(4,208,1.14331),(5,208,1.14331),(6,208,1.14331),(7,208,1.14331),(8,208,1.14331),(9,208,1.14331),(10,208,1.14331),(11,208,1.14331),(12,208,1.14331),(13,208,1.14331),(14,208,1.14331),(15,208,1.14331),(16,208,1.14331),(1,209,0.28),(2,209,0.28),(3,209,0.28),(4,209,0.28),(5,209,0.28),(6,209,0.28),(7,209,0.28),(8,209,0.28),(9,209,0.28),(10,209,0.28),(11,209,0.28),(12,209,0.28),(13,209,0.28),(14,209,0.28),(15,209,0.28),(16,209,0.28),(1,210,1.77338),(2,210,1.77338),(3,210,1.77338),(4,210,1.77338),(5,210,1.77338),(6,210,1.77338),(7,210,1.77338),(8,210,1.77338),(9,210,1.77338),(10,210,1.77338),(11,210,1.77338),(12,210,1.77338),(13,210,1.77338),(14,210,1.77338),(15,210,1.77338),(16,210,1.77338),(1,211,2.24),(2,211,2.24),(3,211,2.24),(4,211,2.24),(5,211,2.24),(6,211,2.24),(7,211,2.24),(8,211,2.24),(9,211,2.24),(10,211,2.24),(11,211,2.24),(12,211,2.24),(13,211,2.24),(14,211,2.24),(15,211,2.24),(16,211,2.24),(1,212,2.22),(1,213,5.18),(1,214,5.67321),(1,215,0.79992),(2,215,0.79992),(3,215,0.79992),(4,215,0.79992),(5,215,0.79992),(6,215,0.79992),(7,215,0.79992),(8,215,0.79992),(9,215,0.79992),(10,215,0.79992),(11,215,0.79992),(12,215,0.79992),(13,215,0.79992),(14,215,0.79992),(15,215,0.79992),(16,215,0.79992),(1,216,3.19992),(2,216,3.19992),(3,216,3.19992),(4,216,3.19992),(5,216,3.19992),(6,216,3.19992),(7,216,3.19992),(8,216,3.19992),(9,216,3.19992),(10,216,3.19992),(11,216,3.19992),(12,216,3.19992),(13,216,3.19992),(14,216,3.19992),(15,216,3.19992),(16,216,3.19992),(2,513,5.42679),(2,514,6.90679),(4,519,0.96),(5,519,0.96),(6,519,0.96),(16,519,0.96),(2,519,2.96),(9,519,2.96),(2,520,6.66),(3,528,1.23321),(6,528,1.23321),(3,529,4.44),(10,529,4.44),(3,530,4.93321),(4,570,2.00004),(5,570,2.00004),(6,570,2.00004),(16,570,2.00004),(4,571,1.48),(4,572,4.81),(4,573,5.30321),(5,599,1.48),(5,600,4.81),(5,601,5.55),(7,622,4.56321),(7,623,5.92),(7,632,2.46679),(9,655,5.55),(9,656,6.29),(9,657,1.23321),(9,658,4.81),(10,667,5.30321),(11,705,0.98679),(11,706,4.68679),(13,731,2.22),(14,743,1.48),(14,744,4.81),(14,745,5.42679),(14,746,4.56321),(14,747,5.67321),(14,753,1.48),(14,754,5.05679),(14,755,5.92),(15,758,4.31679),(15,759,5.05679),(1,787,1.21331);


--
-- Table structure for table `#__finder_links_terms1`
--



CREATE TABLE `#__finder_links_terms1` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_links_terms1`
--


INSERT INTO `#__finder_links_terms1` (`link_id`, `term_id`, `weight`) VALUES (6,620,0.17);


--
-- Table structure for table `#__finder_links_terms2`
--



CREATE TABLE `#__finder_links_terms2` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_links_terms2`
--


INSERT INTO `#__finder_links_terms2` (`link_id`, `term_id`, `weight`) VALUES (1,97,0.32669),(2,97,0.32669),(3,97,0.32669),(4,97,0.32669),(5,97,0.32669),(6,97,0.32669),(7,97,0.32669),(8,97,0.32669),(9,97,0.32669),(10,97,0.32669),(11,97,0.32669),(12,97,0.32669),(13,97,0.32669),(14,97,0.32669),(15,97,0.32669),(16,97,0.32669),(1,98,0.98),(2,98,0.98),(3,98,0.98),(4,98,0.98),(5,98,0.98),(6,98,0.98),(7,98,0.98),(8,98,0.98),(9,98,0.98),(10,98,0.98),(11,98,0.98),(12,98,0.98),(13,98,0.98),(14,98,0.98),(15,98,0.98),(16,98,0.98),(1,99,1.21331),(2,99,1.21331),(3,99,1.21331),(4,99,1.21331),(5,99,1.21331),(6,99,1.21331),(7,99,1.21331),(8,99,1.21331),(9,99,1.21331),(10,99,1.21331),(11,99,1.21331),(12,99,1.21331),(13,99,1.21331),(14,99,1.21331),(15,99,1.21331),(16,99,1.21331),(1,100,0.32669),(2,100,0.32669),(3,100,0.32669),(4,100,0.32669),(5,100,0.32669),(6,100,0.32669),(7,100,0.32669),(8,100,0.32669),(9,100,0.32669),(10,100,0.32669),(11,100,0.32669),(12,100,0.32669),(13,100,0.32669),(14,100,0.32669),(15,100,0.32669),(16,100,0.32669),(1,101,0.95669),(2,101,0.95669),(3,101,0.95669),(4,101,0.95669),(5,101,0.95669),(6,101,0.95669),(7,101,0.95669),(8,101,0.95669),(9,101,0.95669),(10,101,0.95669),(11,101,0.95669),(12,101,0.95669),(13,101,0.95669),(14,101,0.95669),(15,101,0.95669),(16,101,0.95669),(1,102,1.07331),(2,102,1.07331),(3,102,1.07331),(4,102,1.07331),(5,102,1.07331),(6,102,1.07331),(7,102,1.07331),(8,102,1.07331),(9,102,1.07331),(10,102,1.07331),(11,102,1.07331),(12,102,1.07331),(13,102,1.07331),(14,102,1.07331),(15,102,1.07331),(16,102,1.07331),(2,103,0.42),(3,103,0.42),(4,103,0.42),(5,103,0.42),(6,103,0.42),(7,103,0.42),(8,103,0.42),(9,103,0.42),(10,103,0.42),(11,103,0.42),(12,103,0.42),(13,103,0.42),(14,103,0.42),(15,103,0.42),(16,103,0.42),(1,103,0.42),(1,104,0.91),(2,104,0.91),(3,104,0.91),(4,104,0.91),(5,104,0.91),(6,104,0.91),(7,104,0.91),(8,104,0.91),(9,104,0.91),(10,104,0.91),(11,104,0.91),(12,104,0.91),(13,104,0.91),(14,104,0.91),(15,104,0.91),(16,104,0.91),(1,105,1.19),(2,105,1.19),(3,105,1.19),(4,105,1.19),(5,105,1.19),(6,105,1.19),(7,105,1.19),(8,105,1.19),(9,105,1.19),(10,105,1.19),(11,105,1.19),(12,105,1.19),(13,105,1.19),(14,105,1.19),(15,105,1.19),(16,105,1.19),(1,106,0.93331),(2,106,0.93331),(3,106,0.93331),(4,106,0.93331),(5,106,0.93331),(6,106,0.93331),(7,106,0.93331),(8,106,0.93331),(9,106,0.93331),(10,106,0.93331),(11,106,0.93331),(12,106,0.93331),(13,106,0.93331),(14,106,0.93331),(15,106,0.93331),(16,106,0.93331),(1,107,1.05),(2,107,1.05),(3,107,1.05),(4,107,1.05),(5,107,1.05),(6,107,1.05),(7,107,1.05),(8,107,1.05),(9,107,1.05),(10,107,1.05),(11,107,1.05),(12,107,1.05),(13,107,1.05),(14,107,1.05),(15,107,1.05),(16,107,1.05),(1,108,0.88669),(2,108,0.88669),(3,108,0.88669),(4,108,0.88669),(5,108,0.88669),(6,108,0.88669),(7,108,0.88669),(8,108,0.88669),(9,108,0.88669),(10,108,0.88669),(11,108,0.88669),(12,108,0.88669),(13,108,0.88669),(14,108,0.88669),(15,108,0.88669),(16,108,0.88669),(1,109,1.19),(2,109,1.19),(3,109,1.19),(4,109,1.19),(5,109,1.19),(6,109,1.19),(7,109,1.19),(8,109,1.19),(9,109,1.19),(10,109,1.19),(11,109,1.19),(12,109,1.19),(13,109,1.19),(14,109,1.19),(15,109,1.19),(16,109,1.19),(1,110,0.37331),(2,110,0.37331),(3,110,0.37331),(4,110,0.37331),(5,110,0.37331),(6,110,0.37331),(7,110,0.37331),(8,110,0.37331),(9,110,0.37331),(10,110,0.37331),(11,110,0.37331),(12,110,0.37331),(13,110,0.37331),(14,110,0.37331),(15,110,0.37331),(16,110,0.37331),(1,111,1.02669),(2,111,1.02669),(3,111,1.02669),(4,111,1.02669),(5,111,1.02669),(6,111,1.02669),(7,111,1.02669),(8,111,1.02669),(9,111,1.02669),(10,111,1.02669),(11,111,1.02669),(12,111,1.02669),(13,111,1.02669),(14,111,1.02669),(15,111,1.02669),(16,111,1.02669),(2,112,1.30669),(3,112,1.30669),(4,112,1.30669),(5,112,1.30669),(6,112,1.30669),(7,112,1.30669),(8,112,1.30669),(9,112,1.30669),(10,112,1.30669),(11,112,1.30669),(12,112,1.30669),(13,112,1.30669),(14,112,1.30669),(15,112,1.30669),(16,112,1.30669),(1,112,1.30669),(1,113,0.28),(2,113,0.28),(3,113,0.28),(4,113,0.28),(5,113,0.28),(6,113,0.28),(7,113,0.28),(8,113,0.28),(9,113,0.28),(10,113,0.28),(11,113,0.28),(12,113,0.28),(13,113,0.28),(14,113,0.28),(15,113,0.28),(16,113,0.28),(1,114,0.98),(2,114,0.98),(3,114,0.98),(4,114,0.98),(5,114,0.98),(6,114,0.98),(7,114,0.98),(8,114,0.98),(9,114,0.98),(10,114,0.98),(11,114,0.98),(12,114,0.98),(13,114,0.98),(14,114,0.98),(15,114,0.98),(16,114,0.98),(1,115,1.19),(2,115,1.19),(3,115,1.19),(4,115,1.19),(5,115,1.19),(6,115,1.19),(7,115,1.19),(8,115,1.19),(9,115,1.19),(10,115,1.19),(11,115,1.19),(12,115,1.19),(13,115,1.19),(14,115,1.19),(15,115,1.19),(16,115,1.19),(3,537,1.23321),(6,537,1.23321),(3,538,4.68679),(6,538,4.68679),(3,539,5.05679),(6,539,5.05679),(5,590,1.48),(5,591,1.23321),(5,592,4.81),(5,593,5.55),(1,793,1.39986),(1,794,5.74014),(1,795,5.48345);


--
-- Table structure for table `#__finder_links_terms3`
--



CREATE TABLE `#__finder_links_terms3` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_links_terms3`
--


INSERT INTO `#__finder_links_terms3` (`link_id`, `term_id`, `weight`) VALUES (8,637,1.23321),(8,638,5.30321),(8,639,6.29),(8,640,0.98679),(8,641,4.93321),(8,642,5.92);


--
-- Table structure for table `#__finder_links_terms4`
--



CREATE TABLE `#__finder_links_terms4` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_links_terms4`
--


INSERT INTO `#__finder_links_terms4` (`link_id`, `term_id`, `weight`) VALUES (1,25,1.53993),(2,25,1.53993),(3,25,1.53993),(4,25,1.53993),(5,25,1.53993),(6,25,1.53993),(7,25,1.53993),(8,25,1.53993),(9,25,1.53993),(10,25,1.53993),(11,25,1.53993),(12,25,1.53993),(13,25,1.53993),(14,25,1.53993),(15,25,1.53993),(16,25,1.53993),(1,26,1.05),(2,26,1.05),(3,26,1.05),(4,26,1.05),(5,26,1.05),(6,26,1.05),(7,26,1.05),(8,26,1.05),(9,26,1.05),(10,26,1.05),(11,26,1.05),(12,26,1.05),(13,26,1.05),(14,26,1.05),(15,26,1.05),(16,26,1.05),(1,27,1.12),(2,27,1.12),(3,27,1.12),(4,27,1.12),(5,27,1.12),(6,27,1.12),(7,27,1.12),(8,27,1.12),(9,27,1.12),(10,27,1.12),(11,27,1.12),(12,27,1.12),(13,27,1.12),(14,27,1.12),(15,27,1.12),(16,27,1.12),(1,28,2.19338),(2,28,2.19338),(3,28,2.19338),(4,28,2.19338),(5,28,2.19338),(6,28,2.19338),(7,28,2.19338),(8,28,2.19338),(9,28,2.19338),(10,28,2.19338),(11,28,2.19338),(12,28,2.19338),(13,28,2.19338),(14,28,2.19338),(15,28,2.19338),(16,28,2.19338),(1,29,2.38),(2,29,2.38),(3,29,2.38),(4,29,2.38),(5,29,2.38),(6,29,2.38),(7,29,2.38),(8,29,2.38),(9,29,2.38),(10,29,2.38),(11,29,2.38),(12,29,2.38),(13,29,2.38),(14,29,2.38),(15,29,2.38),(16,29,2.38),(1,30,0.56007),(2,30,0.56007),(3,30,0.56007),(4,30,0.56007),(5,30,0.56007),(6,30,0.56007),(7,30,0.56007),(8,30,0.56007),(9,30,0.56007),(10,30,0.56007),(11,30,0.56007),(12,30,0.56007),(13,30,0.56007),(14,30,0.56007),(15,30,0.56007),(16,30,0.56007),(1,31,0.88669),(2,31,0.88669),(3,31,0.88669),(4,31,0.88669),(5,31,0.88669),(6,31,0.88669),(7,31,0.88669),(8,31,0.88669),(9,31,0.88669),(10,31,0.88669),(11,31,0.88669),(12,31,0.88669),(13,31,0.88669),(14,31,0.88669),(15,31,0.88669),(16,31,0.88669),(1,32,1.02669),(2,32,1.02669),(3,32,1.02669),(4,32,1.02669),(5,32,1.02669),(6,32,1.02669),(7,32,1.02669),(8,32,1.02669),(9,32,1.02669),(10,32,1.02669),(11,32,1.02669),(12,32,1.02669),(13,32,1.02669),(14,32,1.02669),(15,32,1.02669),(16,32,1.02669),(1,33,1.91338),(2,33,1.91338),(3,33,1.91338),(4,33,1.91338),(5,33,1.91338),(6,33,1.91338),(7,33,1.91338),(8,33,1.91338),(9,33,1.91338),(10,33,1.91338),(11,33,1.91338),(12,33,1.91338),(13,33,1.91338),(14,33,1.91338),(15,33,1.91338),(16,33,1.91338),(1,34,2.47338),(2,34,2.47338),(3,34,2.47338),(4,34,2.47338),(5,34,2.47338),(6,34,2.47338),(7,34,2.47338),(8,34,2.47338),(9,34,2.47338),(10,34,2.47338),(11,34,2.47338),(12,34,2.47338),(13,34,2.47338),(14,34,2.47338),(15,34,2.47338),(16,34,2.47338),(1,189,0.69993),(2,189,0.69993),(3,189,0.69993),(4,189,0.69993),(5,189,0.69993),(6,189,0.69993),(7,189,0.69993),(8,189,0.69993),(9,189,0.69993),(10,189,0.69993),(11,189,0.69993),(12,189,0.69993),(13,189,0.69993),(14,189,0.69993),(15,189,0.69993),(16,189,0.69993),(1,190,1.86662),(2,190,1.86662),(3,190,1.86662),(4,190,1.86662),(5,190,1.86662),(6,190,1.86662),(7,190,1.86662),(8,190,1.86662),(9,190,1.86662),(10,190,1.86662),(11,190,1.86662),(12,190,1.86662),(13,190,1.86662),(14,190,1.86662),(15,190,1.86662),(16,190,1.86662),(1,191,2.1),(2,191,2.1),(3,191,2.1),(4,191,2.1),(5,191,2.1),(6,191,2.1),(7,191,2.1),(8,191,2.1),(9,191,2.1),(10,191,2.1),(11,191,2.1),(12,191,2.1),(13,191,2.1),(14,191,2.1),(15,191,2.1),(16,191,2.1),(1,192,0.91),(2,192,0.91),(3,192,0.91),(4,192,0.91),(5,192,0.91),(6,192,0.91),(7,192,0.91),(8,192,0.91),(9,192,0.91),(10,192,0.91),(11,192,0.91),(12,192,0.91),(13,192,0.91),(14,192,0.91),(15,192,0.91),(16,192,0.91),(1,193,1.02669),(2,193,1.02669),(3,193,1.02669),(4,193,1.02669),(5,193,1.02669),(6,193,1.02669),(7,193,1.02669),(8,193,1.02669),(9,193,1.02669),(10,193,1.02669),(11,193,1.02669),(12,193,1.02669),(13,193,1.02669),(14,193,1.02669),(15,193,1.02669),(16,193,1.02669),(1,194,0.28),(2,194,0.28),(3,194,0.28),(4,194,0.28),(5,194,0.28),(6,194,0.28),(7,194,0.28),(8,194,0.28),(9,194,0.28),(10,194,0.28),(11,194,0.28),(12,194,0.28),(13,194,0.28),(14,194,0.28),(15,194,0.28),(16,194,0.28),(1,195,0.95669),(2,195,0.95669),(3,195,0.95669),(4,195,0.95669),(5,195,0.95669),(6,195,0.95669),(7,195,0.95669),(8,195,0.95669),(9,195,0.95669),(10,195,0.95669),(11,195,0.95669),(12,195,0.95669),(13,195,0.95669),(14,195,0.95669),(15,195,0.95669),(16,195,0.95669),(1,196,1.05),(2,196,1.05),(3,196,1.05),(4,196,1.05),(5,196,1.05),(6,196,1.05),(7,196,1.05),(8,196,1.05),(9,196,1.05),(10,196,1.05),(11,196,1.05),(12,196,1.05),(13,196,1.05),(14,196,1.05),(15,196,1.05),(16,196,1.05),(4,569,0.56004),(5,569,0.56004),(6,569,0.56004),(16,569,0.56004),(5,597,1.23321),(5,598,5.18),(5,602,0.74),(13,602,0.74),(5,603,4.81),(5,604,5.67321),(7,624,0.63996),(8,624,0.63996),(9,624,0.63996),(10,624,0.63996),(9,651,0.17),(11,698,1.72679),(11,699,5.18),(11,700,5.67321),(12,719,0.98679),(12,720,4.81),(13,735,5.30321);


--
-- Table structure for table `#__finder_links_terms5`
--



CREATE TABLE `#__finder_links_terms5` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_links_terms5`
--




--
-- Table structure for table `#__finder_links_terms6`
--



CREATE TABLE `#__finder_links_terms6` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_links_terms6`
--


INSERT INTO `#__finder_links_terms6` (`link_id`, `term_id`, `weight`) VALUES (1,116,0.23331),(2,116,0.23331),(3,116,0.23331),(4,116,0.23331),(5,116,0.23331),(6,116,0.23331),(7,116,0.23331),(8,116,0.23331),(9,116,0.23331),(10,116,0.23331),(11,116,0.23331),(12,116,0.23331),(13,116,0.23331),(14,116,0.23331),(15,116,0.23331),(16,116,0.23331),(1,117,0.98),(2,117,0.98),(3,117,0.98),(4,117,0.98),(5,117,0.98),(6,117,0.98),(7,117,0.98),(8,117,0.98),(9,117,0.98),(10,117,0.98),(11,117,0.98),(12,117,0.98),(13,117,0.98),(14,117,0.98),(15,117,0.98),(16,117,0.98),(1,118,1.16669),(2,118,1.16669),(3,118,1.16669),(4,118,1.16669),(5,118,1.16669),(6,118,1.16669),(7,118,1.16669),(8,118,1.16669),(9,118,1.16669),(10,118,1.16669),(11,118,1.16669),(12,118,1.16669),(13,118,1.16669),(14,118,1.16669),(15,118,1.16669),(16,118,1.16669),(2,119,0.42),(3,119,0.42),(4,119,0.42),(5,119,0.42),(6,119,0.42),(7,119,0.42),(8,119,0.42),(9,119,0.42),(10,119,0.42),(11,119,0.42),(12,119,0.42),(13,119,0.42),(14,119,0.42),(15,119,0.42),(16,119,0.42),(1,119,0.42),(1,120,1.05),(2,120,1.05),(3,120,1.05),(4,120,1.05),(5,120,1.05),(6,120,1.05),(7,120,1.05),(8,120,1.05),(9,120,1.05),(10,120,1.05),(11,120,1.05),(12,120,1.05),(13,120,1.05),(14,120,1.05),(15,120,1.05),(16,120,1.05),(1,121,1.21331),(2,121,1.21331),(3,121,1.21331),(4,121,1.21331),(5,121,1.21331),(6,121,1.21331),(7,121,1.21331),(8,121,1.21331),(9,121,1.21331),(10,121,1.21331),(11,121,1.21331),(12,121,1.21331),(13,121,1.21331),(14,121,1.21331),(15,121,1.21331),(16,121,1.21331),(1,122,0.56),(2,122,0.56),(3,122,0.56),(4,122,0.56),(5,122,0.56),(6,122,0.56),(7,122,0.56),(8,122,0.56),(9,122,0.56),(10,122,0.56),(11,122,0.56),(12,122,0.56),(13,122,0.56),(14,122,0.56),(15,122,0.56),(16,122,0.56),(1,123,2.24),(2,123,2.24),(3,123,2.24),(4,123,2.24),(5,123,2.24),(6,123,2.24),(7,123,2.24),(8,123,2.24),(9,123,2.24),(10,123,2.24),(11,123,2.24),(12,123,2.24),(13,123,2.24),(14,123,2.24),(15,123,2.24),(16,123,2.24),(1,124,2.52),(2,124,2.52),(3,124,2.52),(4,124,2.52),(5,124,2.52),(6,124,2.52),(7,124,2.52),(8,124,2.52),(9,124,2.52),(10,124,2.52),(11,124,2.52),(12,124,2.52),(13,124,2.52),(14,124,2.52),(15,124,2.52),(16,124,2.52),(1,125,0.46662),(2,125,0.46662),(3,125,0.46662),(4,125,0.46662),(5,125,0.46662),(6,125,0.46662),(7,125,0.46662),(8,125,0.46662),(9,125,0.46662),(10,125,0.46662),(11,125,0.46662),(12,125,0.46662),(13,125,0.46662),(14,125,0.46662),(15,125,0.46662),(16,125,0.46662),(1,126,1.96),(2,126,1.96),(3,126,1.96),(4,126,1.96),(5,126,1.96),(6,126,1.96),(7,126,1.96),(8,126,1.96),(9,126,1.96),(10,126,1.96),(11,126,1.96),(12,126,1.96),(13,126,1.96),(14,126,1.96),(15,126,1.96),(16,126,1.96),(1,127,2.42662),(2,127,2.42662),(3,127,2.42662),(4,127,2.42662),(5,127,2.42662),(6,127,2.42662),(7,127,2.42662),(8,127,2.42662),(9,127,2.42662),(10,127,2.42662),(11,127,2.42662),(12,127,2.42662),(13,127,2.42662),(14,127,2.42662),(15,127,2.42662),(16,127,2.42662),(2,128,0.84),(3,128,0.84),(4,128,0.84),(5,128,0.84),(6,128,0.84),(7,128,0.84),(8,128,0.84),(9,128,0.84),(10,128,0.84),(11,128,0.84),(12,128,0.84),(13,128,0.84),(14,128,0.84),(15,128,0.84),(16,128,0.84),(1,128,0.84),(1,129,1.02669),(2,129,1.02669),(3,129,1.02669),(4,129,1.02669),(5,129,1.02669),(6,129,1.02669),(7,129,1.02669),(8,129,1.02669),(9,129,1.02669),(10,129,1.02669),(11,129,1.02669),(12,129,1.02669),(13,129,1.02669),(14,129,1.02669),(15,129,1.02669),(16,129,1.02669),(1,130,1.19),(2,130,1.19),(3,130,1.19),(4,130,1.19),(5,130,1.19),(6,130,1.19),(7,130,1.19),(8,130,1.19),(9,130,1.19),(10,130,1.19),(11,130,1.19),(12,130,1.19),(13,130,1.19),(14,130,1.19),(15,130,1.19),(16,130,1.19),(1,131,2.00662),(2,131,2.00662),(3,131,2.00662),(4,131,2.00662),(5,131,2.00662),(6,131,2.00662),(7,131,2.00662),(8,131,2.00662),(9,131,2.00662),(10,131,2.00662),(11,131,2.00662),(12,131,2.00662),(13,131,2.00662),(14,131,2.00662),(15,131,2.00662),(16,131,2.00662),(1,132,2.19338),(2,132,2.19338),(3,132,2.19338),(4,132,2.19338),(5,132,2.19338),(6,132,2.19338),(7,132,2.19338),(8,132,2.19338),(9,132,2.19338),(10,132,2.19338),(11,132,2.19338),(12,132,2.19338),(13,132,2.19338),(14,132,2.19338),(15,132,2.19338),(16,132,2.19338),(2,516,1.23321),(2,517,4.56321),(2,518,6.16679),(4,565,1.97321),(14,565,1.97321),(4,566,5.55),(4,567,5.92),(10,679,1.48),(10,680,1.48),(10,681,4.81),(10,682,5.55),(11,701,1.72679),(11,702,5.42679),(11,703,6.41321),(15,766,0.49321),(15,767,4.68679);


--
-- Table structure for table `#__finder_links_terms7`
--



CREATE TABLE `#__finder_links_terms7` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_links_terms7`
--


INSERT INTO `#__finder_links_terms7` (`link_id`, `term_id`, `weight`) VALUES (1,133,0.14),(2,133,0.14),(3,133,0.14),(4,133,0.14),(5,133,0.14),(6,133,0.14),(7,133,0.14),(8,133,0.14),(9,133,0.14),(10,133,0.14),(11,133,0.14),(12,133,0.14),(13,133,0.14),(14,133,0.14),(15,133,0.14),(16,133,0.14),(1,134,0.88669),(2,134,0.88669),(3,134,0.88669),(4,134,0.88669),(5,134,0.88669),(6,134,0.88669),(7,134,0.88669),(8,134,0.88669),(9,134,0.88669),(10,134,0.88669),(11,134,0.88669),(12,134,0.88669),(13,134,0.88669),(14,134,0.88669),(15,134,0.88669),(16,134,0.88669),(1,135,1.12),(2,135,1.12),(3,135,1.12),(4,135,1.12),(5,135,1.12),(6,135,1.12),(7,135,1.12),(8,135,1.12),(9,135,1.12),(10,135,1.12),(11,135,1.12),(12,135,1.12),(13,135,1.12),(14,135,1.12),(15,135,1.12),(16,135,1.12),(2,136,0.42),(3,136,0.42),(4,136,0.42),(5,136,0.42),(6,136,0.42),(7,136,0.42),(8,136,0.42),(9,136,0.42),(10,136,0.42),(11,136,0.42),(12,136,0.42),(13,136,0.42),(14,136,0.42),(15,136,0.42),(16,136,0.42),(1,136,0.42),(1,137,1.82),(2,137,1.82),(3,137,1.82),(4,137,1.82),(5,137,1.82),(6,137,1.82),(7,137,1.82),(8,137,1.82),(9,137,1.82),(10,137,1.82),(11,137,1.82),(12,137,1.82),(13,137,1.82),(14,137,1.82),(15,137,1.82),(16,137,1.82),(1,138,2.14662),(2,138,2.14662),(3,138,2.14662),(4,138,2.14662),(5,138,2.14662),(6,138,2.14662),(7,138,2.14662),(8,138,2.14662),(9,138,2.14662),(10,138,2.14662),(11,138,2.14662),(12,138,2.14662),(13,138,2.14662),(14,138,2.14662),(15,138,2.14662),(16,138,2.14662),(1,139,1.00331),(2,139,1.00331),(3,139,1.00331),(4,139,1.00331),(5,139,1.00331),(6,139,1.00331),(7,139,1.00331),(8,139,1.00331),(9,139,1.00331),(10,139,1.00331),(11,139,1.00331),(12,139,1.00331),(13,139,1.00331),(14,139,1.00331),(15,139,1.00331),(16,139,1.00331),(1,140,1.12),(2,140,1.12),(3,140,1.12),(4,140,1.12),(5,140,1.12),(6,140,1.12),(7,140,1.12),(8,140,1.12),(9,140,1.12),(10,140,1.12),(11,140,1.12),(12,140,1.12),(13,140,1.12),(14,140,1.12),(15,140,1.12),(16,140,1.12),(1,141,0.74),(1,142,4.68679),(1,143,0.69993),(2,143,0.69993),(3,143,0.69993),(4,143,0.69993),(5,143,0.69993),(6,143,0.69993),(7,143,0.69993),(8,143,0.69993),(9,143,0.69993),(10,143,0.69993),(11,143,0.69993),(12,143,0.69993),(13,143,0.69993),(14,143,0.69993),(15,143,0.69993),(16,143,0.69993),(1,144,1.02669),(2,144,1.02669),(3,144,1.02669),(4,144,1.02669),(5,144,1.02669),(6,144,1.02669),(7,144,1.02669),(8,144,1.02669),(9,144,1.02669),(10,144,1.02669),(11,144,1.02669),(12,144,1.02669),(13,144,1.02669),(14,144,1.02669),(15,144,1.02669),(16,144,1.02669),(1,145,1.14331),(2,145,1.14331),(3,145,1.14331),(4,145,1.14331),(5,145,1.14331),(6,145,1.14331),(7,145,1.14331),(8,145,1.14331),(9,145,1.14331),(10,145,1.14331),(11,145,1.14331),(12,145,1.14331),(13,145,1.14331),(14,145,1.14331),(15,145,1.14331),(16,145,1.14331),(1,146,1.82),(2,146,1.82),(3,146,1.82),(4,146,1.82),(5,146,1.82),(6,146,1.82),(7,146,1.82),(8,146,1.82),(9,146,1.82),(10,146,1.82),(11,146,1.82),(12,146,1.82),(13,146,1.82),(14,146,1.82),(15,146,1.82),(16,146,1.82),(1,147,2.1),(2,147,2.1),(3,147,2.1),(4,147,2.1),(5,147,2.1),(6,147,2.1),(7,147,2.1),(8,147,2.1),(9,147,2.1),(10,147,2.1),(11,147,2.1),(12,147,2.1),(13,147,2.1),(14,147,2.1),(15,147,2.1),(16,147,2.1),(1,148,0.56),(2,148,0.56),(3,148,0.56),(4,148,0.56),(5,148,0.56),(6,148,0.56),(7,148,0.56),(8,148,0.56),(9,148,0.56),(10,148,0.56),(11,148,0.56),(12,148,0.56),(13,148,0.56),(14,148,0.56),(15,148,0.56),(16,148,0.56),(1,149,1.91338),(2,149,1.91338),(3,149,1.91338),(4,149,1.91338),(5,149,1.91338),(6,149,1.91338),(7,149,1.91338),(8,149,1.91338),(9,149,1.91338),(10,149,1.91338),(11,149,1.91338),(12,149,1.91338),(13,149,1.91338),(14,149,1.91338),(15,149,1.91338),(16,149,1.91338),(1,150,2.19338),(2,150,2.19338),(3,150,2.19338),(4,150,2.19338),(5,150,2.19338),(6,150,2.19338),(7,150,2.19338),(8,150,2.19338),(9,150,2.19338),(10,150,2.19338),(11,150,2.19338),(12,150,2.19338),(13,150,2.19338),(14,150,2.19338),(15,150,2.19338),(16,150,2.19338),(1,151,0.18669),(2,151,0.18669),(3,151,0.18669),(4,151,0.18669),(5,151,0.18669),(6,151,0.18669),(7,151,0.18669),(8,151,0.18669),(9,151,0.18669),(10,151,0.18669),(11,151,0.18669),(12,151,0.18669),(13,151,0.18669),(14,151,0.18669),(15,151,0.18669),(16,151,0.18669),(1,152,0.93331),(2,152,0.93331),(3,152,0.93331),(4,152,0.93331),(5,152,0.93331),(6,152,0.93331),(7,152,0.93331),(8,152,0.93331),(9,152,0.93331),(10,152,0.93331),(11,152,0.93331),(12,152,0.93331),(13,152,0.93331),(14,152,0.93331),(15,152,0.93331),(16,152,0.93331),(1,153,1.12),(2,153,1.12),(3,153,1.12),(4,153,1.12),(5,153,1.12),(6,153,1.12),(7,153,1.12),(8,153,1.12),(9,153,1.12),(10,153,1.12),(11,153,1.12),(12,153,1.12),(13,153,1.12),(14,153,1.12),(15,153,1.12),(16,153,1.12),(1,181,0.37338),(2,181,0.37338),(3,181,0.37338),(4,181,0.37338),(5,181,0.37338),(6,181,0.37338),(7,181,0.37338),(8,181,0.37338),(9,181,0.37338),(10,181,0.37338),(11,181,0.37338),(12,181,0.37338),(13,181,0.37338),(14,181,0.37338),(15,181,0.37338),(16,181,0.37338),(1,182,1.09669),(2,182,1.09669),(3,182,1.09669),(4,182,1.09669),(5,182,1.09669),(6,182,1.09669),(7,182,1.09669),(8,182,1.09669),(9,182,1.09669),(10,182,1.09669),(11,182,1.09669),(12,182,1.09669),(13,182,1.09669),(14,182,1.09669),(15,182,1.09669),(16,182,1.09669),(1,183,1.26),(2,183,1.26),(3,183,1.26),(4,183,1.26),(5,183,1.26),(6,183,1.26),(7,183,1.26),(8,183,1.26),(9,183,1.26),(10,183,1.26),(11,183,1.26),(12,183,1.26),(13,183,1.26),(14,183,1.26),(15,183,1.26),(16,183,1.26),(1,184,1.02669),(2,184,1.02669),(3,184,1.02669),(4,184,1.02669),(5,184,1.02669),(6,184,1.02669),(7,184,1.02669),(8,184,1.02669),(9,184,1.02669),(10,184,1.02669),(11,184,1.02669),(12,184,1.02669),(13,184,1.02669),(14,184,1.02669),(15,184,1.02669),(16,184,1.02669),(1,185,1.28331),(2,185,1.28331),(3,185,1.28331),(4,185,1.28331),(5,185,1.28331),(6,185,1.28331),(7,185,1.28331),(8,185,1.28331),(9,185,1.28331),(10,185,1.28331),(11,185,1.28331),(12,185,1.28331),(13,185,1.28331),(14,185,1.28331),(15,185,1.28331),(16,185,1.28331),(1,186,0.37338),(2,186,0.37338),(3,186,0.37338),(4,186,0.37338),(5,186,0.37338),(6,186,0.37338),(7,186,0.37338),(8,186,0.37338),(9,186,0.37338),(10,186,0.37338),(11,186,0.37338),(12,186,0.37338),(13,186,0.37338),(14,186,0.37338),(15,186,0.37338),(16,186,0.37338),(1,187,1.86662),(2,187,1.86662),(3,187,1.86662),(4,187,1.86662),(5,187,1.86662),(6,187,1.86662),(7,187,1.86662),(8,187,1.86662),(9,187,1.86662),(10,187,1.86662),(11,187,1.86662),(12,187,1.86662),(13,187,1.86662),(14,187,1.86662),(15,187,1.86662),(16,187,1.86662),(1,188,2.1),(2,188,2.1),(3,188,2.1),(4,188,2.1),(5,188,2.1),(6,188,2.1),(7,188,2.1),(8,188,2.1),(9,188,2.1),(10,188,2.1),(11,188,2.1),(12,188,2.1),(13,188,2.1),(14,188,2.1),(15,188,2.1),(16,188,2.1),(1,225,1.02662),(2,225,1.02662),(3,225,1.02662),(4,225,1.02662),(5,225,1.02662),(6,225,1.02662),(7,225,1.02662),(8,225,1.02662),(9,225,1.02662),(10,225,1.02662),(11,225,1.02662),(12,225,1.02662),(13,225,1.02662),(14,225,1.02662),(15,225,1.02662),(16,225,1.02662),(1,226,2.19338),(2,226,2.19338),(3,226,2.19338),(4,226,2.19338),(5,226,2.19338),(6,226,2.19338),(7,226,2.19338),(8,226,2.19338),(9,226,2.19338),(10,226,2.19338),(11,226,2.19338),(12,226,2.19338),(13,226,2.19338),(14,226,2.19338),(15,226,2.19338),(16,226,2.19338),(1,227,2.38),(2,227,2.38),(3,227,2.38),(4,227,2.38),(5,227,2.38),(6,227,2.38),(7,227,2.38),(8,227,2.38),(9,227,2.38),(10,227,2.38),(11,227,2.38),(12,227,2.38),(13,227,2.38),(14,227,2.38),(15,227,2.38),(16,227,2.38),(1,228,0.37338),(2,228,0.37338),(3,228,0.37338),(4,228,0.37338),(5,228,0.37338),(6,228,0.37338),(7,228,0.37338),(8,228,0.37338),(9,228,0.37338),(10,228,0.37338),(11,228,0.37338),(12,228,0.37338),(13,228,0.37338),(14,228,0.37338),(15,228,0.37338),(16,228,0.37338),(1,229,1.91338),(2,229,1.91338),(3,229,1.91338),(4,229,1.91338),(5,229,1.91338),(6,229,1.91338),(7,229,1.91338),(8,229,1.91338),(9,229,1.91338),(10,229,1.91338),(11,229,1.91338),(12,229,1.91338),(13,229,1.91338),(14,229,1.91338),(15,229,1.91338),(16,229,1.91338),(1,230,2.24),(2,230,2.24),(3,230,2.24),(4,230,2.24),(5,230,2.24),(6,230,2.24),(7,230,2.24),(8,230,2.24),(9,230,2.24),(10,230,2.24),(11,230,2.24),(12,230,2.24),(13,230,2.24),(14,230,2.24),(15,230,2.24),(16,230,2.24),(1,231,0.64008),(2,231,0.64008),(3,231,0.64008),(4,231,0.64008),(5,231,0.64008),(6,231,0.64008),(7,231,0.64008),(8,231,0.64008),(9,231,0.64008),(10,231,0.64008),(11,231,0.64008),(12,231,0.64008),(13,231,0.64008),(14,231,0.64008),(15,231,0.64008),(16,231,0.64008),(16,781,0.49321);


--
-- Table structure for table `#__finder_links_terms8`
--



CREATE TABLE `#__finder_links_terms8` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_links_terms8`
--


INSERT INTO `#__finder_links_terms8` (`link_id`, `term_id`, `weight`) VALUES (1,35,0.18669),(2,35,0.18669),(3,35,0.18669),(4,35,0.18669),(5,35,0.18669),(6,35,0.18669),(7,35,0.18669),(8,35,0.18669),(9,35,0.18669),(10,35,0.18669),(11,35,0.18669),(12,35,0.18669),(13,35,0.18669),(14,35,0.18669),(15,35,0.18669),(16,35,0.18669),(1,36,0.88669),(2,36,0.88669),(3,36,0.88669),(4,36,0.88669),(5,36,0.88669),(6,36,0.88669),(7,36,0.88669),(8,36,0.88669),(9,36,0.88669),(10,36,0.88669),(11,36,0.88669),(12,36,0.88669),(13,36,0.88669),(14,36,0.88669),(15,36,0.88669),(16,36,0.88669),(1,37,1.12),(2,37,1.12),(3,37,1.12),(4,37,1.12),(5,37,1.12),(6,37,1.12),(7,37,1.12),(8,37,1.12),(9,37,1.12),(10,37,1.12),(11,37,1.12),(12,37,1.12),(13,37,1.12),(14,37,1.12),(15,37,1.12),(16,37,1.12),(1,38,0.46662),(2,38,0.46662),(3,38,0.46662),(4,38,0.46662),(5,38,0.46662),(6,38,0.46662),(7,38,0.46662),(8,38,0.46662),(9,38,0.46662),(10,38,0.46662),(11,38,0.46662),(12,38,0.46662),(13,38,0.46662),(14,38,0.46662),(15,38,0.46662),(16,38,0.46662),(1,39,2.19338),(2,39,2.19338),(3,39,2.19338),(4,39,2.19338),(5,39,2.19338),(6,39,2.19338),(7,39,2.19338),(8,39,2.19338),(9,39,2.19338),(10,39,2.19338),(11,39,2.19338),(12,39,2.19338),(13,39,2.19338),(14,39,2.19338),(15,39,2.19338),(16,39,2.19338),(1,40,2.47338),(2,40,2.47338),(3,40,2.47338),(4,40,2.47338),(5,40,2.47338),(6,40,2.47338),(7,40,2.47338),(8,40,2.47338),(9,40,2.47338),(10,40,2.47338),(11,40,2.47338),(12,40,2.47338),(13,40,2.47338),(14,40,2.47338),(15,40,2.47338),(16,40,2.47338),(1,41,0.28),(2,41,0.28),(3,41,0.28),(4,41,0.28),(5,41,0.28),(6,41,0.28),(7,41,0.28),(8,41,0.28),(9,41,0.28),(10,41,0.28),(11,41,0.28),(12,41,0.28),(13,41,0.28),(14,41,0.28),(15,41,0.28),(16,41,0.28),(1,42,0.88669),(2,42,0.88669),(3,42,0.88669),(4,42,0.88669),(5,42,0.88669),(6,42,0.88669),(7,42,0.88669),(8,42,0.88669),(9,42,0.88669),(10,42,0.88669),(11,42,0.88669),(12,42,0.88669),(13,42,0.88669),(14,42,0.88669),(15,42,0.88669),(16,42,0.88669),(1,43,0.93331),(2,43,0.93331),(3,43,0.93331),(4,43,0.93331),(5,43,0.93331),(6,43,0.93331),(7,43,0.93331),(8,43,0.93331),(9,43,0.93331),(10,43,0.93331),(11,43,0.93331),(12,43,0.93331),(13,43,0.93331),(14,43,0.93331),(15,43,0.93331),(16,43,0.93331),(1,44,0.91),(2,44,0.91),(3,44,0.91),(4,44,0.91),(5,44,0.91),(6,44,0.91),(7,44,0.91),(8,44,0.91),(9,44,0.91),(10,44,0.91),(11,44,0.91),(12,44,0.91),(13,44,0.91),(14,44,0.91),(15,44,0.91),(16,44,0.91),(1,45,1.07331),(2,45,1.07331),(3,45,1.07331),(4,45,1.07331),(5,45,1.07331),(6,45,1.07331),(7,45,1.07331),(8,45,1.07331),(9,45,1.07331),(10,45,1.07331),(11,45,1.07331),(12,45,1.07331),(13,45,1.07331),(14,45,1.07331),(15,45,1.07331),(16,45,1.07331),(1,46,0.37338),(2,46,0.37338),(3,46,0.37338),(4,46,0.37338),(5,46,0.37338),(6,46,0.37338),(7,46,0.37338),(8,46,0.37338),(9,46,0.37338),(10,46,0.37338),(11,46,0.37338),(12,46,0.37338),(13,46,0.37338),(14,46,0.37338),(15,46,0.37338),(16,46,0.37338),(2,47,0.84),(3,47,0.84),(4,47,0.84),(5,47,0.84),(6,47,0.84),(7,47,0.84),(8,47,0.84),(9,47,0.84),(10,47,0.84),(11,47,0.84),(12,47,0.84),(13,47,0.84),(14,47,0.84),(15,47,0.84),(16,47,0.84),(1,47,0.84),(1,48,0.98),(2,48,0.98),(3,48,0.98),(4,48,0.98),(5,48,0.98),(6,48,0.98),(7,48,0.98),(8,48,0.98),(9,48,0.98),(10,48,0.98),(11,48,0.98),(12,48,0.98),(13,48,0.98),(14,48,0.98),(15,48,0.98),(16,48,0.98),(1,49,0.88669),(2,49,0.88669),(3,49,0.88669),(4,49,0.88669),(5,49,0.88669),(6,49,0.88669),(7,49,0.88669),(8,49,0.88669),(9,49,0.88669),(10,49,0.88669),(11,49,0.88669),(12,49,0.88669),(13,49,0.88669),(14,49,0.88669),(15,49,0.88669),(16,49,0.88669),(1,50,1.07331),(2,50,1.07331),(3,50,1.07331),(4,50,1.07331),(5,50,1.07331),(6,50,1.07331),(7,50,1.07331),(8,50,1.07331),(9,50,1.07331),(10,50,1.07331),(11,50,1.07331),(12,50,1.07331),(13,50,1.07331),(14,50,1.07331),(15,50,1.07331),(16,50,1.07331),(1,71,0.37331),(2,71,0.37331),(3,71,0.37331),(4,71,0.37331),(5,71,0.37331),(6,71,0.37331),(7,71,0.37331),(8,71,0.37331),(9,71,0.37331),(10,71,0.37331),(11,71,0.37331),(12,71,0.37331),(13,71,0.37331),(14,71,0.37331),(15,71,0.37331),(16,71,0.37331),(1,72,1.00331),(2,72,1.00331),(3,72,1.00331),(4,72,1.00331),(5,72,1.00331),(6,72,1.00331),(7,72,1.00331),(8,72,1.00331),(9,72,1.00331),(10,72,1.00331),(11,72,1.00331),(12,72,1.00331),(13,72,1.00331),(14,72,1.00331),(15,72,1.00331),(16,72,1.00331),(1,73,1.09669),(2,73,1.09669),(3,73,1.09669),(4,73,1.09669),(5,73,1.09669),(6,73,1.09669),(7,73,1.09669),(8,73,1.09669),(9,73,1.09669),(10,73,1.09669),(11,73,1.09669),(12,73,1.09669),(13,73,1.09669),(14,73,1.09669),(15,73,1.09669),(16,73,1.09669),(2,74,0.84),(3,74,0.84),(4,74,0.84),(5,74,0.84),(6,74,0.84),(7,74,0.84),(8,74,0.84),(9,74,0.84),(10,74,0.84),(11,74,0.84),(12,74,0.84),(13,74,0.84),(14,74,0.84),(15,74,0.84),(16,74,0.84),(1,74,0.84),(1,75,1.05),(2,75,1.05),(3,75,1.05),(4,75,1.05),(5,75,1.05),(6,75,1.05),(7,75,1.05),(8,75,1.05),(9,75,1.05),(10,75,1.05),(11,75,1.05),(12,75,1.05),(13,75,1.05),(14,75,1.05),(15,75,1.05),(16,75,1.05),(1,76,1.19),(2,76,1.19),(3,76,1.19),(4,76,1.19),(5,76,1.19),(6,76,1.19),(7,76,1.19),(8,76,1.19),(9,76,1.19),(10,76,1.19),(11,76,1.19),(12,76,1.19),(13,76,1.19),(14,76,1.19),(15,76,1.19),(16,76,1.19),(1,77,1.07331),(2,77,1.07331),(3,77,1.07331),(4,77,1.07331),(5,77,1.07331),(6,77,1.07331),(7,77,1.07331),(8,77,1.07331),(9,77,1.07331),(10,77,1.07331),(11,77,1.07331),(12,77,1.07331),(13,77,1.07331),(14,77,1.07331),(15,77,1.07331),(16,77,1.07331),(1,78,1.19),(2,78,1.19),(3,78,1.19),(4,78,1.19),(5,78,1.19),(6,78,1.19),(7,78,1.19),(8,78,1.19),(9,78,1.19),(10,78,1.19),(11,78,1.19),(12,78,1.19),(13,78,1.19),(14,78,1.19),(15,78,1.19),(16,78,1.19),(1,79,0.32669),(2,79,0.32669),(3,79,0.32669),(4,79,0.32669),(5,79,0.32669),(6,79,0.32669),(7,79,0.32669),(8,79,0.32669),(9,79,0.32669),(10,79,0.32669),(11,79,0.32669),(12,79,0.32669),(13,79,0.32669),(14,79,0.32669),(15,79,0.32669),(16,79,0.32669),(1,80,0.98),(2,80,0.98),(3,80,0.98),(4,80,0.98),(5,80,0.98),(6,80,0.98),(7,80,0.98),(8,80,0.98),(9,80,0.98),(10,80,0.98),(11,80,0.98),(12,80,0.98),(13,80,0.98),(14,80,0.98),(15,80,0.98),(16,80,0.98),(1,81,1.07331),(2,81,1.07331),(3,81,1.07331),(4,81,1.07331),(5,81,1.07331),(6,81,1.07331),(7,81,1.07331),(8,81,1.07331),(9,81,1.07331),(10,81,1.07331),(11,81,1.07331),(12,81,1.07331),(13,81,1.07331),(14,81,1.07331),(15,81,1.07331),(16,81,1.07331),(2,82,0.84),(3,82,0.84),(4,82,0.84),(5,82,0.84),(6,82,0.84),(7,82,0.84),(8,82,0.84),(9,82,0.84),(10,82,0.84),(11,82,0.84),(12,82,0.84),(13,82,0.84),(14,82,0.84),(15,82,0.84),(16,82,0.84),(1,82,0.84),(1,83,1.02669),(2,83,1.02669),(3,83,1.02669),(4,83,1.02669),(5,83,1.02669),(6,83,1.02669),(7,83,1.02669),(8,83,1.02669),(9,83,1.02669),(10,83,1.02669),(11,83,1.02669),(12,83,1.02669),(13,83,1.02669),(14,83,1.02669),(15,83,1.02669),(16,83,1.02669),(1,84,1.19),(2,84,1.19),(3,84,1.19),(4,84,1.19),(5,84,1.19),(6,84,1.19),(7,84,1.19),(8,84,1.19),(9,84,1.19),(10,84,1.19),(11,84,1.19),(12,84,1.19),(13,84,1.19),(14,84,1.19),(15,84,1.19),(16,84,1.19),(1,87,0.32669),(2,87,0.32669),(3,87,0.32669),(4,87,0.32669),(5,87,0.32669),(6,87,0.32669),(7,87,0.32669),(8,87,0.32669),(9,87,0.32669),(10,87,0.32669),(11,87,0.32669),(12,87,0.32669),(13,87,0.32669),(14,87,0.32669),(15,87,0.32669),(16,87,0.32669),(1,88,1.05),(2,88,1.05),(3,88,1.05),(4,88,1.05),(5,88,1.05),(6,88,1.05),(7,88,1.05),(8,88,1.05),(9,88,1.05),(10,88,1.05),(11,88,1.05),(12,88,1.05),(13,88,1.05),(14,88,1.05),(15,88,1.05),(16,88,1.05),(1,89,1.21331),(2,89,1.21331),(3,89,1.21331),(4,89,1.21331),(5,89,1.21331),(6,89,1.21331),(7,89,1.21331),(8,89,1.21331),(9,89,1.21331),(10,89,1.21331),(11,89,1.21331),(12,89,1.21331),(13,89,1.21331),(14,89,1.21331),(15,89,1.21331),(16,89,1.21331),(1,90,0.6666),(2,90,0.6666),(3,90,0.6666),(4,90,0.6666),(5,90,0.6666),(6,90,0.6666),(7,90,0.6666),(8,90,0.6666),(9,90,0.6666),(10,90,0.6666),(11,90,0.6666),(12,90,0.6666),(13,90,0.6666),(14,90,0.6666),(15,90,0.6666),(16,90,0.6666),(10,91,0.49321),(1,91,0.49321),(1,92,4.44),(1,93,5.05679),(1,94,0.32004),(2,94,0.32004),(3,94,0.32004),(4,94,0.32004),(5,94,0.32004),(6,94,0.32004),(7,94,0.32004),(8,94,0.32004),(9,94,0.32004),(10,94,0.32004),(11,94,0.32004),(12,94,0.32004),(13,94,0.32004),(14,94,0.32004),(15,94,0.32004),(16,94,0.32004),(2,95,0.15996),(3,95,0.15996),(4,95,0.15996),(5,95,0.15996),(6,95,0.15996),(7,95,0.15996),(8,95,0.15996),(9,95,0.15996),(10,95,0.15996),(11,95,0.15996),(12,95,0.15996),(13,95,0.15996),(14,95,0.15996),(15,95,0.15996),(16,95,0.15996),(1,95,0.15996),(1,96,1.47996),(2,96,1.47996),(3,96,1.47996),(4,96,1.47996),(5,96,1.47996),(6,96,1.47996),(7,96,1.47996),(8,96,1.47996),(9,96,1.47996),(10,96,1.47996),(11,96,1.47996),(12,96,1.47996),(13,96,1.47996),(14,96,1.47996),(15,96,1.47996),(16,96,1.47996),(1,164,0.56),(2,164,0.56),(3,164,0.56),(4,164,0.56),(5,164,0.56),(6,164,0.56),(7,164,0.56),(8,164,0.56),(9,164,0.56),(10,164,0.56),(11,164,0.56),(12,164,0.56),(13,164,0.56),(14,164,0.56),(15,164,0.56),(16,164,0.56),(1,165,1.14331),(2,165,1.14331),(3,165,1.14331),(4,165,1.14331),(5,165,1.14331),(6,165,1.14331),(7,165,1.14331),(8,165,1.14331),(9,165,1.14331),(10,165,1.14331),(11,165,1.14331),(12,165,1.14331),(13,165,1.14331),(14,165,1.14331),(15,165,1.14331),(16,165,1.14331),(1,166,1.23669),(2,166,1.23669),(3,166,1.23669),(4,166,1.23669),(5,166,1.23669),(6,166,1.23669),(7,166,1.23669),(8,166,1.23669),(9,166,1.23669),(10,166,1.23669),(11,166,1.23669),(12,166,1.23669),(13,166,1.23669),(14,166,1.23669),(15,166,1.23669),(16,166,1.23669),(1,167,0.37331),(2,167,0.37331),(3,167,0.37331),(4,167,0.37331),(5,167,0.37331),(6,167,0.37331),(7,167,0.37331),(8,167,0.37331),(9,167,0.37331),(10,167,0.37331),(11,167,0.37331),(12,167,0.37331),(13,167,0.37331),(14,167,0.37331),(15,167,0.37331),(16,167,0.37331),(1,168,1.02669),(2,168,1.02669),(3,168,1.02669),(4,168,1.02669),(5,168,1.02669),(6,168,1.02669),(7,168,1.02669),(8,168,1.02669),(9,168,1.02669),(10,168,1.02669),(11,168,1.02669),(12,168,1.02669),(13,168,1.02669),(14,168,1.02669),(15,168,1.02669),(16,168,1.02669),(1,169,1.16669),(2,169,1.16669),(3,169,1.16669),(4,169,1.16669),(5,169,1.16669),(6,169,1.16669),(7,169,1.16669),(8,169,1.16669),(9,169,1.16669),(10,169,1.16669),(11,169,1.16669),(12,169,1.16669),(13,169,1.16669),(14,169,1.16669),(15,169,1.16669),(16,169,1.16669),(1,170,0.46662),(2,170,0.46662),(3,170,0.46662),(4,170,0.46662),(5,170,0.46662),(6,170,0.46662),(7,170,0.46662),(8,170,0.46662),(9,170,0.46662),(10,170,0.46662),(11,170,0.46662),(12,170,0.46662),(13,170,0.46662),(14,170,0.46662),(15,170,0.46662),(16,170,0.46662),(1,171,1.00331),(2,171,1.00331),(3,171,1.00331),(4,171,1.00331),(5,171,1.00331),(6,171,1.00331),(7,171,1.00331),(8,171,1.00331),(9,171,1.00331),(10,171,1.00331),(11,171,1.00331),(12,171,1.00331),(13,171,1.00331),(14,171,1.00331),(15,171,1.00331),(16,171,1.00331),(1,172,1.19),(2,172,1.19),(3,172,1.19),(4,172,1.19),(5,172,1.19),(6,172,1.19),(7,172,1.19),(8,172,1.19),(9,172,1.19),(10,172,1.19),(11,172,1.19),(12,172,1.19),(13,172,1.19),(14,172,1.19),(15,172,1.19),(16,172,1.19),(1,173,0.91),(2,173,0.91),(3,173,0.91),(4,173,0.91),(5,173,0.91),(6,173,0.91),(7,173,0.91),(8,173,0.91),(9,173,0.91),(10,173,0.91),(11,173,0.91),(12,173,0.91),(13,173,0.91),(14,173,0.91),(15,173,0.91),(16,173,0.91),(1,174,1.14331),(2,174,1.14331),(3,174,1.14331),(4,174,1.14331),(5,174,1.14331),(6,174,1.14331),(7,174,1.14331),(8,174,1.14331),(9,174,1.14331),(10,174,1.14331),(11,174,1.14331),(12,174,1.14331),(13,174,1.14331),(14,174,1.14331),(15,174,1.14331),(16,174,1.14331),(1,175,0.32669),(2,175,0.32669),(3,175,0.32669),(4,175,0.32669),(5,175,0.32669),(6,175,0.32669),(7,175,0.32669),(8,175,0.32669),(9,175,0.32669),(10,175,0.32669),(11,175,0.32669),(12,175,0.32669),(13,175,0.32669),(14,175,0.32669),(15,175,0.32669),(16,175,0.32669),(1,176,1.14331),(2,176,1.14331),(3,176,1.14331),(4,176,1.14331),(5,176,1.14331),(6,176,1.14331),(7,176,1.14331),(8,176,1.14331),(9,176,1.14331),(10,176,1.14331),(11,176,1.14331),(12,176,1.14331),(13,176,1.14331),(14,176,1.14331),(15,176,1.14331),(16,176,1.14331),(1,177,1.23669),(2,177,1.23669),(3,177,1.23669),(4,177,1.23669),(5,177,1.23669),(6,177,1.23669),(7,177,1.23669),(8,177,1.23669),(9,177,1.23669),(10,177,1.23669),(11,177,1.23669),(12,177,1.23669),(13,177,1.23669),(14,177,1.23669),(15,177,1.23669),(16,177,1.23669),(1,178,0.46662),(2,178,0.46662),(3,178,0.46662),(4,178,0.46662),(5,178,0.46662),(6,178,0.46662),(7,178,0.46662),(8,178,0.46662),(9,178,0.46662),(10,178,0.46662),(11,178,0.46662),(12,178,0.46662),(13,178,0.46662),(14,178,0.46662),(15,178,0.46662),(16,178,0.46662),(1,179,1.82),(2,179,1.82),(3,179,1.82),(4,179,1.82),(5,179,1.82),(6,179,1.82),(7,179,1.82),(8,179,1.82),(9,179,1.82),(10,179,1.82),(11,179,1.82),(12,179,1.82),(13,179,1.82),(14,179,1.82),(15,179,1.82),(16,179,1.82),(1,180,2.05338),(2,180,2.05338),(3,180,2.05338),(4,180,2.05338),(5,180,2.05338),(6,180,2.05338),(7,180,2.05338),(8,180,2.05338),(9,180,2.05338),(10,180,2.05338),(11,180,2.05338),(12,180,2.05338),(13,180,2.05338),(14,180,2.05338),(15,180,2.05338),(16,180,2.05338),(2,515,2.71321),(3,533,0.24),(11,533,0.24),(12,533,0.24),(13,533,0.24),(9,533,0.74),(15,533,0.74),(3,543,0.39996),(11,543,0.39996),(12,543,0.39996),(13,543,0.39996),(3,544,1.52004),(11,544,1.52004),(12,544,1.52004),(13,544,1.52004),(3,545,1.68),(11,545,1.68),(12,545,1.68),(13,545,1.68),(4,562,0.49321),(12,562,0.49321),(16,562,0.49321),(4,563,4.44),(16,563,4.44),(4,564,5.05679),(4,568,0.98679),(14,568,0.98679),(7,621,0.17),(7,629,1.72679),(7,630,5.55),(7,631,5.79679),(8,643,1.72679),(8,644,1.72679),(8,645,5.55),(10,677,4.68679),(10,678,5.18),(11,704,0.74),(12,713,0.98679),(12,714,4.56321),(12,715,5.18),(13,728,0.49321),(13,729,4.44),(13,730,5.67321),(14,751,5.05679),(14,752,5.42679),(15,761,4.44),(15,762,4.81),(15,763,1.48),(15,764,5.42679),(15,765,5.92),(16,779,4.81),(1,788,1.05),(1,789,1.19),(1,790,1.39986),(1,791,4.78345),(1,792,5.48345);


--
-- Table structure for table `#__finder_links_terms9`
--



CREATE TABLE `#__finder_links_terms9` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_links_terms9`
--


INSERT INTO `#__finder_links_terms9` (`link_id`, `term_id`, `weight`) VALUES (1,232,0.28),(2,232,0.28),(3,232,0.28),(4,232,0.28),(5,232,0.28),(6,232,0.28),(7,232,0.28),(8,232,0.28),(9,232,0.28),(10,232,0.28),(11,232,0.28),(12,232,0.28),(13,232,0.28),(14,232,0.28),(15,232,0.28),(16,232,0.28),(2,233,1.68),(3,233,1.68),(4,233,1.68),(5,233,1.68),(6,233,1.68),(7,233,1.68),(8,233,1.68),(9,233,1.68),(10,233,1.68),(11,233,1.68),(12,233,1.68),(13,233,1.68),(14,233,1.68),(15,233,1.68),(16,233,1.68),(1,233,1.68),(1,234,1.86662),(2,234,1.86662),(3,234,1.86662),(4,234,1.86662),(5,234,1.86662),(6,234,1.86662),(7,234,1.86662),(8,234,1.86662),(9,234,1.86662),(10,234,1.86662),(11,234,1.86662),(12,234,1.86662),(13,234,1.86662),(14,234,1.86662),(15,234,1.86662),(16,234,1.86662),(1,235,0.46662),(2,235,0.46662),(3,235,0.46662),(4,235,0.46662),(5,235,0.46662),(6,235,0.46662),(7,235,0.46662),(8,235,0.46662),(9,235,0.46662),(10,235,0.46662),(11,235,0.46662),(12,235,0.46662),(13,235,0.46662),(14,235,0.46662),(15,235,0.46662),(16,235,0.46662),(1,236,0.98),(2,236,0.98),(3,236,0.98),(4,236,0.98),(5,236,0.98),(6,236,0.98),(7,236,0.98),(8,236,0.98),(9,236,0.98),(10,236,0.98),(11,236,0.98),(12,236,0.98),(13,236,0.98),(14,236,0.98),(15,236,0.98),(16,236,0.98),(1,237,1.12),(2,237,1.12),(3,237,1.12),(4,237,1.12),(5,237,1.12),(6,237,1.12),(7,237,1.12),(8,237,1.12),(9,237,1.12),(10,237,1.12),(11,237,1.12),(12,237,1.12),(13,237,1.12),(14,237,1.12),(15,237,1.12),(16,237,1.12),(1,238,0.95669),(2,238,0.95669),(3,238,0.95669),(4,238,0.95669),(5,238,0.95669),(6,238,0.95669),(7,238,0.95669),(8,238,0.95669),(9,238,0.95669),(10,238,0.95669),(11,238,0.95669),(12,238,0.95669),(13,238,0.95669),(14,238,0.95669),(15,238,0.95669),(16,238,0.95669),(1,239,1.07331),(2,239,1.07331),(3,239,1.07331),(4,239,1.07331),(5,239,1.07331),(6,239,1.07331),(7,239,1.07331),(8,239,1.07331),(9,239,1.07331),(10,239,1.07331),(11,239,1.07331),(12,239,1.07331),(13,239,1.07331),(14,239,1.07331),(15,239,1.07331),(16,239,1.07331),(2,240,0.42),(3,240,0.42),(4,240,0.42),(5,240,0.42),(6,240,0.42),(7,240,0.42),(8,240,0.42),(9,240,0.42),(10,240,0.42),(11,240,0.42),(12,240,0.42),(13,240,0.42),(14,240,0.42),(15,240,0.42),(16,240,0.42),(1,240,0.42),(1,241,1.16669),(2,241,1.16669),(3,241,1.16669),(4,241,1.16669),(5,241,1.16669),(6,241,1.16669),(7,241,1.16669),(8,241,1.16669),(9,241,1.16669),(10,241,1.16669),(11,241,1.16669),(12,241,1.16669),(13,241,1.16669),(14,241,1.16669),(15,241,1.16669),(16,241,1.16669),(1,242,1.26),(2,242,1.26),(3,242,1.26),(4,242,1.26),(5,242,1.26),(6,242,1.26),(7,242,1.26),(8,242,1.26),(9,242,1.26),(10,242,1.26),(11,242,1.26),(12,242,1.26),(13,242,1.26),(14,242,1.26),(15,242,1.26),(16,242,1.26),(1,243,0.93338),(2,243,0.93338),(3,243,0.93338),(4,243,0.93338),(5,243,0.93338),(6,243,0.93338),(7,243,0.93338),(8,243,0.93338),(9,243,0.93338),(10,243,0.93338),(11,243,0.93338),(12,243,0.93338),(13,243,0.93338),(14,243,0.93338),(15,243,0.93338),(16,243,0.93338),(1,244,1.02669),(2,244,1.02669),(3,244,1.02669),(4,244,1.02669),(5,244,1.02669),(6,244,1.02669),(7,244,1.02669),(8,244,1.02669),(9,244,1.02669),(10,244,1.02669),(11,244,1.02669),(12,244,1.02669),(13,244,1.02669),(14,244,1.02669),(15,244,1.02669),(16,244,1.02669),(1,245,1.21331),(2,245,1.21331),(3,245,1.21331),(4,245,1.21331),(5,245,1.21331),(6,245,1.21331),(7,245,1.21331),(8,245,1.21331),(9,245,1.21331),(10,245,1.21331),(11,245,1.21331),(12,245,1.21331),(13,245,1.21331),(14,245,1.21331),(15,245,1.21331),(16,245,1.21331),(1,246,1.07331),(2,246,1.07331),(3,246,1.07331),(4,246,1.07331),(5,246,1.07331),(6,246,1.07331),(7,246,1.07331),(8,246,1.07331),(9,246,1.07331),(10,246,1.07331),(11,246,1.07331),(12,246,1.07331),(13,246,1.07331),(14,246,1.07331),(15,246,1.07331),(16,246,1.07331),(1,247,1.19),(2,247,1.19),(3,247,1.19),(4,247,1.19),(5,247,1.19),(6,247,1.19),(7,247,1.19),(8,247,1.19),(9,247,1.19),(10,247,1.19),(11,247,1.19),(12,247,1.19),(13,247,1.19),(14,247,1.19),(15,247,1.19),(16,247,1.19),(1,248,1.16655),(2,248,1.16655),(3,248,1.16655),(4,248,1.16655),(5,248,1.16655),(6,248,1.16655),(7,248,1.16655),(8,248,1.16655),(9,248,1.16655),(10,248,1.16655),(11,248,1.16655),(12,248,1.16655),(13,248,1.16655),(14,248,1.16655),(15,248,1.16655),(16,248,1.16655),(1,249,0.95669),(2,249,0.95669),(3,249,0.95669),(4,249,0.95669),(5,249,0.95669),(6,249,0.95669),(7,249,0.95669),(8,249,0.95669),(9,249,0.95669),(10,249,0.95669),(11,249,0.95669),(12,249,0.95669),(13,249,0.95669),(14,249,0.95669),(15,249,0.95669),(16,249,0.95669),(1,250,1.16669),(2,250,1.16669),(3,250,1.16669),(4,250,1.16669),(5,250,1.16669),(6,250,1.16669),(7,250,1.16669),(8,250,1.16669),(9,250,1.16669),(10,250,1.16669),(11,250,1.16669),(12,250,1.16669),(13,250,1.16669),(14,250,1.16669),(15,250,1.16669),(16,250,1.16669),(1,251,0.93331),(2,251,0.93331),(3,251,0.93331),(4,251,0.93331),(5,251,0.93331),(6,251,0.93331),(7,251,0.93331),(8,251,0.93331),(9,251,0.93331),(10,251,0.93331),(11,251,0.93331),(12,251,0.93331),(13,251,0.93331),(14,251,0.93331),(15,251,0.93331),(16,251,0.93331),(1,252,1.07331),(2,252,1.07331),(3,252,1.07331),(4,252,1.07331),(5,252,1.07331),(6,252,1.07331),(7,252,1.07331),(8,252,1.07331),(9,252,1.07331),(10,252,1.07331),(11,252,1.07331),(12,252,1.07331),(13,252,1.07331),(14,252,1.07331),(15,252,1.07331),(16,252,1.07331),(1,253,0.93331),(2,253,0.93331),(3,253,0.93331),(4,253,0.93331),(5,253,0.93331),(6,253,0.93331),(7,253,0.93331),(8,253,0.93331),(9,253,0.93331),(10,253,0.93331),(11,253,0.93331),(12,253,0.93331),(13,253,0.93331),(14,253,0.93331),(15,253,0.93331),(16,253,0.93331),(1,254,1.07331),(2,254,1.07331),(3,254,1.07331),(4,254,1.07331),(5,254,1.07331),(6,254,1.07331),(7,254,1.07331),(8,254,1.07331),(9,254,1.07331),(10,254,1.07331),(11,254,1.07331),(12,254,1.07331),(13,254,1.07331),(14,254,1.07331),(15,254,1.07331),(16,254,1.07331),(1,255,1.21331),(2,255,1.21331),(3,255,1.21331),(4,255,1.21331),(5,255,1.21331),(6,255,1.21331),(7,255,1.21331),(8,255,1.21331),(9,255,1.21331),(10,255,1.21331),(11,255,1.21331),(12,255,1.21331),(13,255,1.21331),(14,255,1.21331),(15,255,1.21331),(16,255,1.21331),(1,256,1.02669),(2,256,1.02669),(3,256,1.02669),(4,256,1.02669),(5,256,1.02669),(6,256,1.02669),(7,256,1.02669),(8,256,1.02669),(9,256,1.02669),(10,256,1.02669),(11,256,1.02669),(12,256,1.02669),(13,256,1.02669),(14,256,1.02669),(15,256,1.02669),(16,256,1.02669),(1,257,1.16669),(2,257,1.16669),(3,257,1.16669),(4,257,1.16669),(5,257,1.16669),(6,257,1.16669),(7,257,1.16669),(8,257,1.16669),(9,257,1.16669),(10,257,1.16669),(11,257,1.16669),(12,257,1.16669),(13,257,1.16669),(14,257,1.16669),(15,257,1.16669),(16,257,1.16669),(1,258,0.37331),(2,258,0.37331),(3,258,0.37331),(4,258,0.37331),(5,258,0.37331),(6,258,0.37331),(7,258,0.37331),(8,258,0.37331),(9,258,0.37331),(10,258,0.37331),(11,258,0.37331),(12,258,0.37331),(13,258,0.37331),(14,258,0.37331),(15,258,0.37331),(16,258,0.37331),(1,259,1.02669),(2,259,1.02669),(3,259,1.02669),(4,259,1.02669),(5,259,1.02669),(6,259,1.02669),(7,259,1.02669),(8,259,1.02669),(9,259,1.02669),(10,259,1.02669),(11,259,1.02669),(12,259,1.02669),(13,259,1.02669),(14,259,1.02669),(15,259,1.02669),(16,259,1.02669),(1,260,1.28331),(2,260,1.28331),(3,260,1.28331),(4,260,1.28331),(5,260,1.28331),(6,260,1.28331),(7,260,1.28331),(8,260,1.28331),(9,260,1.28331),(10,260,1.28331),(11,260,1.28331),(12,260,1.28331),(13,260,1.28331),(14,260,1.28331),(15,260,1.28331),(16,260,1.28331),(3,531,0.49321),(6,531,0.49321),(3,532,4.68679),(6,532,4.68679),(4,559,0.98679),(14,559,0.98679),(4,560,5.30321),(14,560,5.30321),(4,561,6.16679),(10,668,0.74),(10,669,4.44),(10,670,4.93321),(10,671,1.23321),(10,672,5.18),(10,673,5.55),(15,760,1.23321),(16,773,1.48),(16,774,4.81),(16,775,5.30321);


--
-- Table structure for table `#__finder_links_termsa`
--



CREATE TABLE `#__finder_links_termsa` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_links_termsa`
--


INSERT INTO `#__finder_links_termsa` (`link_id`, `term_id`, `weight`) VALUES (4,558,0.17);


--
-- Table structure for table `#__finder_links_termsb`
--



CREATE TABLE `#__finder_links_termsb` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_links_termsb`
--


INSERT INTO `#__finder_links_termsb` (`link_id`, `term_id`, `weight`) VALUES (1,85,0.32004),(2,85,0.32004),(14,85,0.32004),(15,85,0.32004),(2,86,1.83996),(14,86,1.83996),(15,86,1.83996),(1,86,1.83996),(7,627,1.23321),(7,628,5.67321),(10,674,1.23321),(10,675,4.81),(10,676,5.18),(16,776,0.49321),(16,777,4.81),(16,778,5.18);


--
-- Table structure for table `#__finder_links_termsc`
--



CREATE TABLE `#__finder_links_termsc` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_links_termsc`
--


INSERT INTO `#__finder_links_termsc` (`link_id`, `term_id`, `weight`) VALUES (1,2,0.17),(2,512,0.17),(8,636,0.17),(10,666,0.34),(11,697,0.34),(12,712,0.34),(13,727,0.34),(14,742,0.34),(15,757,0.34),(16,772,0.34);


--
-- Table structure for table `#__finder_links_termsd`
--



CREATE TABLE `#__finder_links_termsd` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_links_termsd`
--


INSERT INTO `#__finder_links_termsd` (`link_id`, `term_id`, `weight`) VALUES (1,1,0),(2,1,0),(3,1,0),(4,1,0),(5,1,0),(6,1,0),(7,1,0),(8,1,0),(9,1,0),(10,1,0),(11,1,0),(12,1,0),(13,1,0),(14,1,0),(15,1,0),(16,1,0),(1,154,0.18669),(2,154,0.18669),(3,154,0.18669),(4,154,0.18669),(5,154,0.18669),(6,154,0.18669),(7,154,0.18669),(8,154,0.18669),(9,154,0.18669),(10,154,0.18669),(11,154,0.18669),(12,154,0.18669),(13,154,0.18669),(14,154,0.18669),(15,154,0.18669),(16,154,0.18669),(1,155,1.00331),(2,155,1.00331),(3,155,1.00331),(4,155,1.00331),(5,155,1.00331),(6,155,1.00331),(7,155,1.00331),(8,155,1.00331),(9,155,1.00331),(10,155,1.00331),(11,155,1.00331),(12,155,1.00331),(13,155,1.00331),(14,155,1.00331),(15,155,1.00331),(16,155,1.00331),(1,156,1.14331),(2,156,1.14331),(3,156,1.14331),(4,156,1.14331),(5,156,1.14331),(6,156,1.14331),(7,156,1.14331),(8,156,1.14331),(9,156,1.14331),(10,156,1.14331),(11,156,1.14331),(12,156,1.14331),(13,156,1.14331),(14,156,1.14331),(15,156,1.14331),(16,156,1.14331),(1,157,0.98679),(1,158,0.18669),(2,158,0.18669),(3,158,0.18669),(4,158,0.18669),(5,158,0.18669),(6,158,0.18669),(7,158,0.18669),(8,158,0.18669),(9,158,0.18669),(10,158,0.18669),(11,158,0.18669),(12,158,0.18669),(13,158,0.18669),(14,158,0.18669),(15,158,0.18669),(16,158,0.18669),(2,159,0.84),(3,159,0.84),(4,159,0.84),(5,159,0.84),(6,159,0.84),(7,159,0.84),(8,159,0.84),(9,159,0.84),(10,159,0.84),(11,159,0.84),(12,159,0.84),(13,159,0.84),(14,159,0.84),(15,159,0.84),(16,159,0.84),(1,159,0.84),(1,160,0.93331),(2,160,0.93331),(3,160,0.93331),(4,160,0.93331),(5,160,0.93331),(6,160,0.93331),(7,160,0.93331),(8,160,0.93331),(9,160,0.93331),(10,160,0.93331),(11,160,0.93331),(12,160,0.93331),(13,160,0.93331),(14,160,0.93331),(15,160,0.93331),(16,160,0.93331),(1,161,1.12),(2,161,1.12),(3,161,1.12),(4,161,1.12),(5,161,1.12),(6,161,1.12),(7,161,1.12),(8,161,1.12),(9,161,1.12),(10,161,1.12),(11,161,1.12),(12,161,1.12),(13,161,1.12),(14,161,1.12),(15,161,1.12),(16,161,1.12),(1,162,1.86662),(2,162,1.86662),(3,162,1.86662),(4,162,1.86662),(5,162,1.86662),(6,162,1.86662),(7,162,1.86662),(8,162,1.86662),(9,162,1.86662),(10,162,1.86662),(11,162,1.86662),(12,162,1.86662),(13,162,1.86662),(14,162,1.86662),(15,162,1.86662),(16,162,1.86662),(1,163,2.00662),(2,163,2.00662),(3,163,2.00662),(4,163,2.00662),(5,163,2.00662),(6,163,2.00662),(7,163,2.00662),(8,163,2.00662),(9,163,2.00662),(10,163,2.00662),(11,163,2.00662),(12,163,2.00662),(13,163,2.00662),(14,163,2.00662),(15,163,2.00662),(16,163,2.00662),(3,540,0.15996),(11,540,0.15996),(12,540,0.15996),(13,540,0.15996),(3,541,1.44),(11,541,1.44),(12,541,1.44),(13,541,1.44),(3,542,1.59996),(11,542,1.59996),(12,542,1.59996),(13,542,1.59996),(5,594,0.49321),(5,595,4.68679),(5,596,5.18),(9,652,0.49321),(9,653,4.68679),(9,654,5.18),(15,768,1.72679),(15,769,5.05679),(15,770,5.42679);


--
-- Table structure for table `#__finder_links_termse`
--



CREATE TABLE `#__finder_links_termse` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_links_termse`
--


INSERT INTO `#__finder_links_termse` (`link_id`, `term_id`, `weight`) VALUES (1,51,0.37338),(2,51,0.37338),(3,51,0.37338),(4,51,0.37338),(5,51,0.37338),(6,51,0.37338),(7,51,0.37338),(8,51,0.37338),(9,51,0.37338),(10,51,0.37338),(11,51,0.37338),(12,51,0.37338),(13,51,0.37338),(14,51,0.37338),(15,51,0.37338),(16,51,0.37338),(1,52,1.82),(2,52,1.82),(3,52,1.82),(4,52,1.82),(5,52,1.82),(6,52,1.82),(7,52,1.82),(8,52,1.82),(9,52,1.82),(10,52,1.82),(11,52,1.82),(12,52,1.82),(13,52,1.82),(14,52,1.82),(15,52,1.82),(16,52,1.82),(1,53,2.14662),(2,53,2.14662),(3,53,2.14662),(4,53,2.14662),(5,53,2.14662),(6,53,2.14662),(7,53,2.14662),(8,53,2.14662),(9,53,2.14662),(10,53,2.14662),(11,53,2.14662),(12,53,2.14662),(13,53,2.14662),(14,53,2.14662),(15,53,2.14662),(16,53,2.14662),(1,54,0.18669),(2,54,0.18669),(3,54,0.18669),(4,54,0.18669),(5,54,0.18669),(6,54,0.18669),(7,54,0.18669),(8,54,0.18669),(9,54,0.18669),(10,54,0.18669),(11,54,0.18669),(12,54,0.18669),(13,54,0.18669),(14,54,0.18669),(15,54,0.18669),(16,54,0.18669),(1,55,1.02669),(2,55,1.02669),(3,55,1.02669),(4,55,1.02669),(5,55,1.02669),(6,55,1.02669),(7,55,1.02669),(8,55,1.02669),(9,55,1.02669),(10,55,1.02669),(11,55,1.02669),(12,55,1.02669),(13,55,1.02669),(14,55,1.02669),(15,55,1.02669),(16,55,1.02669),(1,56,1.21331),(2,56,1.21331),(3,56,1.21331),(4,56,1.21331),(5,56,1.21331),(6,56,1.21331),(7,56,1.21331),(8,56,1.21331),(9,56,1.21331),(10,56,1.21331),(11,56,1.21331),(12,56,1.21331),(13,56,1.21331),(14,56,1.21331),(15,56,1.21331),(16,56,1.21331),(1,57,0.14),(2,57,0.14),(3,57,0.14),(4,57,0.14),(5,57,0.14),(6,57,0.14),(7,57,0.14),(8,57,0.14),(9,57,0.14),(10,57,0.14),(11,57,0.14),(12,57,0.14),(13,57,0.14),(14,57,0.14),(15,57,0.14),(16,57,0.14),(2,58,0.84),(3,58,0.84),(4,58,0.84),(5,58,0.84),(6,58,0.84),(7,58,0.84),(8,58,0.84),(9,58,0.84),(10,58,0.84),(11,58,0.84),(12,58,0.84),(13,58,0.84),(14,58,0.84),(15,58,0.84),(16,58,0.84),(1,58,0.84),(1,59,1.05),(2,59,1.05),(3,59,1.05),(4,59,1.05),(5,59,1.05),(6,59,1.05),(7,59,1.05),(8,59,1.05),(9,59,1.05),(10,59,1.05),(11,59,1.05),(12,59,1.05),(13,59,1.05),(14,59,1.05),(15,59,1.05),(16,59,1.05),(1,60,0.23331),(2,60,0.23331),(3,60,0.23331),(4,60,0.23331),(5,60,0.23331),(6,60,0.23331),(7,60,0.23331),(8,60,0.23331),(9,60,0.23331),(10,60,0.23331),(11,60,0.23331),(12,60,0.23331),(13,60,0.23331),(14,60,0.23331),(15,60,0.23331),(16,60,0.23331),(1,61,0.95669),(2,61,0.95669),(3,61,0.95669),(4,61,0.95669),(5,61,0.95669),(6,61,0.95669),(7,61,0.95669),(8,61,0.95669),(9,61,0.95669),(10,61,0.95669),(11,61,0.95669),(12,61,0.95669),(13,61,0.95669),(14,61,0.95669),(15,61,0.95669),(16,61,0.95669),(1,62,1.05),(2,62,1.05),(3,62,1.05),(4,62,1.05),(5,62,1.05),(6,62,1.05),(7,62,1.05),(8,62,1.05),(9,62,1.05),(10,62,1.05),(11,62,1.05),(12,62,1.05),(13,62,1.05),(14,62,1.05),(15,62,1.05),(16,62,1.05),(1,63,0.27993),(2,63,0.27993),(3,63,0.27993),(4,63,0.27993),(5,63,0.27993),(6,63,0.27993),(7,63,0.27993),(8,63,0.27993),(9,63,0.27993),(10,63,0.27993),(11,63,0.27993),(12,63,0.27993),(13,63,0.27993),(14,63,0.27993),(15,63,0.27993),(16,63,0.27993),(1,64,2.52),(2,64,2.52),(3,64,2.52),(4,64,2.52),(5,64,2.52),(6,64,2.52),(7,64,2.52),(8,64,2.52),(9,64,2.52),(10,64,2.52),(11,64,2.52),(12,64,2.52),(13,64,2.52),(14,64,2.52),(15,64,2.52),(16,64,2.52),(1,65,0.98),(2,65,0.98),(3,65,0.98),(4,65,0.98),(5,65,0.98),(6,65,0.98),(7,65,0.98),(8,65,0.98),(9,65,0.98),(10,65,0.98),(11,65,0.98),(12,65,0.98),(13,65,0.98),(14,65,0.98),(15,65,0.98),(16,65,0.98),(1,66,1.00331),(2,66,1.00331),(3,66,1.00331),(4,66,1.00331),(5,66,1.00331),(6,66,1.00331),(7,66,1.00331),(8,66,1.00331),(9,66,1.00331),(10,66,1.00331),(11,66,1.00331),(12,66,1.00331),(13,66,1.00331),(14,66,1.00331),(15,66,1.00331),(16,66,1.00331),(1,67,0.95669),(2,67,0.95669),(3,67,0.95669),(4,67,0.95669),(5,67,0.95669),(6,67,0.95669),(7,67,0.95669),(8,67,0.95669),(9,67,0.95669),(10,67,0.95669),(11,67,0.95669),(12,67,0.95669),(13,67,0.95669),(14,67,0.95669),(15,67,0.95669),(16,67,0.95669),(1,68,0.32669),(2,68,0.32669),(3,68,0.32669),(4,68,0.32669),(5,68,0.32669),(6,68,0.32669),(7,68,0.32669),(8,68,0.32669),(9,68,0.32669),(10,68,0.32669),(11,68,0.32669),(12,68,0.32669),(13,68,0.32669),(14,68,0.32669),(15,68,0.32669),(16,68,0.32669),(1,69,1.02669),(2,69,1.02669),(3,69,1.02669),(4,69,1.02669),(5,69,1.02669),(6,69,1.02669),(7,69,1.02669),(8,69,1.02669),(9,69,1.02669),(10,69,1.02669),(11,69,1.02669),(12,69,1.02669),(13,69,1.02669),(14,69,1.02669),(15,69,1.02669),(16,69,1.02669),(1,70,1.09669),(2,70,1.09669),(3,70,1.09669),(4,70,1.09669),(5,70,1.09669),(6,70,1.09669),(7,70,1.09669),(8,70,1.09669),(9,70,1.09669),(10,70,1.09669),(11,70,1.09669),(12,70,1.09669),(13,70,1.09669),(14,70,1.09669),(15,70,1.09669),(16,70,1.09669),(1,217,0.28),(2,217,0.28),(3,217,0.28),(4,217,0.28),(5,217,0.28),(6,217,0.28),(7,217,0.28),(8,217,0.28),(9,217,0.28),(10,217,0.28),(11,217,0.28),(12,217,0.28),(13,217,0.28),(14,217,0.28),(15,217,0.28),(16,217,0.28),(1,218,1.00331),(2,218,1.00331),(3,218,1.00331),(4,218,1.00331),(5,218,1.00331),(6,218,1.00331),(7,218,1.00331),(8,218,1.00331),(9,218,1.00331),(10,218,1.00331),(11,218,1.00331),(12,218,1.00331),(13,218,1.00331),(14,218,1.00331),(15,218,1.00331),(16,218,1.00331),(1,219,1.12),(2,219,1.12),(3,219,1.12),(4,219,1.12),(5,219,1.12),(6,219,1.12),(7,219,1.12),(8,219,1.12),(9,219,1.12),(10,219,1.12),(11,219,1.12),(12,219,1.12),(13,219,1.12),(14,219,1.12),(15,219,1.12),(16,219,1.12),(2,220,0.84),(3,220,0.84),(4,220,0.84),(5,220,0.84),(6,220,0.84),(7,220,0.84),(8,220,0.84),(9,220,0.84),(10,220,0.84),(11,220,0.84),(12,220,0.84),(13,220,0.84),(14,220,0.84),(15,220,0.84),(16,220,0.84),(1,220,0.84),(1,221,1.09669),(2,221,1.09669),(3,221,1.09669),(4,221,1.09669),(5,221,1.09669),(6,221,1.09669),(7,221,1.09669),(8,221,1.09669),(9,221,1.09669),(10,221,1.09669),(11,221,1.09669),(12,221,1.09669),(13,221,1.09669),(14,221,1.09669),(15,221,1.09669),(16,221,1.09669),(1,222,1.21331),(2,222,1.21331),(3,222,1.21331),(4,222,1.21331),(5,222,1.21331),(6,222,1.21331),(7,222,1.21331),(8,222,1.21331),(9,222,1.21331),(10,222,1.21331),(11,222,1.21331),(12,222,1.21331),(13,222,1.21331),(14,222,1.21331),(15,222,1.21331),(16,222,1.21331),(1,223,1.02669),(2,223,1.02669),(3,223,1.02669),(4,223,1.02669),(5,223,1.02669),(6,223,1.02669),(7,223,1.02669),(8,223,1.02669),(9,223,1.02669),(10,223,1.02669),(11,223,1.02669),(12,223,1.02669),(13,223,1.02669),(14,223,1.02669),(15,223,1.02669),(16,223,1.02669),(1,224,1.23669),(2,224,1.23669),(3,224,1.23669),(4,224,1.23669),(5,224,1.23669),(6,224,1.23669),(7,224,1.23669),(8,224,1.23669),(9,224,1.23669),(10,224,1.23669),(11,224,1.23669),(12,224,1.23669),(13,224,1.23669),(14,224,1.23669),(15,224,1.23669),(16,224,1.23669),(3,527,0.17),(3,534,0.74),(3,535,4.81),(3,536,5.18),(11,546,0.24),(12,546,0.24),(13,546,0.24),(4,546,0.74),(10,546,0.74),(16,546,0.74),(3,546,0.98),(3,547,1.47996),(11,547,1.47996),(12,547,1.47996),(13,547,1.47996),(3,548,4.56321),(3,549,5.30321),(3,550,0.49321),(6,550,0.49321),(3,551,4.31679),(6,551,4.31679),(3,552,5.05679),(6,552,5.05679),(4,574,4.68679),(5,589,0.17),(7,625,0.39996),(8,625,0.39996),(9,625,0.39996),(10,625,0.39996),(7,626,1.76004),(8,626,1.76004),(9,626,1.76004),(10,626,1.76004),(10,683,4.93321),(12,716,1.97321),(12,717,5.05679),(12,718,5.67321),(14,748,1.23321),(14,749,5.18),(14,750,5.79679),(16,780,4.44);


--
-- Table structure for table `#__finder_links_termsf`
--



CREATE TABLE `#__finder_links_termsf` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_links_termsf`
--


INSERT INTO `#__finder_links_termsf` (`link_id`, `term_id`, `weight`) VALUES (2,521,0.98679),(2,522,4.93321),(2,523,5.18),(7,633,1.72679),(7,634,4.81),(7,635,5.55),(11,707,1.48),(11,708,5.42679),(11,709,6.04321),(13,732,0.74),(13,733,4.44),(13,734,4.93321);


--
-- Table structure for table `#__finder_taxonomy`
--



CREATE TABLE `#__finder_taxonomy` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0',
  `title` varchar(255) NOT NULL,
  `state` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `access` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `ordering` tinyint(1) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `parent_id` (`parent_id`),
  KEY `state` (`state`),
  KEY `ordering` (`ordering`),
  KEY `access` (`access`),
  KEY `idx_parent_published` (`parent_id`,`state`,`access`)
) ENGINE=InnoDB AUTO_INCREMENT=13 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_taxonomy`
--


INSERT INTO `#__finder_taxonomy` (`id`, `parent_id`, `title`, `state`, `access`, `ordering`) VALUES (1,0,'ROOT',0,0,0),(2,1,'Type',1,1,0),(3,2,'K2 Item',1,1,0),(4,1,'Author',1,1,0),(5,4,'Super User',1,1,0),(6,1,'K2 Category',1,1,0),(7,6,'Gear Accessories',1,1,0),(8,1,'Language',1,1,0),(9,8,'*',1,1,0),(10,6,'Photo Of The Day',1,1,0),(11,6,'Snowboarding Resorts',1,1,0),(12,6,'Event Coverage',1,1,0);


--
-- Table structure for table `#__finder_taxonomy_map`
--



CREATE TABLE `#__finder_taxonomy_map` (
  `link_id` int(10) unsigned NOT NULL,
  `node_id` int(10) unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`node_id`),
  KEY `link_id` (`link_id`),
  KEY `node_id` (`node_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_taxonomy_map`
--


INSERT INTO `#__finder_taxonomy_map` (`link_id`, `node_id`) VALUES (1,3),(1,5),(1,7),(1,9),(2,3),(2,5),(2,7),(2,9),(3,3),(3,5),(3,9),(3,10),(4,3),(4,5),(4,9),(4,11),(5,3),(5,5),(5,9),(5,11),(6,3),(6,5),(6,9),(6,11),(7,3),(7,5),(7,9),(7,12),(8,3),(8,5),(8,9),(8,12),(9,3),(9,5),(9,9),(9,12),(10,3),(10,5),(10,9),(10,12),(11,3),(11,5),(11,9),(11,10),(12,3),(12,5),(12,9),(12,10),(13,3),(13,5),(13,9),(13,10),(14,3),(14,5),(14,7),(14,9),(15,3),(15,5),(15,7),(15,9),(16,3),(16,5),(16,9),(16,11);


--
-- Table structure for table `#__finder_terms`
--



CREATE TABLE `#__finder_terms` (
  `term_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `term` varchar(75) NOT NULL,
  `stem` varchar(75) NOT NULL,
  `common` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `phrase` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `weight` float unsigned NOT NULL DEFAULT '0',
  `soundex` varchar(75) NOT NULL,
  `links` int(10) NOT NULL DEFAULT '0',
  `language` char(3) NOT NULL DEFAULT '',
  PRIMARY KEY (`term_id`),
  UNIQUE KEY `idx_term` (`term`),
  KEY `idx_term_phrase` (`term`,`phrase`),
  KEY `idx_stem_phrase` (`stem`,`phrase`),
  KEY `idx_soundex_phrase` (`soundex`,`phrase`)
) ENGINE=InnoDB AUTO_INCREMENT=802 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_terms`
--


INSERT INTO `#__finder_terms` (`term_id`, `term`, `stem`, `common`, `phrase`, `weight`, `soundex`, `links`, `language`) VALUES (1,'','',0,0,0,'',18,'*'),(2,'1','1',0,0,0.1,'',3,'*'),(3,'a','a',0,0,0.0667,'A000',18,'*'),(4,'a risus','a risus',0,1,1.2333,'A620',18,'*'),(5,'a risus nec','a risus nec',0,1,1.3667,'A6252',18,'*'),(6,'a velit','a velit',0,1,1.2333,'A143',18,'*'),(7,'a velit vitae','a velit vitae',0,1,1.4333,'A14313',18,'*'),(8,'accessories','accessories',0,0,0.7333,'A262',6,'*'),(9,'aenean','aenean',0,0,0.4,'A500',18,'*'),(10,'aenean eu','aenean eu',0,1,1.3,'A500',18,'*'),(11,'aenean eu leo','aenean eu leo',0,1,1.4333,'A540',18,'*'),(12,'aliquam','aliquam',0,0,0.4667,'A425',18,'*'),(13,'aliquam tempus','aliquam tempus',0,1,1.4667,'A4253512',18,'*'),(14,'aliquam tempus rutrum','aliquam tempus rutrum',0,1,1.7,'A42535126365',18,'*'),(15,'amet','amet',0,0,0.2667,'A530',18,'*'),(16,'amet fermentum','amet fermentum',0,1,1.4667,'A5316535',18,'*'),(17,'amet fermentum etiam','amet fermentum etiam',0,1,1.6667,'A531653535',18,'*'),(18,'amet fermentum nullam','amet fermentum nullam',0,1,1.7,'A531653545',18,'*'),(19,'at','at',0,0,0.1333,'A300',18,'*'),(20,'at lobortis','at lobortis',0,1,1.3667,'A341632',18,'*'),(21,'at lobortis donec','at lobortis donec',0,1,1.5667,'A341632352',18,'*'),(22,'auctor','auctor',0,0,0.4,'A236',18,'*'),(23,'auctor fringilla','auctor fringilla',0,1,1.5333,'A23616524',18,'*'),(24,'auctor fringilla cras','auctor fringilla cras',0,1,1.7,'A23616524262',18,'*'),(25,'consectetur','consectetur',0,0,0.7333,'C5236',18,'*'),(26,'consectetur est','consectetur est',0,1,1.5,'C523623',18,'*'),(27,'consectetur est at','consectetur est at',0,1,1.6,'C523623',18,'*'),(28,'consectetur purus','consectetur purus',0,1,1.5667,'C5236162',18,'*'),(29,'consectetur purus sit','consectetur purus sit',0,1,1.7,'C52361623',18,'*'),(30,'cras','cras',0,0,0.2667,'C620',18,'*'),(31,'cras dui','cras dui',0,1,1.2667,'C623',18,'*'),(32,'cras dui velit','cras dui velit',0,1,1.4667,'C623143',18,'*'),(33,'cras mattis','cras mattis',0,1,1.3667,'C62532',18,'*'),(34,'cras mattis consectetur','cras mattis consectetur',0,1,1.7667,'C625325236',18,'*'),(35,'diam','diam',0,0,0.2667,'D500',18,'*'),(36,'diam non','diam non',0,1,1.2667,'D500',18,'*'),(37,'diam non tincidunt','diam non tincidunt',0,1,1.6,'D5352353',18,'*'),(38,'donec','donec',0,0,0.3333,'D520',18,'*'),(39,'donec ullamcorper','donec ullamcorper',0,1,1.5667,'D52452616',18,'*'),(40,'donec ullamcorper nulla','donec ullamcorper nulla',0,1,1.7667,'D5245261654',18,'*'),(41,'dui','dui',0,0,0.2,'D000',18,'*'),(42,'dui duis','dui duis',0,1,1.2667,'D200',18,'*'),(43,'dui duis a','dui duis a',0,1,1.3333,'D200',18,'*'),(44,'dui velit','dui velit',0,1,1.3,'D143',18,'*'),(45,'dui velit luctus','dui velit luctus',0,1,1.5333,'D1434232',18,'*'),(46,'duis','duis',0,0,0.2667,'D200',18,'*'),(47,'duis a','duis a',0,1,1.2,'D200',18,'*'),(48,'duis a risus','duis a risus',0,1,1.4,'D262',18,'*'),(49,'duis sed','duis sed',0,1,1.2667,'D230',18,'*'),(50,'duis sed laoreet','duis sed laoreet',0,1,1.5333,'D23463',18,'*'),(51,'eget','eget',0,0,0.2667,'E230',18,'*'),(52,'eget urna','eget urna',0,1,1.3,'E2365',18,'*'),(53,'eget urna mollis','eget urna mollis',0,1,1.5333,'E236542',18,'*'),(54,'erat','erat',0,0,0.2667,'E630',18,'*'),(55,'erat tincidunt','erat tincidunt',0,1,1.4667,'E6352353',18,'*'),(56,'erat tincidunt feugiat','erat tincidunt feugiat',0,1,1.7333,'E6352353123',18,'*'),(57,'est','est',0,0,0.2,'E230',18,'*'),(58,'est at','est at',0,1,1.2,'E230',18,'*'),(59,'est at lobortis','est at lobortis',0,1,1.5,'E2341632',18,'*'),(60,'etiam','etiam',0,0,0.3333,'E350',18,'*'),(61,'etiam porta','etiam porta',0,1,1.3667,'E35163',18,'*'),(62,'etiam porta sem','etiam porta sem',0,1,1.5,'E3516325',18,'*'),(63,'eu','eu',0,0,0.1333,'E000',18,'*'),(64,'eu leo','eu leo',0,1,1.2,'E400',18,'*'),(65,'eu leo donec','eu leo donec',0,1,1.4,'E4352',18,'*'),(66,'eu leo nullam','eu leo nullam',0,1,1.4333,'E4545',18,'*'),(67,'eu leo quam','eu leo quam',0,1,1.3667,'E425',18,'*'),(68,'euismod','euismod',0,0,0.4667,'E253',18,'*'),(69,'euismod aenean','euismod aenean',0,1,1.4667,'E2535',18,'*'),(70,'euismod aenean eu','euismod aenean eu',0,1,1.5667,'E2535',18,'*'),(71,'facilisi','facilisi',0,0,0.5333,'F242',18,'*'),(72,'facilisi duis','facilisi duis',0,1,1.4333,'F24232',18,'*'),(73,'facilisi duis sed','facilisi duis sed',0,1,1.5667,'F242323',18,'*'),(74,'fermentum','fermentum',0,0,0.6,'F6535',18,'*'),(75,'fermentum etiam','fermentum etiam',0,1,1.5,'F653535',18,'*'),(76,'fermentum etiam porta','fermentum etiam porta',0,1,1.7,'F653535163',18,'*'),(77,'fermentum nullam','fermentum nullam',0,1,1.5333,'F653545',18,'*'),(78,'fermentum nullam quis','fermentum nullam quis',0,1,1.7,'F6535452',18,'*'),(79,'feugiat','feugiat',0,0,0.4667,'F230',18,'*'),(80,'feugiat cras','feugiat cras',0,1,1.4,'F23262',18,'*'),(81,'feugiat cras dui','feugiat cras dui',0,1,1.5333,'F232623',18,'*'),(82,'fringilla','fringilla',0,0,0.6,'F6524',18,'*'),(83,'fringilla cras','fringilla cras',0,1,1.4667,'F6524262',18,'*'),(84,'fringilla cras mattis','fringilla cras mattis',0,1,1.7,'F6524262532',18,'*'),(85,'gear','gear',0,0,0.2667,'G600',6,'*'),(86,'gear accessories','gear accessories',0,1,1.5333,'G6262',6,'*'),(87,'iaculis','iaculis',0,0,0.4667,'I242',18,'*'),(88,'iaculis aliquam','iaculis aliquam',0,1,1.5,'I242425',18,'*'),(89,'iaculis aliquam tempus','iaculis aliquam tempus',0,1,1.7333,'I2424253512',18,'*'),(90,'index','index',0,0,0.3333,'I532',18,'*'),(91,'is','is',0,0,0.1333,'I200',4,'*'),(92,'is now','is now',0,1,1.2,'I250',3,'*'),(93,'is now open','is now open',0,1,1.3667,'I2515',3,'*'),(94,'item','item',0,0,0.2667,'I350',18,'*'),(95,'k2','k2',0,0,0.1333,'K000',18,'*'),(96,'k2 item','k2 item',0,1,1.2333,'K350',18,'*'),(97,'lacinia','lacinia',0,0,0.4667,'L250',18,'*'),(98,'lacinia quam','lacinia quam',0,1,1.4,'L2525',18,'*'),(99,'lacinia quam venenatis','lacinia quam venenatis',0,1,1.7333,'L25251532',18,'*'),(100,'laoreet','laoreet',0,0,0.4667,'L630',18,'*'),(101,'laoreet dui','laoreet dui',0,1,1.3667,'L630',18,'*'),(102,'laoreet dui duis','laoreet dui duis',0,1,1.5333,'L632',18,'*'),(103,'leo','leo',0,0,0.2,'L000',18,'*'),(104,'leo donec','leo donec',0,1,1.3,'L352',18,'*'),(105,'leo donec ullamcorper','leo donec ullamcorper',0,1,1.7,'L352452616',18,'*'),(106,'leo nullam','leo nullam',0,1,1.3333,'L545',18,'*'),(107,'leo nullam quis','leo nullam quis',0,1,1.5,'L5452',18,'*'),(108,'leo quam','leo quam',0,1,1.2667,'L250',18,'*'),(109,'leo quam pellentesque','leo quam pellentesque',0,1,1.7,'L2514532',18,'*'),(110,'lobortis','lobortis',0,0,0.5333,'L1632',18,'*'),(111,'lobortis donec','lobortis donec',0,1,1.4667,'L1632352',18,'*'),(112,'lobortis donec ullamcorper','lobortis donec ullamcorper',0,1,1.8667,'L1632352452616',18,'*'),(113,'luctus','luctus',0,0,0.4,'L232',18,'*'),(114,'luctus vitae','luctus vitae',0,1,1.4,'L23213',18,'*'),(115,'luctus vitae volutpat','luctus vitae volutpat',0,1,1.7,'L2321314313',18,'*'),(116,'magna','magna',0,0,0.3333,'M250',18,'*'),(117,'magna mollis','magna mollis',0,1,1.4,'M2542',18,'*'),(118,'magna mollis euismod','magna mollis euismod',0,1,1.6667,'M254253',18,'*'),(119,'malesuada','malesuada',0,0,0.6,'M423',18,'*'),(120,'malesuada magna','malesuada magna',0,1,1.5,'M423525',18,'*'),(121,'malesuada magna mollis','malesuada magna mollis',0,1,1.7333,'M42352542',18,'*'),(122,'mattis','mattis',0,0,0.4,'M320',18,'*'),(123,'mattis consectetur','mattis consectetur',0,1,1.6,'M325236',18,'*'),(124,'mattis consectetur purus','mattis consectetur purus',0,1,1.8,'M325236162',18,'*'),(125,'metus','metus',0,0,0.3333,'M320',18,'*'),(126,'metus auctor','metus auctor',0,1,1.4,'M3236',18,'*'),(127,'metus auctor fringilla','metus auctor fringilla',0,1,1.7333,'M323616524',18,'*'),(128,'mollis','mollis',0,0,0.4,'M420',18,'*'),(129,'mollis euismod','mollis euismod',0,1,1.4667,'M4253',18,'*'),(130,'mollis euismod aenean','mollis euismod aenean',0,1,1.7,'M42535',18,'*'),(131,'mollis ornare','mollis ornare',0,1,1.4333,'M42656',18,'*'),(132,'mollis ornare vel','mollis ornare vel',0,1,1.5667,'M4265614',18,'*'),(133,'nec','nec',0,0,0.2,'N200',18,'*'),(134,'nec erat','nec erat',0,1,1.2667,'N263',18,'*'),(135,'nec erat tincidunt','nec erat tincidunt',0,1,1.6,'N26352353',18,'*'),(136,'non','non',0,0,0.2,'N000',18,'*'),(137,'non metus','non metus',0,1,1.3,'N320',18,'*'),(138,'non metus auctor','non metus auctor',0,1,1.5333,'N3236',18,'*'),(139,'non tincidunt','non tincidunt',0,1,1.4333,'N352353',18,'*'),(140,'non tincidunt odio','non tincidunt odio',0,1,1.6,'N352353',18,'*'),(141,'now','now',0,0,0.2,'N000',3,'*'),(142,'now open','now open',0,1,1.2667,'N150',3,'*'),(143,'nulla','nulla',0,0,0.3333,'N400',18,'*'),(144,'nulla facilisi','nulla facilisi',0,1,1.4667,'N41242',18,'*'),(145,'nulla facilisi duis','nulla facilisi duis',0,1,1.6333,'N4124232',18,'*'),(146,'nulla non','nulla non',0,1,1.3,'N450',18,'*'),(147,'nulla non metus','nulla non metus',0,1,1.5,'N4532',18,'*'),(148,'nullam','nullam',0,0,0.4,'N450',18,'*'),(149,'nullam quis','nullam quis',0,1,1.3667,'N452',18,'*'),(150,'nullam quis risus','nullam quis risus',0,1,1.5667,'N45262',18,'*'),(151,'nunc','nunc',0,0,0.2667,'N200',18,'*'),(152,'nunc porta','nunc porta',0,1,1.3333,'N2163',18,'*'),(153,'nunc porta iaculis','nunc porta iaculis',0,1,1.6,'N2163242',18,'*'),(154,'odio','odio',0,0,0.2667,'O300',18,'*'),(155,'odio pharetra','odio pharetra',0,1,1.4333,'O31636',18,'*'),(156,'odio pharetra vitae','odio pharetra vitae',0,1,1.6333,'O3163613',18,'*'),(157,'open','open',0,0,0.2667,'O150',3,'*'),(158,'orci','orci',0,0,0.2667,'O620',18,'*'),(159,'ornare','ornare',0,0,0.4,'O656',18,'*'),(160,'ornare sem','ornare sem',0,1,1.3333,'O65625',18,'*'),(161,'ornare sem lacinia','ornare sem lacinia',0,1,1.6,'O65625425',18,'*'),(162,'ornare vel','ornare vel',0,1,1.3333,'O65614',18,'*'),(163,'ornare vel eu','ornare vel eu',0,1,1.4333,'O65614',18,'*'),(164,'pellentesque','pellentesque',0,0,0.8,'P4532',18,'*'),(165,'pellentesque ornare','pellentesque ornare',0,1,1.6333,'P4532656',18,'*'),(166,'pellentesque ornare sem','pellentesque ornare sem',0,1,1.7667,'P453265625',18,'*'),(167,'pharetra','pharetra',0,0,0.5333,'P636',18,'*'),(168,'pharetra vitae','pharetra vitae',0,1,1.4667,'P63613',18,'*'),(169,'pharetra vitae nulla','pharetra vitae nulla',0,1,1.6667,'P6361354',18,'*'),(170,'porta','porta',0,0,0.3333,'P630',18,'*'),(171,'porta iaculis','porta iaculis',0,1,1.4333,'P63242',18,'*'),(172,'porta iaculis aliquam','porta iaculis aliquam',0,1,1.7,'P63242425',18,'*'),(173,'porta sem','porta sem',0,1,1.3,'P6325',18,'*'),(174,'porta sem malesuada','porta sem malesuada',0,1,1.6333,'P6325423',18,'*'),(175,'posuere','posuere',0,0,0.4667,'P260',18,'*'),(176,'posuere consectetur','posuere consectetur',0,1,1.6333,'P2625236',18,'*'),(177,'posuere consectetur est','posuere consectetur est',0,1,1.7667,'P262523623',18,'*'),(178,'purus','purus',0,0,0.3333,'P620',18,'*'),(179,'purus sit','purus sit',0,1,1.3,'P623',18,'*'),(180,'purus sit amet','purus sit amet',0,1,1.4667,'P62353',18,'*'),(181,'quam','quam',0,0,0.2667,'Q500',18,'*'),(182,'quam pellentesque','quam pellentesque',0,1,1.5667,'Q514532',18,'*'),(183,'quam pellentesque ornare','quam pellentesque ornare',0,1,1.8,'Q514532656',18,'*'),(184,'quam venenatis','quam venenatis',0,1,1.4667,'Q51532',18,'*'),(185,'quam venenatis vestibulum','quam venenatis vestibulum',0,1,1.8333,'Q51532123145',18,'*'),(186,'quis','quis',0,0,0.2667,'Q000',18,'*'),(187,'quis risus','quis risus',0,1,1.3333,'Q620',18,'*'),(188,'quis risus eget','quis risus eget',0,1,1.5,'Q623',18,'*'),(189,'risus','risus',0,0,0.3333,'R200',18,'*'),(190,'risus eget','risus eget',0,1,1.3333,'R230',18,'*'),(191,'risus eget urna','risus eget urna',0,1,1.5,'R2365',18,'*'),(192,'risus nec','risus nec',0,1,1.3,'R252',18,'*'),(193,'risus nec erat','risus nec erat',0,1,1.4667,'R25263',18,'*'),(194,'rutrum','rutrum',0,0,0.4,'R365',18,'*'),(195,'rutrum diam','rutrum diam',0,1,1.3667,'R36535',18,'*'),(196,'rutrum diam non','rutrum diam non',0,1,1.5,'R36535',18,'*'),(197,'sed','sed',0,0,0.2,'S300',18,'*'),(198,'sed a','sed a',0,1,1.1667,'S300',18,'*'),(199,'sed a velit','sed a velit',0,1,1.3667,'S3143',18,'*'),(200,'sed laoreet','sed laoreet',0,1,1.3667,'S3463',18,'*'),(201,'sed laoreet dui','sed laoreet dui',0,1,1.5,'S3463',18,'*'),(202,'sed posuere','sed posuere',0,1,1.3667,'S3126',18,'*'),(203,'sed posuere consectetur','sed posuere consectetur',0,1,1.7667,'S312625236',18,'*'),(204,'sem','sem',0,0,0.2,'S500',18,'*'),(205,'sem lacinia','sem lacinia',0,1,1.3667,'S5425',18,'*'),(206,'sem lacinia quam','sem lacinia quam',0,1,1.5333,'S542525',18,'*'),(207,'sem malesuada','sem malesuada',0,1,1.4333,'S5423',18,'*'),(208,'sem malesuada magna','sem malesuada magna',0,1,1.6333,'S5423525',18,'*'),(209,'sit','sit',0,0,0.2,'S300',18,'*'),(210,'sit amet','sit amet',0,1,1.2667,'S353',18,'*'),(211,'sit amet fermentum','sit amet fermentum',0,1,1.6,'S35316535',18,'*'),(212,'snowbasin','snowbasin',0,0,0.6,'S5125',3,'*'),(213,'snowbasin is','snowbasin is',0,1,1.4,'S51252',3,'*'),(214,'snowbasin is now','snowbasin is now',0,1,1.5333,'S512525',3,'*'),(215,'super','super',0,0,0.3333,'S160',18,'*'),(216,'super user','super user',0,1,1.3333,'S1626',18,'*'),(217,'tempus','tempus',0,0,0.4,'T512',18,'*'),(218,'tempus rutrum','tempus rutrum',0,1,1.4333,'T5126365',18,'*'),(219,'tempus rutrum diam','tempus rutrum diam',0,1,1.6,'T512636535',18,'*'),(220,'tincidunt','tincidunt',0,0,0.6,'T52353',18,'*'),(221,'tincidunt feugiat','tincidunt feugiat',0,1,1.5667,'T52353123',18,'*'),(222,'tincidunt feugiat cras','tincidunt feugiat cras',0,1,1.7333,'T52353123262',18,'*'),(223,'tincidunt odio','tincidunt odio',0,1,1.4667,'T52353',18,'*'),(224,'tincidunt odio pharetra','tincidunt odio pharetra',0,1,1.7667,'T523531636',18,'*'),(225,'ullamcorper','ullamcorper',0,0,0.7333,'U452616',18,'*'),(226,'ullamcorper nulla','ullamcorper nulla',0,1,1.5667,'U45261654',18,'*'),(227,'ullamcorper nulla non','ullamcorper nulla non',0,1,1.7,'U452616545',18,'*'),(228,'urna','urna',0,0,0.2667,'U650',18,'*'),(229,'urna mollis','urna mollis',0,1,1.3667,'U6542',18,'*'),(230,'urna mollis ornare','urna mollis ornare',0,1,1.6,'U6542656',18,'*'),(231,'user','user',0,0,0.2667,'U260',18,'*'),(232,'vel','vel',0,0,0.2,'V400',18,'*'),(233,'vel eu','vel eu',0,1,1.2,'V400',18,'*'),(234,'vel eu leo','vel eu leo',0,1,1.3333,'V400',18,'*'),(235,'velit','velit',0,0,0.3333,'V430',18,'*'),(236,'velit luctus','velit luctus',0,1,1.4,'V434232',18,'*'),(237,'velit luctus vitae','velit luctus vitae',0,1,1.6,'V43423213',18,'*'),(238,'velit vitae','velit vitae',0,1,1.3667,'V4313',18,'*'),(239,'velit vitae nunc','velit vitae nunc',0,1,1.5333,'V431352',18,'*'),(240,'venenatis','venenatis',0,0,0.6,'V532',18,'*'),(241,'venenatis vestibulum','venenatis vestibulum',0,1,1.6667,'V532123145',18,'*'),(242,'venenatis vestibulum sed','venenatis vestibulum sed',0,1,1.8,'V53212314523',18,'*'),(243,'vestibulum','vestibulum',0,0,0.6667,'V23145',18,'*'),(244,'vestibulum sed','vestibulum sed',0,1,1.4667,'V2314523',18,'*'),(245,'vestibulum sed posuere','vestibulum sed posuere',0,1,1.7333,'V2314523126',18,'*'),(246,'vestibulum vitae','vestibulum vitae',0,1,1.5333,'V2314513',18,'*'),(247,'vestibulum vitae orci','vestibulum vitae orci',0,1,1.7,'V231451362',18,'*'),(248,'vitae','vitae',0,0,0.3333,'V300',18,'*'),(249,'vitae nulla','vitae nulla',0,1,1.3667,'V354',18,'*'),(250,'vitae nulla facilisi','vitae nulla facilisi',0,1,1.6667,'V3541242',18,'*'),(251,'vitae nunc','vitae nunc',0,1,1.3333,'V352',18,'*'),(252,'vitae nunc porta','vitae nunc porta',0,1,1.5333,'V352163',18,'*'),(253,'vitae orci','vitae orci',0,1,1.3333,'V362',18,'*'),(254,'vitae vestibulum','vitae vestibulum',0,1,1.5333,'V3123145',18,'*'),(255,'vitae vestibulum vitae','vitae vestibulum vitae',0,1,1.7333,'V312314513',18,'*'),(256,'vitae volutpat','vitae volutpat',0,1,1.4667,'V314313',18,'*'),(257,'vitae volutpat vitae','vitae volutpat vitae',0,1,1.6667,'V31431313',18,'*'),(258,'volutpat','volutpat',0,0,0.5333,'V4313',18,'*'),(259,'volutpat vitae','volutpat vitae',0,1,1.4667,'V431313',18,'*'),(260,'volutpat vitae vestibulum','volutpat vitae vestibulum',0,1,1.8333,'V431313123145',18,'*'),(512,'2','2',0,0,0.1,'',1,'*'),(513,'a snowboarding','a snowboarding',0,1,1.4667,'A2516352',1,'*'),(514,'a snowboarding destination','a snowboarding destination',0,1,1.8667,'A2516352323535',1,'*'),(515,'destination','destination',0,0,0.7333,'D23535',1,'*'),(516,'makes','makes',0,0,0.3333,'M200',1,'*'),(517,'makes a','makes a',0,1,1.2333,'M200',1,'*'),(518,'makes a snowboarding','makes a snowboarding',0,1,1.6667,'M2516352',1,'*'),(519,'snowboarding','snowboarding',0,0,0.8,'S516352',6,'*'),(520,'snowboarding destination','snowboarding destination',0,1,1.8,'S516352323535',1,'*'),(521,'what','what',0,0,0.2667,'W300',1,'*'),(522,'what makes','what makes',0,1,1.3333,'W352',1,'*'),(523,'what makes a','what makes a',0,1,1.4,'W352',1,'*'),(527,'3','3',0,0,0.1,'',1,'*'),(528,'alive','alive',0,0,0.3333,'A410',2,'*'),(529,'at the','at the',0,1,1.2,'A300',2,'*'),(530,'at the end','at the end',0,1,1.3333,'A353',1,'*'),(531,'be','be',0,0,0.1333,'B000',2,'*'),(532,'be alive','be alive',0,1,1.2667,'B410',2,'*'),(533,'day','day',0,0,0.2,'D000',6,'*'),(534,'end','end',0,0,0.2,'E530',1,'*'),(535,'end happy','end happy',0,1,1.3,'E531',1,'*'),(536,'end happy to','end happy to',0,1,1.4,'E5313',1,'*'),(537,'happy','happy',0,0,0.3333,'H100',2,'*'),(538,'happy to','happy to',0,1,1.2667,'H130',2,'*'),(539,'happy to be','happy to be',0,1,1.3667,'H131',2,'*'),(540,'of','of',0,0,0.1333,'O100',4,'*'),(541,'of the','of the',0,1,1.2,'O130',4,'*'),(542,'of the day','of the day',0,1,1.3333,'O130',4,'*'),(543,'photo','photo',0,0,0.3333,'P300',4,'*'),(544,'photo of','photo of',0,1,1.2667,'P310',4,'*'),(545,'photo of the','photo of the',0,1,1.4,'P313',4,'*'),(546,'the','the',0,0,0.2,'T000',7,'*'),(547,'the day','the day',0,1,1.2333,'T000',4,'*'),(548,'the end','the end',0,1,1.2333,'T530',1,'*'),(549,'the end happy','the end happy',0,1,1.4333,'T531',1,'*'),(550,'to','to',0,0,0.1333,'T000',2,'*'),(551,'to be','to be',0,1,1.1667,'T100',2,'*'),(552,'to be alive','to be alive',0,1,1.3667,'T141',2,'*'),(558,'4','4',0,0,0.1,'',1,'*'),(559,'bear','bear',0,0,0.2667,'B600',2,'*'),(560,'bear mountain','bear mountain',0,1,1.4333,'B6535',2,'*'),(561,'bear mountain sunday','bear mountain sunday',0,1,1.6667,'B6535253',1,'*'),(562,'in','in',0,0,0.1333,'I500',3,'*'),(563,'in the','in the',0,1,1.2,'I530',2,'*'),(564,'in the park','in the park',0,1,1.3667,'I53162',1,'*'),(565,'mountain','mountain',0,0,0.5333,'M350',2,'*'),(566,'mountain sunday','mountain sunday',0,1,1.5,'M35253',1,'*'),(567,'mountain sunday in','mountain sunday in',0,1,1.6,'M352535',1,'*'),(568,'park','park',0,0,0.2667,'P620',2,'*'),(569,'resorts','resorts',0,0,0.4667,'R2632',4,'*'),(570,'snowboarding resorts','snowboarding resorts',0,1,1.6667,'S51635262632',4,'*'),(571,'sunday','sunday',0,0,0.4,'S530',1,'*'),(572,'sunday in','sunday in',0,1,1.3,'S535',1,'*'),(573,'sunday in the','sunday in the',0,1,1.4333,'S5353',1,'*'),(574,'the park','the park',0,1,1.2667,'T162',1,'*'),(589,'5','5',0,0,0.1,'',1,'*'),(590,'higher','higher',0,0,0.4,'H260',1,'*'),(591,'later','later',0,0,0.3333,'L360',1,'*'),(592,'later you','later you',0,1,1.3,'L360',1,'*'),(593,'later you reach','later you reach',0,1,1.5,'L362',1,'*'),(594,'or','or',0,0,0.1333,'O600',1,'*'),(595,'or later','or later',0,1,1.2667,'O6436',1,'*'),(596,'or later you','or later you',0,1,1.4,'O6436',1,'*'),(597,'reach','reach',0,0,0.3333,'R200',1,'*'),(598,'reach higher','reach higher',0,1,1.4,'R260',1,'*'),(599,'sooner','sooner',0,0,0.4,'S560',1,'*'),(600,'sooner or','sooner or',0,1,1.3,'S560',1,'*'),(601,'sooner or later','sooner or later',0,1,1.5,'S56436',1,'*'),(602,'you','you',0,0,0.2,'Y000',2,'*'),(603,'you reach','you reach',0,1,1.3,'Y620',1,'*'),(604,'you reach higher','you reach higher',0,1,1.5333,'Y626',1,'*'),(620,'6','6',0,0,0.1,'',1,'*'),(621,'7','7',0,0,0.1,'',1,'*'),(622,'a great','a great',0,1,1.2333,'A263',1,'*'),(623,'a great slopestyle','a great slopestyle',0,1,1.6,'A263241234',1,'*'),(624,'coverage','coverage',0,0,0.5333,'C162',4,'*'),(625,'event','event',0,0,0.3333,'E153',4,'*'),(626,'event coverage','event coverage',0,1,1.4667,'E1532162',4,'*'),(627,'great','great',0,0,0.3333,'G630',1,'*'),(628,'great slopestyle','great slopestyle',0,1,1.5333,'G63241234',1,'*'),(629,'perfect','perfect',0,0,0.4667,'P6123',1,'*'),(630,'perfect weather','perfect weather',0,1,1.5,'P61236',1,'*'),(631,'perfect weather a','perfect weather a',0,1,1.5667,'P61236',1,'*'),(632,'slopestyle','slopestyle',0,0,0.6667,'S41234',1,'*'),(633,'weather','weather',0,0,0.4667,'W360',1,'*'),(634,'weather a','weather a',0,1,1.3,'W360',1,'*'),(635,'weather a great','weather a great',0,1,1.5,'W36263',1,'*'),(636,'8','8',0,0,0.1,'',1,'*'),(637,'jared','jared',0,0,0.3333,'J630',1,'*'),(638,'jared premium','jared premium',0,1,1.4333,'J63165',1,'*'),(639,'jared premium partner','jared premium partner',0,1,1.7,'J6316516356',1,'*'),(640,'just','just',0,0,0.2667,'J300',1,'*'),(641,'just jared','just jared',0,1,1.3333,'J3263',1,'*'),(642,'just jared premium','just jared premium',0,1,1.6,'J3263165',1,'*'),(643,'partner','partner',0,0,0.4667,'P6356',1,'*'),(644,'premium','premium',0,0,0.4667,'P650',1,'*'),(645,'premium partner','premium partner',0,1,1.5,'P6516356',1,'*'),(651,'9','9',0,0,0.1,'',1,'*'),(652,'on','on',0,0,0.1333,'O500',1,'*'),(653,'on sunny','on sunny',0,1,1.2667,'O525',1,'*'),(654,'on sunny day','on sunny day',0,1,1.4,'O5253',1,'*'),(655,'snowboarding on','snowboarding on',0,1,1.5,'S5163525',1,'*'),(656,'snowboarding on sunny','snowboarding on sunny',0,1,1.7,'S516352525',1,'*'),(657,'sunny','sunny',0,0,0.3333,'S500',1,'*'),(658,'sunny day','sunny day',0,1,1.3,'S530',1,'*'),(666,'10','10',0,0,0.2,'',1,'*'),(667,'at the moment','at the moment',0,1,1.4333,'A353',1,'*'),(668,'big','big',0,0,0.2,'B200',1,'*'),(669,'big at','big at',0,1,1.2,'B230',1,'*'),(670,'big at the','big at the',0,1,1.3333,'B230',1,'*'),(671,'billy','billy',0,0,0.3333,'B400',1,'*'),(672,'billy morgan','billy morgan',0,1,1.4,'B45625',1,'*'),(673,'billy morgan is','billy morgan is',0,1,1.5,'B456252',1,'*'),(674,'going','going',0,0,0.3333,'G520',1,'*'),(675,'going big','going big',0,1,1.3,'G5212',1,'*'),(676,'going big at','going big at',0,1,1.4,'G52123',1,'*'),(677,'is going','is going',0,1,1.2667,'I252',1,'*'),(678,'is going big','is going big',0,1,1.4,'I25212',1,'*'),(679,'moment','moment',0,0,0.4,'M300',1,'*'),(680,'morgan','morgan',0,0,0.4,'M625',1,'*'),(681,'morgan is','morgan is',0,1,1.3,'M6252',1,'*'),(682,'morgan is going','morgan is going',0,1,1.5,'M625252',1,'*'),(683,'the moment','the moment',0,1,1.3333,'T530',1,'*'),(697,'11','11',0,0,0.2,'',1,'*'),(698,'craving','craving',0,0,0.4667,'C6152',1,'*'),(699,'craving some','craving some',0,1,1.4,'C61525',1,'*'),(700,'craving some pow','craving some pow',0,1,1.5333,'C615251',1,'*'),(701,'missing','missing',0,0,0.4667,'M252',1,'*'),(702,'missing winter','missing winter',0,1,1.4667,'M252536',1,'*'),(703,'missing winter craving','missing winter craving',0,1,1.7333,'M25253626152',1,'*'),(704,'pow','pow',0,0,0.2,'P000',1,'*'),(705,'some','some',0,0,0.2667,'S500',1,'*'),(706,'some pow','some pow',0,1,1.2667,'S510',1,'*'),(707,'winter','winter',0,0,0.4,'W536',1,'*'),(708,'winter craving','winter craving',0,1,1.4667,'W53626152',1,'*'),(709,'winter craving some','winter craving some',0,1,1.6333,'W536261525',1,'*'),(712,'12','12',0,0,0.2,'',1,'*'),(713,'face','face',0,0,0.2667,'F200',1,'*'),(714,'in your','in your',0,1,1.2333,'I560',1,'*'),(715,'in your face','in your face',0,1,1.4,'I5612',1,'*'),(716,'torstein','torstein',0,0,0.5333,'T6235',1,'*'),(717,'torstein in','torstein in',0,1,1.3667,'T6235',1,'*'),(718,'torstein in your','torstein in your',0,1,1.5333,'T62356',1,'*'),(719,'your','your',0,0,0.2667,'Y600',1,'*'),(720,'your face','your face',0,1,1.3,'Y612',1,'*'),(727,'13','13',0,0,0.2,'',1,'*'),(728,'do','do',0,0,0.1333,'D000',1,'*'),(729,'do you','do you',0,1,1.2,'D000',1,'*'),(730,'do you snowboard','do you snowboard',0,1,1.5333,'D25163',1,'*'),(731,'snowboard','snowboard',0,0,0.6,'S5163',1,'*'),(732,'why','why',0,0,0.2,'W000',1,'*'),(733,'why do','why do',0,1,1.2,'W300',1,'*'),(734,'why do you','why do you',0,1,1.3333,'W300',1,'*'),(735,'you snowboard','you snowboard',0,1,1.4333,'Y25163',1,'*'),(742,'14','14',0,0,0.2,'',1,'*'),(743,'action','action',0,0,0.4,'A235',1,'*'),(744,'action at','action at',0,1,1.3,'A2353',1,'*'),(745,'action at bear','action at bear',0,1,1.4667,'A235316',1,'*'),(746,'at bear','at bear',0,1,1.2333,'A316',1,'*'),(747,'at bear mountain','at bear mountain',0,1,1.5333,'A316535',1,'*'),(748,'early','early',0,0,0.3333,'E640',1,'*'),(749,'early season','early season',0,1,1.4,'E6425',1,'*'),(750,'early season park','early season park',0,1,1.5667,'E6425162',1,'*'),(751,'park action','park action',0,1,1.3667,'P6235',1,'*'),(752,'park action at','park action at',0,1,1.4667,'P62353',1,'*'),(753,'season','season',0,0,0.4,'S500',1,'*'),(754,'season park','season park',0,1,1.3667,'S5162',1,'*'),(755,'season park action','season park action',0,1,1.6,'S516235',1,'*'),(757,'15','15',0,0,0.2,'',1,'*'),(758,'at mt','at mt',0,1,1.1667,'A353',1,'*'),(759,'at mt baker','at mt baker',0,1,1.3667,'A353126',1,'*'),(760,'baker','baker',0,0,0.3333,'B260',1,'*'),(761,'day at','day at',0,1,1.2,'D000',1,'*'),(762,'day at mt','day at mt',0,1,1.3,'D530',1,'*'),(763,'insane','insane',0,0,0.4,'I525',1,'*'),(764,'insane opening','insane opening',0,1,1.4667,'I525152',1,'*'),(765,'insane opening day','insane opening day',0,1,1.6,'I5251523',1,'*'),(766,'mt','mt',0,0,0.1333,'M300',1,'*'),(767,'mt baker','mt baker',0,1,1.2667,'M3126',1,'*'),(768,'opening','opening',0,0,0.4667,'O152',1,'*'),(769,'opening day','opening day',0,1,1.3667,'O1523',1,'*'),(770,'opening day at','opening day at',0,1,1.4667,'O1523',1,'*'),(772,'16','16',0,0,0.2,'',1,'*'),(773,'bigger','bigger',0,0,0.4,'B260',1,'*'),(774,'bigger in','bigger in',0,1,1.3,'B265',1,'*'),(775,'bigger in the','bigger in the',0,1,1.4333,'B2653',1,'*'),(776,'go','go',0,0,0.1333,'G000',1,'*'),(777,'go bigger','go bigger',0,1,1.3,'G126',1,'*'),(778,'go bigger in','go bigger in',0,1,1.4,'G1265',1,'*'),(779,'in the uk','in the uk',0,1,1.3,'I532',1,'*'),(780,'the uk','the uk',0,1,1.2,'T200',1,'*'),(781,'uk','uk',0,0,0.1333,'U200',1,'*'),(787,'auctor fringilla lorem','auctor fringilla lorem',0,1,1.7333,'A2361652465',1,'*'),(788,'fringilla lorem','fringilla lorem',0,1,1.5,'F652465',1,'*'),(789,'fringilla lorem ipsum','fringilla lorem ipsum',0,1,1.7,'F652465125',1,'*'),(790,'ipsum','ipsum',0,0,0.3333,'I125',1,'*'),(791,'ipsum lorem','ipsum lorem',0,1,1.3667,'I125465',1,'*'),(792,'ipsum lorem ipsum','ipsum lorem ipsum',0,1,1.5667,'I125465125',1,'*'),(793,'lorem','lorem',0,0,0.3333,'L650',1,'*'),(794,'lorem ipsum','lorem ipsum',0,1,1.3667,'L65125',1,'*'),(795,'lorem ipsum lorem','lorem ipsum lorem',0,1,1.5667,'L65125465',1,'*');


--
-- Table structure for table `#__finder_terms_common`
--



CREATE TABLE `#__finder_terms_common` (
  `term` varchar(75) NOT NULL,
  `language` varchar(3) NOT NULL,
  KEY `idx_word_lang` (`term`,`language`),
  KEY `idx_lang` (`language`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_terms_common`
--


INSERT INTO `#__finder_terms_common` (`term`, `language`) VALUES ('a','en'),('about','en'),('after','en'),('ago','en'),('all','en'),('am','en'),('an','en'),('and','en'),('ani','en'),('any','en'),('are','en'),('aren\'t','en'),('as','en'),('at','en'),('be','en'),('but','en'),('by','en'),('for','en'),('from','en'),('get','en'),('go','en'),('how','en'),('if','en'),('in','en'),('into','en'),('is','en'),('isn\'t','en'),('it','en'),('its','en'),('me','en'),('more','en'),('most','en'),('must','en'),('my','en'),('new','en'),('no','en'),('none','en'),('not','en'),('noth','en'),('nothing','en'),('of','en'),('off','en'),('often','en'),('old','en'),('on','en'),('onc','en'),('once','en'),('onli','en'),('only','en'),('or','en'),('other','en'),('our','en'),('ours','en'),('out','en'),('over','en'),('page','en'),('she','en'),('should','en'),('small','en'),('so','en'),('some','en'),('than','en'),('thank','en'),('that','en'),('the','en'),('their','en'),('theirs','en'),('them','en'),('then','en'),('there','en'),('these','en'),('they','en'),('this','en'),('those','en'),('thus','en'),('time','en'),('times','en'),('to','en'),('too','en'),('true','en'),('under','en'),('until','en'),('up','en'),('upon','en'),('use','en'),('user','en'),('users','en'),('veri','en'),('version','en'),('very','en'),('via','en'),('want','en'),('was','en'),('way','en'),('were','en'),('what','en'),('when','en'),('where','en'),('whi','en'),('which','en'),('who','en'),('whom','en'),('whose','en'),('why','en'),('wide','en'),('will','en'),('with','en'),('within','en'),('without','en'),('would','en'),('yes','en'),('yet','en'),('you','en'),('your','en'),('yours','en');


--
-- Table structure for table `#__finder_tokens`
--



CREATE TABLE `#__finder_tokens` (
  `term` varchar(75) NOT NULL,
  `stem` varchar(75) NOT NULL,
  `common` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `phrase` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `weight` float unsigned NOT NULL DEFAULT '1',
  `context` tinyint(1) unsigned NOT NULL DEFAULT '2',
  `language` char(3) NOT NULL DEFAULT '',
  KEY `idx_word` (`term`),
  KEY `idx_context` (`context`)
) ENGINE=MEMORY DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_tokens`
--




--
-- Table structure for table `#__finder_tokens_aggregate`
--



CREATE TABLE `#__finder_tokens_aggregate` (
  `term_id` int(10) unsigned NOT NULL,
  `map_suffix` char(1) NOT NULL,
  `term` varchar(75) NOT NULL,
  `stem` varchar(75) NOT NULL,
  `common` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `phrase` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `term_weight` float unsigned NOT NULL,
  `context` tinyint(1) unsigned NOT NULL DEFAULT '2',
  `context_weight` float unsigned NOT NULL,
  `total_weight` float unsigned NOT NULL,
  `language` char(3) NOT NULL DEFAULT '',
  KEY `token` (`term`),
  KEY `keyword_id` (`term_id`)
) ENGINE=MEMORY DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_tokens_aggregate`
--




--
-- Table structure for table `#__finder_types`
--



CREATE TABLE `#__finder_types` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `title` varchar(100) NOT NULL,
  `mime` varchar(100) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `title` (`title`)
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__finder_types`
--


INSERT INTO `#__finder_types` (`id`, `title`, `mime`) VALUES (1,'K2 Item',''),(2,'Category',''),(3,'Contact',''),(4,'Article',''),(5,'News Feed',''),(6,'Web Link','');


--
-- Table structure for table `#__k2_attachments`
--



CREATE TABLE `#__k2_attachments` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `itemID` int(11) NOT NULL,
  `filename` varchar(255) NOT NULL,
  `title` varchar(255) NOT NULL,
  `titleAttribute` text NOT NULL,
  `hits` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `itemID` (`itemID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__k2_attachments`
--




--
-- Table structure for table `#__k2_categories`
--



CREATE TABLE `#__k2_categories` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `alias` varchar(255) NOT NULL,
  `description` text NOT NULL,
  `parent` int(11) DEFAULT '0',
  `extraFieldsGroup` int(11) NOT NULL,
  `published` smallint(6) NOT NULL DEFAULT '0',
  `access` int(11) NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `image` varchar(255) NOT NULL,
  `params` text NOT NULL,
  `trash` smallint(6) NOT NULL DEFAULT '0',
  `plugins` text NOT NULL,
  `language` char(7) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `category` (`published`,`access`,`trash`),
  KEY `parent` (`parent`),
  KEY `ordering` (`ordering`),
  KEY `published` (`published`),
  KEY `access` (`access`),
  KEY `trash` (`trash`),
  KEY `language` (`language`)
) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__k2_categories`
--


INSERT INTO `#__k2_categories` (`id`, `name`, `alias`, `description`, `parent`, `extraFieldsGroup`, `published`, `access`, `ordering`, `image`, `params`, `trash`, `plugins`, `language`) VALUES (1,'Snowboarding Resorts','snowboarding-resorts','',0,1,1,1,1,'1.jpg','{\"inheritFrom\":\"0\",\"theme\":\"\",\"num_leading_items\":\"4\",\"num_leading_columns\":\"1\",\"leadingImgSize\":\"Large\",\"num_primary_items\":\"4\",\"num_primary_columns\":\"1\",\"primaryImgSize\":\"Large\",\"num_secondary_items\":\"4\",\"num_secondary_columns\":\"1\",\"secondaryImgSize\":\"Large\",\"num_links\":\"2\",\"num_links_columns\":\"1\",\"linksImgSize\":\"Large\",\"catCatalogMode\":\"1\",\"catFeaturedItems\":\"1\",\"catOrdering\":\"\",\"catPagination\":\"2\",\"catPaginationResults\":\"1\",\"catTitle\":\"0\",\"catTitleItemCounter\":\"0\",\"catDescription\":\"0\",\"catImage\":\"0\",\"catFeedLink\":\"1\",\"catFeedIcon\":\"1\",\"subCategories\":\"0\",\"subCatColumns\":\"4\",\"subCatOrdering\":\"\",\"subCatTitle\":\"0\",\"subCatTitleItemCounter\":\"0\",\"subCatDescription\":\"0\",\"subCatImage\":\"0\",\"itemImageXS\":\"\",\"itemImageS\":\"\",\"itemImageM\":\"\",\"itemImageL\":\"\",\"itemImageXL\":\"\",\"catItemTitle\":\"1\",\"catItemTitleLinked\":\"1\",\"catItemFeaturedNotice\":\"0\",\"catItemAuthor\":\"1\",\"catItemDateCreated\":\"1\",\"catItemRating\":\"0\",\"catItemImage\":\"1\",\"catItemIntroText\":\"1\",\"catItemIntroTextWordLimit\":\"\",\"catItemExtraFields\":\"0\",\"catItemHits\":\"0\",\"catItemCategory\":\"1\",\"catItemTags\":\"0\",\"catItemAttachments\":\"0\",\"catItemAttachmentsCounter\":\"0\",\"catItemVideo\":\"0\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"0\",\"catItemImageGallery\":\"0\",\"catItemDateModified\":\"0\",\"catItemReadMore\":\"1\",\"catItemCommentsAnchor\":\"1\",\"catItemK2Plugins\":\"1\",\"itemDateCreated\":\"1\",\"itemTitle\":\"1\",\"itemFeaturedNotice\":\"1\",\"itemAuthor\":\"1\",\"itemFontResizer\":\"1\",\"itemPrintButton\":\"1\",\"itemEmailButton\":\"1\",\"itemSocialButton\":\"1\",\"itemVideoAnchor\":\"1\",\"itemImageGalleryAnchor\":\"1\",\"itemCommentsAnchor\":\"1\",\"itemRating\":\"1\",\"itemImage\":\"1\",\"itemImgSize\":\"Large\",\"itemImageMainCaption\":\"1\",\"itemImageMainCredits\":\"1\",\"itemIntroText\":\"1\",\"itemFullText\":\"1\",\"itemExtraFields\":\"1\",\"itemDateModified\":\"1\",\"itemHits\":\"1\",\"itemCategory\":\"1\",\"itemTags\":\"1\",\"itemAttachments\":\"1\",\"itemAttachmentsCounter\":\"1\",\"itemVideo\":\"1\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"0\",\"itemVideoCaption\":\"1\",\"itemVideoCredits\":\"1\",\"itemImageGallery\":\"1\",\"itemNavigation\":\"1\",\"itemComments\":\"1\",\"itemTwitterButton\":\"1\",\"itemFacebookButton\":\"1\",\"itemGooglePlusOneButton\":\"1\",\"itemAuthorBlock\":\"1\",\"itemAuthorImage\":\"1\",\"itemAuthorDescription\":\"1\",\"itemAuthorURL\":\"1\",\"itemAuthorEmail\":\"0\",\"itemAuthorLatest\":\"1\",\"itemAuthorLatestLimit\":\"5\",\"itemRelated\":\"1\",\"itemRelatedLimit\":\"5\",\"itemRelatedTitle\":\"1\",\"itemRelatedCategory\":\"0\",\"itemRelatedImageSize\":\"0\",\"itemRelatedIntrotext\":\"0\",\"itemRelatedFulltext\":\"0\",\"itemRelatedAuthor\":\"0\",\"itemRelatedMedia\":\"0\",\"itemRelatedImageGallery\":\"0\",\"itemK2Plugins\":\"1\",\"catMetaDesc\":\"\",\"catMetaKey\":\"\",\"catMetaRobots\":\"\",\"catMetaAuthor\":\"\"}',0,'','*'),(2,'Event Coverage','event-coverage','',0,0,1,1,2,'','{\"inheritFrom\":\"1\",\"theme\":\"\",\"num_leading_items\":\"2\",\"num_leading_columns\":\"1\",\"leadingImgSize\":\"Large\",\"num_primary_items\":\"4\",\"num_primary_columns\":\"2\",\"primaryImgSize\":\"Medium\",\"num_secondary_items\":\"4\",\"num_secondary_columns\":\"1\",\"secondaryImgSize\":\"Small\",\"num_links\":\"4\",\"num_links_columns\":\"1\",\"linksImgSize\":\"XSmall\",\"catCatalogMode\":\"0\",\"catFeaturedItems\":\"1\",\"catOrdering\":\"\",\"catPagination\":\"2\",\"catPaginationResults\":\"1\",\"catTitle\":\"1\",\"catTitleItemCounter\":\"1\",\"catDescription\":\"1\",\"catImage\":\"1\",\"catFeedLink\":\"1\",\"catFeedIcon\":\"1\",\"subCategories\":\"1\",\"subCatColumns\":\"2\",\"subCatOrdering\":\"\",\"subCatTitle\":\"1\",\"subCatTitleItemCounter\":\"1\",\"subCatDescription\":\"1\",\"subCatImage\":\"1\",\"itemImageXS\":\"\",\"itemImageS\":\"\",\"itemImageM\":\"\",\"itemImageL\":\"\",\"itemImageXL\":\"\",\"catItemTitle\":\"1\",\"catItemTitleLinked\":\"1\",\"catItemFeaturedNotice\":\"0\",\"catItemAuthor\":\"1\",\"catItemDateCreated\":\"1\",\"catItemRating\":\"0\",\"catItemImage\":\"1\",\"catItemIntroText\":\"1\",\"catItemIntroTextWordLimit\":\"\",\"catItemExtraFields\":\"0\",\"catItemHits\":\"0\",\"catItemCategory\":\"1\",\"catItemTags\":\"1\",\"catItemAttachments\":\"0\",\"catItemAttachmentsCounter\":\"0\",\"catItemVideo\":\"0\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"0\",\"catItemImageGallery\":\"0\",\"catItemDateModified\":\"0\",\"catItemReadMore\":\"1\",\"catItemCommentsAnchor\":\"1\",\"catItemK2Plugins\":\"1\",\"itemDateCreated\":\"1\",\"itemTitle\":\"1\",\"itemFeaturedNotice\":\"1\",\"itemAuthor\":\"1\",\"itemFontResizer\":\"1\",\"itemPrintButton\":\"1\",\"itemEmailButton\":\"1\",\"itemSocialButton\":\"1\",\"itemVideoAnchor\":\"1\",\"itemImageGalleryAnchor\":\"1\",\"itemCommentsAnchor\":\"1\",\"itemRating\":\"1\",\"itemImage\":\"1\",\"itemImgSize\":\"Large\",\"itemImageMainCaption\":\"1\",\"itemImageMainCredits\":\"1\",\"itemIntroText\":\"1\",\"itemFullText\":\"1\",\"itemExtraFields\":\"1\",\"itemDateModified\":\"1\",\"itemHits\":\"1\",\"itemCategory\":\"1\",\"itemTags\":\"1\",\"itemAttachments\":\"1\",\"itemAttachmentsCounter\":\"1\",\"itemVideo\":\"1\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"0\",\"itemVideoCaption\":\"1\",\"itemVideoCredits\":\"1\",\"itemImageGallery\":\"1\",\"itemNavigation\":\"1\",\"itemComments\":\"1\",\"itemTwitterButton\":\"1\",\"itemFacebookButton\":\"1\",\"itemGooglePlusOneButton\":\"1\",\"itemAuthorBlock\":\"1\",\"itemAuthorImage\":\"1\",\"itemAuthorDescription\":\"1\",\"itemAuthorURL\":\"1\",\"itemAuthorEmail\":\"0\",\"itemAuthorLatest\":\"1\",\"itemAuthorLatestLimit\":\"5\",\"itemRelated\":\"1\",\"itemRelatedLimit\":\"5\",\"itemRelatedTitle\":\"1\",\"itemRelatedCategory\":\"0\",\"itemRelatedImageSize\":\"0\",\"itemRelatedIntrotext\":\"0\",\"itemRelatedFulltext\":\"0\",\"itemRelatedAuthor\":\"0\",\"itemRelatedMedia\":\"0\",\"itemRelatedImageGallery\":\"0\",\"itemK2Plugins\":\"1\",\"catMetaDesc\":\"\",\"catMetaKey\":\"\",\"catMetaRobots\":\"\",\"catMetaAuthor\":\"\"}',0,'','*'),(3,'Gear Accessories','gear-accessories','',0,1,1,1,3,'','{\"inheritFrom\":\"1\",\"theme\":\"\",\"num_leading_items\":\"2\",\"num_leading_columns\":\"1\",\"leadingImgSize\":\"Large\",\"num_primary_items\":\"4\",\"num_primary_columns\":\"2\",\"primaryImgSize\":\"Medium\",\"num_secondary_items\":\"4\",\"num_secondary_columns\":\"1\",\"secondaryImgSize\":\"Small\",\"num_links\":\"4\",\"num_links_columns\":\"1\",\"linksImgSize\":\"XSmall\",\"catCatalogMode\":\"0\",\"catFeaturedItems\":\"1\",\"catOrdering\":\"\",\"catPagination\":\"2\",\"catPaginationResults\":\"1\",\"catTitle\":\"1\",\"catTitleItemCounter\":\"1\",\"catDescription\":\"1\",\"catImage\":\"1\",\"catFeedLink\":\"1\",\"catFeedIcon\":\"1\",\"subCategories\":\"1\",\"subCatColumns\":\"2\",\"subCatOrdering\":\"\",\"subCatTitle\":\"1\",\"subCatTitleItemCounter\":\"1\",\"subCatDescription\":\"1\",\"subCatImage\":\"1\",\"itemImageXS\":\"\",\"itemImageS\":\"\",\"itemImageM\":\"\",\"itemImageL\":\"\",\"itemImageXL\":\"\",\"catItemTitle\":\"1\",\"catItemTitleLinked\":\"1\",\"catItemFeaturedNotice\":\"0\",\"catItemAuthor\":\"1\",\"catItemDateCreated\":\"1\",\"catItemRating\":\"0\",\"catItemImage\":\"1\",\"catItemIntroText\":\"1\",\"catItemIntroTextWordLimit\":\"\",\"catItemExtraFields\":\"0\",\"catItemHits\":\"0\",\"catItemCategory\":\"1\",\"catItemTags\":\"1\",\"catItemAttachments\":\"0\",\"catItemAttachmentsCounter\":\"0\",\"catItemVideo\":\"0\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"0\",\"catItemImageGallery\":\"0\",\"catItemDateModified\":\"0\",\"catItemReadMore\":\"1\",\"catItemCommentsAnchor\":\"1\",\"catItemK2Plugins\":\"1\",\"itemDateCreated\":\"1\",\"itemTitle\":\"1\",\"itemFeaturedNotice\":\"1\",\"itemAuthor\":\"1\",\"itemFontResizer\":\"1\",\"itemPrintButton\":\"1\",\"itemEmailButton\":\"1\",\"itemSocialButton\":\"1\",\"itemVideoAnchor\":\"1\",\"itemImageGalleryAnchor\":\"1\",\"itemCommentsAnchor\":\"1\",\"itemRating\":\"1\",\"itemImage\":\"1\",\"itemImgSize\":\"Large\",\"itemImageMainCaption\":\"1\",\"itemImageMainCredits\":\"1\",\"itemIntroText\":\"1\",\"itemFullText\":\"1\",\"itemExtraFields\":\"1\",\"itemDateModified\":\"1\",\"itemHits\":\"1\",\"itemCategory\":\"1\",\"itemTags\":\"1\",\"itemAttachments\":\"1\",\"itemAttachmentsCounter\":\"1\",\"itemVideo\":\"1\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"0\",\"itemVideoCaption\":\"1\",\"itemVideoCredits\":\"1\",\"itemImageGallery\":\"1\",\"itemNavigation\":\"1\",\"itemComments\":\"1\",\"itemTwitterButton\":\"1\",\"itemFacebookButton\":\"1\",\"itemGooglePlusOneButton\":\"1\",\"itemAuthorBlock\":\"1\",\"itemAuthorImage\":\"1\",\"itemAuthorDescription\":\"1\",\"itemAuthorURL\":\"1\",\"itemAuthorEmail\":\"0\",\"itemAuthorLatest\":\"1\",\"itemAuthorLatestLimit\":\"5\",\"itemRelated\":\"1\",\"itemRelatedLimit\":\"5\",\"itemRelatedTitle\":\"1\",\"itemRelatedCategory\":\"0\",\"itemRelatedImageSize\":\"0\",\"itemRelatedIntrotext\":\"0\",\"itemRelatedFulltext\":\"0\",\"itemRelatedAuthor\":\"0\",\"itemRelatedMedia\":\"0\",\"itemRelatedImageGallery\":\"0\",\"itemK2Plugins\":\"1\",\"catMetaDesc\":\"\",\"catMetaKey\":\"\",\"catMetaRobots\":\"\",\"catMetaAuthor\":\"\"}',0,'','*'),(4,'Photo Of The Day','photo-of-the-day','',0,1,1,1,4,'','{\"inheritFrom\":\"1\",\"theme\":\"\",\"num_leading_items\":\"2\",\"num_leading_columns\":\"1\",\"leadingImgSize\":\"Large\",\"num_primary_items\":\"4\",\"num_primary_columns\":\"2\",\"primaryImgSize\":\"Medium\",\"num_secondary_items\":\"4\",\"num_secondary_columns\":\"1\",\"secondaryImgSize\":\"Small\",\"num_links\":\"4\",\"num_links_columns\":\"1\",\"linksImgSize\":\"XSmall\",\"catCatalogMode\":\"0\",\"catFeaturedItems\":\"1\",\"catOrdering\":\"\",\"catPagination\":\"2\",\"catPaginationResults\":\"1\",\"catTitle\":\"1\",\"catTitleItemCounter\":\"1\",\"catDescription\":\"1\",\"catImage\":\"1\",\"catFeedLink\":\"1\",\"catFeedIcon\":\"1\",\"subCategories\":\"1\",\"subCatColumns\":\"2\",\"subCatOrdering\":\"\",\"subCatTitle\":\"1\",\"subCatTitleItemCounter\":\"1\",\"subCatDescription\":\"1\",\"subCatImage\":\"1\",\"itemImageXS\":\"\",\"itemImageS\":\"\",\"itemImageM\":\"\",\"itemImageL\":\"\",\"itemImageXL\":\"\",\"catItemTitle\":\"1\",\"catItemTitleLinked\":\"1\",\"catItemFeaturedNotice\":\"0\",\"catItemAuthor\":\"1\",\"catItemDateCreated\":\"1\",\"catItemRating\":\"0\",\"catItemImage\":\"1\",\"catItemIntroText\":\"1\",\"catItemIntroTextWordLimit\":\"\",\"catItemExtraFields\":\"0\",\"catItemHits\":\"0\",\"catItemCategory\":\"1\",\"catItemTags\":\"1\",\"catItemAttachments\":\"0\",\"catItemAttachmentsCounter\":\"0\",\"catItemVideo\":\"0\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"0\",\"catItemImageGallery\":\"0\",\"catItemDateModified\":\"0\",\"catItemReadMore\":\"1\",\"catItemCommentsAnchor\":\"1\",\"catItemK2Plugins\":\"1\",\"itemDateCreated\":\"1\",\"itemTitle\":\"1\",\"itemFeaturedNotice\":\"1\",\"itemAuthor\":\"1\",\"itemFontResizer\":\"1\",\"itemPrintButton\":\"1\",\"itemEmailButton\":\"1\",\"itemSocialButton\":\"1\",\"itemVideoAnchor\":\"1\",\"itemImageGalleryAnchor\":\"1\",\"itemCommentsAnchor\":\"1\",\"itemRating\":\"1\",\"itemImage\":\"1\",\"itemImgSize\":\"Large\",\"itemImageMainCaption\":\"1\",\"itemImageMainCredits\":\"1\",\"itemIntroText\":\"1\",\"itemFullText\":\"1\",\"itemExtraFields\":\"1\",\"itemDateModified\":\"1\",\"itemHits\":\"1\",\"itemCategory\":\"1\",\"itemTags\":\"1\",\"itemAttachments\":\"1\",\"itemAttachmentsCounter\":\"1\",\"itemVideo\":\"1\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"0\",\"itemVideoCaption\":\"1\",\"itemVideoCredits\":\"1\",\"itemImageGallery\":\"1\",\"itemNavigation\":\"1\",\"itemComments\":\"1\",\"itemTwitterButton\":\"1\",\"itemFacebookButton\":\"1\",\"itemGooglePlusOneButton\":\"1\",\"itemAuthorBlock\":\"1\",\"itemAuthorImage\":\"1\",\"itemAuthorDescription\":\"1\",\"itemAuthorURL\":\"1\",\"itemAuthorEmail\":\"0\",\"itemAuthorLatest\":\"1\",\"itemAuthorLatestLimit\":\"5\",\"itemRelated\":\"1\",\"itemRelatedLimit\":\"5\",\"itemRelatedTitle\":\"1\",\"itemRelatedCategory\":\"0\",\"itemRelatedImageSize\":\"0\",\"itemRelatedIntrotext\":\"0\",\"itemRelatedFulltext\":\"0\",\"itemRelatedAuthor\":\"0\",\"itemRelatedMedia\":\"0\",\"itemRelatedImageGallery\":\"0\",\"itemK2Plugins\":\"1\",\"catMetaDesc\":\"\",\"catMetaKey\":\"\",\"catMetaRobots\":\"\",\"catMetaAuthor\":\"\"}',0,'','*');


--
-- Table structure for table `#__k2_comments`
--



CREATE TABLE `#__k2_comments` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `itemID` int(11) NOT NULL,
  `userID` int(11) NOT NULL,
  `userName` varchar(255) NOT NULL,
  `commentDate` datetime NOT NULL,
  `commentText` text NOT NULL,
  `commentEmail` varchar(255) NOT NULL,
  `commentURL` varchar(255) NOT NULL,
  `published` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `itemID` (`itemID`),
  KEY `userID` (`userID`),
  KEY `published` (`published`),
  KEY `latestComments` (`published`,`commentDate`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__k2_comments`
--


INSERT INTO `#__k2_comments` (`id`, `itemID`, `userID`, `userName`, `commentDate`, `commentText`, `commentEmail`, `commentURL`, `published`) VALUES (1,1,0,'Paulo','2012-12-05 08:16:22','Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Cras mattis consectetur purus sit amet fermentum. Donec id elit non mi porta gravida at eget metus.','paulo@tttt.er','',1),(2,1,944,'Super User','2012-12-05 08:17:36','Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Vestibulum id ligula porta felis euismod semper. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Cras mattis consectetur purus sit amet fermentum. Donec id elit non mi porta gravida at eget metus.','blank@gavick.com','',1);


--
-- Table structure for table `#__k2_extra_fields`
--



CREATE TABLE `#__k2_extra_fields` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `value` text NOT NULL,
  `type` varchar(255) NOT NULL,
  `group` int(11) NOT NULL,
  `published` tinyint(4) NOT NULL,
  `ordering` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `group` (`group`),
  KEY `published` (`published`),
  KEY `ordering` (`ordering`)
) ENGINE=MyISAM AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__k2_extra_fields`
--


INSERT INTO `#__k2_extra_fields` (`id`, `name`, `value`, `type`, `group`, `published`, `ordering`) VALUES (1,'Frame','[{\"name\":null,\"value\":\"\",\"editor\":null,\"target\":null,\"alias\":\"Frame\",\"required\":0,\"showNull\":0}]','textarea',1,1,1),(2,'Fork','[{\"name\":null,\"value\":\"\",\"editor\":null,\"target\":null,\"alias\":\"Fork\",\"required\":0,\"showNull\":0}]','textarea',1,1,2),(3,'Gears','[{\"name\":null,\"value\":\"\",\"editor\":null,\"target\":null,\"alias\":\"Gears\",\"required\":0,\"showNull\":0}]','textarea',1,1,3);


--
-- Table structure for table `#__k2_extra_fields_groups`
--



CREATE TABLE `#__k2_extra_fields_groups` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__k2_extra_fields_groups`
--


INSERT INTO `#__k2_extra_fields_groups` (`id`, `name`) VALUES (1,'Extra fields group');


--
-- Table structure for table `#__k2_items`
--



CREATE TABLE `#__k2_items` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL,
  `alias` varchar(255) DEFAULT NULL,
  `catid` int(11) NOT NULL,
  `published` smallint(6) NOT NULL DEFAULT '0',
  `introtext` mediumtext NOT NULL,
  `fulltext` mediumtext NOT NULL,
  `video` text,
  `gallery` varchar(255) DEFAULT NULL,
  `extra_fields` text CHARACTER SET utf8 COLLATE utf8_unicode_ci,
  `extra_fields_search` text NOT NULL,
  `created` datetime NOT NULL,
  `created_by` int(11) NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL,
  `checked_out` int(10) unsigned NOT NULL,
  `checked_out_time` datetime NOT NULL,
  `modified` datetime NOT NULL,
  `modified_by` int(11) NOT NULL DEFAULT '0',
  `publish_up` datetime NOT NULL,
  `publish_down` datetime NOT NULL,
  `trash` smallint(6) NOT NULL DEFAULT '0',
  `access` int(11) NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `featured` smallint(6) NOT NULL DEFAULT '0',
  `featured_ordering` int(11) NOT NULL DEFAULT '0',
  `image_caption` text NOT NULL,
  `image_credits` varchar(255) NOT NULL,
  `video_caption` text NOT NULL,
  `video_credits` varchar(255) NOT NULL,
  `hits` int(10) unsigned NOT NULL,
  `params` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `metakey` text NOT NULL,
  `plugins` text NOT NULL,
  `language` char(7) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `item` (`published`,`publish_up`,`publish_down`,`trash`,`access`),
  KEY `catid` (`catid`),
  KEY `created_by` (`created_by`),
  KEY `ordering` (`ordering`),
  KEY `featured` (`featured`),
  KEY `featured_ordering` (`featured_ordering`),
  KEY `hits` (`hits`),
  KEY `created` (`created`),
  KEY `language` (`language`),
  FULLTEXT KEY `search` (`title`,`introtext`,`fulltext`,`extra_fields_search`,`image_caption`,`image_credits`,`video_caption`,`video_credits`,`metadesc`,`metakey`),
  FULLTEXT KEY `title` (`title`)
) ENGINE=MyISAM AUTO_INCREMENT=17 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__k2_items`
--


INSERT INTO `#__k2_items` (`id`, `title`, `alias`, `catid`, `published`, `introtext`, `fulltext`, `video`, `gallery`, `extra_fields`, `extra_fields_search`, `created`, `created_by`, `created_by_alias`, `checked_out`, `checked_out_time`, `modified`, `modified_by`, `publish_up`, `publish_down`, `trash`, `access`, `ordering`, `featured`, `featured_ordering`, `image_caption`, `image_credits`, `video_caption`, `video_credits`, `hits`, `params`, `metadesc`, `metadata`, `metakey`, `plugins`, `language`) VALUES (1,'Snowbasin is now open','snowbasin-is-now-open',3,1,'<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n','\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla. Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>\r\n<ul>\r\n<li>Lorem Ipsum</li>\r\n<li>Lorem Ipsum</li>\r\n<li>Lorem Ipsum</li>\r\n</ul>\r\n<ol>\r\n<li>Lorem Ipsum</li>\r\n<li>Lorem Ipsum</li>\r\n<li>Lorem Ipsum</li>\r\n</ol>',NULL,NULL,'[{\"id\":\"1\",\"value\":\"\"},{\"id\":\"2\",\"value\":\"\"},{\"id\":\"3\",\"value\":\"\"}]','   ','2012-12-03 11:26:54',944,'',0,'0000-00-00 00:00:00','2013-02-08 09:13:30',944,'2012-12-03 11:26:54','0000-00-00 00:00:00',0,1,1,1,1,'Snowbasin is now open','','','',17,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemTwitterButton\":\"\",\"itemFacebookButton\":\"\",\"itemGooglePlusOneButton\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemRelatedTitle\":\"\",\"itemRelatedCategory\":\"\",\"itemRelatedImageSize\":\"\",\"itemRelatedIntrotext\":\"\",\"itemRelatedFulltext\":\"\",\"itemRelatedAuthor\":\"\",\"itemRelatedMedia\":\"\",\"itemRelatedImageGallery\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','*'),(2,'What Makes A Snowboarding Destination','what-makes-a-snowboarding-destination',3,1,'<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n','\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla. Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>',NULL,NULL,'[{\"id\":\"1\",\"value\":\"\"},{\"id\":\"2\",\"value\":\"\"},{\"id\":\"3\",\"value\":\"\"}]','   ','2012-12-03 11:31:02',944,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00',0,'2012-12-03 11:31:02','0000-00-00 00:00:00',0,1,2,0,0,'What Makes A Snowboarding Destination Tick For You?','','','',0,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemTwitterButton\":\"\",\"itemFacebookButton\":\"\",\"itemGooglePlusOneButton\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemRelatedTitle\":\"\",\"itemRelatedCategory\":\"\",\"itemRelatedImageSize\":\"\",\"itemRelatedIntrotext\":\"\",\"itemRelatedFulltext\":\"\",\"itemRelatedAuthor\":\"\",\"itemRelatedMedia\":\"\",\"itemRelatedImageGallery\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','*'),(3,'At the End - Happy To Be Alive','at-the-end-happy-to-be-alive',4,1,'<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n','\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla. Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>',NULL,NULL,'[{\"id\":\"1\",\"value\":\"\"},{\"id\":\"2\",\"value\":\"\"},{\"id\":\"3\",\"value\":\"\"}]','   ','2012-12-03 11:32:58',944,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00',0,'2012-12-03 11:32:58','0000-00-00 00:00:00',0,1,1,1,2,'At the End - Happy To Be Alive','','','',0,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemTwitterButton\":\"\",\"itemFacebookButton\":\"\",\"itemGooglePlusOneButton\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemRelatedTitle\":\"\",\"itemRelatedCategory\":\"\",\"itemRelatedImageSize\":\"\",\"itemRelatedIntrotext\":\"\",\"itemRelatedFulltext\":\"\",\"itemRelatedAuthor\":\"\",\"itemRelatedMedia\":\"\",\"itemRelatedImageGallery\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','*'),(4,'Bear Mountain Sunday In The Park','bear-mountain-sunday-in-the-park',1,1,'<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n','\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla. Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>',NULL,NULL,'[{\"id\":\"1\",\"value\":\"\"},{\"id\":\"2\",\"value\":\"\"},{\"id\":\"3\",\"value\":\"\"}]','   ','2012-12-03 11:37:37',944,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00',0,'2012-12-03 11:37:37','0000-00-00 00:00:00',0,1,1,0,0,'Bear Mountain Sunday In The Park 2012','','','',0,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemTwitterButton\":\"\",\"itemFacebookButton\":\"\",\"itemGooglePlusOneButton\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemRelatedTitle\":\"\",\"itemRelatedCategory\":\"\",\"itemRelatedImageSize\":\"\",\"itemRelatedIntrotext\":\"\",\"itemRelatedFulltext\":\"\",\"itemRelatedAuthor\":\"\",\"itemRelatedMedia\":\"\",\"itemRelatedImageGallery\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','*'),(5,'Sooner or later you reach higher','sooner-or-later-you-reach-higher',1,1,'<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n','\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla. Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>',NULL,NULL,'[{\"id\":\"1\",\"value\":\"\"},{\"id\":\"2\",\"value\":\"\"},{\"id\":\"3\",\"value\":\"\"}]','   ','2012-12-03 11:39:02',944,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00',0,'2012-12-03 11:39:02','0000-00-00 00:00:00',0,1,2,1,3,'Sooner or later you reach that magical point','','','',0,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemTwitterButton\":\"\",\"itemFacebookButton\":\"\",\"itemGooglePlusOneButton\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemRelatedTitle\":\"\",\"itemRelatedCategory\":\"\",\"itemRelatedImageSize\":\"\",\"itemRelatedIntrotext\":\"\",\"itemRelatedFulltext\":\"\",\"itemRelatedAuthor\":\"\",\"itemRelatedMedia\":\"\",\"itemRelatedImageGallery\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','*'),(6,'Happy To Be Alive','happy-to-be-alive',1,1,'<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n','\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla. Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>',NULL,NULL,'[{\"id\":\"1\",\"value\":\"\"},{\"id\":\"2\",\"value\":\"\"},{\"id\":\"3\",\"value\":\"\"}]','   ','2012-12-03 11:40:57',944,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00',0,'2012-12-03 11:40:57','0000-00-00 00:00:00',0,1,3,0,0,' Happy To Be Alive','','','',3,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemTwitterButton\":\"\",\"itemFacebookButton\":\"\",\"itemGooglePlusOneButton\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemRelatedTitle\":\"\",\"itemRelatedCategory\":\"\",\"itemRelatedImageSize\":\"\",\"itemRelatedIntrotext\":\"\",\"itemRelatedFulltext\":\"\",\"itemRelatedAuthor\":\"\",\"itemRelatedMedia\":\"\",\"itemRelatedImageGallery\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','*'),(7,'Perfect weather, a great slopestyle','perfect-weather-a-great-slopestyle',2,1,'<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n','\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla. Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>',NULL,NULL,'[]','','2012-12-03 11:42:47',944,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00',0,'2012-12-03 11:42:47','0000-00-00 00:00:00',0,1,1,1,4,'Perfect weather, a great slopestyle','','','',0,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemTwitterButton\":\"\",\"itemFacebookButton\":\"\",\"itemGooglePlusOneButton\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemRelatedTitle\":\"\",\"itemRelatedCategory\":\"\",\"itemRelatedImageSize\":\"\",\"itemRelatedIntrotext\":\"\",\"itemRelatedFulltext\":\"\",\"itemRelatedAuthor\":\"\",\"itemRelatedMedia\":\"\",\"itemRelatedImageGallery\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','*'),(8,'Just Jared premium partner','just-jared-premium-partner',2,1,'<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n','\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla. Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>',NULL,NULL,'[]','','2012-12-03 11:44:17',944,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00',0,'2012-12-03 11:44:17','0000-00-00 00:00:00',0,1,2,0,0,' Just Jared premium partner','','','',0,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemTwitterButton\":\"\",\"itemFacebookButton\":\"\",\"itemGooglePlusOneButton\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemRelatedTitle\":\"\",\"itemRelatedCategory\":\"\",\"itemRelatedImageSize\":\"\",\"itemRelatedIntrotext\":\"\",\"itemRelatedFulltext\":\"\",\"itemRelatedAuthor\":\"\",\"itemRelatedMedia\":\"\",\"itemRelatedImageGallery\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','*'),(9,'Snowboarding on sunny day','snowboarding-on-sunny-day',2,1,'<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n','\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla. Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>',NULL,NULL,'[]','','2012-12-03 11:45:50',944,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00',0,'2012-12-03 11:45:50','0000-00-00 00:00:00',0,1,3,1,5,'Snowboarding on sunny day','','','',0,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemTwitterButton\":\"\",\"itemFacebookButton\":\"\",\"itemGooglePlusOneButton\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemRelatedTitle\":\"\",\"itemRelatedCategory\":\"\",\"itemRelatedImageSize\":\"\",\"itemRelatedIntrotext\":\"\",\"itemRelatedFulltext\":\"\",\"itemRelatedAuthor\":\"\",\"itemRelatedMedia\":\"\",\"itemRelatedImageGallery\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','*'),(10,'Billy Morgan is going big at the moment','billy-morgan-is-going-big-at-the-moment',2,1,'<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n','\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla. Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>',NULL,NULL,'[]','','2012-12-03 11:47:17',944,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00',0,'2012-12-03 11:47:17','0000-00-00 00:00:00',0,1,4,0,0,'Billy Morgan is going big at the moment','','','',0,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemTwitterButton\":\"\",\"itemFacebookButton\":\"\",\"itemGooglePlusOneButton\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemRelatedTitle\":\"\",\"itemRelatedCategory\":\"\",\"itemRelatedImageSize\":\"\",\"itemRelatedIntrotext\":\"\",\"itemRelatedFulltext\":\"\",\"itemRelatedAuthor\":\"\",\"itemRelatedMedia\":\"\",\"itemRelatedImageGallery\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','*'),(11,'Missing Winter? Craving Some Pow?','missing-winter?-craving-some-pow?',4,1,'<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n','\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla. Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>',NULL,NULL,'[{\"id\":\"1\",\"value\":\"\"},{\"id\":\"2\",\"value\":\"\"},{\"id\":\"3\",\"value\":\"\"}]','   ','2012-12-03 11:51:30',944,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00',0,'2012-12-03 11:51:30','0000-00-00 00:00:00',0,1,2,1,6,'Missing Winter? Craving Some Pow?','','','',0,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemTwitterButton\":\"\",\"itemFacebookButton\":\"\",\"itemGooglePlusOneButton\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemRelatedTitle\":\"\",\"itemRelatedCategory\":\"\",\"itemRelatedImageSize\":\"\",\"itemRelatedIntrotext\":\"\",\"itemRelatedFulltext\":\"\",\"itemRelatedAuthor\":\"\",\"itemRelatedMedia\":\"\",\"itemRelatedImageGallery\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','*'),(12,'Torstein – In Your Face','torstein-–-in-your-face',4,1,'<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n','\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla. Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>',NULL,NULL,'[{\"id\":\"1\",\"value\":\"\"},{\"id\":\"2\",\"value\":\"\"},{\"id\":\"3\",\"value\":\"\"}]','   ','2012-12-03 11:53:14',944,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00',0,'2012-12-03 11:53:14','0000-00-00 00:00:00',0,1,3,0,0,'Torstein – In Your Face','','','',0,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemTwitterButton\":\"\",\"itemFacebookButton\":\"\",\"itemGooglePlusOneButton\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemRelatedTitle\":\"\",\"itemRelatedCategory\":\"\",\"itemRelatedImageSize\":\"\",\"itemRelatedIntrotext\":\"\",\"itemRelatedFulltext\":\"\",\"itemRelatedAuthor\":\"\",\"itemRelatedMedia\":\"\",\"itemRelatedImageGallery\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','*'),(13,'Why Do You Snowboard?','why-do-you-snowboard?',4,1,'<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n','\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla. Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>',NULL,NULL,'[{\"id\":\"1\",\"value\":\"\"},{\"id\":\"2\",\"value\":\"\"},{\"id\":\"3\",\"value\":\"\"}]','   ','2012-12-03 11:54:37',944,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00',0,'2012-12-03 11:54:37','0000-00-00 00:00:00',0,1,4,1,7,'Why Do You Snowboard? ','','','',0,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemTwitterButton\":\"\",\"itemFacebookButton\":\"\",\"itemGooglePlusOneButton\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemRelatedTitle\":\"\",\"itemRelatedCategory\":\"\",\"itemRelatedImageSize\":\"\",\"itemRelatedIntrotext\":\"\",\"itemRelatedFulltext\":\"\",\"itemRelatedAuthor\":\"\",\"itemRelatedMedia\":\"\",\"itemRelatedImageGallery\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','*'),(14,'Early Season Park Action at Bear Mountain','early-season-park-action-at-bear-mountain',3,1,'<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n','\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla. Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>',NULL,NULL,'[{\"id\":\"1\",\"value\":\"\"},{\"id\":\"2\",\"value\":\"\"},{\"id\":\"3\",\"value\":\"\"}]','   ','2012-12-03 11:56:02',944,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00',0,'2012-12-03 11:56:02','0000-00-00 00:00:00',0,1,3,0,0,'Early Season Park Action at Bear Mountain','','','',0,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemTwitterButton\":\"\",\"itemFacebookButton\":\"\",\"itemGooglePlusOneButton\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemRelatedTitle\":\"\",\"itemRelatedCategory\":\"\",\"itemRelatedImageSize\":\"\",\"itemRelatedIntrotext\":\"\",\"itemRelatedFulltext\":\"\",\"itemRelatedAuthor\":\"\",\"itemRelatedMedia\":\"\",\"itemRelatedImageGallery\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','*'),(15,'Insane Opening Day at Mt Baker','insane-opening-day-at-mt-baker',3,1,'<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n','\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla. Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>',NULL,NULL,'[{\"id\":\"1\",\"value\":\"\"},{\"id\":\"2\",\"value\":\"\"},{\"id\":\"3\",\"value\":\"\"}]','   ','2012-12-03 11:57:26',944,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00',0,'2012-12-03 11:57:26','0000-00-00 00:00:00',0,1,4,1,8,'Insane Opening Day at Mt Baker','','','',0,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemTwitterButton\":\"\",\"itemFacebookButton\":\"\",\"itemGooglePlusOneButton\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemRelatedTitle\":\"\",\"itemRelatedCategory\":\"\",\"itemRelatedImageSize\":\"\",\"itemRelatedIntrotext\":\"\",\"itemRelatedFulltext\":\"\",\"itemRelatedAuthor\":\"\",\"itemRelatedMedia\":\"\",\"itemRelatedImageGallery\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','*'),(16,'Go Bigger In The UK?','go-bigger-in-the-uk?',1,1,'<p>Sed a velit vitae nunc porta iaculis. Aliquam tempus rutrum diam, non tincidunt odio pharetra vitae. Nulla facilisi. Duis sed laoreet dui. Duis a risus nec erat tincidunt feugiat. Cras dui velit, luctus vitae volutpat vitae, vestibulum vitae orci.</p>\r\n','\r\n<p>Cras mattis consectetur purus sit amet fermentum. Nullam quis risus eget urna mollis ornare vel eu leo. Nullam quis risus eget urna mollis ornare vel eu leo. Donec ullamcorper nulla non metus auctor fringilla. Cras mattis consectetur purus sit amet fermentum. Etiam porta sem malesuada magna mollis euismod. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Sed posuere consectetur est at lobortis. Donec ullamcorper nulla non metus auctor fringilla.</p>',NULL,NULL,'[{\"id\":\"1\",\"value\":\"\"},{\"id\":\"2\",\"value\":\"\"},{\"id\":\"3\",\"value\":\"\"}]','   ','2012-12-03 11:59:11',944,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00',0,'2012-12-03 11:59:11','0000-00-00 00:00:00',0,1,4,0,0,'Go Bigger In The UK?','','','',0,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemTwitterButton\":\"\",\"itemFacebookButton\":\"\",\"itemGooglePlusOneButton\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemRelatedTitle\":\"\",\"itemRelatedCategory\":\"\",\"itemRelatedImageSize\":\"\",\"itemRelatedIntrotext\":\"\",\"itemRelatedFulltext\":\"\",\"itemRelatedAuthor\":\"\",\"itemRelatedMedia\":\"\",\"itemRelatedImageGallery\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','*');


--
-- Table structure for table `#__k2_rating`
--



CREATE TABLE `#__k2_rating` (
  `itemID` int(11) NOT NULL DEFAULT '0',
  `rating_sum` int(11) unsigned NOT NULL DEFAULT '0',
  `rating_count` int(11) unsigned NOT NULL DEFAULT '0',
  `lastip` varchar(50) NOT NULL DEFAULT '',
  PRIMARY KEY (`itemID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__k2_rating`
--




--
-- Table structure for table `#__k2_tags`
--



CREATE TABLE `#__k2_tags` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `published` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `published` (`published`),
  FULLTEXT KEY `name` (`name`)
) ENGINE=MyISAM AUTO_INCREMENT=39 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__k2_tags`
--


INSERT INTO `#__k2_tags` (`id`, `name`, `published`) VALUES (1,'Snowboarding',1),(2,'Sports',1),(3,'radical',1),(4,'event',1),(5,'snow',1),(6,'slow motion',1),(7,'Tricky Jump',1),(8,'now',1),(9,'Jump',1),(10,'Snowboard',1),(11,'amazing',1),(12,'speed',1),(13,'events',1),(14,'cold',1),(15,'weather',1),(16,'sliding',1),(17,'free style',1),(18,'Sport',1),(19,'moves',1),(20,'jumps',1),(21,'danger',1),(22,'Just Jared',1),(23,'Premium',1),(24,'Partner',1),(25,'Support',1),(26,'Style',1),(27,'Wear',1),(28,'Sunny day',1),(29,'down',1),(30,'Billy Morgan',1),(31,'Big Moment',1),(32,'Winter',1),(33,'performance',1),(34,'spots',1),(35,'jumping',1),(36,'people',1),(37,'Free Live',1),(38,'Adventure',1);


--
-- Table structure for table `#__k2_tags_xref`
--



CREATE TABLE `#__k2_tags_xref` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `tagID` int(11) NOT NULL,
  `itemID` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `tagID` (`tagID`),
  KEY `itemID` (`itemID`)
) ENGINE=MyISAM AUTO_INCREMENT=102 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__k2_tags_xref`
--


INSERT INTO `#__k2_tags_xref` (`id`, `tagID`, `itemID`) VALUES (101,6,1),(100,5,1),(99,4,1),(98,3,1),(97,2,1),(96,1,1),(13,7,2),(14,1,2),(15,2,2),(16,3,2),(17,8,2),(18,9,2),(19,10,3),(20,2,3),(21,3,3),(22,11,3),(23,12,3),(24,13,3),(25,9,4),(26,1,4),(27,2,4),(28,3,4),(29,14,4),(30,15,4),(31,1,5),(32,2,5),(33,16,5),(34,5,5),(35,17,5),(36,9,5),(37,1,6),(38,3,6),(39,18,6),(40,19,6),(41,20,6),(42,1,7),(43,20,7),(44,2,7),(45,3,7),(46,21,7),(47,22,8),(48,23,8),(49,24,8),(50,25,8),(51,26,8),(52,27,8),(53,1,9),(54,28,9),(55,17,9),(56,16,9),(57,29,9),(58,30,10),(59,31,10),(60,1,10),(61,3,10),(62,18,10),(63,32,11),(64,1,11),(65,20,11),(66,2,11),(67,12,11),(68,1,12),(69,2,12),(70,3,12),(71,11,12),(72,20,12),(73,10,13),(74,2,13),(75,3,13),(76,20,13),(77,11,13),(78,1,14),(79,5,14),(80,3,14),(81,26,14),(82,33,14),(83,1,15),(84,34,15),(85,2,15),(86,17,15),(87,35,15),(88,36,15),(89,3,15),(90,1,16),(91,9,16),(92,37,16),(93,26,16),(94,18,16),(95,38,16);


--
-- Table structure for table `#__k2_user_groups`
--



CREATE TABLE `#__k2_user_groups` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `permissions` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__k2_user_groups`
--


INSERT INTO `#__k2_user_groups` (`id`, `name`, `permissions`) VALUES (1,'Registered','{\"comment\":\"1\",\"frontEdit\":\"0\",\"add\":\"0\",\"editOwn\":\"0\",\"editAll\":\"0\",\"publish\":\"0\",\"inheritance\":\"0\",\"categories\":\"all\"}'),(2,'Site Owner','{\"comment\":\"1\",\"frontEdit\":\"1\",\"add\":\"1\",\"editOwn\":\"1\",\"editAll\":\"1\",\"publish\":\"1\",\"inheritance\":\"1\",\"categories\":\"all\"}');


--
-- Table structure for table `#__k2_users`
--



CREATE TABLE `#__k2_users` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `userID` int(11) NOT NULL,
  `userName` varchar(255) DEFAULT NULL,
  `gender` enum('m','f') NOT NULL DEFAULT 'm',
  `description` text NOT NULL,
  `image` varchar(255) DEFAULT NULL,
  `url` varchar(255) DEFAULT NULL,
  `group` int(11) NOT NULL DEFAULT '0',
  `plugins` text NOT NULL,
  `ip` varchar(15) NOT NULL,
  `hostname` varchar(255) NOT NULL,
  `notes` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `userID` (`userID`),
  KEY `group` (`group`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__k2_users`
--


INSERT INTO `#__k2_users` (`id`, `userID`, `userName`, `gender`, `description`, `image`, `url`, `group`, `plugins`, `ip`, `hostname`, `notes`) VALUES (1,944,'Super User','m','<p>Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum.</p>','1.jpg','http://www.gavick.com',1,'','213.73.8.39','admr-39.olsztyn.net.pl','');


--
-- Table structure for table `#__languages`
--



CREATE TABLE `#__languages` (
  `lang_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `lang_code` char(7) NOT NULL,
  `title` varchar(50) NOT NULL,
  `title_native` varchar(50) NOT NULL,
  `sef` varchar(50) NOT NULL,
  `image` varchar(50) NOT NULL,
  `description` varchar(512) NOT NULL,
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `sitename` varchar(1024) NOT NULL DEFAULT '',
  `published` int(11) NOT NULL DEFAULT '0',
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`lang_id`),
  UNIQUE KEY `idx_sef` (`sef`),
  UNIQUE KEY `idx_image` (`image`),
  UNIQUE KEY `idx_langcode` (`lang_code`),
  KEY `idx_access` (`access`),
  KEY `idx_ordering` (`ordering`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__languages`
--


INSERT INTO `#__languages` (`lang_id`, `lang_code`, `title`, `title_native`, `sef`, `image`, `description`, `metakey`, `metadesc`, `sitename`, `published`, `access`, `ordering`) VALUES (1,'en-GB','English (UK)','English (UK)','en','en','','','','',1,0,1);


--
-- Table structure for table `#__menu`
--



CREATE TABLE `#__menu` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `menutype` varchar(24) NOT NULL COMMENT 'The type of menu this item belongs to. FK to #__menu_types.menutype',
  `title` varchar(255) NOT NULL COMMENT 'The display title of the menu item.',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL COMMENT 'The SEF alias of the menu item.',
  `note` varchar(255) NOT NULL DEFAULT '',
  `path` varchar(1024) NOT NULL COMMENT 'The computed path of the menu item based on the alias field.',
  `link` varchar(1024) NOT NULL COMMENT 'The actually link the menu item refers to.',
  `type` varchar(16) NOT NULL COMMENT 'The type of link: Component, URL, Alias, Separator',
  `published` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'The published state of the menu link.',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '1' COMMENT 'The parent menu item in the menu tree.',
  `level` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The relative level in the tree.',
  `component_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to #__extensions.id',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to #__users.id',
  `checked_out_time` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'The time the menu item was checked out.',
  `browserNav` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'The click behaviour of the link.',
  `access` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The access level required to view the menu item.',
  `img` varchar(255) NOT NULL COMMENT 'The image of the menu item.',
  `template_style_id` int(10) unsigned NOT NULL DEFAULT '0',
  `params` text NOT NULL COMMENT 'JSON encoded data for the menu item.',
  `lft` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set lft.',
  `rgt` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set rgt.',
  `home` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Indicates if this menu item is the home or default page.',
  `language` char(7) NOT NULL DEFAULT '',
  `client_id` tinyint(4) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_client_id_parent_id_alias_language` (`client_id`,`parent_id`,`alias`,`language`),
  KEY `idx_componentid` (`component_id`,`menutype`,`published`,`access`),
  KEY `idx_menutype` (`menutype`),
  KEY `idx_left_right` (`lft`,`rgt`),
  KEY `idx_alias` (`alias`),
  KEY `idx_path` (`path`(255)),
  KEY `idx_language` (`language`)
) ENGINE=InnoDB AUTO_INCREMENT=262 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__menu`
--


INSERT INTO `#__menu` (`id`, `menutype`, `title`, `alias`, `note`, `path`, `link`, `type`, `published`, `parent_id`, `level`, `component_id`, `checked_out`, `checked_out_time`, `browserNav`, `access`, `img`, `template_style_id`, `params`, `lft`, `rgt`, `home`, `language`, `client_id`) VALUES (1,'','Menu_Item_Root','root','','','','',1,0,0,0,0,'0000-00-00 00:00:00',0,0,'',0,'',0,321,0,'*',0),(2,'menu','com_banners','Banners','','Banners','index.php?option=com_banners','component',0,1,1,4,0,'0000-00-00 00:00:00',0,0,'class:banners',0,'',1,10,0,'*',1),(3,'menu','com_banners','Banners','','Banners/Banners','index.php?option=com_banners','component',0,2,2,4,0,'0000-00-00 00:00:00',0,0,'class:banners',0,'',2,3,0,'*',1),(4,'menu','com_banners_categories','Categories','','Banners/Categories','index.php?option=com_categories&extension=com_banners','component',0,2,2,6,0,'0000-00-00 00:00:00',0,0,'class:banners-cat',0,'',4,5,0,'*',1),(5,'menu','com_banners_clients','Clients','','Banners/Clients','index.php?option=com_banners&view=clients','component',0,2,2,4,0,'0000-00-00 00:00:00',0,0,'class:banners-clients',0,'',6,7,0,'*',1),(6,'menu','com_banners_tracks','Tracks','','Banners/Tracks','index.php?option=com_banners&view=tracks','component',0,2,2,4,0,'0000-00-00 00:00:00',0,0,'class:banners-tracks',0,'',8,9,0,'*',1),(7,'menu','com_contact','Contacts','','Contacts','index.php?option=com_contact','component',0,1,1,8,0,'0000-00-00 00:00:00',0,0,'class:contact',0,'',131,136,0,'*',1),(8,'menu','com_contact','Contacts','','Contacts/Contacts','index.php?option=com_contact','component',0,7,2,8,0,'0000-00-00 00:00:00',0,0,'class:contact',0,'',132,133,0,'*',1),(9,'menu','com_contact_categories','Categories','','Contacts/Categories','index.php?option=com_categories&extension=com_contact','component',0,7,2,6,0,'0000-00-00 00:00:00',0,0,'class:contact-cat',0,'',134,135,0,'*',1),(10,'menu','com_messages','Messaging','','Messaging','index.php?option=com_messages','component',0,1,1,15,0,'0000-00-00 00:00:00',0,0,'class:messages',0,'',137,142,0,'*',1),(11,'menu','com_messages_add','New Private Message','','Messaging/New Private Message','index.php?option=com_messages&task=message.add','component',0,10,2,15,0,'0000-00-00 00:00:00',0,0,'class:messages-add',0,'',138,139,0,'*',1),(12,'menu','com_messages_read','Read Private Message','','Messaging/Read Private Message','index.php?option=com_messages','component',0,10,2,15,0,'0000-00-00 00:00:00',0,0,'class:messages-read',0,'',140,141,0,'*',1),(13,'menu','com_newsfeeds','News Feeds','','News Feeds','index.php?option=com_newsfeeds','component',0,1,1,17,0,'0000-00-00 00:00:00',0,0,'class:newsfeeds',0,'',143,148,0,'*',1),(14,'menu','com_newsfeeds_feeds','Feeds','','News Feeds/Feeds','index.php?option=com_newsfeeds','component',0,13,2,17,0,'0000-00-00 00:00:00',0,0,'class:newsfeeds',0,'',144,145,0,'*',1),(15,'menu','com_newsfeeds_categories','Categories','','News Feeds/Categories','index.php?option=com_categories&extension=com_newsfeeds','component',0,13,2,6,0,'0000-00-00 00:00:00',0,0,'class:newsfeeds-cat',0,'',146,147,0,'*',1),(16,'menu','com_redirect','Redirect','','Redirect','index.php?option=com_redirect','component',0,1,1,24,0,'0000-00-00 00:00:00',0,0,'class:redirect',0,'',161,162,0,'*',1),(17,'menu','com_search','Basic Search','','Basic Search','index.php?option=com_search','component',0,1,1,19,0,'0000-00-00 00:00:00',0,0,'class:search',0,'',151,152,0,'*',1),(18,'menu','com_weblinks','Weblinks','','Weblinks','index.php?option=com_weblinks','component',0,1,1,21,0,'0000-00-00 00:00:00',0,0,'class:weblinks',0,'',153,158,0,'*',1),(19,'menu','com_weblinks_links','Links','','Weblinks/Links','index.php?option=com_weblinks','component',0,18,2,21,0,'0000-00-00 00:00:00',0,0,'class:weblinks',0,'',154,155,0,'*',1),(20,'menu','com_weblinks_categories','Categories','','Weblinks/Categories','index.php?option=com_categories&extension=com_weblinks','component',0,18,2,6,0,'0000-00-00 00:00:00',0,0,'class:weblinks-cat',0,'',156,157,0,'*',1),(21,'menu','com_finder','Smart Search','','Smart Search','index.php?option=com_finder','component',0,1,1,27,0,'0000-00-00 00:00:00',0,0,'class:finder',0,'',149,150,0,'*',1),(22,'menu','com_joomlaupdate','Joomla! Update','','Joomla! Update','index.php?option=com_joomlaupdate','component',0,1,1,28,0,'0000-00-00 00:00:00',0,0,'class:joomlaupdate',0,'',159,160,0,'*',1),(101,'mainmenu','Home','home','','home','index.php?option=com_content&view=featured','component',1,1,1,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"featured_categories\":[\"\"],\"layout_type\":\"blog\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"0\",\"num_columns\":\"1\",\"num_links\":\"0\",\"multi_column_order\":\"1\",\"orderby_pri\":\"\",\"orderby_sec\":\"rdate\",\"order_date\":\"\",\"show_pagination\":\"0\",\"show_pagination_results\":\"0\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"1\",\"link_author\":\"1\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"0\",\"show_print_icon\":\"0\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"show_feed_link\":\"1\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',11,12,1,'*',0),(113,'footmenu','Owners Manuals','2012-12-03-12-16-32','','2012-12-03-12-16-32','#','url',1,1,1,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',163,164,0,'*',0),(114,'footmenu','Job Openings','2012-12-03-12-17-11','','2012-12-03-12-17-11','#','url',1,1,1,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',165,166,0,'*',0),(115,'footmenu','FAQs','2012-12-03-12-17-32','','2012-12-03-12-17-32','#','url',1,1,1,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',167,168,0,'*',0),(116,'footmenu','Contact Us','2012-12-03-12-17-56','','2012-12-03-12-17-56','#','url',1,1,1,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',169,170,0,'*',0),(117,'footmenu','Site Map','2012-12-03-12-18-30','','2012-12-03-12-18-30','#','url',1,1,1,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',171,172,0,'*',0),(118,'mainemu','Submit a Web Link','submit-a-web-link','','submit-a-web-link','index.php?option=com_weblinks&view=form&layout=edit','component',1,1,1,21,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',173,174,0,'*',0),(119,'mainemu','User profile','user-profile','','user-profile','index.php?option=com_users&view=profile','component',1,1,1,25,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',175,176,0,'*',0),(120,'mainemu','Edit User Profile','edit-user-profile','','edit-user-profile','index.php?option=com_users&view=profile&layout=edit','component',1,1,1,25,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',177,178,0,'*',0),(121,'topnav','Home','2012-12-03-12-24-54','','2012-12-03-12-24-54','#','url',1,1,1,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',179,180,0,'*',0),(122,'topnav','Blog','2012-12-03-12-25-14','','2012-12-03-12-25-14','#','url',1,1,1,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',181,182,0,'*',0),(123,'topnav','Download','2012-12-03-12-25-36','','2012-12-03-12-25-36','#','url',1,1,1,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',183,184,0,'*',0),(124,'topnav','About Us','2012-12-03-12-25-52','','2012-12-03-12-25-52','#','url',1,1,1,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',185,186,0,'*',0),(125,'topnav','Contact','2012-12-03-12-26-19','','2012-12-03-12-26-19','#','url',1,1,1,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',187,188,0,'*',0),(126,'categories-menu','Dresses','2012-12-03-12-27-03','','2012-12-03-12-27-03','#','url',1,1,1,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',189,190,0,'*',0),(127,'categories-menu','Jackets & Coats','2012-12-03-12-27-23','','2012-12-03-12-27-23','#','url',1,1,1,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',191,192,0,'*',0),(128,'categories-menu','Jeans','2012-12-03-12-27-39','','2012-12-03-12-27-39','#','url',1,1,1,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',193,194,0,'*',0),(129,'categories-menu','Jumpsuits','2012-12-03-12-27-56','','2012-12-03-12-27-56','#','url',1,1,1,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',195,196,0,'*',0),(130,'categories-menu','Nightwear','2012-12-03-12-28-17','','2012-12-03-12-28-17','#','url',1,1,1,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',197,198,0,'*',0),(131,'categories-menu','Shoes','2012-12-03-12-28-36','','2012-12-03-12-28-36','#','url',1,1,1,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',199,200,0,'*',0),(132,'categories-menu','Skirts','2012-12-03-12-28-57','','2012-12-03-12-28-57','#','url',1,1,1,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',201,202,0,'*',0),(133,'categories-menu','Socks & Tights','2012-12-03-12-29-18','','2012-12-03-12-29-18','#','url',1,1,1,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',203,204,0,'*',0),(134,'categories-menu','Sports','2012-12-03-12-29-35','','2012-12-03-12-29-35','#','url',1,1,1,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',205,206,0,'*',0),(135,'menu-helper','XBOX 360','2012-12-03-12-30-22','','2012-12-03-12-30-22','#','url',1,1,1,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',207,208,0,'*',0),(136,'menu-helper','PS3','2012-12-03-12-30-37','','2012-12-03-12-30-37','#','url',1,1,1,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',209,210,0,'*',0),(137,'menu-helper','Wii U','2012-12-03-12-30-53','','2012-12-03-12-30-53','#','url',1,1,1,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',211,212,0,'*',0),(138,'menu-helper','PC','2012-12-03-12-31-09','','2012-12-03-12-31-09','#','url',1,1,1,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',213,214,0,'*',0),(139,'menu-helper','Vita','2012-12-03-12-31-26','','2012-12-03-12-31-26','#','url',1,1,1,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',215,216,0,'*',0),(140,'menu-helper','3DS','2012-12-03-12-31-41','','2012-12-03-12-31-41','#','url',1,1,1,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',217,218,0,'*',0),(141,'menu-helper','iPhone','2012-12-03-12-31-59','','2012-12-03-12-31-59','#','url',1,1,1,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',219,220,0,'*',0),(142,'menu-helper','Tech','2012-12-03-12-32-15','','2012-12-03-12-32-15','#','url',1,1,1,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',221,222,0,'*',0),(143,'menu-helper','Movies','2012-12-03-12-32-36','','2012-12-03-12-32-36','#','url',1,1,1,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',223,224,0,'*',0),(144,'menu-helper','TV','2012-12-03-12-32-53','','2012-12-03-12-32-53','#','url',1,1,1,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',225,226,0,'*',0),(145,'menu-helper','Comics','2012-12-03-12-33-10','','2012-12-03-12-33-10','#','url',1,1,1,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',227,228,0,'*',0),(146,'mainmenu','Template','template','','template','index.php?option=com_content&view=category&id=15','component',1,1,1,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"show_pagination_limit\":\"\",\"filter_field\":\"\",\"show_headings\":\"\",\"list_show_date\":\"\",\"date_format\":\"\",\"list_show_hits\":\"\",\"list_show_author\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"display_num\":\"10\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',13,96,0,'*',0),(147,'mainmenu','Template articles','template-articles','','template/template-articles','index.php?option=com_content&view=categories&id=0','component',1,146,2,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_base_description\":\"\",\"categories_description\":\"\",\"maxLevelcat\":\"\",\"show_empty_categories_cat\":\"\",\"show_subcat_desc_cat\":\"\",\"show_cat_num_articles_cat\":\"\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"4\",\"num_columns\":\"2\",\"num_links\":\"4\",\"multi_column_order\":\"\",\"show_subcategory_content\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_pagination_limit\":\"\",\"filter_field\":\"\",\"show_headings\":\"\",\"list_show_date\":\"\",\"date_format\":\"\",\"list_show_hits\":\"\",\"list_show_author\":\"\",\"display_num\":\"10\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',14,27,0,'*',0),(148,'mainmenu','Error page','2012-12-03-12-58-23','','template/template-articles/2012-12-03-12-58-23','?option=non-existing-component','url',1,147,3,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',15,16,0,'*',0),(149,'mainmenu','Offline page','2012-12-03-12-58-48','','template/template-articles/2012-12-03-12-58-48','?tmpl=offline','url',1,147,3,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',17,18,0,'*',0),(150,'mainmenu','Module positions','module-positions','','template/template-articles/module-positions','index.php?option=com_content&view=article&id=5','component',1,147,3,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"1\",\"link_titles\":\"0\",\"show_intro\":\"0\",\"info_block_position\":\"0\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_icons\":\"0\",\"show_print_icon\":\"0\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',19,20,0,'*',0),(151,'mainmenu','Layouts','2012-12-03-13-01-27','','template/2012-12-03-13-01-27','http://www.gavick.com/documentation/joomla-templates/templates-for-joomla-1-6/responsive-layout-2/','url',1,146,2,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',28,29,0,'*',0),(152,'mainmenu','Module variations','module-variations','','template/template-articles/module-variations','index.php?option=com_content&view=article&id=7','component',1,147,3,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"1\",\"link_titles\":\"0\",\"show_intro\":\"1\",\"info_block_position\":\"0\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_icons\":\"1\",\"show_print_icon\":\"1\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',21,22,0,'*',0),(153,'mainmenu','K2','k2','','k2','index.php?option=com_k2&view=item&layout=item&id=6','component',1,1,1,10000,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',99,120,0,'*',0),(154,'mainmenu','Typography','typography','','typography','index.php?option=com_content&view=article&id=4','component',1,1,1,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',97,98,0,'*',0),(155,'mainmenu','Page breaks','page-breaks','','template/template-articles/page-breaks','index.php?option=com_content&view=article&id=8','component',1,147,3,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"0\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',23,24,0,'*',0),(156,'mainmenu','Articles','articles','','template/articles','index.php?option=com_content&view=category&id=17','component',1,146,2,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"show_pagination_limit\":\"\",\"filter_field\":\"hide\",\"show_headings\":\"\",\"list_show_date\":\"\",\"date_format\":\"\",\"list_show_hits\":\"\",\"list_show_author\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"alpha\",\"order_date\":\"created\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"display_num\":\"5\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',30,49,0,'*',0),(157,'mainmenu','Archived articles','archived-articles','','template/articles/archived-articles','index.php?option=com_content&view=archive','component',1,156,3,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"orderby_sec\":\"alpha\",\"order_date\":\"created\",\"display_num\":\"5\",\"filter_field\":\"hide\",\"introtext_limit\":\"100\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"link_titles\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_hits\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',31,38,0,'*',0),(158,'mainmenu','by Title','archived-articles-by-title','','template/articles/archived-articles/archived-articles-by-title','index.php?option=com_content&view=archive','component',1,157,4,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"orderby_sec\":\"alpha\",\"order_date\":\"created\",\"display_num\":\"5\",\"filter_field\":\"title\",\"introtext_limit\":\"100\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"link_titles\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_hits\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"Archived articles sorted by title\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',32,33,0,'*',0),(159,'mainmenu','by Author','archived-articles-by-author','','template/articles/archived-articles/archived-articles-by-author','index.php?option=com_content&view=archive','component',1,157,4,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"orderby_sec\":\"alpha\",\"order_date\":\"created\",\"display_num\":\"5\",\"filter_field\":\"author\",\"introtext_limit\":\"100\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"link_titles\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_hits\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"Archived articles sorted by author\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',34,35,0,'*',0),(160,'mainmenu','by Hits','by-hits','','template/articles/archived-articles/by-hits','index.php?option=com_content&view=archive','component',1,157,4,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"orderby_sec\":\"alpha\",\"order_date\":\"created\",\"display_num\":\"5\",\"filter_field\":\"hits\",\"introtext_limit\":\"100\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"link_titles\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_hits\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"Archived articles sorted by hits\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',36,37,0,'*',0),(161,'mainmenu','Single Article','single-article','','template/articles/single-article','index.php?option=com_content&view=article&id=14','component',1,156,3,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"Example of the single article\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',39,40,0,'*',0),(162,'mainmenu','List All Categories','list-all-categories','','template/articles/list-all-categories','index.php?option=com_content&view=categories&id=0','component',1,156,3,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_base_description\":\"0\",\"categories_description\":\"\",\"maxLevelcat\":\"-1\",\"show_empty_categories_cat\":\"1\",\"show_subcat_desc_cat\":\"1\",\"show_cat_num_articles_cat\":\"1\",\"show_category_title\":\"1\",\"show_description\":\"1\",\"show_description_image\":\"1\",\"maxLevel\":\"-1\",\"show_empty_categories\":\"1\",\"show_no_articles\":\"1\",\"show_subcat_desc\":\"1\",\"show_cat_num_articles\":\"1\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"4\",\"num_columns\":\"2\",\"num_links\":\"4\",\"multi_column_order\":\"\",\"show_subcategory_content\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_pagination_limit\":\"\",\"filter_field\":\"\",\"show_headings\":\"\",\"list_show_date\":\"\",\"date_format\":\"\",\"list_show_hits\":\"\",\"list_show_author\":\"\",\"display_num\":\"10\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":1,\"page_heading\":\"List of the all categories\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"List of the all categories.\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',41,42,0,'*',0),(163,'mainmenu','Category blog','category-blog','','template/articles/category-blog','index.php?option=com_content&view=category&layout=blog&id=17','component',1,156,3,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"layout_type\":\"blog\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"num_leading_articles\":\"3\",\"num_intro_articles\":\"0\",\"num_columns\":\"1\",\"num_links\":\"3\",\"multi_column_order\":\"\",\"show_subcategory_content\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"order\",\"order_date\":\"\",\"show_pagination\":\"1\",\"show_pagination_results\":\"1\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"Category with the blog layout.\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',43,44,0,'*',0),(164,'mainmenu','Category list','category-list','','template/articles/category-list','index.php?option=com_content&view=category&id=17','component',1,156,3,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"show_pagination_limit\":\"\",\"filter_field\":\"\",\"show_headings\":\"\",\"list_show_date\":\"\",\"date_format\":\"\",\"list_show_hits\":\"\",\"list_show_author\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"display_num\":\"10\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"List of the items in the specific category.\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',45,46,0,'*',0),(165,'mainmenu','Featured Articles','featured-articles','','template/articles/featured-articles','index.php?option=com_content&view=featured','component',1,156,3,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"featured_categories\":[\"\"],\"layout_type\":\"blog\",\"num_leading_articles\":\"2\",\"num_intro_articles\":\"1\",\"num_columns\":\"1\",\"num_links\":\"5\",\"multi_column_order\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"List of the featured articles\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',47,48,0,'*',0),(166,'mainmenu','Item','item','','k2/item','index.php?option=com_k2&view=item&layout=item&id=1','component',1,153,2,10000,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',100,101,0,'*',0),(167,'mainmenu','Categories','categories','','k2/categories','index.php?option=com_k2&view=itemlist&layout=category&task=&id=','component',1,153,2,10000,0,'0000-00-00 00:00:00',0,1,'',0,'{\"categories\":[\"3\",\"4\"],\"catCatalogMode\":\"0\",\"theme\":\"default\",\"num_leading_items\":\"4\",\"num_leading_columns\":\"1\",\"leadingImgSize\":\"Large\",\"num_primary_items\":\"0\",\"num_primary_columns\":\"2\",\"primaryImgSize\":\"Medium\",\"num_secondary_items\":\"0\",\"num_secondary_columns\":\"1\",\"secondaryImgSize\":\"Small\",\"num_links\":\"0\",\"num_links_columns\":\"1\",\"linksImgSize\":\"XSmall\",\"catFeaturedItems\":\"0\",\"catOrdering\":\"order\",\"catPagination\":\"2\",\"catPaginationResults\":\"1\",\"catFeedLink\":\"1\",\"catFeedIcon\":\"1\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',104,113,0,'*',0),(168,'mainmenu','Contacts','contacts','','template/contacts','index.php?option=com_contact&view=categories&id=0','component',1,146,2,8,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_base_description\":\"\",\"categories_description\":\"\",\"maxLevelcat\":\"\",\"show_empty_categories_cat\":\"\",\"show_subcat_desc_cat\":\"\",\"show_cat_items_cat\":\"\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_items\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_position_headings\":\"\",\"show_email_headings\":\"\",\"show_telephone_headings\":\"\",\"show_mobile_headings\":\"\",\"show_fax_headings\":\"\",\"show_suburb_headings\":\"\",\"show_state_headings\":\"\",\"show_country_headings\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"presentation_style\":\"\",\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"show_feed_link\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',50,59,0,'*',0),(169,'mainmenu','List All Contact Categories','list-all-contact-categories','','template/contacts/list-all-contact-categories','index.php?option=com_contact&view=categories&id=0','component',1,168,3,8,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_base_description\":\"\",\"categories_description\":\"\",\"maxLevelcat\":\"\",\"show_empty_categories_cat\":\"\",\"show_subcat_desc_cat\":\"\",\"show_cat_items_cat\":\"\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_items\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_position_headings\":\"\",\"show_email_headings\":\"\",\"show_telephone_headings\":\"\",\"show_mobile_headings\":\"\",\"show_fax_headings\":\"\",\"show_suburb_headings\":\"\",\"show_state_headings\":\"\",\"show_country_headings\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"presentation_style\":\"\",\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"show_feed_link\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',51,52,0,'*',0),(170,'mainmenu','List Contacts in a Category','list-contacts-in-a-category','','template/contacts/list-contacts-in-a-category','index.php?option=com_contact&view=category&id=9','component',1,168,3,8,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_items\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_position_headings\":\"\",\"show_email_headings\":\"\",\"show_telephone_headings\":\"\",\"show_mobile_headings\":\"\",\"show_fax_headings\":\"\",\"show_suburb_headings\":\"\",\"show_state_headings\":\"\",\"show_country_headings\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"initial_sort\":\"\",\"presentation_style\":\"\",\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"show_feed_link\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',53,54,0,'*',0),(171,'mainmenu','Featured Contacts','featured-contacts','','template/contacts/featured-contacts','index.php?option=com_contact&view=featured','component',1,168,3,8,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_position_headings\":\"\",\"show_email_headings\":\"\",\"show_telephone_headings\":\"\",\"show_mobile_headings\":\"\",\"show_fax_headings\":\"\",\"show_suburb_headings\":\"\",\"show_state_headings\":\"\",\"show_country_headings\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"presentation_style\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',55,56,0,'*',0),(172,'mainmenu','Single Contact','single-contact','','template/contacts/single-contact','index.php?option=com_contact&view=contact&id=1','component',1,168,3,8,0,'0000-00-00 00:00:00',0,1,'',0,'{\"presentation_style\":\"\",\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',57,58,0,'*',0),(173,'mainmenu','Newsfeeds','newsfeeds','','template/newsfeeds','index.php?option=com_newsfeeds&view=categories&id=0','component',1,146,2,17,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_base_description\":\"\",\"categories_description\":\"\",\"maxLevelcat\":\"\",\"show_empty_categories_cat\":\"\",\"show_subcat_desc_cat\":\"\",\"show_cat_items_cat\":\"\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_items\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_articles\":\"\",\"show_link\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_feed_image\":\"\",\"show_feed_description\":\"\",\"show_item_description\":\"\",\"feed_character_count\":\"0\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',60,67,0,'*',0),(174,'mainmenu','List All News Feed Categories','list-all-news-feed-categories','','template/newsfeeds/list-all-news-feed-categories','index.php?option=com_newsfeeds&view=categories&id=0','component',1,173,3,17,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_base_description\":\"\",\"categories_description\":\"\",\"maxLevelcat\":\"\",\"show_empty_categories_cat\":\"\",\"show_subcat_desc_cat\":\"\",\"show_cat_items_cat\":\"\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_items\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_articles\":\"\",\"show_link\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_feed_image\":\"\",\"show_feed_description\":\"\",\"show_item_description\":\"\",\"feed_character_count\":\"0\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',61,62,0,'*',0),(175,'mainmenu','List News Feeds in a Category','list-news-feeds-in-a-category','','template/newsfeeds/list-news-feeds-in-a-category','index.php?option=com_newsfeeds&view=category&id=11','component',1,173,3,17,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_items\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_articles\":\"\",\"show_link\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_feed_image\":\"\",\"show_feed_description\":\"\",\"show_item_description\":\"\",\"feed_character_count\":\"0\",\"feed_display_order\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',63,64,0,'*',0),(176,'mainmenu','Single News Feed','single-news-feed','','template/newsfeeds/single-news-feed','index.php?option=com_newsfeeds&view=newsfeed&id=1','component',1,173,3,17,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_feed_image\":\"\",\"show_feed_description\":\"\",\"show_item_description\":\"\",\"feed_character_count\":\"0\",\"feed_display_order\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',65,66,0,'*',0),(177,'mainmenu','Iframe wrapper','iframe-wrapper','','template/template-articles/iframe-wrapper','index.php?option=com_wrapper&view=wrapper','component',1,147,3,2,0,'0000-00-00 00:00:00',0,1,'',0,'{\"url\":\"http:\\/\\/www.gavick.com\",\"scrolling\":\"auto\",\"width\":\"100%\",\"height\":\"500\",\"height_auto\":\"0\",\"add_scheme\":\"1\",\"frameborder\":\"1\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',25,26,0,'*',0),(178,'mainmenu','Search','search','','template/search','index.php?option=com_search&view=search&searchword=','component',1,146,2,19,0,'0000-00-00 00:00:00',0,1,'',0,'{\"search_areas\":\"\",\"show_date\":\"\",\"searchphrase\":\"0\",\"ordering\":\"newest\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',68,73,0,'*',0),(179,'mainmenu','Search','com-search','','template/search/com-search','index.php?option=com_search&view=search&searchword=','component',1,178,3,19,0,'0000-00-00 00:00:00',0,1,'',0,'{\"search_areas\":\"\",\"show_date\":\"\",\"searchphrase\":\"0\",\"ordering\":\"newest\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"com_search component\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',71,72,0,'*',0),(180,'mainmenu','Smart search','smart-search','','template/search/smart-search','index.php?option=com_finder&view=search&q=&f=','component',1,178,3,27,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_date_filters\":\"\",\"show_advanced\":\"\",\"expand_advanced\":\"\",\"show_description\":\"\",\"description_length\":255,\"show_url\":\"\",\"show_pagination_limit\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"allow_empty_query\":\"0\",\"sort_order\":\"\",\"sort_direction\":\"\",\"show_feed\":\"0\",\"show_feed_text\":\"0\",\"show_feed_link\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"com_finder component\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',69,70,0,'*',0),(181,'mainmenu','Weblinks','weblinks','','template/weblinks','index.php?option=com_weblinks&view=categories&id=0','component',1,146,2,21,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_base_description\":\"\",\"categories_description\":\"\",\"maxLevelcat\":\"-1\",\"show_empty_categories_cat\":\"\",\"show_subcat_desc_cat\":\"\",\"show_cat_num_links_cat\":\"\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_links\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_link_description\":\"\",\"show_link_hits\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',74,81,0,'*',0),(182,'mainmenu','List All Web Link Categories','list-all-web-link-categories','','template/weblinks/list-all-web-link-categories','index.php?option=com_weblinks&view=categories&id=0','component',1,181,3,21,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_base_description\":\"\",\"categories_description\":\"\",\"maxLevelcat\":\"-1\",\"show_empty_categories_cat\":\"\",\"show_subcat_desc_cat\":\"\",\"show_cat_num_links_cat\":\"\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_links\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_link_description\":\"\",\"show_link_hits\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',75,76,0,'*',0),(183,'mainmenu','List Web Links in a Category','list-web-links-in-a-category','','template/weblinks/list-web-links-in-a-category','index.php?option=com_weblinks&view=category&id=14','component',1,181,3,21,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_links\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_link_description\":\"\",\"show_link_hits\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_feed_link\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',77,78,0,'*',0),(184,'mainmenu','Submit a Web Link','submit-a-web-link','','template/weblinks/submit-a-web-link','index.php?option=com_weblinks&view=form&layout=edit','component',1,181,3,21,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',79,80,0,'*',0),(185,'mainmenu','Users','users','','template/users','index.php?option=com_users&view=login','component',1,146,2,25,0,'0000-00-00 00:00:00',0,1,'',0,'{\"login_redirect_url\":\"\",\"logindescription_show\":\"1\",\"login_description\":\"\",\"login_image\":\"\",\"logout_redirect_url\":\"\",\"logoutdescription_show\":\"1\",\"logout_description\":\"\",\"logout_image\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',82,95,0,'*',0),(186,'mainmenu','Login form','login-form','','template/users/login-form','index.php?option=com_users&view=login','component',1,185,3,25,0,'0000-00-00 00:00:00',0,1,'',0,'{\"login_redirect_url\":\"\",\"logindescription_show\":\"1\",\"login_description\":\"\",\"login_image\":\"\",\"logout_redirect_url\":\"\",\"logoutdescription_show\":\"1\",\"logout_description\":\"\",\"logout_image\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":1,\"page_heading\":\"Sign in\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',83,84,0,'*',0),(187,'mainmenu','User profile','user-profile','','template/users/user-profile','index.php?option=com_users&view=profile','component',1,185,3,25,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',85,86,0,'*',0),(188,'mainmenu','Edit User Profile','edit-user-profile','','template/users/edit-user-profile','index.php?option=com_users&view=profile&layout=edit','component',1,185,3,25,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',87,88,0,'*',0),(189,'mainmenu','Registration form','registration-form','','template/users/registration-form','index.php?option=com_users&view=registration','component',1,185,3,25,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',89,90,0,'*',0),(190,'mainmenu','Username Reminder Request','username-reminder-request','','template/users/username-reminder-request','index.php?option=com_users&view=remind','component',1,185,3,25,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',93,94,0,'*',0),(191,'mainmenu','Password Reset','password-reset','','template/users/password-reset','index.php?option=com_users&view=reset','component',1,185,3,25,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',91,92,0,'*',0),(192,'mainmenu','Tag','tag','','k2/tag','index.php?option=com_k2&view=itemlist&layout=tag&tag=Snowboard&task=tag','component',1,153,2,10000,0,'0000-00-00 00:00:00',0,1,'',0,'{\"theme\":\"default\",\"tagOrdering\":\"\",\"tagFeedLink\":\"1\",\"tagFeedIcon\":\"1\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',102,103,0,'*',0),(193,'mainmenu','User page','user-page','','k2/user-page','index.php?option=com_k2&view=itemlist&layout=user&id=944&task=user','component',1,153,2,10000,0,'0000-00-00 00:00:00',0,1,'',0,'{\"theme\":\"default\",\"userCategoriesFilter\":[\"1\",\"3\"],\"userOrdering\":\"hits\",\"userFeedLink\":\"1\",\"userFeedIcon\":\"1\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',114,115,0,'*',0),(194,'mainmenu','Latest items - 1 col','latest-items-1-col','','k2/latest-items-1-col','index.php?option=com_k2&view=latest&layout=latest','component',1,153,2,10000,0,'0000-00-00 00:00:00',0,1,'',0,'{\"theme\":\"default\",\"source\":\"1\",\"latestItemsCols\":\"1\",\"latestItemsLimit\":\"1\",\"latestItemsDisplayEffect\":\"all\",\"userName\":\"1\",\"userImage\":\"1\",\"userDescription\":\"1\",\"userURL\":\"1\",\"userEmail\":\"0\",\"userFeed\":\"1\",\"categoryIDs\":[\"1\",\"2\",\"3\",\"4\"],\"categoryTitle\":\"0\",\"categoryDescription\":\"0\",\"categoryImage\":\"0\",\"categoryFeed\":\"0\",\"latestItemTitle\":\"1\",\"latestItemTitleLinked\":\"1\",\"latestItemDateCreated\":\"1\",\"latestItemImage\":\"1\",\"latestItemImageSize\":\"Large\",\"latestItemVideo\":\"1\",\"latestItemVideoWidth\":\"\",\"latestItemVideoHeight\":\"\",\"latestItemAudioWidth\":\"\",\"latestItemAudioHeight\":\"\",\"latestItemVideoAutoPlay\":\"0\",\"latestItemIntroText\":\"1\",\"latestItemCategory\":\"1\",\"latestItemTags\":\"0\",\"latestItemReadMore\":\"1\",\"latestItemCommentsAnchor\":\"0\",\"feedLink\":\"1\",\"latestItemK2Plugins\":\"0\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',116,117,0,'*',0),(195,'mainmenu','Latest items  - 2 col','latest-items-2-col','','k2/latest-items-2-col','index.php?option=com_k2&view=latest&layout=latest','component',1,153,2,10000,0,'0000-00-00 00:00:00',0,1,'',0,'{\"theme\":\"default\",\"source\":\"1\",\"latestItemsCols\":\"2\",\"latestItemsLimit\":\"4\",\"latestItemsDisplayEffect\":\"all\",\"userName\":\"1\",\"userImage\":\"1\",\"userDescription\":\"1\",\"userURL\":\"1\",\"userEmail\":\"0\",\"userFeed\":\"1\",\"categoryIDs\":[\"1\",\"3\"],\"categoryTitle\":\"0\",\"categoryDescription\":\"0\",\"categoryImage\":\"0\",\"categoryFeed\":\"0\",\"latestItemTitle\":\"1\",\"latestItemTitleLinked\":\"1\",\"latestItemDateCreated\":\"1\",\"latestItemImage\":\"1\",\"latestItemImageSize\":\"Medium\",\"latestItemVideo\":\"1\",\"latestItemVideoWidth\":\"\",\"latestItemVideoHeight\":\"\",\"latestItemAudioWidth\":\"\",\"latestItemAudioHeight\":\"\",\"latestItemVideoAutoPlay\":\"0\",\"latestItemIntroText\":\"1\",\"latestItemCategory\":\"1\",\"latestItemTags\":\"0\",\"latestItemReadMore\":\"1\",\"latestItemCommentsAnchor\":\"0\",\"feedLink\":\"1\",\"latestItemK2Plugins\":\"0\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',118,119,0,'*',0),(196,'mainmenu','Snowboarding Resorts','snowboarding-resorts','','k2/categories/snowboarding-resorts','index.php?option=com_k2&view=itemlist&layout=category&task=category&id=1','component',1,167,3,10000,0,'0000-00-00 00:00:00',0,1,'',0,'{\"categories\":[\"1\"],\"singleCatOrdering\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',105,106,0,'*',0),(197,'mainmenu','Event Coverage','event-coverage','','k2/categories/event-coverage','index.php?option=com_k2&view=itemlist&layout=category&task=category&id=2','component',1,167,3,10000,0,'0000-00-00 00:00:00',0,1,'',0,'{\"categories\":[\"2\"],\"singleCatOrdering\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',107,108,0,'*',0),(198,'mainmenu','Gear Accessories','gear-accessories','','k2/categories/gear-accessories','index.php?option=com_k2&view=itemlist&layout=category&task=category&id=3','component',1,167,3,10000,0,'0000-00-00 00:00:00',0,1,'',0,'{\"categories\":[\"3\"],\"singleCatOrdering\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',109,110,0,'*',0),(199,'mainmenu','Photo of the Day','photo-of-the-day','','k2/categories/photo-of-the-day','index.php?option=com_k2&view=itemlist&layout=category&task=category&id=4','component',1,167,3,10000,0,'0000-00-00 00:00:00',0,1,'',0,'{\"categories\":[\"4\"],\"singleCatOrdering\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',111,112,0,'*',0),(200,'mainmenu','Styles','2012-12-03-13-50-10','','2012-12-03-13-50-10','#styles','url',-2,1,1,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',121,130,0,'*',0),(201,'mainmenu','Freestyle','2012-12-03-13-51-10','','2012-12-03-13-50-10/2012-12-03-13-51-10','#freestyle','url',-2,200,2,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\" gk-style-1\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',122,123,0,'*',0),(202,'mainmenu','Retro','2012-12-03-13-52-22','','2012-12-03-13-50-10/2012-12-03-13-52-22','#grunge','url',-2,200,2,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\" gk-style-2\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',124,125,0,'*',0),(203,'mainmenu','Magazine','2012-12-03-13-53-19','','2012-12-03-13-50-10/2012-12-03-13-53-19','#magazine','url',-2,200,2,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\" gk-style-3\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',126,127,0,'*',0),(204,'mainmenu','Christmas','2012-12-03-13-54-29','','2012-12-03-13-50-10/2012-12-03-13-54-29','#christmas','url',-2,200,2,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\" gk-style-4\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',128,129,0,'*',0),(205,'mobile-menu','Home','home-2','','home-2','index.php?option=com_content&view=featured','component',1,1,1,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"featured_categories\":[\"\"],\"layout_type\":\"blog\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"3\",\"num_columns\":\"3\",\"num_links\":\"0\",\"multi_column_order\":\"1\",\"orderby_pri\":\"\",\"orderby_sec\":\"front\",\"order_date\":\"\",\"show_pagination\":\"2\",\"show_pagination_results\":\"1\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"1\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":1,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',229,230,0,'*',0),(206,'mobile-menu','Template articles','template-articles','','template-articles','','separator',1,1,1,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',231,248,0,'*',0),(207,'mobile-menu','Error page','2012-12-03-12-58-23','','template-articles/2012-12-03-12-58-23','?option=non-existing-component','url',1,206,2,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',234,235,0,'*',0),(208,'mobile-menu','Offline page','2012-12-03-12-58-48','','template-articles/2012-12-03-12-58-48','?tmpl=offline','url',1,206,2,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',236,237,0,'*',0),(209,'mobile-menu','Module positions','module-positions','','template-articles/module-positions','index.php?option=com_content&view=article&id=5','component',-2,206,2,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"1\",\"link_titles\":\"0\",\"show_intro\":\"0\",\"info_block_position\":\"0\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_icons\":\"0\",\"show_print_icon\":\"0\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',238,239,0,'*',0),(210,'mobile-menu','Module variations','module-variations','','template-articles/module-variations','index.php?option=com_content&view=article&id=7','component',-2,206,2,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"1\",\"link_titles\":\"0\",\"show_intro\":\"1\",\"info_block_position\":\"0\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_icons\":\"1\",\"show_print_icon\":\"1\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',240,241,0,'*',0),(211,'mobile-menu','Page breaks','page-breaks','','template-articles/page-breaks','index.php?option=com_content&view=article&id=8','component',-2,206,2,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',242,243,0,'*',0),(212,'mobile-menu','Iframe wrapper','iframe-wrapper','','template-articles/iframe-wrapper','index.php?option=com_wrapper&view=wrapper','component',-2,206,2,2,0,'0000-00-00 00:00:00',0,1,'',0,'{\"url\":\"http:\\/\\/www.gavick.com\",\"scrolling\":\"auto\",\"width\":\"100%\",\"height\":\"500\",\"height_auto\":\"0\",\"add_scheme\":\"1\",\"frameborder\":\"1\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',244,245,0,'*',0),(213,'mobile-menu','Typography','typography','','template-articles/typography','index.php?option=com_content&view=article&id=4','component',1,206,2,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',232,233,0,'*',0),(214,'mobile-menu','Messages','messages','','template-articles/messages','index.php?option=com_content&view=article&id=6','component',1,206,2,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',246,247,0,'*',0),(215,'mobile-menu','Joomla pages I','joomla-pages-i','','joomla-pages-i','','separator',1,1,1,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',249,262,0,'*',0),(216,'mobile-menu','Joomla pages II','joomla-pages-ii','','joomla-pages-ii','','separator',1,1,1,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',263,278,0,'*',0),(217,'mobile-menu','Joomla pages III','joomla-pages-iii','','joomla-pages-iii','','separator',1,1,1,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu_image\":\"\",\"menu_text\":1,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',279,298,0,'*',0),(218,'mobile-menu','Contact categories','contact-categories','','joomla-pages-i/contact-categories','index.php?option=com_contact&view=categories&id=0','component',1,215,2,8,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_base_description\":\"\",\"categories_description\":\"\",\"maxLevelcat\":\"\",\"show_empty_categories_cat\":\"\",\"show_subcat_desc_cat\":\"\",\"show_cat_items_cat\":\"\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_items\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_position_headings\":\"\",\"show_email_headings\":\"\",\"show_telephone_headings\":\"\",\"show_mobile_headings\":\"\",\"show_fax_headings\":\"\",\"show_suburb_headings\":\"\",\"show_state_headings\":\"\",\"show_country_headings\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"presentation_style\":\"\",\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"show_feed_link\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',250,251,0,'*',0),(219,'mobile-menu','Contacts in Category','contacts-in-category','','joomla-pages-i/contacts-in-category','index.php?option=com_contact&view=category&id=9','component',1,215,2,8,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_items\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_position_headings\":\"\",\"show_email_headings\":\"\",\"show_telephone_headings\":\"\",\"show_mobile_headings\":\"\",\"show_fax_headings\":\"\",\"show_suburb_headings\":\"\",\"show_state_headings\":\"\",\"show_country_headings\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"initial_sort\":\"\",\"presentation_style\":\"\",\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"show_feed_link\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',252,253,0,'*',0),(220,'mobile-menu','Featured contacts','featured-contacts','','joomla-pages-i/featured-contacts','index.php?option=com_contact&view=featured','component',1,215,2,8,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_position_headings\":\"\",\"show_email_headings\":\"\",\"show_telephone_headings\":\"\",\"show_mobile_headings\":\"\",\"show_fax_headings\":\"\",\"show_suburb_headings\":\"\",\"show_state_headings\":\"\",\"show_country_headings\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"presentation_style\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',260,261,0,'*',0),(221,'mobile-menu','Single Contact','single-contact','','joomla-pages-i/single-contact','index.php?option=com_contact&view=contact&id=1','component',1,215,2,8,0,'0000-00-00 00:00:00',0,1,'',0,'{\"presentation_style\":\"\",\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',254,255,0,'*',0),(222,'mobile-menu','Web Link Categories Link','web-link-categories-link','','joomla-pages-i/web-link-categories-link','index.php?option=com_weblinks&view=categories&id=0','component',1,215,2,21,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_base_description\":\"\",\"categories_description\":\"\",\"maxLevelcat\":\"-1\",\"show_empty_categories_cat\":\"\",\"show_subcat_desc_cat\":\"\",\"show_cat_num_links_cat\":\"\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_links\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_link_description\":\"\",\"show_link_hits\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',258,259,0,'*',0),(223,'mobile-menu','Weblink single category','weblink-single-category','','joomla-pages-i/weblink-single-category','index.php?option=com_weblinks&view=category&id=14','component',1,215,2,21,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_links\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_link_description\":\"\",\"show_link_hits\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_feed_link\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',256,257,0,'*',0),(224,'mobile-menu','News feeds categories list','news-feeds-categories-list','','joomla-pages-ii/news-feeds-categories-list','index.php?option=com_newsfeeds&view=categories&id=0','component',1,216,2,17,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_base_description\":\"\",\"categories_description\":\"\",\"maxLevelcat\":\"\",\"show_empty_categories_cat\":\"\",\"show_subcat_desc_cat\":\"\",\"show_cat_items_cat\":\"\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_items\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_articles\":\"\",\"show_link\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_feed_image\":\"\",\"show_feed_description\":\"\",\"show_item_description\":\"\",\"feed_character_count\":\"0\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',264,265,0,'*',0),(225,'mobile-menu','News feeds in a category','news-feeds-in-a-category','','joomla-pages-ii/news-feeds-in-a-category','index.php?option=com_newsfeeds&view=category&id=11','component',1,216,2,17,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_items\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_articles\":\"\",\"show_link\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_feed_image\":\"\",\"show_feed_description\":\"\",\"show_item_description\":\"\",\"feed_character_count\":\"0\",\"feed_display_order\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',266,267,0,'*',0),(226,'mobile-menu','User login','user-login','','joomla-pages-ii/user-login','index.php?option=com_users&view=login','component',1,216,2,25,0,'0000-00-00 00:00:00',0,1,'',0,'{\"login_redirect_url\":\"\",\"logindescription_show\":\"1\",\"login_description\":\"\",\"login_image\":\"\",\"logout_redirect_url\":\"\",\"logoutdescription_show\":\"1\",\"logout_description\":\"\",\"logout_image\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":1,\"page_heading\":\"Sign in\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',268,269,0,'*',0),(227,'mobile-menu','User profile','user-profile','','joomla-pages-ii/user-profile','index.php?option=com_users&view=profile','component',1,216,2,25,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',272,273,0,'*',0),(228,'mobile-menu','User registration','user-registration','','joomla-pages-ii/user-registration','index.php?option=com_users&view=registration','component',1,216,2,25,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',270,271,0,'*',0),(229,'mobile-menu','User remind','user-remind','','joomla-pages-ii/user-remind','index.php?option=com_users&view=remind','component',1,216,2,25,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',274,275,0,'*',0),(230,'mobile-menu','Password reset','password-reset','','joomla-pages-ii/password-reset','index.php?option=com_users&view=reset','component',1,216,2,25,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',276,277,0,'*',0),(231,'mobile-menu','Archived articles','archived-articles','','joomla-pages-iii/archived-articles','index.php?option=com_content&view=archive','component',1,217,2,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"orderby_sec\":\"alpha\",\"order_date\":\"created\",\"display_num\":\"5\",\"filter_field\":\"hide\",\"introtext_limit\":\"100\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"link_titles\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_hits\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',280,287,0,'*',0),(232,'mobile-menu','Single Article','single-article','','joomla-pages-iii/single-article','index.php?option=com_content&view=article&id=14','component',1,217,2,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',288,289,0,'*',0),(233,'mobile-menu','Categories List','categories-list','','joomla-pages-iii/categories-list','index.php?option=com_content&view=categories&id=0','component',1,217,2,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_base_description\":\"0\",\"categories_description\":\"\",\"maxLevelcat\":\"-1\",\"show_empty_categories_cat\":\"1\",\"show_subcat_desc_cat\":\"1\",\"show_cat_num_articles_cat\":\"1\",\"show_category_title\":\"1\",\"show_description\":\"1\",\"show_description_image\":\"1\",\"maxLevel\":\"-1\",\"show_empty_categories\":\"1\",\"show_no_articles\":\"1\",\"show_subcat_desc\":\"1\",\"show_cat_num_articles\":\"1\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"4\",\"num_columns\":\"2\",\"num_links\":\"4\",\"multi_column_order\":\"\",\"show_subcategory_content\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_pagination_limit\":\"\",\"filter_field\":\"\",\"show_headings\":\"\",\"list_show_date\":\"\",\"date_format\":\"\",\"list_show_hits\":\"\",\"list_show_author\":\"\",\"display_num\":\"10\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',290,291,0,'*',0),(234,'mobile-menu','Blog Layout','blog-layout','','joomla-pages-iii/blog-layout','index.php?option=com_content&view=category&layout=blog&id=17','component',1,217,2,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"layout_type\":\"blog\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"2\",\"num_columns\":\"2\",\"num_links\":\"4\",\"multi_column_order\":\"\",\"show_subcategory_content\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',292,293,0,'*',0),(235,'mobile-menu','Category List','category-list','','joomla-pages-iii/category-list','index.php?option=com_content&view=category&id=17','component',1,217,2,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"show_pagination_limit\":\"\",\"filter_field\":\"\",\"show_headings\":\"\",\"list_show_date\":\"\",\"date_format\":\"\",\"list_show_hits\":\"\",\"list_show_author\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"display_num\":\"10\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',294,295,0,'*',0),(236,'mobile-menu','Featured Articles','featured-articles','','joomla-pages-iii/featured-articles','index.php?option=com_content&view=featured','component',1,217,2,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"featured_categories\":[\"\"],\"layout_type\":\"blog\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"3\",\"num_columns\":\"3\",\"num_links\":\"0\",\"multi_column_order\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',296,297,0,'*',0),(237,'mobile-menu','by Title','archived-articles-by-title','','joomla-pages-iii/archived-articles/archived-articles-by-title','index.php?option=com_content&view=archive','component',-2,231,3,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"orderby_sec\":\"alpha\",\"order_date\":\"created\",\"display_num\":\"5\",\"filter_field\":\"title\",\"introtext_limit\":\"100\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"link_titles\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_hits\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"Archived articles sorted by title\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',281,282,0,'*',0),(238,'mobile-menu','by Author','archived-articles-by-author','','joomla-pages-iii/archived-articles/archived-articles-by-author','index.php?option=com_content&view=archive','component',-2,231,3,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"orderby_sec\":\"alpha\",\"order_date\":\"created\",\"display_num\":\"5\",\"filter_field\":\"author\",\"introtext_limit\":\"100\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"link_titles\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_hits\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"Archived articles sorted by author\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',283,284,0,'*',0),(239,'mobile-menu','by Hits','by-hits','','joomla-pages-iii/archived-articles/by-hits','index.php?option=com_content&view=archive','component',-2,231,3,22,0,'0000-00-00 00:00:00',0,1,'',0,'{\"orderby_sec\":\"alpha\",\"order_date\":\"created\",\"display_num\":\"5\",\"filter_field\":\"hits\",\"introtext_limit\":\"100\",\"show_intro\":\"\",\"info_block_position\":\"0\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"link_titles\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_hits\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0,\"gk_showtitle\":\"1\",\"gk_desc\":\"Archived articles sorted by hits\",\"gk_cols\":\"1\",\"gk_group\":\"0\",\"gk_class\":\"\",\"gk_subcontent\":\"0\",\"gk_subcontent_pos_positions\":\"menu1\",\"gk_rel\":\"0\"}',285,286,0,'*',0),(251,'main','COM_K2','com-k2','','com-k2','index.php?option=com_k2','component',0,1,1,10000,0,'0000-00-00 00:00:00',0,1,'../media/k2/assets/images/system/k2_16x16.png',0,'',299,320,0,'',1),(252,'main','K2_ITEMS','k2-items','','com-k2/k2-items','index.php?option=com_k2&view=items','component',0,251,2,10000,0,'0000-00-00 00:00:00',0,1,'class:component',0,'',300,301,0,'',1),(253,'main','K2_CATEGORIES','k2-categories','','com-k2/k2-categories','index.php?option=com_k2&view=categories','component',0,251,2,10000,0,'0000-00-00 00:00:00',0,1,'class:component',0,'',302,303,0,'',1),(254,'main','K2_TAGS','k2-tags','','com-k2/k2-tags','index.php?option=com_k2&view=tags','component',0,251,2,10000,0,'0000-00-00 00:00:00',0,1,'class:component',0,'',304,305,0,'',1),(255,'main','K2_COMMENTS','k2-comments','','com-k2/k2-comments','index.php?option=com_k2&view=comments','component',0,251,2,10000,0,'0000-00-00 00:00:00',0,1,'class:component',0,'',306,307,0,'',1),(256,'main','K2_USERS','k2-users','','com-k2/k2-users','index.php?option=com_k2&view=users','component',0,251,2,10000,0,'0000-00-00 00:00:00',0,1,'class:component',0,'',308,309,0,'',1),(257,'main','K2_USER_GROUPS','k2-user-groups','','com-k2/k2-user-groups','index.php?option=com_k2&view=usergroups','component',0,251,2,10000,0,'0000-00-00 00:00:00',0,1,'class:component',0,'',310,311,0,'',1),(258,'main','K2_EXTRA_FIELDS','k2-extra-fields','','com-k2/k2-extra-fields','index.php?option=com_k2&view=extrafields','component',0,251,2,10000,0,'0000-00-00 00:00:00',0,1,'class:component',0,'',312,313,0,'',1),(259,'main','K2_EXTRA_FIELD_GROUPS','k2-extra-field-groups','','com-k2/k2-extra-field-groups','index.php?option=com_k2&view=extrafieldsgroups','component',0,251,2,10000,0,'0000-00-00 00:00:00',0,1,'class:component',0,'',314,315,0,'',1),(260,'main','K2_MEDIA_MANAGER','k2-media-manager','','com-k2/k2-media-manager','index.php?option=com_k2&view=media','component',0,251,2,10000,0,'0000-00-00 00:00:00',0,1,'class:component',0,'',316,317,0,'',1),(261,'main','K2_INFORMATION','k2-information','','com-k2/k2-information','index.php?option=com_k2&view=info','component',0,251,2,10000,0,'0000-00-00 00:00:00',0,1,'class:component',0,'',318,319,0,'',1);


--
-- Table structure for table `#__menu_types`
--



CREATE TABLE `#__menu_types` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `menutype` varchar(24) NOT NULL,
  `title` varchar(48) NOT NULL,
  `description` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_menutype` (`menutype`)
) ENGINE=InnoDB AUTO_INCREMENT=8 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__menu_types`
--


INSERT INTO `#__menu_types` (`id`, `menutype`, `title`, `description`) VALUES (1,'mainmenu','Main Menu','The main menu for the site'),(2,'footmenu','Footer menu',''),(3,'mobile-menu','Mobile menu',''),(4,'mainemu','User Menu',''),(5,'topnav','Top nav',''),(6,'categories-menu','Categories menu',''),(7,'menu-helper','Menu helper','');


--
-- Table structure for table `#__messages`
--



CREATE TABLE `#__messages` (
  `message_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `user_id_from` int(10) unsigned NOT NULL DEFAULT '0',
  `user_id_to` int(10) unsigned NOT NULL DEFAULT '0',
  `folder_id` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `date_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `state` tinyint(1) NOT NULL DEFAULT '0',
  `priority` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `subject` varchar(255) NOT NULL DEFAULT '',
  `message` text NOT NULL,
  PRIMARY KEY (`message_id`),
  KEY `useridto_state` (`user_id_to`,`state`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__messages`
--




--
-- Table structure for table `#__messages_cfg`
--



CREATE TABLE `#__messages_cfg` (
  `user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `cfg_name` varchar(100) NOT NULL DEFAULT '',
  `cfg_value` varchar(255) NOT NULL DEFAULT '',
  UNIQUE KEY `idx_user_var_name` (`user_id`,`cfg_name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__messages_cfg`
--




--
-- Table structure for table `#__modules`
--



CREATE TABLE `#__modules` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(100) NOT NULL DEFAULT '',
  `note` varchar(255) NOT NULL DEFAULT '',
  `content` text NOT NULL,
  `ordering` int(11) NOT NULL DEFAULT '0',
  `position` varchar(50) NOT NULL DEFAULT '',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `module` varchar(50) DEFAULT NULL,
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `showtitle` tinyint(3) unsigned NOT NULL DEFAULT '1',
  `params` text NOT NULL,
  `client_id` tinyint(4) NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `published` (`published`,`access`),
  KEY `newsfeeds` (`module`,`published`),
  KEY `idx_language` (`language`)
) ENGINE=InnoDB AUTO_INCREMENT=124 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__modules`
--


INSERT INTO `#__modules` (`id`, `title`, `note`, `content`, `ordering`, `position`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `published`, `module`, `access`, `showtitle`, `params`, `client_id`, `language`) VALUES (1,'Main Menu','','',1,'position-7',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_menu',1,1,'{\"menutype\":\"mainmenu\",\"startLevel\":\"0\",\"endLevel\":\"0\",\"showAllChildren\":\"0\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"\",\"moduleclass_sfx\":\"_menu\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}',0,'*'),(2,'Login','','',1,'login',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_login',1,1,'',1,'*'),(3,'Popular Articles','','',3,'cpanel',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_popular',3,1,'{\"count\":\"5\",\"catid\":\"\",\"user_id\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\",\"automatic_title\":\"1\"}',1,'*'),(4,'Recently Added Articles','','',4,'cpanel',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_latest',3,1,'{\"count\":\"5\",\"ordering\":\"c_dsc\",\"catid\":\"\",\"user_id\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\",\"automatic_title\":\"1\"}',1,'*'),(8,'Toolbar','','',1,'toolbar',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_toolbar',3,1,'',1,'*'),(9,'Quick Icons','','',1,'icon',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_quickicon',3,1,'',1,'*'),(10,'Logged-in Users','','',2,'cpanel',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_logged',3,1,'{\"count\":\"5\",\"name\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\",\"automatic_title\":\"1\"}',1,'*'),(12,'Admin Menu','','',1,'menu',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_menu',3,1,'{\"layout\":\"\",\"moduleclass_sfx\":\"\",\"shownew\":\"1\",\"showhelp\":\"1\",\"cache\":\"0\"}',1,'*'),(13,'Admin Submenu','','',1,'submenu',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_submenu',3,1,'',1,'*'),(14,'User Status','','',2,'status',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_status',3,1,'',1,'*'),(15,'Title','','',1,'title',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_title',3,1,'',1,'*'),(16,'Login','','',1,'login',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_login',1,1,'{\"pretext\":\"\",\"posttext\":\"\",\"login\":\"\",\"logout\":\"\",\"greeting\":\"1\",\"name\":\"0\",\"usesecure\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(17,'Breadcrumbs','','',1,'position-2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_breadcrumbs',1,1,'{\"showHere\":\"0\",\"showHome\":\"0\",\"homeText\":\"\",\"showLast\":\"1\",\"separator\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(79,'Multilanguage status','','',1,'status',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_multilangstatus',3,1,'{\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\"}',1,'*'),(86,'Joomla Version','','',1,'footer',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_version',3,1,'{\"format\":\"short\",\"product\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\"}',1,'*'),(87,'K2 Comments','','',0,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_k2_comments',1,1,'',0,'*'),(88,'K2 Content','','',0,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_k2_content',1,1,'',0,'*'),(89,'Categories','','',6,'sidebar',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_k2_tools',1,1,'{\"moduleclass_sfx\":\" dark\",\"module_usage\":\"4\",\"archiveItemsCounter\":\"1\",\"archiveCategory\":\"0\",\"authors_module_category\":\"0\",\"authorItemsCounter\":\"1\",\"authorAvatar\":\"1\",\"authorAvatarWidthSelect\":\"custom\",\"authorAvatarWidth\":\"50\",\"authorLatestItem\":\"1\",\"calendarCategory\":\"0\",\"home\":\"\",\"seperator\":\"\",\"root_id\":\"0\",\"end_level\":\"\",\"categoriesListOrdering\":\"order\",\"categoriesListItemsCounter\":\"0\",\"root_id2\":\"0\",\"catfilter\":\"0\",\"getChildren\":\"0\",\"liveSearch\":\"\",\"width\":\"20\",\"text\":\"\",\"button\":\"\",\"imagebutton\":\"\",\"button_text\":\"\",\"min_size\":\"75\",\"max_size\":\"300\",\"cloud_limit\":\"30\",\"cloud_category\":[\"0\"],\"cloud_category_recursive\":\"0\",\"customCode\":\"\",\"parsePhp\":\"0\",\"K2Plugins\":\"0\",\"JPlugins\":\"0\",\"cache\":\"1\",\"cache_time\":\"900\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(90,'K2 Users','','',0,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_k2_users',1,1,'',0,'*'),(91,'K2 User','','',0,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_k2_user',1,1,'',0,'*'),(92,'K2 Quick Icons (admin)','','',0,'cpanel',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_k2_quickicons',1,1,'',1,'*'),(93,'K2 Stats (admin)','','',0,'cpanel',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_k2_stats',1,1,'',1,'*'),(94,'Footer menu','','',1,'footer_nav',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_menu',1,0,'{\"menutype\":\"topnav\",\"active\":\"\",\"startLevel\":\"1\",\"endLevel\":\"1\",\"showAllChildren\":\"0\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(95,'NSP GK4 suffix \" nsp clear\"','','',1,'mainbody_bottom',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_news_pro_gk4',1,1,'{\"moduleclass_sfx\":\" nsp clear\",\"automatic_module_id\":\"1\",\"module_unique_id\":\"newspro1\",\"module_mode\":\"normal\",\"module_width\":\"100\",\"portal_mode_1_module_height\":\"320\",\"module_font_size\":\"100\",\"data_source\":\"all_k2_articles\",\"com_articles\":\"\",\"k2_articles\":\"\",\"news_sort_value\":\"created\",\"news_sort_order\":\"DESC\",\"news_since\":\"\",\"news_frontpage\":\"1\",\"unauthorized\":\"0\",\"only_frontpage\":\"0\",\"startposition\":\"0\",\"time_offset\":\"0\",\"news_portal_mode_1_amount\":\"10\",\"news_portal_mode_2_amount\":\"10\",\"news_portal_mode_3_amount\":\"10\",\"news_portal_mode_4_amount\":\"10\",\"news_portal_mode_5_amount\":\"10\",\"news_full_pages\":\"3\",\"news_column\":\"2\",\"news_rows\":\"1\",\"top_interface_style\":\"arrows_with_pagination\",\"news_content_header_pos\":\"left\",\"news_content_header_float\":\"none\",\"news_header_link\":\"1\",\"use_title_alias\":\"0\",\"title_limit_type\":\"chars\",\"title_limit\":\"17\",\"news_content_image_pos\":\"center\",\"news_content_image_float\":\"none\",\"news_image_link\":\"1\",\"news_content_text_pos\":\"left\",\"news_content_text_float\":\"left\",\"news_text_link\":\"0\",\"news_limit_type\":\"chars\",\"news_limit\":\"80\",\"news_content_info_pos\":\"left\",\"news_content_info_float\":\"none\",\"news_content_info2_pos\":\"left\",\"news_content_info2_float\":\"left\",\"info_format\":\"%DATE %CATEGORY\",\"info2_format\":\"\",\"category_link\":\"1\",\"date_format\":\"d-m-Y H:i\",\"date_publish\":\"0\",\"username\":\"users.name\",\"user_avatar\":\"1\",\"avatar_size\":\"16\",\"art_padding\":\"4px 16px 0 0 \",\"news_header_order\":\"2\",\"news_header_enabled\":\"1\",\"news_image_order\":\"1\",\"news_image_enabled\":\"1\",\"news_text_order\":\"3\",\"news_text_enabled\":\"1\",\"news_info_order\":\"4\",\"news_info_enabled\":\"1\",\"news_info2_order\":\"5\",\"news_info2_enabled\":\"0\",\"news_content_readmore_pos\":\"after\",\"news_readmore_enabled\":\"0\",\"news_short_pages\":\"2\",\"links_amount\":\"3\",\"links_columns_amount\":\"1\",\"bottom_interface_style\":\"arrows\",\"links_margin\":\"12px 0 0 0\",\"links_position\":\"bottom\",\"links_width\":\"50\",\"show_list_description\":\"1\",\"list_title_limit_type\":\"chars\",\"list_title_limit\":\"60\",\"list_text_limit_type\":\"chars\",\"list_text_limit\":\"60\",\"responsive_images\":\"1\",\"wrap_content\":\"0\",\"memory_limit\":\"128M\",\"create_thumbs\":\"1\",\"k2_thumbs\":\"first\",\"thumb_image_type\":\"full\",\"img_auto_scale\":\"0\",\"img_keep_aspect_ratio\":\"0\",\"img_width\":\"240\",\"img_height\":\"160\",\"img_margin\":\"0 0 20px 0\",\"img_bg\":\"#fff\",\"img_stretch\":\"1\",\"img_quality\":\"95\",\"cache_time\":\"30\",\"simple_crop_top\":\"0\",\"simple_crop_bottom\":\"0\",\"simple_crop_left\":\"0\",\"simple_crop_right\":\"0\",\"crop_rules\":\"\",\"autoanim\":\"0\",\"hover_anim\":\"0\",\"animation_speed\":\"400\",\"animation_interval\":\"5000\",\"news_portal_mode_3_open_first\":\"1\",\"animation_function\":\"Fx.Transitions.Expo.easeIn\",\"clean_xhtml\":\"1\",\"more_text_value\":\"...\",\"parse_plugins\":\"0\",\"clean_plugins\":\"0\",\"useCSS\":\"0\",\"useScript\":\"2\",\"useRTL\":\"0\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(96,'User menu','','',1,'usermenu',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_menu',2,1,'{\"menutype\":\"mainemu\",\"active\":\"\",\"startLevel\":\"1\",\"endLevel\":\"0\",\"showAllChildren\":\"0\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(97,'Banner module','','',9,'sidebar',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_banners',1,1,'{\"target\":\"1\",\"count\":\"4\",\"cid\":\"0\",\"catid\":[\"\"],\"tag_search\":\"0\",\"ordering\":\"0\",\"header_text\":\"Featured links:\",\"footer_text\":\"Ads by Joomla!\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(98,'Categories','','',1,'inset',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_menu',1,1,'{\"menutype\":\"categories-menu\",\"active\":\"\",\"startLevel\":\"1\",\"endLevel\":\"0\",\"showAllChildren\":\"0\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"_menu box\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(99,'Suffix \" advertisement\"','','<p>Aenean lacinia bibendum nulla sed consectetur. Etiam porta sem malesuada magna mollis euismod. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum.</p>',1,'sidebar',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" advertisement\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(100,'Menu','','',8,'sidebar',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_menu',1,1,'{\"menutype\":\"footmenu\",\"active\":\"\",\"startLevel\":\"1\",\"endLevel\":\"0\",\"showAllChildren\":\"0\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(101,'Top I','','<p>Maecenas faucibus mollis interdum. Donec id elit non mi porta gravida at eget metus.</p>',1,'top1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(102,'Top II','','<p>Maecenas faucibus mollis interdum. Donec id elit non mi porta gravida at eget metus.</p>',1,'top1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(103,'Top III','','<p>Maecenas faucibus mollis interdum. Donec id elit non mi porta gravida at eget metus.</p>',1,'top1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(104,'Suffix \" dark\"','','<p>Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Donec id elit non mi porta gravida at eget metus.</p>\r\n<ul>\r\n<li><a href=\"#\">Maecenas faucibus</a></li>\r\n<li><a href=\"#\">Vivamus sagittis.</a></li>\r\n<li><a href=\"#\">Praesent commodo.</a></li>\r\n</ul>',3,'sidebar',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" dark\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(105,'Tag Cloud','','',7,'sidebar',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_k2_tools',1,1,'{\"moduleclass_sfx\":\"transparent\",\"module_usage\":\"7\",\"archiveItemsCounter\":\"1\",\"archiveCategory\":\"0\",\"authors_module_category\":\"0\",\"authorItemsCounter\":\"1\",\"authorAvatar\":\"1\",\"authorAvatarWidthSelect\":\"custom\",\"authorAvatarWidth\":\"50\",\"authorLatestItem\":\"1\",\"calendarCategory\":\"0\",\"home\":\"\",\"seperator\":\"\",\"root_id\":\"0\",\"end_level\":\"\",\"categoriesListOrdering\":\"\",\"categoriesListItemsCounter\":\"1\",\"root_id2\":\"0\",\"catfilter\":\"0\",\"getChildren\":\"0\",\"liveSearch\":\"\",\"width\":\"20\",\"text\":\"\",\"button\":\"\",\"imagebutton\":\"\",\"button_text\":\"\",\"min_size\":\"75\",\"max_size\":\"300\",\"cloud_limit\":\"16\",\"cloud_category\":[\"1\",\"2\",\"3\",\"4\"],\"cloud_category_recursive\":\"0\",\"customCode\":\"\",\"parsePhp\":\"0\",\"K2Plugins\":\"0\",\"JPlugins\":\"0\",\"cache\":\"1\",\"cache_time\":\"900\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(106,'Top navigation','','',1,'topnav',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_menu',1,1,'{\"menutype\":\"topnav\",\"active\":\"\",\"startLevel\":\"1\",\"endLevel\":\"0\",\"showAllChildren\":\"0\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(107,'Social icons','','<p><a class=\"gkRSS\" href=\"#\">RSS</a><a class=\"gkTwitter\" href=\"#\">Twitter</a><a class=\"gkFb\" href=\"#\">Facebook</a><a class=\"gkGplus\" href=\"#\">Google+</a></p>',1,'social',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,0,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(108,'Search','','',9,'sidebar',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_search',1,0,'{\"label\":\"\",\"width\":\"20\",\"text\":\"\",\"button\":\"\",\"button_pos\":\"right\",\"imagebutton\":\"\",\"button_text\":\"\",\"opensearch\":\"1\",\"opensearch_title\":\"\",\"set_itemid\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" clear transparent\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(109,'Top menu','','',1,'topmenu',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_menu',1,1,'{\"menutype\":\"menu-helper\",\"active\":\"\",\"startLevel\":\"1\",\"endLevel\":\"0\",\"showAllChildren\":\"0\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(110,'User area','','',1,'usermenu',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_menu',1,1,'{\"menutype\":\"mainemu\",\"active\":\"\",\"startLevel\":\"1\",\"endLevel\":\"0\",\"showAllChildren\":\"1\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(111,'Suffix \" transparent\"','','<p>Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Donec id elit non mi porta gravida at eget metus.</p>\r\n<ul>\r\n<li><a href=\"#\">Maecenas faucibus</a></li>\r\n<li><a href=\"#\">Vivamus sagittis.</a></li>\r\n<li><a href=\"#\">Praesent commodo.</a></li>\r\n</ul>',4,'sidebar',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" transparent\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(112,'Suffix \" color\"','','<p>Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Donec id elit non mi porta gravida at eget metus. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor.</p>',1,'mainbody_top',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"color\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(113,'Image Show GK4','','',1,'banner_mainbody_bottom',944,'2012-12-05 10:24:42','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_image_show_gk4',1,1,'{\"automatic_module_id\":\"1\",\"module_id\":\"gk-is-1\",\"moduleclass_sfx\":\"nobg\",\"module_style\":\"gk_publisher\",\"last_modification\":\"1354703080\",\"image_show_data\":\"[{\\\"name\\\":\\\"Snowboard HighLights\\\",\\\"type\\\":\\\"text\\\",\\\"image\\\":\\\"images\\/demo\\/is_publisher_demo.jpg\\\",\\\"stretch\\\":\\\"nostretch\\\",\\\"access\\\":\\\"public\\\",\\\"published\\\":\\\"1\\\",\\\"content\\\":\\\"Lorem ipsum dolor sit amet, consectetur adipiscing elit.\\\",\\\"url\\\":\\\"#1\\\",\\\"art_id\\\":\\\"\\\",\\\"art_title\\\":\\\"\\\",\\\"artK2_id\\\":\\\"\\\",\\\"artK2_title\\\":\\\"\\\"},{\\\"name\\\":\\\"Amazing Footage\\\",\\\"type\\\":\\\"text\\\",\\\"image\\\":\\\"images\\/demo\\/is_publisher_demo.jpg\\\",\\\"stretch\\\":\\\"nostretch\\\",\\\"access\\\":\\\"public\\\",\\\"published\\\":\\\"1\\\",\\\"content\\\":\\\"Lorem ipsum dolor sit amet, consectetur adipiscing elit.\\\",\\\"url\\\":\\\"#2\\\",\\\"art_id\\\":\\\"\\\",\\\"art_title\\\":\\\"\\\",\\\"artK2_id\\\":\\\"\\\",\\\"artK2_title\\\":\\\"\\\"},{\\\"name\\\":\\\"Stunning Jumps\\\",\\\"type\\\":\\\"text\\\",\\\"image\\\":\\\"images\\/demo\\/is_publisher_demo.jpg\\\",\\\"stretch\\\":\\\"nostretch\\\",\\\"access\\\":\\\"public\\\",\\\"published\\\":\\\"1\\\",\\\"content\\\":\\\"Lorem ipsum dolor sit amet, consectetur adipiscing elit.\\\",\\\"url\\\":\\\"#3\\\",\\\"art_id\\\":\\\"\\\",\\\"art_title\\\":\\\"\\\",\\\"artK2_id\\\":\\\"\\\",\\\"artK2_title\\\":\\\"\\\"}]\",\"config\":\"{\\\"gk_bikestore\\\":{\\\"gk_bikestore_image_width\\\":\\\"640\\\",\\\"gk_bikestore_image_height\\\":\\\"320\\\",\\\"gk_bikestore_image_bg\\\":\\\"#000000\\\",\\\"gk_bikestore_quality\\\":\\\"95\\\",\\\"gk_bikestore_show_title_block\\\":\\\"1\\\",\\\"gk_bikestore_title_block_position\\\":\\\"bottom\\\",\\\"gk_bikestore_title_block_position_x\\\":\\\"left\\\",\\\"gk_bikestore_title_block_length\\\":\\\"30\\\",\\\"gk_bikestore_pagination\\\":\\\"1\\\",\\\"gk_bikestore_pagination_position\\\":\\\"top\\\",\\\"gk_bikestore_slide_links\\\":\\\"1\\\",\\\"gk_bikestore_animation_speed\\\":\\\"500\\\",\\\"gk_bikestore_animation_interval\\\":\\\"5000\\\",\\\"gk_bikestore_autoanimation\\\":\\\"1\\\"},\\\"gk_eSport\\\":{\\\"gk_eSport_image_w\\\":\\\"1000\\\",\\\"gk_eSport_image_h\\\":\\\"550\\\",\\\"gk_eSport_thumb_w\\\":\\\"200\\\",\\\"gk_eSport_thumb_h\\\":\\\"120\\\",\\\"gk_eSport_image_bg\\\":\\\"#000000\\\",\\\"gk_eSport_quality\\\":\\\"95\\\",\\\"gk_eSport_thumbnails\\\":\\\"1\\\",\\\"gk_eSport_thumbnails_position\\\":\\\"gkThumbsBottom\\\",\\\"gk_eSport_text_block\\\":\\\"1\\\",\\\"gk_eSport_slide_links\\\":\\\"1\\\",\\\"gk_eSport_anim_type\\\":\\\"gkDrops\\\",\\\"gk_eSport_animation_speed\\\":\\\"750\\\",\\\"gk_eSport_animation_interval\\\":\\\"35\\\",\\\"gk_eSport_row_amount\\\":\\\"4\\\",\\\"gk_eSport_lvl2_divider\\\":\\\"4\\\",\\\"gk_eSport_max_anim\\\":\\\"5\\\",\\\"gk_eSport_slide_interval\\\":\\\"5000\\\",\\\"gk_eSport_autoanimation\\\":\\\"1\\\"},\\\"gk_fashion\\\":{\\\"gk_fashion_image_width\\\":\\\"640\\\",\\\"gk_fashion_image_height\\\":\\\"320\\\",\\\"gk_fashion_image_bg\\\":\\\"#000000\\\",\\\"gk_fashion_quality\\\":\\\"95\\\",\\\"gk_fashion_show_title_block\\\":\\\"1\\\",\\\"gk_fashion_title_block_position\\\":\\\"bottom\\\",\\\"gk_fashion_title_block_length\\\":\\\"30\\\",\\\"gk_fashion_pagination\\\":\\\"1\\\",\\\"gk_fashion_pagination_position\\\":\\\"top\\\",\\\"gk_fashion_slide_links\\\":\\\"1\\\",\\\"gk_fashion_animation_speed\\\":\\\"500\\\",\\\"gk_fashion_animation_interval\\\":\\\"5000\\\",\\\"gk_fashion_autoanimation\\\":\\\"1\\\"},\\\"gk_game_magazine\\\":{\\\"gk_game_magazine_image_width\\\":\\\"600\\\",\\\"gk_game_magazine_image_height\\\":\\\"600\\\",\\\"gk_game_magazine_image_bg\\\":\\\"#ffffff\\\",\\\"gk_game_magazine_quality\\\":\\\"95\\\",\\\"gk_game_magazine_text_block_position\\\":\\\"right\\\",\\\"gk_game_magazine_total_width\\\":\\\"946\\\",\\\"gk_game_magazine_show_text_block\\\":\\\"1\\\",\\\"gk_game_magazine_text_block_x\\\":\\\"32\\\",\\\"gk_game_magazine_text_block_y\\\":\\\"32\\\",\\\"gk_game_magazine_title_chars_amount\\\":\\\"20\\\",\\\"gk_game_magazine_text_chars_amount\\\":\\\"40\\\",\\\"gk_game_magazine_slide_links\\\":\\\"1\\\",\\\"gk_game_magazine_animation_speed\\\":\\\"500\\\",\\\"gk_game_magazine_animation_interval\\\":\\\"5000\\\",\\\"gk_game_magazine_autoanimation\\\":\\\"1\\\",\\\"gk_game_magazine_animation_type\\\":\\\"opacity\\\",\\\"gk_game_magazine_animation_text_type\\\":\\\"opacity\\\"},\\\"gk_startup\\\":{\\\"gk_startup_image_bg\\\":\\\"#000000\\\",\\\"gk_startup_quality\\\":\\\"95\\\",\\\"gk_startup_desktop_width\\\":\\\"1000\\\",\\\"gk_startup_image_width\\\":\\\"640\\\",\\\"gk_startup_module_height\\\":\\\"420\\\",\\\"gk_startup_tablet_width\\\":\\\"920\\\",\\\"gk_startup_tablet_image_width\\\":\\\"603\\\",\\\"gk_startup_tablet_module_height\\\":\\\"690\\\",\\\"gk_startup_mobile_width\\\":\\\"580\\\",\\\"gk_startup_mobile_image_width\\\":\\\"338\\\",\\\"gk_startup_mobile_module_height\\\":\\\"386\\\",\\\"gk_startup_pagination\\\":\\\"1\\\",\\\"gk_startup_arrows\\\":\\\"1\\\",\\\"gk_startup_slide_links\\\":\\\"1\\\",\\\"gk_startup_animation_speed\\\":\\\"500\\\",\\\"gk_startup_animation_interval\\\":\\\"5000\\\",\\\"gk_startup_autoanimation\\\":\\\"1\\\"},\\\"gk_publisher\\\":{\\\"gk_publisher_image_width\\\":\\\"640\\\",\\\"gk_publisher_image_height\\\":\\\"420\\\",\\\"gk_publisher_image_bg\\\":\\\"#000000\\\",\\\"gk_publisher_quality\\\":\\\"95\\\",\\\"gk_publisher_title_block_position\\\":\\\"bottom\\\",\\\"gk_publisher_show_content_block\\\":\\\"1\\\",\\\"gk_publisher_show_title_block\\\":\\\"1\\\",\\\"gk_publisher_show_text_block\\\":\\\"1\\\",\\\"gk_publisher_title_block_length\\\":\\\"30\\\",\\\"gk_publisher_text_block_length\\\":\\\"80\\\",\\\"gk_publisher_pagination\\\":\\\"1\\\",\\\"gk_publisher_pagination_position\\\":\\\"bottom\\\",\\\"gk_publisher_slide_links\\\":\\\"1\\\",\\\"gk_publisher_animation_speed\\\":\\\"500\\\",\\\"gk_publisher_animation_interval\\\":\\\"5000\\\",\\\"gk_publisher_autoanimation\\\":\\\"1\\\"}}\",\"use_style_css\":\"0\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(114,'Top banner','','<p>Donec at mattis erat! Duis sed massa eget eros gravida vulputate nec ut ipsum.</p>',1,'topbanner',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(115,'Top IV','','<p>Maecenas faucibus mollis interdum. Donec id elit non mi porta gravida at eget metus.</p>',1,'top2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(116,'Top V','','<p>Maecenas faucibus mollis interdum. Donec id elit non mi porta gravida at eget metus.</p>',1,'top2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(117,'Top VI','','<p>Maecenas faucibus mollis interdum. Donec id elit non mi porta gravida at eget metus.</p>',1,'top2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(119,'Social GK5','','',2,'bottom2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_social_gk5',1,1,'{\"automatic_module_id\":\"1\",\"module_id\":\"gk-social-1\",\"moduleclass_sfx\":\"\",\"cookie_conset\":\"0\",\"module_data_source\":\"twitter\",\"twitter_widget\":\"tweets\",\"twitter_username\":\"gavickpro\",\"twitter_search_query\":\"gavickpro\",\"twitter_tweet_amount\":\"3\",\"twitter_title\":\"Search tweets\",\"twitter_desc\":\"by phrase...\",\"twitter_lists\":\"error\",\"twitter_lists_data\":\"\",\"twitter_widget_color\":\"#CECCCC\",\"twitter_tweet_color\":\"#FFFFFF\",\"twitter_link_color\":\"#A51212\",\"twitter_widget_text_color\":\"#474747\",\"twitter_tweet_text_color\":\"#444444\",\"twitter_auto_refresh\":\"true\",\"twitter_loop\":\"true\",\"twitter_behaviour\":\"default\",\"twitter_include_scrollbar\":\"false\",\"twitter_interval\":\"30000\",\"twitter_height\":\"250\",\"twitter_tweet_style\":\"style1\",\"twitter_rows\":\"3\",\"twitter_columns\":\"1\",\"twitter_use_css\":\"0\",\"twitter_show_uname\":\"1\",\"twitter_show_fname\":\"1\",\"twitter_show_actions\":\"1\",\"twitter_show_avatar\":\"1\",\"twitter_time_mode\":\"cdate\",\"twitter_cache\":\"1\",\"twitter_cache_time\":\"10\",\"gplus_id\":\"110937149959405490547\",\"gplus_badge_style\":\"standard_badge\",\"gplus_lang_code\":\"en\",\"gplus_badge_width\":\"300\",\"gplus_badge_color\":\"light\",\"gplus_async_script\":\"1\",\"gplus_html5_valid\":\"1\",\"gplus_custom_name\":\"\",\"gplus_custom_name_pos\":\"before\",\"fb_auto_url\":\"true\",\"fb_site\":\"www.yourdomain.com\",\"fb_app_id\":\"\",\"fb_data_source\":\"activity_feed\",\"fb_code_type\":\"iframe\",\"fb_language\":\"en_US\",\"fb_width\":\"300\",\"fb_height\":\"300\",\"fb_header\":\"true\",\"fb_colorscheme\":\"light\",\"fb_font\":\"arial\",\"fb_border_color\":\"#CECCCC\",\"fb_recommendations\":\"false\",\"fb_link_target\":\"_blank\",\"fb_number_comments\":\"10\",\"fb_width_comments\":\"500\",\"fb_only_number\":\"false\",\"fb_comments_colorscheme\":\"light\",\"fb_only_number_add\":\"awesome comments\",\"fb_only_number_url\":\"false\",\"fb_comments_admin_id\":\"\",\"fb_facepile_width\":\"200\",\"fb_facepile_num_rows\":\"2\",\"fb_facepile_colorscheme\":\"light\",\"fb_facepile_size\":\"small\",\"fb_likebox_width\":\"300\",\"fb_likebox_height\":\"300\",\"fb_likebox_header\":\"true\",\"fb_likebox_colorscheme\":\"light\",\"fb_likebox_faces\":\"true\",\"fb_likebox_stream\":\"true\",\"fb_livestream_width\":\"300\",\"fb_livestream_height\":\"300\",\"fb_livestream_xid\":\"\",\"fb_livestream_url\":\"\",\"fb_livestream_friends\":\"true\",\"fb_rec_width\":\"300\",\"fb_rec_height\":\"300\",\"fb_rec_header\":\"true\",\"fb_rec_colorscheme\":\"light\",\"fb_rec_font\":\"arial\",\"fb_rec_link_target\":\"_blank\",\"fb_rec_border_color\":\"#CECCCC\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(120,'Latest News','','',1,'bottom2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_news_pro_gk4',1,1,'{\"moduleclass_sfx\":\" nsp clear\",\"automatic_module_id\":\"1\",\"module_unique_id\":\"newspro1\",\"module_mode\":\"normal\",\"module_width\":\"100\",\"portal_mode_1_module_height\":\"320\",\"module_font_size\":\"100\",\"data_source\":\"all_k2_articles\",\"com_articles\":\"\",\"k2_articles\":\"\",\"news_sort_value\":\"created\",\"news_sort_order\":\"DESC\",\"news_since\":\"\",\"news_frontpage\":\"1\",\"unauthorized\":\"0\",\"only_frontpage\":\"0\",\"startposition\":\"0\",\"time_offset\":\"0\",\"news_portal_mode_1_amount\":\"10\",\"news_portal_mode_2_amount\":\"10\",\"news_portal_mode_3_amount\":\"10\",\"news_portal_mode_4_amount\":\"10\",\"news_portal_mode_5_amount\":\"10\",\"news_full_pages\":\"4\",\"news_column\":\"1\",\"news_rows\":\"4\",\"top_interface_style\":\"pagination\",\"news_content_header_pos\":\"left\",\"news_content_header_float\":\"none\",\"news_header_link\":\"1\",\"use_title_alias\":\"0\",\"title_limit_type\":\"chars\",\"title_limit\":\"40\",\"news_content_image_pos\":\"left\",\"news_content_image_float\":\"left\",\"news_image_link\":\"1\",\"news_content_text_pos\":\"left\",\"news_content_text_float\":\"left\",\"news_text_link\":\"0\",\"news_limit_type\":\"chars\",\"news_limit\":\"80\",\"news_content_info_pos\":\"left\",\"news_content_info_float\":\"none\",\"news_content_info2_pos\":\"left\",\"news_content_info2_float\":\"left\",\"info_format\":\"%DATE %COMMENTS\",\"info2_format\":\"\",\"category_link\":\"1\",\"date_format\":\"F j, Y\",\"date_publish\":\"0\",\"username\":\"users.name\",\"user_avatar\":\"1\",\"avatar_size\":\"16\",\"art_padding\":\"15px 0\",\"news_header_order\":\"2\",\"news_header_enabled\":\"1\",\"news_image_order\":\"1\",\"news_image_enabled\":\"1\",\"news_text_order\":\"3\",\"news_text_enabled\":\"0\",\"news_info_order\":\"4\",\"news_info_enabled\":\"1\",\"news_info2_order\":\"5\",\"news_info2_enabled\":\"0\",\"news_content_readmore_pos\":\"after\",\"news_readmore_enabled\":\"0\",\"news_short_pages\":\"0\",\"links_amount\":\"3\",\"links_columns_amount\":\"1\",\"bottom_interface_style\":\"arrows\",\"links_margin\":\"12px 0 0 0\",\"links_position\":\"bottom\",\"links_width\":\"50\",\"show_list_description\":\"1\",\"list_title_limit_type\":\"chars\",\"list_title_limit\":\"60\",\"list_text_limit_type\":\"chars\",\"list_text_limit\":\"60\",\"responsive_images\":\"0\",\"wrap_content\":\"1\",\"memory_limit\":\"128M\",\"create_thumbs\":\"1\",\"k2_thumbs\":\"first\",\"thumb_image_type\":\"full\",\"img_auto_scale\":\"0\",\"img_keep_aspect_ratio\":\"0\",\"img_width\":\"90\",\"img_height\":\"63\",\"img_margin\":\"-5px 15px 0 0\",\"img_bg\":\"#fff\",\"img_stretch\":\"1\",\"img_quality\":\"95\",\"cache_time\":\"30\",\"simple_crop_top\":\"0\",\"simple_crop_bottom\":\"0\",\"simple_crop_left\":\"0\",\"simple_crop_right\":\"0\",\"crop_rules\":\"\",\"autoanim\":\"0\",\"hover_anim\":\"0\",\"animation_speed\":\"400\",\"animation_interval\":\"5000\",\"news_portal_mode_3_open_first\":\"1\",\"animation_function\":\"Fx.Transitions.Expo.easeIn\",\"clean_xhtml\":\"1\",\"more_text_value\":\"...\",\"parse_plugins\":\"0\",\"clean_plugins\":\"0\",\"useCSS\":\"0\",\"useScript\":\"2\",\"useRTL\":\"0\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(121,'Suffix \" big\" **it is a second header line example**','','<p>Cras justo odio, dapibus ac facilisis in, egestas eget quam. Curabitur blandit tempus porttitor. Etiam porta sem malesuada magna mollis euismod. Curabitur blandit tempus porttitor. Vestibulum id ligula porta felis euismod semper. Integer posuere erat a ante venenatis dapibus posuere velit aliquet. Sed posuere consectetur est at lobortis.</p>\r\n<p>Vestibulum id ligula porta felis euismod semper. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Cras mattis consectetur purus sit amet fermentum. Maecenas sed diam eget risus varius blandit sit amet non magna. Maecenas faucibus mollis interdum.</p>',1,'mainbody_bottom',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" big\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(122,'Latest News **Pellentesque tristique tellus tristique leo rutrum ut dapibus mauris consequat.**','','',1,'mainbody_bottom',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_news_pro_gk4',1,1,'{\"moduleclass_sfx\":\" nsp big clear\",\"automatic_module_id\":\"1\",\"module_unique_id\":\"newspro1\",\"module_mode\":\"normal\",\"module_width\":\"100\",\"portal_mode_1_module_height\":\"320\",\"module_font_size\":\"100\",\"data_source\":\"k2_categories\",\"com_articles\":\"\",\"k2_categories\":[\"2\"],\"k2_articles\":\"\",\"news_sort_value\":\"created\",\"news_sort_order\":\"DESC\",\"news_since\":\"\",\"news_frontpage\":\"1\",\"unauthorized\":\"0\",\"only_frontpage\":\"0\",\"startposition\":\"0\",\"time_offset\":\"0\",\"news_portal_mode_1_amount\":\"10\",\"news_portal_mode_2_amount\":\"10\",\"news_portal_mode_3_amount\":\"10\",\"news_portal_mode_4_amount\":\"10\",\"news_portal_mode_5_amount\":\"10\",\"news_full_pages\":\"2\",\"news_column\":\"2\",\"news_rows\":\"1\",\"top_interface_style\":\"arrows_with_pagination\",\"news_content_header_pos\":\"center\",\"news_content_header_float\":\"none\",\"news_header_link\":\"1\",\"use_title_alias\":\"0\",\"title_limit_type\":\"chars\",\"title_limit\":\"40\",\"news_content_image_pos\":\"center\",\"news_content_image_float\":\"none\",\"news_image_link\":\"1\",\"news_content_text_pos\":\"center\",\"news_content_text_float\":\"left\",\"news_text_link\":\"0\",\"news_limit_type\":\"chars\",\"news_limit\":\"72\",\"news_content_info_pos\":\"left\",\"news_content_info_float\":\"none\",\"news_content_info2_pos\":\"left\",\"news_content_info2_float\":\"left\",\"info_format\":\"%DATE %CATEGORY\",\"info2_format\":\"\",\"category_link\":\"1\",\"date_format\":\"d-m-Y H:i\",\"date_publish\":\"0\",\"username\":\"users.name\",\"user_avatar\":\"1\",\"avatar_size\":\"16\",\"art_padding\":\"12px 15px 32px 0 \",\"news_header_order\":\"2\",\"news_header_enabled\":\"1\",\"news_image_order\":\"1\",\"news_image_enabled\":\"1\",\"news_text_order\":\"3\",\"news_text_enabled\":\"1\",\"news_info_order\":\"4\",\"news_info_enabled\":\"0\",\"news_info2_order\":\"5\",\"news_info2_enabled\":\"0\",\"news_content_readmore_pos\":\"after\",\"news_readmore_enabled\":\"0\",\"news_short_pages\":\"0\",\"links_amount\":\"3\",\"links_columns_amount\":\"1\",\"bottom_interface_style\":\"arrows\",\"links_margin\":\"12px 0 0 0\",\"links_position\":\"bottom\",\"links_width\":\"50\",\"show_list_description\":\"1\",\"list_title_limit_type\":\"chars\",\"list_title_limit\":\"60\",\"list_text_limit_type\":\"chars\",\"list_text_limit\":\"60\",\"responsive_images\":\"1\",\"wrap_content\":\"0\",\"memory_limit\":\"128M\",\"create_thumbs\":\"1\",\"k2_thumbs\":\"first\",\"thumb_image_type\":\"full\",\"img_auto_scale\":\"0\",\"img_keep_aspect_ratio\":\"0\",\"img_width\":\"240\",\"img_height\":\"154\",\"img_margin\":\"0 0 20px 0\",\"img_bg\":\"#fff\",\"img_stretch\":\"1\",\"img_quality\":\"95\",\"cache_time\":\"30\",\"simple_crop_top\":\"0\",\"simple_crop_bottom\":\"0\",\"simple_crop_left\":\"0\",\"simple_crop_right\":\"0\",\"crop_rules\":\"\",\"autoanim\":\"0\",\"hover_anim\":\"0\",\"animation_speed\":\"400\",\"animation_interval\":\"5000\",\"news_portal_mode_3_open_first\":\"1\",\"animation_function\":\"Fx.Transitions.Expo.easeIn\",\"clean_xhtml\":\"1\",\"more_text_value\":\"...\",\"parse_plugins\":\"0\",\"clean_plugins\":\"0\",\"useCSS\":\"0\",\"useScript\":\"2\",\"useRTL\":\"0\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*'),(123,'Latest News','','',1,'sidebar',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_news_pro_gk4',1,1,'{\"moduleclass_sfx\":\" nsp\",\"automatic_module_id\":\"1\",\"module_unique_id\":\"newspro1\",\"module_mode\":\"normal\",\"module_width\":\"100\",\"portal_mode_1_module_height\":\"320\",\"module_font_size\":\"100\",\"data_source\":\"k2_categories\",\"com_articles\":\"\",\"k2_categories\":[\"2\",\"3\",\"4\",\"1\"],\"k2_articles\":\"\",\"news_sort_value\":\"created\",\"news_sort_order\":\"DESC\",\"news_since\":\"\",\"news_frontpage\":\"1\",\"unauthorized\":\"0\",\"only_frontpage\":\"0\",\"startposition\":\"0\",\"time_offset\":\"0\",\"news_portal_mode_1_amount\":\"10\",\"news_portal_mode_2_amount\":\"10\",\"news_portal_mode_3_amount\":\"10\",\"news_portal_mode_4_amount\":\"10\",\"news_portal_mode_5_amount\":\"10\",\"news_full_pages\":\"4\",\"news_column\":\"1\",\"news_rows\":\"4\",\"top_interface_style\":\"pagination\",\"news_content_header_pos\":\"left\",\"news_content_header_float\":\"null\",\"news_header_link\":\"1\",\"use_title_alias\":\"0\",\"title_limit_type\":\"chars\",\"title_limit\":\"36\",\"news_content_image_pos\":\"left\",\"news_content_image_float\":\"left\",\"news_image_link\":\"1\",\"news_content_text_pos\":\"left\",\"news_content_text_float\":\"left\",\"news_text_link\":\"0\",\"news_limit_type\":\"words\",\"news_limit\":\"30\",\"news_content_info_pos\":\"left\",\"news_content_info_float\":\"null\",\"news_content_info2_pos\":\"left\",\"news_content_info2_float\":\"left\",\"info_format\":\"%DATE  %AUTHOR\",\"info2_format\":\"\",\"category_link\":\"1\",\"date_format\":\"F j, Y\",\"date_publish\":\"0\",\"username\":\"users.name\",\"user_avatar\":\"0\",\"avatar_size\":\"16\",\"art_padding\":\"15px 0\",\"news_header_order\":\"2\",\"news_header_enabled\":\"1\",\"news_image_order\":\"1\",\"news_image_enabled\":\"1\",\"news_text_order\":\"4\",\"news_text_enabled\":\"0\",\"news_info_order\":\"3\",\"news_info_enabled\":\"1\",\"news_info2_order\":\"5\",\"news_info2_enabled\":\"0\",\"news_content_readmore_pos\":\"right\",\"news_readmore_enabled\":\"0\",\"news_short_pages\":\"0\",\"links_amount\":\"0\",\"links_columns_amount\":\"0\",\"bottom_interface_style\":\"none\",\"links_margin\":\"0\",\"links_position\":\"bottom\",\"links_width\":\"50\",\"show_list_description\":\"1\",\"list_title_limit_type\":\"words\",\"list_title_limit\":\"20\",\"list_text_limit_type\":\"words\",\"list_text_limit\":\"30\",\"responsive_images\":\"0\",\"wrap_content\":\"0\",\"memory_limit\":\"128M\",\"create_thumbs\":\"1\",\"k2_thumbs\":\"first\",\"thumb_image_type\":\"full\",\"img_auto_scale\":\"0\",\"img_keep_aspect_ratio\":\"0\",\"img_width\":\"89\",\"img_height\":\"65\",\"img_margin\":\"0 18px 0 0\",\"img_bg\":\"#000\",\"img_stretch\":\"1\",\"img_quality\":\"95\",\"cache_time\":\"30\",\"simple_crop_top\":\"10\",\"simple_crop_bottom\":\"10\",\"simple_crop_left\":\"10\",\"simple_crop_right\":\"10\",\"crop_rules\":\"\",\"autoanim\":\"0\",\"hover_anim\":\"0\",\"animation_speed\":\"400\",\"animation_interval\":\"5000\",\"news_portal_mode_3_open_first\":\"1\",\"animation_function\":\"Fx.Transitions.Expo.easeIn\",\"clean_xhtml\":\"1\",\"more_text_value\":\"...\",\"parse_plugins\":\"0\",\"clean_plugins\":\"0\",\"useCSS\":\"0\",\"useScript\":\"2\",\"useRTL\":\"0\",\"module_tag\":\"div\",\"bootstrap_size\":\"0\",\"header_tag\":\"h3\",\"header_class\":\"\",\"style\":\"0\"}',0,'*');


--
-- Table structure for table `#__modules_menu`
--



CREATE TABLE `#__modules_menu` (
  `moduleid` int(11) NOT NULL DEFAULT '0',
  `menuid` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`moduleid`,`menuid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__modules_menu`
--


INSERT INTO `#__modules_menu` (`moduleid`, `menuid`) VALUES (1,0),(2,0),(3,0),(4,0),(6,0),(7,0),(8,0),(9,0),(10,0),(12,0),(13,0),(14,0),(15,0),(16,0),(17,0),(79,0),(86,0),(89,-154),(89,-150),(89,-149),(92,0),(93,0),(94,0),(95,152),(96,0),(97,152),(98,0),(99,152),(100,152),(101,152),(102,152),(103,152),(104,152),(105,-154),(105,-150),(105,-149),(106,0),(107,0),(108,-154),(108,-152),(108,-150),(108,-149),(109,0),(110,0),(111,152),(112,152),(113,101),(114,0),(115,152),(116,152),(117,152),(119,0),(120,0),(121,152),(122,101),(123,-154),(123,-152),(123,-150);


--
-- Table structure for table `#__newsfeeds`
--



CREATE TABLE `#__newsfeeds` (
  `catid` int(11) NOT NULL DEFAULT '0',
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `link` varchar(200) NOT NULL DEFAULT '',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `numarticles` int(10) unsigned NOT NULL DEFAULT '1',
  `cache_time` int(10) unsigned NOT NULL DEFAULT '3600',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `rtl` tinyint(4) NOT NULL DEFAULT '0',
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL DEFAULT '',
  `params` text NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `description` text NOT NULL,
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `images` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`published`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__newsfeeds`
--


INSERT INTO `#__newsfeeds` (`catid`, `id`, `name`, `alias`, `link`, `published`, `numarticles`, `cache_time`, `checked_out`, `checked_out_time`, `ordering`, `rtl`, `access`, `language`, `params`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `metakey`, `metadesc`, `metadata`, `xreference`, `publish_up`, `publish_down`, `description`, `version`, `hits`, `images`) VALUES (11,1,'GavickPro News','gavickpro-news','http://gavick.com/magazine/index.php?format=feed&type=rss',1,5,3600,0,'0000-00-00 00:00:00',1,0,1,'*','{\"show_feed_image\":\"\",\"show_feed_description\":\"\",\"show_item_description\":\"\",\"feed_character_count\":\"0\",\"newsfeed_layout\":\"\",\"feed_display_order\":\"\"}','2012-12-03 09:15:25',944,'','0000-00-00 00:00:00',0,'','','{\"robots\":\"\",\"rights\":\"\"}','','0000-00-00 00:00:00','0000-00-00 00:00:00','',1,0,'{\"image_first\":\"\",\"float_first\":\"\",\"image_first_alt\":\"\",\"image_first_caption\":\"\",\"image_second\":\"\",\"float_second\":\"\",\"image_second_alt\":\"\",\"image_second_caption\":\"\"}');


--
-- Table structure for table `#__overrider`
--



CREATE TABLE `#__overrider` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `constant` varchar(255) NOT NULL,
  `string` text NOT NULL,
  `file` varchar(255) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__overrider`
--




--
-- Table structure for table `#__redirect_links`
--



CREATE TABLE `#__redirect_links` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `old_url` varchar(255) NOT NULL,
  `new_url` varchar(255) NOT NULL,
  `referer` varchar(150) NOT NULL,
  `comment` varchar(255) NOT NULL,
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `published` tinyint(4) NOT NULL,
  `created_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_link_old` (`old_url`),
  KEY `idx_link_modifed` (`modified_date`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__redirect_links`
--


INSERT INTO `#__redirect_links` (`id`, `old_url`, `new_url`, `referer`, `comment`, `hits`, `published`, `created_date`, `modified_date`) VALUES (1,'http://project.gavick.com/_updates/joomla30/publisher/?option=non-existing-component','','http://project.gavick.com/_updates/joomla30/publisher/','',1,0,'2012-12-04 15:51:31','0000-00-00 00:00:00');


--
-- Table structure for table `#__schemas`
--



CREATE TABLE `#__schemas` (
  `extension_id` int(11) NOT NULL,
  `version_id` varchar(20) NOT NULL,
  PRIMARY KEY (`extension_id`,`version_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__schemas`
--





--
-- Table structure for table `#__session`
--



CREATE TABLE `#__session` (
  `session_id` varchar(200) NOT NULL DEFAULT '',
  `client_id` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `guest` tinyint(4) unsigned DEFAULT '1',
  `time` varchar(14) DEFAULT '',
  `data` mediumtext,
  `userid` int(11) DEFAULT '0',
  `username` varchar(150) DEFAULT '',
  PRIMARY KEY (`session_id`),
  KEY `userid` (`userid`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__session`
--


INSERT INTO `#__session` (`session_id`, `client_id`, `guest`, `time`, `data`, `userid`, `username`) VALUES ('33d8176b4d26d4c0b05556d1150f7524',0,1,'1360670312','__default|a:9:{s:15:\"session.counter\";i:5;s:19:\"session.timer.start\";i:1360668246;s:18:\"session.timer.last\";i:1360669625;s:17:\"session.timer.now\";i:1360670310;s:22:\"session.client.browser\";s:119:\"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_8_2) AppleWebKit/537.17 (KHTML, like Gecko) Chrome/24.0.1312.57 Safari/537.17\";s:8:\"registry\";O:9:\"JRegistry\":1:{s:7:\"\\0\\0\\0data\";O:8:\"stdClass\":0:{}}s:4:\"user\";O:5:\"JUser\":25:{s:9:\"\\0\\0\\0isRoot\";b:0;s:2:\"id\";i:0;s:4:\"name\";N;s:8:\"username\";N;s:5:\"email\";N;s:8:\"password\";N;s:14:\"password_clear\";s:0:\"\";s:5:\"block\";N;s:9:\"sendEmail\";i:0;s:12:\"registerDate\";N;s:13:\"lastvisitDate\";N;s:10:\"activation\";N;s:6:\"params\";N;s:6:\"groups\";a:1:{i:0;s:1:\"9\";}s:5:\"guest\";i:1;s:13:\"lastResetTime\";N;s:10:\"resetCount\";N;s:10:\"\\0\\0\\0_params\";O:9:\"JRegistry\":1:{s:7:\"\\0\\0\\0data\";O:8:\"stdClass\":0:{}}s:14:\"\\0\\0\\0_authGroups\";a:2:{i:0;i:1;i:1;i:9;}s:14:\"\\0\\0\\0_authLevels\";a:3:{i:0;i:1;i:1;i:1;i:2;i:5;}s:15:\"\\0\\0\\0_authActions\";N;s:12:\"\\0\\0\\0_errorMsg\";N;s:10:\"\\0\\0\\0_errors\";a:0:{}s:3:\"aid\";i:0;s:3:\"gid\";i:1;}s:13:\"session.token\";s:32:\"d651e203def35352690dc470364f5c91\";s:16:\"com_mailto.links\";a:1:{s:40:\"afc2b14e7b2eda5de371ffef8651aff7851a6350\";O:8:\"stdClass\":2:{s:4:\"link\";s:82:\"http://project.gavick.com/_updates/joomla30/clean_demo/publisher/index.php/k2/item\";s:6:\"expiry\";i:1360670310;}}}',0,'');


--
-- Table structure for table `#__template_styles`
--



CREATE TABLE `#__template_styles` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `template` varchar(50) NOT NULL DEFAULT '',
  `client_id` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `home` char(7) NOT NULL DEFAULT '0',
  `title` varchar(255) NOT NULL DEFAULT '',
  `params` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_template` (`template`),
  KEY `idx_home` (`home`)
) ENGINE=InnoDB AUTO_INCREMENT=10 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__template_styles`
--


INSERT INTO `#__template_styles` (`id`, `template`, `client_id`, `home`, `title`, `params`) VALUES (4,'beez3',0,'0','Beez3 - Default','{\"wrapperSmall\":\"53\",\"wrapperLarge\":\"72\",\"logo\":\"images\\/joomla_black.gif\",\"sitetitle\":\"Joomla!\",\"sitedescription\":\"Open Source Content Management\",\"navposition\":\"left\",\"templatecolor\":\"personal\",\"html5\":\"0\"}'),(5,'hathor',1,'0','Hathor - Default','{\"showSiteName\":\"0\",\"colourChoice\":\"\",\"boldText\":\"0\"}'),(7,'protostar',0,'0','protostar - Default','{\"templateColor\":\"\",\"logoFile\":\"\",\"googleFont\":\"1\",\"googleFontName\":\"Open+Sans\",\"fluidContainer\":\"0\"}'),(8,'isis',1,'1','isis - Default','{\"templateColor\":\"\",\"logoFile\":\"\"}'),(9,'gk_publisher',0,'1','gk_publisher - Default','{\"template_color\":\"1\",\"default_layout\":\"default\",\"layout_override\":\"\",\"template_width\":\"1000\",\"tablet_width\":\"920\",\"mobile_width\":\"580\",\"sidebar_position\":\"right\",\"sidebar_width\":\"34\",\"sidebar_width_for_pages\":\"\",\"rwd\":\"1\",\"font_name_group1\":\"standard;Arial, Helvetica, sans-serif\",\"font_rules_group1\":\"body,\\r\\n.box .header > small,\\r\\n.gkMenu > ul div.childcontent a,\\r\\n#gkSidebar h4.nspHeader,\\r\\n#gkBottom2 h4.nspHeader\",\"font_name_group2\":\"google;own;http:\\/\\/fonts.googleapis.com\\/css?family=Exo:300,400,600,700;Exo\",\"font_rules_group2\":\"h1, h2, h3, h4, h5, h6,\\r\\n#gkLogo.text,\\r\\n#gkUserArea,\\r\\n#gkMainMenu,\\r\\n.box .header,\\r\\narticle > time,\\r\\nbutton,\\r\\n.button,\\r\\ninput.button,\\r\\nspan.button,\\r\\nbutton.button,\\r\\ndiv.button,\\r\\ninput[type=\\\"submit\\\"],\\r\\ninput[type=\\\"button\\\"],\\r\\n.pagenav-prev a,\\r\\n.pagenav-next a,\\r\\n.readon,\\r\\n.pagination ul li a,\\r\\n.pagination ul li span,\\r\\nfieldset legend\",\"font_name_group3\":\"standard;Verdana, Geneva, sans-serif\",\"font_rules_group3\":\".blank\",\"font_name_group4\":\"standard;Arial, Helvetica, sans-serif\",\"font_rules_group4\":\".blank\",\"login_url\":\"index.php?option=com_users&view=login\",\"register_link\":\"1\",\"register_url\":\"index.php?option=com_users&view=registration\",\"logo_type\":\"css\",\"logo_image\":\"\",\"logo_text\":\"Publisher\",\"logo_slogan\":\"Blog Theme\",\"print_logo\":\"\",\"print_behaviour\":\"nothing\",\"favicon_image\":\"\",\"stylearea\":\"1\",\"framework_logo\":\"1\",\"copyrights\":\"Template Design &copy; <a href=\\\"http:\\/\\/www.gavick.com\\\" title=\\\"Joomla Templates\\\">Joomla Templates<\\/a> GavickPro. All rights reserved.\",\"webmaster_contact_type\":\"email\",\"webmaster_contact\":\"webmaster@gavick.com\",\"typography\":\"1\",\"typo_iconset\":\"1\",\"google_analytics\":\"\",\"tools\":\"none\",\"tools_for_pages\":\"com_k2=enabled\\r\\n101=enabled\\r\\n\",\"mootools_for_pages\":\"\",\"suffix_override\":\"\",\"module_override\":\"\",\"show_menu\":\"1\",\"menu_name\":\"mainmenu\",\"startlevel\":\"0\",\"endlevel\":\"-1\",\"menu_animation\":\"slide_fade\",\"menu_height\":\"1\",\"menu_width\":\"1\",\"menu_col_width\":\"220\",\"menu_duration\":\"250\",\"fb_api_id\":\"171342606239806\",\"fb_lang\":\"en_US\",\"fb_login\":\"1\",\"fb_like\":\"1\",\"fb_like_send\":\"1\",\"fb_like_layout\":\"standard\",\"fb_like_show_faces\":\"true\",\"fb_like_width\":\"400\",\"fb_like_action\":\"like\",\"fb_like_font\":\"arial\",\"fb_like_colorscheme\":\"light\",\"google_plus\":\"1\",\"google_plus_count\":\"1\",\"google_plus_size\":\"medium\",\"google_plus_lang\":\"en-GB\",\"google_plus_share\":\"1\",\"google_plus_share_annotation\":\"bubble\",\"google_plus_share_size\":\"20\",\"tweet_btn\":\"1\",\"tweet_btn_data_count\":\"horizontal\",\"tweet_btn_data_via\":\"\",\"tweet_btn_data_lang\":\"en\",\"pinterest_btn\":\"1\",\"pinterest_btn_style\":\"horizontal\",\"excluded_arts\":\"\",\"excluded_cats\":[\"15\"],\"cookie_consent\":\"0\",\"consenttype\":\"explicit\",\"cookie_latest_version\":\"0\",\"cookie_use_ssl\":\"0\",\"banner_position\":\"bottom\",\"banner_tag_placement\":\"bottom-right\",\"cookie_style\":\"light\",\"refreshOnConsent\":\"0\",\"cookiecss\":\"1\",\"use_gk_cache\":\"0\",\"css_cache\":\"0\",\"css_compression\":\"0\",\"css_override\":\"0\",\"css_prefixer\":\"0\",\"js_compression\":\"0\",\"jscss_excluded\":\"\",\"css_custom\":\"\",\"chrome_frame_support\":\"0\"}');


--
-- Table structure for table `#__update_sites`
--



CREATE TABLE `#__update_sites` (
  `update_site_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) DEFAULT '',
  `type` varchar(20) DEFAULT '',
  `location` text NOT NULL,
  `enabled` int(11) DEFAULT '0',
  `last_check_timestamp` bigint(20) DEFAULT '0',
  PRIMARY KEY (`update_site_id`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8 COMMENT='Update Sites';


--
-- Dumping data for table `#__update_sites`
--


INSERT INTO `#__update_sites` (`update_site_id`, `name`, `type`, `location`, `enabled`, `last_check_timestamp`) VALUES (1,'Joomla Core','collection','http://update.joomla.org/core/list.xml',1,1360668620),(2,'Joomla Extension Directory','collection','http://update.joomla.org/jed/list.xml',1,1360668620),(3,'Accredited Joomla! Translations','collection','http://update.joomla.org/language/translationlist_3.xml',1,1360668620),(4,'K2 Updates','extension','http://getk2.org/update.xml',1,1360668620);


--
-- Table structure for table `#__update_sites_extensions`
--



CREATE TABLE `#__update_sites_extensions` (
  `update_site_id` int(11) NOT NULL DEFAULT '0',
  `extension_id` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`update_site_id`,`extension_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Links extensions to update sites';


--
-- Dumping data for table `#__update_sites_extensions`
--


INSERT INTO `#__update_sites_extensions` (`update_site_id`, `extension_id`) VALUES (1,700),(2,700),(3,600),(4,10000);


--
-- Table structure for table `#__updates`
--



CREATE TABLE `#__updates` (
  `update_id` int(11) NOT NULL AUTO_INCREMENT,
  `update_site_id` int(11) DEFAULT '0',
  `extension_id` int(11) DEFAULT '0',
  `name` varchar(100) DEFAULT '',
  `description` text NOT NULL,
  `element` varchar(100) DEFAULT '',
  `type` varchar(20) DEFAULT '',
  `folder` varchar(20) DEFAULT '',
  `client_id` tinyint(3) DEFAULT '0',
  `version` varchar(10) DEFAULT '',
  `data` text NOT NULL,
  `detailsurl` text NOT NULL,
  `infourl` text NOT NULL,
  PRIMARY KEY (`update_id`)
) ENGINE=InnoDB AUTO_INCREMENT=48 DEFAULT CHARSET=utf8 COMMENT='Available Updates';


--
-- Dumping data for table `#__updates`
--


INSERT INTO `#__updates` (`update_id`, `update_site_id`, `extension_id`, `name`, `description`, `element`, `type`, `folder`, `client_id`, `version`, `data`, `detailsurl`, `infourl`) VALUES (1,3,0,'Flemish','','pkg_nl-BE','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/nl-BE_details.xml',''),(2,3,0,'Chinese Traditional','','pkg_zh-TW','package','',0,'3.0.2.2','','http://update.joomla.org/language/details3/zh-TW_details.xml',''),(3,3,0,'French','','pkg_fr-FR','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/fr-FR_details.xml',''),(4,3,0,'Galician','','pkg_gl-ES','package','',0,'3.0.2.2','','http://update.joomla.org/language/details3/gl-ES_details.xml',''),(5,3,0,'German','','pkg_de-DE','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/de-DE_details.xml',''),(6,3,0,'Hebrew','','pkg_he-IL','package','',0,'3.0.1.1','','http://update.joomla.org/language/details3/he-IL_details.xml',''),(7,3,0,'Hungarian','','pkg_hu-HU','package','',0,'3.0.2.1','','http://update.joomla.org/language/details3/hu-HU_details.xml',''),(8,3,0,'Afrikaans','','pkg_af-ZA','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/af-ZA_details.xml',''),(9,3,0,'Arabic Unitag','','pkg_ar-AA','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/ar-AA_details.xml',''),(10,3,0,'Belarusian','','pkg_be-BY','package','',0,'3.0.2.1','','http://update.joomla.org/language/details3/be-BY_details.xml',''),(11,3,0,'Bulgarian','','pkg_bg-BG','package','',0,'3.0.0.1','','http://update.joomla.org/language/details3/bg-BG_details.xml',''),(12,3,0,'Catalan','','pkg_ca-ES','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/ca-ES_details.xml',''),(13,3,0,'Chinese Simplified','','pkg_zh-CN','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/zh-CN_details.xml',''),(14,3,0,'Croatian','','pkg_hr-HR','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/hr-HR_details.xml',''),(15,3,0,'Danish','','pkg_da-DK','package','',0,'3.0.3.2','','http://update.joomla.org/language/details3/da-DK_details.xml',''),(16,3,0,'Dutch','','pkg_nl-NL','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/nl-NL_details.xml',''),(17,3,0,'English AU','','pkg_en-AU','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/en-AU_details.xml',''),(18,3,0,'English US','','pkg_en-US','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/en-US_details.xml',''),(19,3,0,'Estonian','','pkg_et-EE','package','',0,'3.0.2.1','','http://update.joomla.org/language/details3/et-EE_details.xml',''),(20,3,0,'Italian','','pkg_it-IT','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/it-IT_details.xml',''),(21,3,0,'Japanese','','pkg_ja-JP','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/ja-JP_details.xml',''),(22,3,0,'Korean','','pkg_ko-KR','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/ko-KR_details.xml',''),(23,3,0,'Kurdish Sorani','','pkg_ckb-IQ','package','',0,'3.0.2.1','','http://update.joomla.org/language/details3/ckb-IQ_details.xml',''),(24,3,0,'Latvian','','pkg_lv-LV','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/lv-LV_details.xml',''),(25,3,0,'Macedonian','','pkg_mk-MK','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/mk-MK_details.xml',''),(26,3,0,'Norwegian Bokmal','','pkg_nb-NO','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/nb-NO_details.xml',''),(27,3,0,'Persian','','pkg_fa-IR','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/fa-IR_details.xml',''),(28,3,0,'Polish','','pkg_pl-PL','package','',0,'3.0.3.2','','http://update.joomla.org/language/details3/pl-PL_details.xml',''),(29,3,0,'Russian','','pkg_ru-RU','package','',0,'3.0.2.1','','http://update.joomla.org/language/details3/ru-RU_details.xml',''),(30,3,0,'Slovak','','pkg_sk-SK','package','',0,'3.0.3.2','','http://update.joomla.org/language/details3/sk-SK_details.xml',''),(31,3,0,'Swedish','','pkg_sv-SE','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/sv-SE_details.xml',''),(32,3,0,'Syriac','','pkg_sy-IQ','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/sy-IQ_details.xml',''),(33,3,0,'Tamil','','pkg_ta-IN','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/ta-IN_details.xml',''),(34,3,0,'Thai','','pkg_th-TH','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/th-TH_details.xml',''),(35,3,0,'Turkish','','pkg_tr-TR','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/tr-TR_details.xml',''),(36,3,0,'Ukrainian','','pkg_uk-UA','package','',0,'3.0.2.1','','http://update.joomla.org/language/details3/uk-UA_details.xml',''),(37,3,0,'Uyghur','','pkg_ug-CN','package','',0,'3.0.2.1','','http://update.joomla.org/language/details3/ug-CN_details.xml',''),(38,3,0,'Portuguese Brazil','','pkg_pt-BR','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/pt-BR_details.xml',''),(39,3,0,'Serbian Latin','','pkg_sr-YU','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/sr-YU_details.xml',''),(40,3,0,'Spanish','','pkg_es-ES','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/es-ES_details.xml',''),(41,3,0,'Bosnian','','pkg_bs-BA','package','',0,'3.0.2.1','','http://update.joomla.org/language/details3/bs-BA_details.xml',''),(42,3,0,'Serbian Cyrillic','','pkg_sr-RS','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/sr-RS_details.xml',''),(43,3,0,'Vietnamese','','pkg_vi-VN','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/vi-VN_details.xml',''),(44,3,0,'Bahasa Indonesia','','pkg_id-ID','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/id-ID_details.xml',''),(45,3,0,'Finnish','','pkg_fi-FI','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/fi-FI_details.xml',''),(46,3,0,'Swahili','','pkg_sw-KE','package','',0,'3.0.3.1','','http://update.joomla.org/language/details3/sw-KE_details.xml','');


--
-- Table structure for table `#__user_notes`
--



CREATE TABLE `#__user_notes` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `catid` int(10) unsigned NOT NULL DEFAULT '0',
  `subject` varchar(100) NOT NULL DEFAULT '',
  `body` text NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `created_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_user_id` int(10) unsigned NOT NULL,
  `modified_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `review_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  KEY `idx_user_id` (`user_id`),
  KEY `idx_category_id` (`catid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__user_notes`
--




--
-- Table structure for table `#__user_profiles`
--



CREATE TABLE `#__user_profiles` (
  `user_id` int(11) NOT NULL,
  `profile_key` varchar(100) NOT NULL,
  `profile_value` varchar(255) NOT NULL,
  `ordering` int(11) NOT NULL DEFAULT '0',
  UNIQUE KEY `idx_user_id_profile_key` (`user_id`,`profile_key`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Simple user profile storage table';


--
-- Dumping data for table `#__user_profiles`
--




--
-- Table structure for table `#__user_usergroup_map`
--



CREATE TABLE `#__user_usergroup_map` (
  `user_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Foreign Key to #__users.id',
  `group_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Foreign Key to #__usergroups.id',
  PRIMARY KEY (`user_id`,`group_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__user_usergroup_map`
--


INSERT INTO `#__user_usergroup_map` (`user_id`, `group_id`) VALUES (944,8);


--
-- Table structure for table `#__usergroups`
--



CREATE TABLE `#__usergroups` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Adjacency List Reference Id',
  `lft` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set lft.',
  `rgt` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set rgt.',
  `title` varchar(100) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_usergroup_parent_title_lookup` (`parent_id`,`title`),
  KEY `idx_usergroup_title_lookup` (`title`),
  KEY `idx_usergroup_adjacency_lookup` (`parent_id`),
  KEY `idx_usergroup_nested_set_lookup`  USING BTREE (`lft`,`rgt`) 
) ENGINE=InnoDB AUTO_INCREMENT=10 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__usergroups`
--


INSERT INTO `#__usergroups` (`id`, `parent_id`, `lft`, `rgt`, `title`) VALUES (1,0,1,18,'Public'),(2,1,8,15,'Registered'),(3,2,9,14,'Author'),(4,3,10,13,'Editor'),(5,4,11,12,'Publisher'),(6,1,4,7,'Manager'),(7,6,5,6,'Administrator'),(8,1,16,17,'Super Users'),(9,1,2,3,'Guest');


--
-- Table structure for table `#__users`
--



CREATE TABLE `#__users` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `username` varchar(150) NOT NULL DEFAULT '',
  `email` varchar(100) NOT NULL DEFAULT '',
  `password` varchar(100) NOT NULL DEFAULT '',
  `block` tinyint(4) NOT NULL DEFAULT '0',
  `sendEmail` tinyint(4) DEFAULT '0',
  `registerDate` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `lastvisitDate` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `activation` varchar(100) NOT NULL DEFAULT '',
  `params` text NOT NULL,
  `lastResetTime` datetime NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Date of last password reset',
  `resetCount` int(11) NOT NULL DEFAULT '0' COMMENT 'Count of password resets since lastResetTime',
  PRIMARY KEY (`id`),
  KEY `idx_name` (`name`),
  KEY `idx_block` (`block`),
  KEY `username` (`username`),
  KEY `email` (`email`)
) ENGINE=InnoDB AUTO_INCREMENT=945 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__users`
--


INSERT INTO `#__users` (`id`, `name`, `username`, `email`, `password`, `block`, `sendEmail`, `registerDate`, `lastvisitDate`, `activation`, `params`, `lastResetTime`, `resetCount`) VALUES (944,'Super User','gkadmin','blank@gavick.com','9dbbb348c0feb218d9e19c5dcfdf8db3:L8uq13IggPEjEvqsXh4sVQhfYGk1mWpT',0,1,'2012-12-03 08:27:02','2013-02-12 11:27:12','0','','0000-00-00 00:00:00',0);


--
-- Table structure for table `#__viewlevels`
--



CREATE TABLE `#__viewlevels` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `title` varchar(100) NOT NULL DEFAULT '',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `rules` varchar(5120) NOT NULL COMMENT 'JSON encoded access control.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_assetgroup_title_lookup` (`title`)
) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__viewlevels`
--


INSERT INTO `#__viewlevels` (`id`, `title`, `ordering`, `rules`) VALUES (1,'Public',0,'[1]'),(2,'Registered',1,'[6,2,8]'),(3,'Special',2,'[6,3,8]'),(5,'Guest',0,'[9]');


--
-- Table structure for table `#__weblinks`
--



CREATE TABLE `#__weblinks` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `catid` int(11) NOT NULL DEFAULT '0',
  `title` varchar(250) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `url` varchar(250) NOT NULL DEFAULT '',
  `description` text NOT NULL,
  `hits` int(11) NOT NULL DEFAULT '0',
  `state` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `access` int(11) NOT NULL DEFAULT '1',
  `params` text NOT NULL,
  `language` char(7) NOT NULL DEFAULT '',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if link is featured.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  `images` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`state`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=utf8;


--
-- Dumping data for table `#__weblinks`
--


INSERT INTO `#__weblinks` (`id`, `catid`, `title`, `alias`, `url`, `description`, `hits`, `state`, `checked_out`, `checked_out_time`, `ordering`, `access`, `params`, `language`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `metakey`, `metadesc`, `metadata`, `featured`, `xreference`, `publish_up`, `publish_down`, `version`, `images`) VALUES (1,14,'GavickPro Demo','gavickpro-demo','http://demo.gavick.com','',0,1,0,'0000-00-00 00:00:00',1,1,'{\"target\":\"\",\"width\":\"\",\"height\":\"\",\"count_clicks\":\"\"}','*','2012-12-03 09:17:17',944,'','0000-00-00 00:00:00',0,'','','{\"robots\":\"\",\"rights\":\"\"}',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'{\"image_first\":\"\",\"float_first\":\"\",\"image_first_alt\":\"\",\"image_first_caption\":\"\",\"image_second\":\"\",\"float_second\":\"\",\"image_second_alt\":\"\",\"image_second_caption\":\"\"}'),(2,14,'GavickPro Facebook','gavickpro-facebook','http://www.facebook.com/gavickpro','',0,1,0,'0000-00-00 00:00:00',2,1,'{\"target\":\"\",\"width\":\"\",\"height\":\"\",\"count_clicks\":\"\"}','*','2012-12-03 09:17:31',944,'','0000-00-00 00:00:00',0,'','','{\"robots\":\"\",\"rights\":\"\"}',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'{\"image_first\":\"\",\"float_first\":\"\",\"image_first_alt\":\"\",\"image_first_caption\":\"\",\"image_second\":\"\",\"float_second\":\"\",\"image_second_alt\":\"\",\"image_second_caption\":\"\"}'),(3,14,'GavickPro Homepage','gavickpro-homepage','http://www.gavick.com','',0,1,0,'0000-00-00 00:00:00',3,1,'{\"target\":\"\",\"width\":\"\",\"height\":\"\",\"count_clicks\":\"\"}','*','2012-12-03 09:17:49',944,'','0000-00-00 00:00:00',0,'','','{\"robots\":\"\",\"rights\":\"\"}',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'{\"image_first\":\"\",\"float_first\":\"\",\"image_first_alt\":\"\",\"image_first_caption\":\"\",\"image_second\":\"\",\"float_second\":\"\",\"image_second_alt\":\"\",\"image_second_caption\":\"\"}'),(4,14,'GavickPro Magazine','gavickpro-magazine','http://www.gavickmagazine.com','',0,1,0,'0000-00-00 00:00:00',4,1,'{\"target\":\"\",\"width\":\"\",\"height\":\"\",\"count_clicks\":\"\"}','*','2012-12-03 09:18:06',944,'','0000-00-00 00:00:00',0,'','','{\"robots\":\"\",\"rights\":\"\"}',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'{\"image_first\":\"\",\"float_first\":\"\",\"image_first_alt\":\"\",\"image_first_caption\":\"\",\"image_second\":\"\",\"float_second\":\"\",\"image_second_alt\":\"\",\"image_second_caption\":\"\"}'),(5,14,'GavickPro RSS & News','gavickpro-rss-news','http://www.gavickmagazine.com/index.php?format=feed&type=rss','',0,1,0,'0000-00-00 00:00:00',5,1,'{\"target\":\"\",\"width\":\"\",\"height\":\"\",\"count_clicks\":\"\"}','*','2012-12-03 09:18:20',944,'','0000-00-00 00:00:00',0,'','','{\"robots\":\"\",\"rights\":\"\"}',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'{\"image_first\":\"\",\"float_first\":\"\",\"image_first_alt\":\"\",\"image_first_caption\":\"\",\"image_second\":\"\",\"float_second\":\"\",\"image_second_alt\":\"\",\"image_second_caption\":\"\"}');











-- Dump completed on 2013-02-12 13:22:42
UPDATE `#__users` SET block=1 WHERE block=0
